<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: xoev-profil.ndr.sch 7434 2017-08-24 11:06:25Z fbuettner $ -->
<sch:schema xmlns:sch="http://purl.oclc.org/dsdl/schematron" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" queryBinding="xslt2">
   <sch:title>Allgemeingültige KoSIT-Regeln</sch:title>
   <xsl:include href="xgenerator-library.xgen-core.xsl"/>
   <xsl:include href="xgenerator-library.uml-access-layer.xsl"/>
   <xsl:include href="xoev-profil.profile-access-layer.xsl"/>
   <xsl:include href="xoev-profil.helpers.xsl"/>
   <xsl:include href="kosit-magicdraw-profil.profile-access-layer.xsl"/>
   <xsl:include href="kosit-zubehoer.helpers.xsl"/>
   <xsl:include href="kosit-dokumentations-profil.profile-access-layer.xsl"/>
   <sch:ns uri="http://www.xoev.de/de/xgenerator/framework/1/library" prefix="xgen"/>
   <sch:ns uri="http://www.omg.org/spec/XMI/20131001" prefix="xmi"/>
   <sch:ns uri="http://www.eclipse.org/uml2/5.0.0/UML" prefix="uml"/>
   <sch:ns uri="http://www.xoev.de/de/xoev-profil/3_0_2" prefix="xoev"/>
   <sch:ns uri="http://www.xoev.de/de/kosit-zubehoer/3_1_0" prefix="kosit"/>
   <sch:ns uri="http://www.xoev.de/de/kosit-zubehoer/md/3_1_0" prefix="kosit-md"/>
   <!-- Quelle XGen2-Datei: KoSIT-MUSS.invariants, KoSIT-SOLL.invariants, KoSIT-EMPFEHLUNG.invariants -->
   <!-- Umsetzungsstand: vollständig -->
   <sch:pattern>
      <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)]//ownedComment[../not(uml:is-Activity(.)) and starts-with(body, '&lt;')]">
         <sch:let name="db-ns" value="'xmlns=''http://docbook.org/ns/docbook'''"/>
         <sch:let name="encapsulated-body" value="concat('&lt;section ', $db-ns, '&gt;&lt;title&gt;anonymous-section&lt;/title&gt;', body, '&lt;/section&gt;')"/>
         <sch:let name="errors" value="xgen:relaxng-instance-errors(resolve-uri(xs:anyURI('../../../oxygen-frameworks/kosit-zubehoer-docbook-erweiterung/rng/kosit-docbook.rng')), $encapsulated-body)"/>
         <sch:assert role="error" id="ValidDocBookInComment" test="empty($errors)">Die Dokumentation des Elements <sch:value-of select="xgen:model-path(..)"/> ist kein valides DocBook 5: <sch:value-of select="$errors"/></sch:assert>
      </sch:rule>
   </sch:pattern>
   <!-- Quelle XGen2: MessageEnumerationIncludesAllMessages -->
   <sch:pattern id="Regel1-CodelisteNachrichtentypenEnthaeltAlleNachrichtennummern">
      <sch:title>Codeliste Nachrichtentypen enthaelt alle Nachrichtennummern</sch:title>
      <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and not(xoev:xsdDraft(.))]">
         <sch:let name="vcl" value="/xmi:XMI/uml:Model//packagedElement/xoev:usages-by-client(.)[kosit-md:kositNachrichtenEnumeration(.)]/uml:resolve-supplier(.)"/>
         <sch:let name="instances" value="
               /xmi:XMI/uml:Model/packagedElement[@name = 'Codelisten']//descendant::packagedElement[uml:is-InstanceSpecification(.) and @classifier = $vcl/@xmi:id and
               not(xoev:xoevCodelisteneintragDeprecated(.))]"/>
         <sch:let name="code-spalte" value="($vcl/ownedAttribute[xoev:xoevCodelistenspalte(.)/@empfohleneCodeSpalte = 'true'], ownedAttribute[xoev:xoevCodelistenspalte(.)/@codeSpalte = 'true'])[1]"/>
         <sch:assert role="error" id="CodelisteNachrichtentypenEnthaeltAlleNachrichtennummern" test="
               empty($vcl) or (
               some $instance in $instances
                  satisfies $instance/slot[uml:resolve-definingFeature(.)/@xmi:id = $code-spalte/@xmi:id]/value/@value/normalize-space(.) = tokenize(@name, '\.')[last()]
               )
               ">Falls nicht explizit gekennzeichnet, müssen alle Nachrichten in der Nachrichtentyp-Codeliste enthalten sein. Die Nummer der Nachricht <sch:value-of select="xgen:model-path(.)"/> ist nicht in der Codeliste enthalten.</sch:assert>
      </sch:rule>
   </sch:pattern>
   <!-- Quelle XGen2: versionenNachrichtenkopfUndSchemaKonsistent -->
   <sch:pattern id="Regel2-VersionenNachrichtenkopfUndSchemaKonsistent">
      <sch:title>Versionen Nachrichtenkopf und Schema konsistent</sch:title>
      <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[@name != 'Nachricht.G2G' and xoev:topmost-parent(.)/@name = 'Nachricht.G2G' and ownedAttribute[@name = 'version']]">
         <sch:assert role="error" id="VersionenNachrichtenkopfUndSchemaKonsistent" test="ownedAttribute[@name = 'version']/(defaultValue/@value, defaultValue/body)[1] = (ancestor::packagedElement/xoev:xsdSchema(.)/@version, ancestor::packagedElement/xoev:xoevVersionStandard(.)/@version)[1]">Die Versionsangabe im Nachrichtenkopf muss mit der Versionsangabe zum Schema-Paket übereinstimmen. Der Nachrichtenkopf <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
      </sch:rule>
   </sch:pattern>
   <!-- Quelle XGen2: PropertiesOfTypesAndGlobalElementsAreLocalStructuresElementsOrAttributes -->
   <sch:pattern id="Regel3-TypenUndGlobaleElementeEnthaltenElementeAttributeOderLokaleStrukturen">
      <sch:title>Typen und globale Elemente enthalten Elemente, Attribute oder lokale Strukturen</sch:title>
      <sch:rule context="
            /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[uml:is-Class(.) and ownedAttribute and ancestor::packagedElement/xoev:xsdSchema(.) and not(xoev:xoevVersionCodeliste(.))] |
            /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[uml:is-Class(.) and ownedAttribute and ancestor::packagedElement/xoev:xsdSchema(.) and not(xoev:xoevVersionCodeliste(.))]">
         <sch:assert role="error" id="TypenUndGlobaleElementeEnthaltenElementeAttributeOderLokaleStrukturen" test="count(ownedAttribute[xoev:is-element(.) or xoev:xsdAttribute(.) or xoev:xsdLocalStructure(.)]) = count(ownedAttribute)">Alle UML-Klasseneigenschaften eines Typs oder globalen Elements müssen als lokale Strukturen, Elemente oder Attribute sein. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
      </sch:rule>
   </sch:pattern>
   <!-- Quelle XGen2: NachrichtLeitetVonBasisnachrichtAb -->
   <sch:pattern id="Regel5-NachrichtLeitetVonBasisnachrichtAb">
      <sch:title>Nachricht leitet von Basisnachricht ab</sch:title>
      <sch:rule context="
            /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[not(xoev:xsdDraft(.)) and xoev:xsdMessage(.)] |
            /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[not(xoev:xsdDraft(.)) and xoev:xsdMessage(.)]">
         <sch:assert role="warning" id="NachrichtLeitetVonBasisnachrichtAb" test="
               xoev:allParents(.)[@name = 'Nachricht.G2G']">Eine Nachricht soll von der Basisnachricht 'Nachricht.G2G' ableiten. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
      </sch:rule>
   </sch:pattern>
   <!-- Quelle XGen2: NoUnreferencedTypesInXsdSchemaPackage -->
   <sch:pattern id="Regel5-KeineNichtGenutztenTypenInSchemapaket">
      <sch:title>Keine nicht genutzten Typen in Schemapaket</sch:title>
      <sch:rule context="
            /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)]//packagedElement[uml:is-Class(.) and not(xoev:xsdDraft(.)) and not(xoev:xsdGlobalElement(.)) and not(xoev:xoevVersionCodeliste(.)) and not(xoev:xoevCodeliste(.))] |
            /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)]//nestedClassifier[uml:is-Class(.) and not(xoev:xsdDraft(.)) and not(xoev:xsdGlobalElement(.)) and not(xoev:xoevVersionCodeliste(.)) and not(xoev:xoevCodeliste(.))]">
         <sch:let name="class" value="."/>
         <sch:assert role="information" id="KeineNichtGenutztenTypenInSchemapaket" test="
               ancestor::packagedElement[xoev:xsdXModel(.)]//ownedAttribute[uml:resolve-type(.)/@xmi:id = $class/@xmi:id] or
               ancestor::packagedElement[xoev:xsdXModel(.)]//generalization/uml:resolve-general(.)/@xmi:id = $class/@xmi:id or
               ancestor::packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdUnionMember(.)]/uml:resolve-supplier(.)/@xmi:id = $class/@xmi:id">Klassen aus einem xsdSchema-Paket müssen benutzt werden (entweder als Typ einer Eigenschaft, als Basistyp einer Generalisierung oder als Union Member Type). Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
      </sch:rule>
   </sch:pattern>

   <sch:pattern id="Regel6-CodelisteNachrichtentypenKonsistentZuNachrichtennamen">
      <sch:title>Codeliste Nachrichtentypen konsistent zu Nachrichtennamen</sch:title>
      <sch:rule context="
            /xmi:XMI/uml:Model/packagedElement[@name = 'Codelisten']//packagedElement[
            uml:is-InstanceSpecification(.) and
            @classifier = /xmi:XMI/uml:Model/packagedElement[@name = 'Codelisten']
            //packagedElement[xoev:xoevVersionCodeliste(.) and xoev:usages-by-supplier(.)/kosit-md:kositNachrichtenEnumeration(.)]/@xmi:id and
            not(xoev:xoevCodelisteneintragDeprecated(.))]">
         <sch:let name="instance" value="."/>
         <sch:let name="vcl" value="$instance/uml:resolve-classifier(.)"/>
         <sch:let name="cl" value="$vcl/xoev:dependencies-by-client(.)/uml:resolve-supplier(.)"/>
         <sch:let name="code-spalte" value="($vcl/ownedAttribute[xoev:xoevCodelistenspalte(.)/@empfohleneCodeSpalte = 'true'], ownedAttribute[xoev:xoevCodelistenspalte(.)/@codeSpalte = 'true'])[1]"/>
         <sch:let name="beschreibungs-spalte" value="$vcl/ownedAttribute[not(@xmi:id = $code-spalte/@xmi:id)]"/>
         <sch:let name="code" value="$instance/slot[uml:resolve-definingFeature(.)/@xmi:id = $code-spalte/@xmi:id]/value"/>
         <sch:let name="beschreibung" value="$instance/slot[uml:resolve-definingFeature(.)/@xmi:id = $beschreibungs-spalte/@xmi:id]/value"/>
         <sch:let name="nachricht" value="
               $xoev:my-xmodel//(packagedElement | nestedClassifier)[
               xoev:xsdMessage(.) and not(xoev:xsdDraft(.)) and tokenize(@name, '\.')[last()] = $code/@value/normalize-space(.)]"/>
         <sch:assert role="error" id="CodelisteNachrichtentypenKonsistentZuNachrichtennamen" test="
               $nachricht and $nachricht/@name = $beschreibung/@value/normalize-space(.)">Die Beschreibung eines Codes aus der Codeliste für Nachrichtentypen muss dem Namen der Nachricht entsprechen. Der Code <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe. <sch:value-of select="
                  if (empty($nachricht)) then
                     concat('Es existiert keine Nachricht, deren Nummer dem Code ', $code/@value/normalize-space(.), ' entspricht.')
                  else
                     concat('Die Beschreibung des Codes lautet ', $beschreibung/@value/normalize-space(.), '. Der Nachrichtenname lautet ', $nachricht/@name, '.')"/></sch:assert>
      </sch:rule>
   </sch:pattern>

   <sch:pattern id="Regel7-ErweiterungspunktNamensraumEnthaeltXAuslaenderNamensraum">
      <sch:title>ErweiterungspunktNamensraumEnthaeltKorrekteVersion</sch:title>
      <sch:rule context="
            /xmi:XMI/uml:Model/packagedElement[
            xoev:xsdXModel(.) and xoev:xoevStandard(.)/@kennung = 'urn:xoev-de:kosit:standard:xinneres.xauslaender']">
         <sch:let name="erweiterungspunkt" value="//packagedElement[@name = ('AZR.Erweiterungspunkt', 'ERSST.Erweiterungspunkt')]"/>
         <sch:let name="namensraum" value="xoev:xsdXModel(.)/@namespace"/>
         <sch:assert role="error" id="ErweiterungspunktNamensraumEnthaeltXAuslaenderNamensraum" test="
               every $ep in $erweiterungspunkt
                  satisfies starts-with($ep/xoev:xsdAnyContents(.)/@namespace, $namensraum)">Der Namensraum des Erweiterungspunktes muss den XAusländer-Namensraum (mit aktueller Version) enthalten. Der XAusländer-Namensraum lautet "<sch:value-of select="$namensraum"/>". Die Erweiterungspunkt-Namensräume lauten: <sch:value-of select="$erweiterungspunkt/xoev:xsdAnyContents(.)/@namespace"/>.</sch:assert>
      </sch:rule>
   </sch:pattern>
   <sch:pattern id="TypenMitGleichenInhalten">
      <sch:title>TypenMitGleichenInhalten</sch:title>
      <sch:rule context="
            /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[(xoev:elements(.) or xoev:attributes(.)) and not(starts-with(@name, 'Code.'))] |
            /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[(xoev:elements(.) or xoev:attributes(.)) and not(starts-with(@name, 'Code.'))]">
         <sch:let name="typ" value="."/>
         <sch:let name="alle-anderen-typen" value="$typ/ancestor::packagedElement[xoev:xsdXModel(.)]//packagedElement[(xoev:elements(.) or xoev:attributes(.)) and not(@xmi:id = $typ/@xmi:id)]"/>
         <sch:let name="typen-mit-gleichen-inhalten" value="
               $alle-anderen-typen[
               count((xoev:elements(.), xoev:attributes(.))) = count($typ/(xoev:elements(.), xoev:attributes(.))) and
               (if (generalization[not(xoev:xsdRestriction(.))]/uml:resolve-general(.)/@xmi:id) then
                  (generalization[not(xoev:xsdRestriction(.))]/uml:resolve-general(.)/@xmi:id =
                  $typ/generalization[not(xoev:xsdRestriction(.))]/uml:resolve-general(.)/@xmi:id)
               else
                  true()) and
               (every $p in (xoev:elements(.), xoev:attributes(.))
                  satisfies
                  (some $pt in $typ/(xoev:elements(.), xoev:attributes(.))
                     satisfies
                     $p/@name = $pt/@name and
                     $p/xoev:lowerBound(.) = $pt/xoev:lowerBound(.) and
                     $p/xoev:upperBound(.) = $pt/xoev:upperBound(.) and
                     $p/uml:resolve-type(.)/@xmi:id = $pt/uml:resolve-type(.)/@xmi:id))]"/>
         <sch:assert role="warning" id="Rule-TypenMitGleichenInhalten" test="empty($typen-mit-gleichen-inhalten)">Es existieren Typen mit den gleichen Inhalten. Das heißt, sie erweitern den gleichen Basistypen (sofern vorhanden) und alle Elemente und/oder Attribute sind gleich (haben die gleichen Namen, dieselben Multiplizitäten und dieselben Typen). Typ <sch:value-of select="$typ/@name"/> ist identisch mit den Typen <sch:value-of select="$typen-mit-gleichen-inhalten/@name"/>.</sch:assert>
      </sch:rule>
   </sch:pattern>
   <sch:pattern id="Regel2-VersionsangabeImNachrichtenkopfEntsprichtVersionStandardXBasisdaten">
      <sch:title>Versionsangabe im Nachrichtenkopf entspricht Version des Standards</sch:title>
      <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[@name = 'Nachricht.XBasisdaten']">
         <sch:assert role="error" id="VersionsangabeImNachrichtenkopfEntsprichtVersionStandardXBasisdaten" test="ownedAttribute[@name = 'version']/(defaultValue/@value, defaultValue/body)[1] = ancestor::packagedElement/xoev:xoevVersionStandard(.)/@version">Die Versionsangabe im Nachrichtenkopf muss der Version des Standards entsprechen. Der Nachrichtenkopf <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
      </sch:rule>
   </sch:pattern>

   <sch:pattern id="Regel-NachrichtMitTitel">
      <sch:title>Nachricht hat einen Titel</sch:title>
      <sch:rule context="
            /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[not(xoev:xsdDraft(.)) and xoev:xsdMessage(.)] |
            /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[not(xoev:xsdDraft(.)) and xoev:xsdMessage(.)]">
         <sch:assert role="error" id="NachrichtMitTitel" test="xoev:xsdTitled(.)">Eine Nachricht muss einen Titel besitzen (xsdTitled/@title). Betroffene Nachricht: <sch:value-of select="xgen:model-path(.)"/></sch:assert>
      </sch:rule>
   </sch:pattern>

   <sch:pattern id="Regel-TitelNichtLeer">
      <sch:title>Ein Titel darf nicht leer sein</sch:title>
      <sch:rule context="
            /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[not(xoev:xsdDraft(.)) and xoev:xsdTitled(.)] |
            /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[not(xoev:xsdDraft(.)) and xoev:xsdTitled(.)]">
         <sch:assert role="error" id="TitelNichtLeer" test="xoev:xsdTitled(.)/@title and normalize-space(xoev:xsdTitled(.)/@title) != ''">Bei der Nutzung des Stereotyps xsdTitle darf die Eigenschaft @title nicht leer sein (oder ausschließlich aus Whitespaces bestehen). Betroffene Klasse: <sch:value-of select="xgen:model-path(.)"/></sch:assert>
      </sch:rule>
   </sch:pattern>
</sch:schema>
