<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: xoev-profil.ndr.sch 7434 2017-08-24 11:06:25Z fbuettner $ -->
<sch:schema xmlns:sch="http://purl.oclc.org/dsdl/schematron" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" queryBinding="xslt2">

    <sch:title>KoSIT-WSDL-Regeln</sch:title>
    <xsl:include href="xgenerator-library.xgen-core.xsl"/>
    <xsl:include href="xgenerator-library.uml-access-layer.xsl"/>
    <xsl:include href="xoev-profil.profile-access-layer.xsl"/>
    <xsl:include href="xoev-profil.helpers.xsl"/>
    <xsl:include href="osci-transport-profil.profile-access-layer.xsl"/>
    <xsl:include href="kosit-zubehoer.helpers.xsl"/>
    <xsl:include href="kosit-dokumentations-profil.profile-access-layer.xsl"/>

    <sch:ns uri="http://www.xoev.de/de/xgenerator/framework/1/library" prefix="xgen"/>
    <sch:ns uri="http://www.omg.org/spec/XMI/20131001" prefix="xmi"/>
    <sch:ns uri="http://www.eclipse.org/uml2/5.0.0/UML" prefix="uml"/>
    <sch:ns uri="http://www.xoev.de/de/xoev-profil/3_0_2" prefix="xoev"/>
    <sch:ns uri="http://www.xoev.de/de/kosit-zubehoer/wsdl/3_1_0" prefix="kosit-wsdl"/>
    <sch:ns uri="http://www.xoev.de/de/kosit-zubehoer/3_1_0" prefix="kosit"/>

    <!-- Quelle XGen2-Datei: OSCI-Transport.invariants -->

    <!-- Umsetzungsstand: vollständig -->

    <!-- Quelle XGen2: wsdlVorlagedateiZugeordnet -->
    <sch:pattern id="pattern-WSDLVorlagedateiDerNachrichtZugeordnet">
        <sch:title>WSDL-Vorlagedatei der Nachricht zugeordnet</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.)[@wsdlVorlagedatei = 'zugeordnet' or empty(@wsdlVorlagedatei)]]">
            <sch:assert role="error" id="rule-WSDLVorlagedateiDerNachrichtZugeordnet" test="kosit:dependencies-by-supplier(.)/uml:resolve-client(.)[kosit-wsdl:wsdlService(.)]">Falls nicht explizit gekennzeichnet, müssen alle Nachrichten mindestens einem Dienst zugeordnet sein. Die Nachricht <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <sch:pattern id="pattern-WSDLVorlagedateiDerNachrichtTemporaerNichtZugeordnet">
        <sch:title>WSDL-Vorlagedatei der Nachricht zugeordnet</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.)/@wsdlVorlagedatei = 'temporaerNichtZugeordnet']">
            <sch:assert role="warning" id="rule-WSDLVorlagedateiDerNachrichtTemporaerNichtZugeordnet" test="false()">Der Nachricht <sch:value-of select="xgen:model-path(.)"/> ist eine WSDL-Vorlagedatei temporär nicht zugeordnet.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <sch:pattern id="pattern-WSDLVorlagedateiFalschZugeordnet">
        <sch:title>WSDL-Vorlagedatei der Nachricht zugeordnet</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.)/@wsdlVorlagedatei = ('dauerhaftNichtZugeordnet','temporaerNichtZugeordnet')]">
            <sch:assert role="error" id="rule-WSDLVorlagedateiFalschZugeordnet" test="empty(kosit:dependencies-by-supplier(.)/uml:resolve-client(.)[kosit-wsdl:wsdlService(.)])">Wenn für eine Nachricht bestimmt wurde, dass eine WSDL-Vorlage-Datei temporär oder dauerhaft nicht zuzuordnen ist, darf die Nachricht dementsprechend keinem Dienst zugeordnet sein. Die Nachricht <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>     

    <!-- Quelle XGen2: passendesKommunikationsszenario -->
    <sch:pattern id="Regel2-DienstMitGueltigemKommunikationsszenario">
        <sch:title>Dienst mit gültigem Kommunikationsszenario</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@Kommunikationsszenario]">
            <sch:assert role="error" id="DienstMitGueltigemKommunikationsszenario" test="kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'one-way-active' or kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'one-way-passive' or kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'request-response' or kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'request-response-noprotocol'">Erlaubte Kommunikationsszenarien sind one-way-active, one-way-passive, request-response und request-response-noprotocol. Der Dienst <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: passendesKommunikationsszenario -->
    <sch:pattern id="Regel3-TransportszenarioMitGueltigemKommunikationsszenario">
        <sch:title>Transportszenario mit gueltigem Kommunikationsszenario</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario]">
            <sch:assert role="error" id="TransportszenarioMitGueltigemKommunikationsszenario" test="kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'one-way-active' or kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'one-way-passive' or kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'request-response' or kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'request-response-noprotocol'">Erlaubte Kommunikationsszenarien sind one-way-active, one-way-passive, request-response und request-response-noprotocol. Das OSCI-Transportszenario <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: passendeSignaturInhaltsdaten -->
    <sch:pattern id="Regel4-DienstMitGueltigemSignaturlevelFuerInhaltsdaten">
        <sch:title>Dienst mit gueltigem Signaturlevel für Inhaltsdaten</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@SignaturInhaltsdaten]">
            <sch:assert role="error" id="DienstMitGueltigemSignaturlevelFuerInhaltsdaten" test="kosit-wsdl:wsdlService(.)/@SignaturInhaltsdaten = 'none' or kosit-wsdl:wsdlService(.)/@SignaturInhaltsdaten = 'advanced' or kosit-wsdl:wsdlService(.)/@SignaturInhaltsdaten = 'qualified'">Erlaubtes Signaturlevel für Inhaltsdaten ist none, advanced oder qualified. Der Dienst <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: passendeSignaturInhaltsdaten -->
    <sch:pattern id="Regel5-TransportszenarioMitGueltigemSignaturlevelFuerInhaltsdaten">
        <sch:title>Transportszenario mit gueltigem Signaturlevel für Inhaltsdaten</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:osciTransportScenario(.)/@SignaturInhaltsdaten]">
            <sch:assert role="error" id="TransportszenarioMitGueltigemSignaturlevelFuerInhaltsdaten" test="kosit-wsdl:osciTransportScenario(.)/@SignaturInhaltsdaten = 'none' or kosit-wsdl:osciTransportScenario(.)/@SignaturInhaltsdaten = 'advanced' or kosit-wsdl:osciTransportScenario(.)/@SignaturInhaltsdaten = 'qualified'">Erlaubtes Signaturlevel für Inhaltsdaten ist none, advanced oder qualified. Das OSCI-Transportszenario <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: passendeSignaturNutzdaten -->
    <sch:pattern id="Regel6-DienstMitGueltigemSignaturlevelFuerNutzdaten">
        <sch:title>Dienst mit gueltigem Signaturlevel für Nutzdaten</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@SignaturNutzdaten]">
            <sch:assert role="error" id="DienstMitGueltigemSignaturlevelFuerNutzdaten" test="kosit-wsdl:wsdlService(.)/@SignaturNutzdaten = 'none' or kosit-wsdl:wsdlService(.)/@SignaturNutzdaten = 'advanced' or kosit-wsdl:wsdlService(.)/@SignaturNutzdaten = 'qualified'">Erlaubtes Signaturlevel für Nutzdaten ist none, advanced oder qualified. Der Dienst <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: passendeSignaturNutzdaten -->
    <sch:pattern id="Regel7-TransportszenarioMitGueltigemSignaturlevelFuerNutzdaten">
        <sch:title>Transportszenario mit gueltigem Signaturlevel für Nutzdaten</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:osciTransportScenario(.)/@SignaturNutzdaten]">
            <sch:assert role="error" id="TransportszenarioMitGueltigemSignaturlevelFuerNutzdaten" test="kosit-wsdl:osciTransportScenario(.)/@SignaturNutzdaten = 'none' or kosit-wsdl:osciTransportScenario(.)/@SignaturNutzdaten = 'advanced' or kosit-wsdl:osciTransportScenario(.)/@SignaturNutzdaten = 'qualified'">Erlaubtes Signaturlevel für Nutzdaten ist none, advanced oder qualified. Das OSCI-Transportszenario <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: optionalerContainerBestimmt -->
    <sch:pattern id="Regel8-NutzungOptionalerContainerKorrektGeregeltInDienst">
        <sch:title>Nutzung optionaler Container korrekt geregelt in Dienst</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@OptionalerContainer]">
            <sch:assert role="error" id="NutzungOptionalerContainerKorrektGeregeltInDienst" test="kosit-wsdl:wsdlService(.)/@OptionalerContainer = 'true' or kosit-wsdl:wsdlService(.)/@OptionalerContainer = 'false'">Nutzung des optionalen Containers muss geregelt sein ('true' oder 'false'). Der Dienst <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: optionalerContainerBestimmt -->
    <sch:pattern id="Regel9-NutzungOptionalerContainerKorrektGeregeltInTransportszenario">
        <sch:title>Nutzung optionaler Container korrekt geregelt in Transportszenario</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:osciTransportScenario(.)/@OptionalerContainer]">
            <sch:assert role="error" id="NutzungOptionalerContainerKorrektGeregeltInTransportszenario" test="kosit-wsdl:osciTransportScenario(.)/@OptionalerContainer = 'true' or kosit-wsdl:osciTransportScenario(.)/@OptionalerContainer = 'false'">Nutzung des optionalen Containers muss geregelt sein ('true' oder 'false'). Das OSCI-Transportszenario <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: oneWayActiveMessages -->
    <sch:pattern id="Regel10-KorrekteServiceMessagesInOneWayActive">
        <sch:title>Korrekte Service Messages in one-way-active</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'one-way-active' or xoev:allParents(.)[kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'one-way-active']]">
            <sch:assert role="error" id="KorrekteServiceMessagesInOneWayActive" test="
                    every $dep in xoev:dependencies-by-client(.)
                        satisfies $dep/kosit-wsdl:wsdlServiceMessage(.) and not($dep/kosit-wsdl:wsdlServiceInputMessage(.)) and not($dep/kosit-wsdl:wsdlServiceOutputMessage(.)) and not($dep/kosit-wsdl:wsdlServiceFaultMessage(.))">One-way-active-Szenarios beziehen ausschließlich allgemeine Service-Messages ein. Der Dienst <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: requestResponseMessages -->
    <sch:pattern id="Regel11-KorrekteServiceMessagesInRequestResponse">
        <sch:title>Korrekte Service Messages in request-response</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'request-response' or xoev:allParents(.)[kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'request-response']]">
            <sch:assert role="error" id="KorrekteServiceMessagesInRequestResponse" test="
                    every $dep in xoev:dependencies-by-client(.)
                        satisfies not($dep/kosit-wsdl:wsdlServiceMessage(.)) and
                        count(($dep/kosit-wsdl:wsdlServiceInputMessage(.), $dep/kosit-wsdl:wsdlServiceOutputMessage(.), $dep/kosit-wsdl:wsdlServiceFaultMessage(.))) = 1">Request-response-Szenarios beziehen ausschließlich Input- , Output- und Fault-Messages ein. Der Dienst <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: unterstützteSzenarien -->
    <sch:pattern id="Regel12-NichtUnterstuetzteSzenarienInDiensten">
        <sch:title>Nicht Unterstuetzte Szenarien in Diensten</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'one-way-passive' or kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'request-response-noprotocol']">
            <sch:assert role="error" id="NichtUnterstuetzteSzenarienInDiensten" test="false()">One-way-passive und request-response-noprotocol noch nicht unterstützt. Der Dienst <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: unterstützteSzenarien -->
    <sch:pattern id="Regel12-NichtUnterstuetzteSzenarienInTransportszenarien">
        <sch:title>Nicht Unterstuetzte Szenarien in Transportszenarien</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'one-way-passive' or kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'request-response-noprotocol']">
            <sch:assert role="error" id="NichtUnterstuetzteSzenarienInTransportszenarien" test="false()">One-way-passive und request-response-noprotocol noch nicht unterstützt. Der Dienst <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <sch:pattern id="pattern-MaximalEinWsdlSchemaTarget">
        <sch:title>Korrekte WSDL-Modellierung im Kontext WSDL-Service- and -Operations</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlServiceAndOperations(.)]">
            <sch:assert role="error" id="rule-MaximalEinWsdlSchemaTarget" test="count(xoev:dependencies-by-client(.)[kosit-wsdl:wsdlSchemaTarget(.)]) &lt;= 1">Ein Dienst mit dem Stereotyp wsdlServiceAndOperations darf maximal ein WSDL-Schema-Target (Abhängigkeitsbeziehung mit dem Stereotyp wsdlSchemaTarget) besitzen. Der Dienst <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <sch:pattern id="pattern-WsdlSchemaTargetUndWsdlSchemaImportNurZwischenDienstUndSchemaPaket">
        <sch:title>Korrekte WSDL-Modellierung im Kontext WSDL-Service- and -Operations</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlSchemaTarget(.) or kosit-wsdl:wsdlSchemaImport(.)]">
            <sch:assert role="error" id="rule-WsdlSchemaTargetUndWsdlSchemaImportNurZwischenDienstUndSchemaPaket" test="uml:resolve-client(.)[kosit-wsdl:wsdlServiceAndOperations(.)] and uml:resolve-supplier(.)[xoev:xsdSchema(.)]">Eine Abhängigkeitsbeziehung mit dem Stereotyp wsdlSchemaImport oder wsdlSchemaTarget muss einen Dienst (wsdlServiceAndOperations) mit einem Schema-Paket (xsdSchema) verbinden. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

</sch:schema>
