<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns="http://docbook.org/ns/docbook" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:kosit-use-cases="http://www.xoev.de/de/kosit-zubehoer/use-cases/3_1_0" xmlns:kosit="http://www.xoev.de/de/kosit-zubehoer/3_1_0" xmlns:xoev="http://www.xoev.de/de/xoev-profil/3_0_2" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" xmlns:xgen="http://www.xoev.de/de/xgenerator/framework/1/library" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML" version="2.0" exclude-result-prefixes="xmi xsl kosit xoev kosit-use-cases xgen uml xsd">
    <xsl:template match="/" mode="kosit:default">
        <xsl:call-template name="kosit-use-cases:section-for-actors"/>
        <xsl:apply-templates select="root()/descendant::packagedElement[uml:is-Actor(.)][kosit-use-cases:qualifizierter-name(., '/') != '']" mode="kosit-use-cases:actor">
            <xsl:sort select="kosit-use-cases:qualifizierter-name(., '/')"/>
        </xsl:apply-templates>
        <xsl:apply-templates select="root()/(descendant::packagedElement, descendant::ownedUseCase)[uml:is-UseCase(.)]" mode="kosit-use-cases:section-for-use-case">
            <xsl:with-param name="with-id" select="true()"/>
        </xsl:apply-templates>
        <xsl:apply-templates select="root()/(descendant::packagedElement, descendant::ownedUseCase)[uml:is-UseCase(.)]" mode="kosit-use-cases:section-for-use-case">
            <xsl:with-param name="with-id" select="false()"/>
        </xsl:apply-templates>
        <xsl:apply-templates select="$xoev:my-xmodel/descendant::packagedElement[kosit:docGeneration(.)]/descendant::packagedElement[uml:is-Class(.) and not(xoev:xsdAnyContents(.) or xoev:xsdChoice(.) or xoev:xsdCode(.) or xoev:xsdGlobalElement(.) or xoev:xsdGroup(.) or xoev:xsdMessage(.) or xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.) or xoev:xsdUnion(.) or ownedAttribute[xoev:is-element(.) or xoev:xsdAttribute(.)])]" mode="kosit-use-cases:section-for-artefact"> </xsl:apply-templates>
    </xsl:template>
    <xsl:template name="kosit-use-cases:section-for-actors">
        <xsl:call-template name="xgen:result-document">
            <xsl:with-param name="local-path" select="xsd:anyURI('dokumente/UseCases/AlleAkteure.xml')"/>
            <xsl:with-param name="content">
                <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
                <xsl:variable name="doctype" as="xsd:string*"><![CDATA[<!DOCTYPE section [<!ENTITY % complete SYSTEM "../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
                <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
                <xsl:element name="section">
                    <xsl:attribute name="version">5</xsl:attribute>
                    <xsl:attribute name="xml:lang">de</xsl:attribute>
                    <xsl:attribute name="xml:id">section.alle.akteure</xsl:attribute>
                    <xsl:namespace name="xlink">http://www.w3.org/1999/xlink</xsl:namespace>
                    <title>Akteure</title>
                    <xsl:for-each select="root()/descendant::packagedElement[uml:is-Actor(.)][kosit-use-cases:qualifizierter-name(., '/') != '']">
                        <xsl:element name="include" namespace="http://www.w3.org/2001/XInclude">
                            <xsl:attribute name="href" select="concat(kosit-use-cases:qualifizierter-name(., '/'), '.xml')"/>
                        </xsl:element>
                    </xsl:for-each>
                </xsl:element>
            </xsl:with-param>
        </xsl:call-template>
    </xsl:template>
    <xsl:template match="packagedElement" mode="kosit-use-cases:actor">
        <xsl:call-template name="xgen:result-document">
            <xsl:with-param name="local-path" select="xsd:anyURI(concat('dokumente/UseCases/', kosit-use-cases:qualifizierter-name(., '/'), '.xml'))"/>
            <xsl:with-param name="content">
                <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
                <xsl:variable name="doctype" as="xsd:string*"><![CDATA[<!DOCTYPE section [<!ENTITY % complete SYSTEM "../../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
                <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
                <xsl:element name="section">
                    <xsl:attribute name="version">5</xsl:attribute>
                    <xsl:attribute name="xml:lang">de</xsl:attribute>
                    <xsl:attribute name="xml:id" select="concat('actor.', kosit-use-cases:qualifizierter-name(., '.'))"/>
                    <xsl:namespace name="xlink">http://www.w3.org/1999/xlink</xsl:namespace>
                    <title>
                        <xsl:value-of select="@name"/>
                    </title>
                    <xsl:for-each select="ownedComment/body[. != '']">
                        <xsl:value-of select="xgen:unescaped-xml(.)"/>
                    </xsl:for-each>
                </xsl:element>
            </xsl:with-param>
        </xsl:call-template>
    </xsl:template>
    <xsl:function name="kosit-use-cases:qualifizierter-name" as="xsd:string">
        <xsl:param name="element" as="node()"/>
        <xsl:param name="trenner" as="xsd:string"/>
        <xsl:choose>
            <xsl:when test="$element/parent::packagedElement">
                <xsl:value-of select="concat(kosit-use-cases:qualifizierter-name($element/parent::packagedElement, $trenner), $trenner ,replace($element/@name,'[\s&amp;/-]+','_'))"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="replace($element/@name,'[\s&amp;/-]+','_')"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:function>
    <xsl:template match="packagedElement | ownedUseCase" mode="kosit-use-cases:section-for-use-case">
        <xsl:param name="with-id" as="xsd:boolean" required="yes"/>
        <xsl:call-template name="xgen:result-document">
            <xsl:with-param name="local-path" select="
                    xsd:anyURI(concat('dokumente/UseCases/', kosit-use-cases:qualifizierter-name(., '/'), if ($with-id) then
                        ''
                    else
                        '_noId', '.xml'))"/>
            <xsl:with-param name="content">
                <xsl:variable name="use-case" select="."/>
                <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
                <xsl:variable name="doctype" as="xsd:string*"><![CDATA[<!DOCTYPE section [
<!ENTITY % complete SYSTEM "]]><xsl:for-each select="tokenize(kosit-use-cases:qualifizierter-name(., '/'), '/')">../</xsl:for-each>../../../ent/complete.ent<![CDATA[">
%complete;]>]]></xsl:variable>
                <xsl:value-of select="xgen:unescaped-xml(string-join($doctype, ''))"/>
                <xsl:element name="section">
                    <xsl:attribute name="version">5</xsl:attribute>
                    <xsl:attribute name="xml:lang">de</xsl:attribute>
                    <xsl:if test="$with-id">
                        <xsl:attribute name="xml:id" select="concat('usecase.', kosit-use-cases:qualifizierter-name(., '.'))"/>
                    </xsl:if>
                    <xsl:namespace name="xlink">http://www.w3.org/1999/xlink</xsl:namespace>
                    <title>
                        <xsl:value-of select="$use-case/@name"/>
                    </title>
                    <para>
                        <informaltable>
                            <xsl:variable name="used-artefacts" select="$use-case/kosit-use-cases:dependencies-by-client(.)[uml:is-Usage(.) and empty(kosit-use-cases:create(.))]"/>
                            <xsl:if test="include/uml:resolve-addition(.)">
                                <tgroup cols="3">
                                    <colspec colname="usecase" colnum="1" colwidth="128mm"/>
                                    <colspec colname="reference" colnum="2" colwidth="20mm"/>
                                    <colspec colname="page" colnum="3" colwidth="12mm"/>
                                    <spanspec spanname="all" namest="usecase" nameend="page"/>
                                    <thead>
                                        <row>
                                            <entry spanname="all" align="center">Eingebundene Use Cases</entry>
                                        </row>
                                    </thead>
                                    <tbody>
                                        <row>
                                            <entry>
                                                <emphasis role="bold">Use Case</emphasis>
                                            </entry>
                                            <entry>
                                                <emphasis role="bold">Ref.</emphasis>
                                            </entry>
                                            <entry>
                                                <emphasis role="bold">Seite</emphasis>
                                            </entry>
                                        </row>
                                        <xsl:for-each select="include/uml:resolve-addition(.)">
                                            <xsl:sort select="@name"/>
                                            <row>
                                                <entry>
                                                    <xsl:value-of select="replace(@name,'&amp;','&#38;')"/>
                                                </entry>
                                                <xsl:variable name="use-case-id" select="concat('usecase.', kosit-use-cases:docbook-id(.))"/>
                                                <entry>
                                                    <xref linkend="{$use-case-id}" role="AbschnittNummer"/>
                                                </entry>
                                                <entry>
                                                    <xref linkend="{$use-case-id}" role="Seitenzahl"/>
                                                </entry>
                                            </row>
                                            <xsl:for-each select="ownedComment/body[. != '']">
                                                <row>
                                                    <entry spanname="all">
                                                        <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                                    </entry>
                                                </row>
                                            </xsl:for-each>
                                        </xsl:for-each>
                                    </tbody>
                                </tgroup>
                            </xsl:if>
                            <xsl:if test="$used-artefacts">
                                <tgroup cols="3">
                                    <colspec colname="usecase" colnum="1" colwidth="128mm"/>
                                    <colspec colname="reference" colnum="2" colwidth="20mm"/>
                                    <colspec colname="page" colnum="3" colwidth="12mm"/>
                                    <spanspec spanname="all" namest="usecase" nameend="page"/>
                                    <thead>
                                        <row>
                                            <entry spanname="all" align="center">Verwendete Artefakte</entry>
                                        </row>
                                    </thead>
                                    <tbody>
                                        <row>
                                            <entry>
                                                <emphasis role="bold">Artefakt</emphasis>
                                            </entry>
                                            <entry>
                                                <emphasis role="bold">Ref.</emphasis>
                                            </entry>
                                            <entry>
                                                <emphasis role="bold">Seite</emphasis>
                                            </entry>
                                        </row>
                                        <xsl:for-each select="$used-artefacts">
                                            <xsl:sort select="uml:resolve-supplier(.)/@name"/>
                                            <xsl:variable name="class" select="uml:resolve-supplier(.)"/>
                                            <xsl:variable name="class-id" select="kosit-use-cases:docbook-id($class)"/>
                                            <row>
                                                <entry>
                                                    <xsl:value-of select="$class/@name"/>
                                                </entry>
                                                <entry>
                                                    <xref linkend="{$class-id}" role="AbschnittNummer"/>
                                                </entry>
                                                <entry>
                                                    <xref linkend="{$class-id}" role="Seitenzahl"/>
                                                </entry>
                                            </row>
                                            <xsl:for-each select="ownedComment/body[. != '']">
                                                <row>
                                                    <entry spanname="all">
                                                        <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                                    </entry>
                                                </row>
                                            </xsl:for-each>
                                        </xsl:for-each>
                                    </tbody>
                                </tgroup>
                            </xsl:if>
                            <tgroup cols="1">
                                <colspec colname="documentation" colnum="1" colwidth="160mm"/>
                                <thead>
                                    <row>
                                        <entry>Beschreibung</entry>
                                    </row>
                                </thead>
                                <tbody>
                                    <row>
                                        <entry>
                                            <xsl:choose>
                                                <xsl:when test="
                                                        some $c in ownedComment/body
                                                            satisfies $c = '[nd]'"/>
                                                <xsl:when test="ownedComment/body[. != '']">
                                                    <xsl:for-each select="ownedComment/body[. != '']">
                                                        <xsl:sort select="."/>
                                                        <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                                    </xsl:for-each>
                                                </xsl:when>
                                                <xsl:otherwise>
                                                    <annotation role="todo">
                                                        <info>
                                                            <title>Dokumentation fehlt!</title>
                                                        </info>
                                                        <para>Dieses ToDo wurde automatisch generiert.</para>
                                                    </annotation>
                                                </xsl:otherwise>
                                            </xsl:choose>
                                        </entry>
                                    </row>
                                </tbody>
                            </tgroup>
                        </informaltable>
                    </para>
                </xsl:element>
            </xsl:with-param>
        </xsl:call-template>
    </xsl:template>
    <xsl:function name="kosit-use-cases:docbook-id" as="xsd:string">
        <xsl:param name="element" as="node()"/>
        <xsl:value-of select="replace(kosit-use-cases:qualifizierter-name($element,'.'), '[\s&lt;&gt;#%?&amp;{}\-\\()]+', '_')"/>
    </xsl:function>
    <xsl:key name="kosit-use-cases:dependency-by-client" match="packagedElement[@xmi:type = ('uml:Dependency', 'uml:Usage')]" use="@client"/>
    <xsl:function name="kosit-use-cases:dependencies-by-client" as="element()*">
        <xsl:param name="element" as="element()"/>
        <xsl:sequence select="key('kosit-use-cases:dependency-by-client', $element/@xmi:id, root($element))"/>
    </xsl:function>
    <xsl:template match="packagedElement" mode="kosit-use-cases:section-for-artefact">
        <xsl:variable name="artefakt" select="."/>
        <xsl:call-template name="xgen:result-document">
            <xsl:with-param name="local-path" select="xsd:anyURI(concat('dokumente/UseCases/', kosit-use-cases:qualifizierter-name(., '/'), '.xml'))"/>
            <xsl:with-param name="content">
                <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
                <xsl:variable name="doctype" as="xsd:string*"><![CDATA[<!DOCTYPE section [
<!ENTITY % complete SYSTEM "]]><xsl:for-each select="tokenize(kosit-use-cases:qualifizierter-name(., '/'), '/')">../</xsl:for-each>../ent/complete.ent<![CDATA[">
%complete;]>]]></xsl:variable>
                <xsl:value-of select="xgen:unescaped-xml(string-join($doctype, ''))"/>
                <xsl:element name="section">
                    <xsl:attribute name="version">5</xsl:attribute>
                    <xsl:attribute name="xml:lang">de</xsl:attribute>
                    <xsl:attribute name="xml:id" select="kosit-use-cases:docbook-id(.)"/>
                    <xsl:namespace name="xlink">http://www.w3.org/1999/xlink</xsl:namespace>
                    <title>
                        <xsl:value-of select="xgen:unescaped-xml((xoev:xsdTitled(.)/@title[. != ''], @name)[1])"/>
                    </title>
                    <subtitle>
                        <xsl:text>Artefakt: </xsl:text>
                        <emphasis role="codebf">
                            <xsl:value-of select="@name"/>
                        </emphasis>
                        <xsl:if test="@isAbstract = 'true'">
                            <xsl:text> (abstrakt)</xsl:text>
                        </xsl:if>
                    </subtitle>
                    <xsl:choose>
                        <xsl:when test="
                                some $c in ownedComment/body
                                    satisfies $c = '[nd]'"/>
                        <xsl:when test="ownedComment/body[. != '']">
                            <xsl:for-each select="ownedComment/body[. != '']">
                                <xsl:sort select="."/>
                                <xsl:value-of select="xgen:unescaped-xml(.)"/>
                            </xsl:for-each>
                        </xsl:when>
                        <xsl:otherwise>
                            <annotation role="todo">
                                <info>
                                    <title>Dokumentation des Typs fehlt!</title>
                                </info>
                                <para>Dieses ToDo wurde automatisch generiert.</para>
                            </annotation>
                        </xsl:otherwise>
                    </xsl:choose>
                    <xsl:if test="ownedAttribute">
                        <informaltable xml:id="{concat('table.',kosit-use-cases:docbook-id($artefakt))}">
                            <tgroup cols="3">
                                <colspec colname="attribute" colnum="1" colwidth="71mm"/>
                                <colspec colname="type" colnum="2" colwidth="71mm"/>
                                <colspec colname="cardinality" colnum="3" colwidth="18mm"/>
                                <spanspec spanname="all" namest="attribute" nameend="cardinality"/>
                                <thead>
                                    <row>
                                        <entry spanname="all" align="center">
                                            <xsl:value-of select="
                                                    concat('Attribut', if (count($artefakt/ownedAttribute) gt 1) then
                                                        'e'
                                                    else
                                                        '', ' von ')"/>
                                            <emphasis role="codebf">
                                                <xsl:value-of select="$artefakt/@name"/>
                                            </emphasis>
                                        </entry>
                                    </row>
                                    <row>
                                        <entry>Attribut</entry>
                                        <entry>Typ</entry>
                                        <entry>Häufigkeit</entry>
                                    </row>
                                </thead>
                                <tbody>
                                    <xsl:for-each select="$artefakt/ownedAttribute">
                                        <row>
                                            <entry>
                                                <xsl:value-of select="
                                                        if (@name != '') then
                                                            @name
                                                        else
                                                            ''"/>
                                            </entry>
                                            <entry>
                                                <emphasis role="codebf">
                                                    <xsl:value-of select="
                                                            if (uml:resolve-type(.)/@name != '') then
                                                                uml:resolve-type(.)/@name
                                                            else
                                                                ''"/>
                                                </emphasis>
                                            </entry>
                                            <entry>
                                                <xsl:variable name="lower" select="
                                                        if (lowerValue/@value = 1 or not(lowerValue)) then
                                                            '1'
                                                        else
                                                            if (lowerValue and not(lowerValue/@value)) then
                                                                '0'
                                                            else
                                                                lowerValue/@value"/>
                                                <xsl:variable name="upper" select="
                                                        if (upperValue/@value = '*') then
                                                            'n'
                                                        else
                                                            if (upperValue/@value = '1' or not(upperValue)) then
                                                                '1'
                                                            else
                                                                if (upperValue and not(upperValue/@value)) then
                                                                    '0'
                                                                else
                                                                    upperValue/@value"/>
                                                <xsl:value-of select="$lower"/>
                                                <xsl:if test="$lower != $upper">..<xsl:value-of select="$upper"/></xsl:if>
                                            </entry>
                                    
                                        </row>
                                    </xsl:for-each>
                                </tbody>
                            </tgroup>
                        </informaltable>
                    </xsl:if>
                </xsl:element>
            </xsl:with-param>
        </xsl:call-template>
    </xsl:template>
</xsl:stylesheet>
