<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<xsl:stylesheet xmlns:iso="http://purl.oclc.org/dsdl/schematron"
                xmlns:kosit="http://www.xoev.de/de/kosit-zubehoer/3_1_0"
                xmlns:kosit-wsdl="http://www.xoev.de/de/kosit-zubehoer/wsdl/3_1_0"
                xmlns:saxon="http://saxon.sf.net/"
                xmlns:schold="http://www.ascc.net/xml/schematron"
                xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML"
                xmlns:xgen="http://www.xoev.de/de/xgenerator/framework/1/library"
                xmlns:xhtml="http://www.w3.org/1999/xhtml"
                xmlns:xmi="http://www.omg.org/spec/XMI/20131001"
                xmlns:xoev="http://www.xoev.de/de/xoev-profil/3_0_2"
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:xsd="http://www.w3.org/2001/XMLSchema"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="2.0"><!--Implementers: please note that overriding process-prolog or process-root is 
    the preferred method for meta-stylesheets to use where possible. -->
   <xsl:param name="archiveDirParameter"/>
   <xsl:param name="archiveNameParameter"/>
   <xsl:param name="fileNameParameter"/>
   <xsl:param name="fileDirParameter"/>
   <xsl:variable name="document-uri">
      <xsl:value-of select="document-uri(/)"/>
   </xsl:variable>
   <!--PHASES-->
   <!--PROLOG-->
   <xsl:output xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
               method="xml"
               omit-xml-declaration="no"
               standalone="yes"
               indent="yes"/>
   <!--XSD TYPES FOR XSLT2-->
   <!--KEYS AND FUNCTIONS-->
   <!--DEFAULT RULES-->
   <!--MODE: SCHEMATRON-SELECT-FULL-PATH-->
   <!--This mode can be used to generate an ugly though full XPath for locators-->
   <xsl:template match="*" mode="schematron-select-full-path">
      <xsl:apply-templates select="." mode="schematron-get-full-path-3"/>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-->
   <!--This mode can be used to generate an ugly though full XPath for locators-->
   <xsl:template match="*" mode="schematron-get-full-path">
      <xsl:apply-templates select="parent::*" mode="schematron-get-full-path"/>
      <xsl:text>/</xsl:text>
      <xsl:choose>
         <xsl:when test="namespace-uri()=''">
            <xsl:value-of select="name()"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:text>*:</xsl:text>
            <xsl:value-of select="local-name()"/>
            <xsl:text>[namespace-uri()='</xsl:text>
            <xsl:value-of select="namespace-uri()"/>
            <xsl:text>']</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:variable name="preceding"
                    select="count(preceding-sibling::*[local-name()=local-name(current())                                   and namespace-uri() = namespace-uri(current())])"/>
      <xsl:text>[</xsl:text>
      <xsl:value-of select="1+ $preceding"/>
      <xsl:text>]</xsl:text>
   </xsl:template>
   <xsl:template match="@*" mode="schematron-get-full-path">
      <xsl:apply-templates select="parent::*" mode="schematron-get-full-path"/>
      <xsl:text>/</xsl:text>
      <xsl:choose>
         <xsl:when test="namespace-uri()=''">@<xsl:value-of select="name()"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:text>@*[local-name()='</xsl:text>
            <xsl:value-of select="local-name()"/>
            <xsl:text>' and namespace-uri()='</xsl:text>
            <xsl:value-of select="namespace-uri()"/>
            <xsl:text>']</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-2-->
   <!--This mode can be used to generate prefixed XPath for humans-->
   <xsl:template match="node() | @*" mode="schematron-get-full-path-2">
      <xsl:for-each select="ancestor-or-self::*">
         <xsl:text>/</xsl:text>
         <xsl:value-of select="name(.)"/>
         <xsl:if test="preceding-sibling::*[name(.)=name(current())]">
            <xsl:text>[</xsl:text>
            <xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>
            <xsl:text>]</xsl:text>
         </xsl:if>
      </xsl:for-each>
      <xsl:if test="not(self::*)">
         <xsl:text/>/@<xsl:value-of select="name(.)"/>
      </xsl:if>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-3-->
   <!--This mode can be used to generate prefixed XPath for humans 
	(Top-level element has index)-->
   <xsl:template match="node() | @*" mode="schematron-get-full-path-3">
      <xsl:for-each select="ancestor-or-self::*">
         <xsl:text>/</xsl:text>
         <xsl:value-of select="name(.)"/>
         <xsl:if test="parent::*">
            <xsl:text>[</xsl:text>
            <xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>
            <xsl:text>]</xsl:text>
         </xsl:if>
      </xsl:for-each>
      <xsl:if test="not(self::*)">
         <xsl:text/>/@<xsl:value-of select="name(.)"/>
      </xsl:if>
   </xsl:template>
   <!--MODE: GENERATE-ID-FROM-PATH -->
   <xsl:template match="/" mode="generate-id-from-path"/>
   <xsl:template match="text()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.text-', 1+count(preceding-sibling::text()), '-')"/>
   </xsl:template>
   <xsl:template match="comment()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.comment-', 1+count(preceding-sibling::comment()), '-')"/>
   </xsl:template>
   <xsl:template match="processing-instruction()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.processing-instruction-', 1+count(preceding-sibling::processing-instruction()), '-')"/>
   </xsl:template>
   <xsl:template match="@*" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.@', name())"/>
   </xsl:template>
   <xsl:template match="*" mode="generate-id-from-path" priority="-0.5">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:text>.</xsl:text>
      <xsl:value-of select="concat('.',name(),'-',1+count(preceding-sibling::*[name()=name(current())]),'-')"/>
   </xsl:template>
   <!--MODE: GENERATE-ID-2 -->
   <xsl:template match="/" mode="generate-id-2">U</xsl:template>
   <xsl:template match="*" mode="generate-id-2" priority="2">
      <xsl:text>U</xsl:text>
      <xsl:number level="multiple" count="*"/>
   </xsl:template>
   <xsl:template match="node()" mode="generate-id-2">
      <xsl:text>U.</xsl:text>
      <xsl:number level="multiple" count="*"/>
      <xsl:text>n</xsl:text>
      <xsl:number count="node()"/>
   </xsl:template>
   <xsl:template match="@*" mode="generate-id-2">
      <xsl:text>U.</xsl:text>
      <xsl:number level="multiple" count="*"/>
      <xsl:text>_</xsl:text>
      <xsl:value-of select="string-length(local-name(.))"/>
      <xsl:text>_</xsl:text>
      <xsl:value-of select="translate(name(),':','.')"/>
   </xsl:template>
   <!--Strip characters-->
   <xsl:template match="text()" priority="-1"/>
   <!--SCHEMA SETUP-->
   <xsl:template match="/">
      <svrl:schematron-output xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                              title="KoSIT-WSDL-Regeln"
                              schemaVersion="">
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/xgenerator/framework/1/library"
                                             prefix="xgen"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.omg.org/spec/XMI/20131001" prefix="xmi"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.eclipse.org/uml2/5.0.0/UML" prefix="uml"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/xoev-profil/3_0_2" prefix="xoev"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/kosit-zubehoer/wsdl/3_1_0"
                                             prefix="kosit-wsdl"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/kosit-zubehoer/3_1_0" prefix="kosit"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">pattern-WSDLVorlagedateiDerNachrichtZugeordnet</xsl:attribute>
            <xsl:attribute name="name">WSDL-Vorlagedatei der Nachricht zugeordnet</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M14"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">pattern-WSDLVorlagedateiDerNachrichtTemporaerNichtZugeordnet</xsl:attribute>
            <xsl:attribute name="name">WSDL-Vorlagedatei der Nachricht zugeordnet</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M15"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">pattern-WSDLVorlagedateiFalschZugeordnet</xsl:attribute>
            <xsl:attribute name="name">WSDL-Vorlagedatei der Nachricht zugeordnet</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M16"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel2-DienstMitGueltigemKommunikationsszenario</xsl:attribute>
            <xsl:attribute name="name">Dienst mit gültigem Kommunikationsszenario</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M17"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel3-TransportszenarioMitGueltigemKommunikationsszenario</xsl:attribute>
            <xsl:attribute name="name">Transportszenario mit gueltigem Kommunikationsszenario</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M18"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel4-DienstMitGueltigemSignaturlevelFuerInhaltsdaten</xsl:attribute>
            <xsl:attribute name="name">Dienst mit gueltigem Signaturlevel für Inhaltsdaten</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M19"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel5-TransportszenarioMitGueltigemSignaturlevelFuerInhaltsdaten</xsl:attribute>
            <xsl:attribute name="name">Transportszenario mit gueltigem Signaturlevel für Inhaltsdaten</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M20"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel6-DienstMitGueltigemSignaturlevelFuerNutzdaten</xsl:attribute>
            <xsl:attribute name="name">Dienst mit gueltigem Signaturlevel für Nutzdaten</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M21"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel7-TransportszenarioMitGueltigemSignaturlevelFuerNutzdaten</xsl:attribute>
            <xsl:attribute name="name">Transportszenario mit gueltigem Signaturlevel für Nutzdaten</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M22"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel8-NutzungOptionalerContainerKorrektGeregeltInDienst</xsl:attribute>
            <xsl:attribute name="name">Nutzung optionaler Container korrekt geregelt in Dienst</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M23"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel9-NutzungOptionalerContainerKorrektGeregeltInTransportszenario</xsl:attribute>
            <xsl:attribute name="name">Nutzung optionaler Container korrekt geregelt in Transportszenario</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M24"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel10-KorrekteServiceMessagesInOneWayActive</xsl:attribute>
            <xsl:attribute name="name">Korrekte Service Messages in one-way-active</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M25"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel11-KorrekteServiceMessagesInRequestResponse</xsl:attribute>
            <xsl:attribute name="name">Korrekte Service Messages in request-response</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M26"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel12-NichtUnterstuetzteSzenarienInDiensten</xsl:attribute>
            <xsl:attribute name="name">Nicht Unterstuetzte Szenarien in Diensten</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M27"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel12-NichtUnterstuetzteSzenarienInTransportszenarien</xsl:attribute>
            <xsl:attribute name="name">Nicht Unterstuetzte Szenarien in Transportszenarien</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M28"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">pattern-MaximalEinWsdlSchemaTarget</xsl:attribute>
            <xsl:attribute name="name">Korrekte WSDL-Modellierung im Kontext WSDL-Service- and -Operations</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M29"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">pattern-WsdlSchemaTargetUndWsdlSchemaImportNurZwischenDienstUndSchemaPaket</xsl:attribute>
            <xsl:attribute name="name">Korrekte WSDL-Modellierung im Kontext WSDL-Service- and -Operations</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M30"/>
      </svrl:schematron-output>
   </xsl:template>
   <!--SCHEMATRON PATTERNS-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">KoSIT-WSDL-Regeln</svrl:text>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xgenerator-library.xgen-core.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xgenerator-library.uml-access-layer.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xoev-profil.profile-access-layer.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xoev-profil.helpers.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="osci-transport-profil.profile-access-layer.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="kosit-zubehoer.helpers.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="kosit-dokumentations-profil.profile-access-layer.xsl"/>
   <!--PATTERN pattern-WSDLVorlagedateiDerNachrichtZugeordnetWSDL-Vorlagedatei der Nachricht zugeordnet-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">WSDL-Vorlagedatei der Nachricht zugeordnet</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.)[@wsdlVorlagedatei = 'zugeordnet' or empty(@wsdlVorlagedatei)]]"
                 priority="1000"
                 mode="M14">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="kosit:dependencies-by-supplier(.)/uml:resolve-client(.)[kosit-wsdl:wsdlService(.)]"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="kosit:dependencies-by-supplier(.)/uml:resolve-client(.)[kosit-wsdl:wsdlService(.)]">
               <xsl:attribute name="id">rule-WSDLVorlagedateiDerNachrichtZugeordnet</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Falls nicht explizit gekennzeichnet, müssen alle Nachrichten mindestens einem Dienst zugeordnet sein. Die Nachricht <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M14"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M14"/>
   <xsl:template match="@*|node()" priority="-2" mode="M14">
      <xsl:apply-templates select="*" mode="M14"/>
   </xsl:template>
   <!--PATTERN pattern-WSDLVorlagedateiDerNachrichtTemporaerNichtZugeordnetWSDL-Vorlagedatei der Nachricht zugeordnet-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">WSDL-Vorlagedatei der Nachricht zugeordnet</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.)/@wsdlVorlagedatei = 'temporaerNichtZugeordnet']"
                 priority="1000"
                 mode="M15">

		<!--ASSERT warning-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">rule-WSDLVorlagedateiDerNachrichtTemporaerNichtZugeordnet</xsl:attribute>
               <xsl:attribute name="role">warning</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Nachricht <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> ist eine WSDL-Vorlagedatei temporär nicht zugeordnet.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M15"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M15"/>
   <xsl:template match="@*|node()" priority="-2" mode="M15">
      <xsl:apply-templates select="*" mode="M15"/>
   </xsl:template>
   <!--PATTERN pattern-WSDLVorlagedateiFalschZugeordnetWSDL-Vorlagedatei der Nachricht zugeordnet-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">WSDL-Vorlagedatei der Nachricht zugeordnet</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.)/@wsdlVorlagedatei = ('dauerhaftNichtZugeordnet','temporaerNichtZugeordnet')]"
                 priority="1000"
                 mode="M16">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="empty(kosit:dependencies-by-supplier(.)/uml:resolve-client(.)[kosit-wsdl:wsdlService(.)])"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="empty(kosit:dependencies-by-supplier(.)/uml:resolve-client(.)[kosit-wsdl:wsdlService(.)])">
               <xsl:attribute name="id">rule-WSDLVorlagedateiFalschZugeordnet</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Wenn für eine Nachricht bestimmt wurde, dass eine WSDL-Vorlage-Datei temporär oder dauerhaft nicht zuzuordnen ist, darf die Nachricht dementsprechend keinem Dienst zugeordnet sein. Die Nachricht <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M16"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M16"/>
   <xsl:template match="@*|node()" priority="-2" mode="M16">
      <xsl:apply-templates select="*" mode="M16"/>
   </xsl:template>
   <!--PATTERN Regel2-DienstMitGueltigemKommunikationsszenarioDienst mit gültigem Kommunikationsszenario-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Dienst mit gültigem Kommunikationsszenario</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@Kommunikationsszenario]"
                 priority="1000"
                 mode="M17">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'one-way-active' or kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'one-way-passive' or kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'request-response' or kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'request-response-noprotocol'"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'one-way-active' or kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'one-way-passive' or kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'request-response' or kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'request-response-noprotocol'">
               <xsl:attribute name="id">DienstMitGueltigemKommunikationsszenario</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Erlaubte Kommunikationsszenarien sind one-way-active, one-way-passive, request-response und request-response-noprotocol. Der Dienst <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M17"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M17"/>
   <xsl:template match="@*|node()" priority="-2" mode="M17">
      <xsl:apply-templates select="*" mode="M17"/>
   </xsl:template>
   <!--PATTERN Regel3-TransportszenarioMitGueltigemKommunikationsszenarioTransportszenario mit gueltigem Kommunikationsszenario-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Transportszenario mit gueltigem Kommunikationsszenario</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario]"
                 priority="1000"
                 mode="M18">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'one-way-active' or kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'one-way-passive' or kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'request-response' or kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'request-response-noprotocol'"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'one-way-active' or kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'one-way-passive' or kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'request-response' or kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'request-response-noprotocol'">
               <xsl:attribute name="id">TransportszenarioMitGueltigemKommunikationsszenario</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Erlaubte Kommunikationsszenarien sind one-way-active, one-way-passive, request-response und request-response-noprotocol. Das OSCI-Transportszenario <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M18"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M18"/>
   <xsl:template match="@*|node()" priority="-2" mode="M18">
      <xsl:apply-templates select="*" mode="M18"/>
   </xsl:template>
   <!--PATTERN Regel4-DienstMitGueltigemSignaturlevelFuerInhaltsdatenDienst mit gueltigem Signaturlevel für Inhaltsdaten-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Dienst mit gueltigem Signaturlevel für Inhaltsdaten</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@SignaturInhaltsdaten]"
                 priority="1000"
                 mode="M19">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="kosit-wsdl:wsdlService(.)/@SignaturInhaltsdaten = 'none' or kosit-wsdl:wsdlService(.)/@SignaturInhaltsdaten = 'advanced' or kosit-wsdl:wsdlService(.)/@SignaturInhaltsdaten = 'qualified'"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="kosit-wsdl:wsdlService(.)/@SignaturInhaltsdaten = 'none' or kosit-wsdl:wsdlService(.)/@SignaturInhaltsdaten = 'advanced' or kosit-wsdl:wsdlService(.)/@SignaturInhaltsdaten = 'qualified'">
               <xsl:attribute name="id">DienstMitGueltigemSignaturlevelFuerInhaltsdaten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Erlaubtes Signaturlevel für Inhaltsdaten ist none, advanced oder qualified. Der Dienst <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M19"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M19"/>
   <xsl:template match="@*|node()" priority="-2" mode="M19">
      <xsl:apply-templates select="*" mode="M19"/>
   </xsl:template>
   <!--PATTERN Regel5-TransportszenarioMitGueltigemSignaturlevelFuerInhaltsdatenTransportszenario mit gueltigem Signaturlevel für Inhaltsdaten-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Transportszenario mit gueltigem Signaturlevel für Inhaltsdaten</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:osciTransportScenario(.)/@SignaturInhaltsdaten]"
                 priority="1000"
                 mode="M20">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="kosit-wsdl:osciTransportScenario(.)/@SignaturInhaltsdaten = 'none' or kosit-wsdl:osciTransportScenario(.)/@SignaturInhaltsdaten = 'advanced' or kosit-wsdl:osciTransportScenario(.)/@SignaturInhaltsdaten = 'qualified'"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="kosit-wsdl:osciTransportScenario(.)/@SignaturInhaltsdaten = 'none' or kosit-wsdl:osciTransportScenario(.)/@SignaturInhaltsdaten = 'advanced' or kosit-wsdl:osciTransportScenario(.)/@SignaturInhaltsdaten = 'qualified'">
               <xsl:attribute name="id">TransportszenarioMitGueltigemSignaturlevelFuerInhaltsdaten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Erlaubtes Signaturlevel für Inhaltsdaten ist none, advanced oder qualified. Das OSCI-Transportszenario <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M20"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M20"/>
   <xsl:template match="@*|node()" priority="-2" mode="M20">
      <xsl:apply-templates select="*" mode="M20"/>
   </xsl:template>
   <!--PATTERN Regel6-DienstMitGueltigemSignaturlevelFuerNutzdatenDienst mit gueltigem Signaturlevel für Nutzdaten-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Dienst mit gueltigem Signaturlevel für Nutzdaten</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@SignaturNutzdaten]"
                 priority="1000"
                 mode="M21">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="kosit-wsdl:wsdlService(.)/@SignaturNutzdaten = 'none' or kosit-wsdl:wsdlService(.)/@SignaturNutzdaten = 'advanced' or kosit-wsdl:wsdlService(.)/@SignaturNutzdaten = 'qualified'"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="kosit-wsdl:wsdlService(.)/@SignaturNutzdaten = 'none' or kosit-wsdl:wsdlService(.)/@SignaturNutzdaten = 'advanced' or kosit-wsdl:wsdlService(.)/@SignaturNutzdaten = 'qualified'">
               <xsl:attribute name="id">DienstMitGueltigemSignaturlevelFuerNutzdaten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Erlaubtes Signaturlevel für Nutzdaten ist none, advanced oder qualified. Der Dienst <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M21"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M21"/>
   <xsl:template match="@*|node()" priority="-2" mode="M21">
      <xsl:apply-templates select="*" mode="M21"/>
   </xsl:template>
   <!--PATTERN Regel7-TransportszenarioMitGueltigemSignaturlevelFuerNutzdatenTransportszenario mit gueltigem Signaturlevel für Nutzdaten-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Transportszenario mit gueltigem Signaturlevel für Nutzdaten</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:osciTransportScenario(.)/@SignaturNutzdaten]"
                 priority="1000"
                 mode="M22">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="kosit-wsdl:osciTransportScenario(.)/@SignaturNutzdaten = 'none' or kosit-wsdl:osciTransportScenario(.)/@SignaturNutzdaten = 'advanced' or kosit-wsdl:osciTransportScenario(.)/@SignaturNutzdaten = 'qualified'"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="kosit-wsdl:osciTransportScenario(.)/@SignaturNutzdaten = 'none' or kosit-wsdl:osciTransportScenario(.)/@SignaturNutzdaten = 'advanced' or kosit-wsdl:osciTransportScenario(.)/@SignaturNutzdaten = 'qualified'">
               <xsl:attribute name="id">TransportszenarioMitGueltigemSignaturlevelFuerNutzdaten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Erlaubtes Signaturlevel für Nutzdaten ist none, advanced oder qualified. Das OSCI-Transportszenario <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M22"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M22"/>
   <xsl:template match="@*|node()" priority="-2" mode="M22">
      <xsl:apply-templates select="*" mode="M22"/>
   </xsl:template>
   <!--PATTERN Regel8-NutzungOptionalerContainerKorrektGeregeltInDienstNutzung optionaler Container korrekt geregelt in Dienst-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Nutzung optionaler Container korrekt geregelt in Dienst</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@OptionalerContainer]"
                 priority="1000"
                 mode="M23">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="kosit-wsdl:wsdlService(.)/@OptionalerContainer = 'true' or kosit-wsdl:wsdlService(.)/@OptionalerContainer = 'false'"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="kosit-wsdl:wsdlService(.)/@OptionalerContainer = 'true' or kosit-wsdl:wsdlService(.)/@OptionalerContainer = 'false'">
               <xsl:attribute name="id">NutzungOptionalerContainerKorrektGeregeltInDienst</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Nutzung des optionalen Containers muss geregelt sein ('true' oder 'false'). Der Dienst <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M23"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M23"/>
   <xsl:template match="@*|node()" priority="-2" mode="M23">
      <xsl:apply-templates select="*" mode="M23"/>
   </xsl:template>
   <!--PATTERN Regel9-NutzungOptionalerContainerKorrektGeregeltInTransportszenarioNutzung optionaler Container korrekt geregelt in Transportszenario-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Nutzung optionaler Container korrekt geregelt in Transportszenario</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:osciTransportScenario(.)/@OptionalerContainer]"
                 priority="1000"
                 mode="M24">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="kosit-wsdl:osciTransportScenario(.)/@OptionalerContainer = 'true' or kosit-wsdl:osciTransportScenario(.)/@OptionalerContainer = 'false'"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="kosit-wsdl:osciTransportScenario(.)/@OptionalerContainer = 'true' or kosit-wsdl:osciTransportScenario(.)/@OptionalerContainer = 'false'">
               <xsl:attribute name="id">NutzungOptionalerContainerKorrektGeregeltInTransportszenario</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Nutzung des optionalen Containers muss geregelt sein ('true' oder 'false'). Das OSCI-Transportszenario <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M24"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M24"/>
   <xsl:template match="@*|node()" priority="-2" mode="M24">
      <xsl:apply-templates select="*" mode="M24"/>
   </xsl:template>
   <!--PATTERN Regel10-KorrekteServiceMessagesInOneWayActiveKorrekte Service Messages in one-way-active-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Korrekte Service Messages in one-way-active</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'one-way-active' or xoev:allParents(.)[kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'one-way-active']]"
                 priority="1000"
                 mode="M25">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     every $dep in xoev:dependencies-by-client(.)                         satisfies $dep/kosit-wsdl:wsdlServiceMessage(.) and not($dep/kosit-wsdl:wsdlServiceInputMessage(.)) and not($dep/kosit-wsdl:wsdlServiceOutputMessage(.)) and not($dep/kosit-wsdl:wsdlServiceFaultMessage(.))"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="every $dep in xoev:dependencies-by-client(.) satisfies $dep/kosit-wsdl:wsdlServiceMessage(.) and not($dep/kosit-wsdl:wsdlServiceInputMessage(.)) and not($dep/kosit-wsdl:wsdlServiceOutputMessage(.)) and not($dep/kosit-wsdl:wsdlServiceFaultMessage(.))">
               <xsl:attribute name="id">KorrekteServiceMessagesInOneWayActive</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>One-way-active-Szenarios beziehen ausschließlich allgemeine Service-Messages ein. Der Dienst <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M25"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M25"/>
   <xsl:template match="@*|node()" priority="-2" mode="M25">
      <xsl:apply-templates select="*" mode="M25"/>
   </xsl:template>
   <!--PATTERN Regel11-KorrekteServiceMessagesInRequestResponseKorrekte Service Messages in request-response-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Korrekte Service Messages in request-response</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'request-response' or xoev:allParents(.)[kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'request-response']]"
                 priority="1000"
                 mode="M26">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     every $dep in xoev:dependencies-by-client(.)                         satisfies not($dep/kosit-wsdl:wsdlServiceMessage(.)) and                         count(($dep/kosit-wsdl:wsdlServiceInputMessage(.), $dep/kosit-wsdl:wsdlServiceOutputMessage(.), $dep/kosit-wsdl:wsdlServiceFaultMessage(.))) = 1"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="every $dep in xoev:dependencies-by-client(.) satisfies not($dep/kosit-wsdl:wsdlServiceMessage(.)) and count(($dep/kosit-wsdl:wsdlServiceInputMessage(.), $dep/kosit-wsdl:wsdlServiceOutputMessage(.), $dep/kosit-wsdl:wsdlServiceFaultMessage(.))) = 1">
               <xsl:attribute name="id">KorrekteServiceMessagesInRequestResponse</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Request-response-Szenarios beziehen ausschließlich Input- , Output- und Fault-Messages ein. Der Dienst <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M26"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M26"/>
   <xsl:template match="@*|node()" priority="-2" mode="M26">
      <xsl:apply-templates select="*" mode="M26"/>
   </xsl:template>
   <!--PATTERN Regel12-NichtUnterstuetzteSzenarienInDienstenNicht Unterstuetzte Szenarien in Diensten-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Nicht Unterstuetzte Szenarien in Diensten</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'one-way-passive' or kosit-wsdl:wsdlService(.)/@Kommunikationsszenario = 'request-response-noprotocol']"
                 priority="1000"
                 mode="M27">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NichtUnterstuetzteSzenarienInDiensten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>One-way-passive und request-response-noprotocol noch nicht unterstützt. Der Dienst <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M27"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M27"/>
   <xsl:template match="@*|node()" priority="-2" mode="M27">
      <xsl:apply-templates select="*" mode="M27"/>
   </xsl:template>
   <!--PATTERN Regel12-NichtUnterstuetzteSzenarienInTransportszenarienNicht Unterstuetzte Szenarien in Transportszenarien-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Nicht Unterstuetzte Szenarien in Transportszenarien</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'one-way-passive' or kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario = 'request-response-noprotocol']"
                 priority="1000"
                 mode="M28">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NichtUnterstuetzteSzenarienInTransportszenarien</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>One-way-passive und request-response-noprotocol noch nicht unterstützt. Der Dienst <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M28"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M28"/>
   <xsl:template match="@*|node()" priority="-2" mode="M28">
      <xsl:apply-templates select="*" mode="M28"/>
   </xsl:template>
   <!--PATTERN pattern-MaximalEinWsdlSchemaTargetKorrekte WSDL-Modellierung im Kontext WSDL-Service- and -Operations-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Korrekte WSDL-Modellierung im Kontext WSDL-Service- and -Operations</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlServiceAndOperations(.)]"
                 priority="1000"
                 mode="M29">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="count(xoev:dependencies-by-client(.)[kosit-wsdl:wsdlSchemaTarget(.)]) &lt;= 1"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="count(xoev:dependencies-by-client(.)[kosit-wsdl:wsdlSchemaTarget(.)]) &lt;= 1">
               <xsl:attribute name="id">rule-MaximalEinWsdlSchemaTarget</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Ein Dienst mit dem Stereotyp wsdlServiceAndOperations darf maximal ein WSDL-Schema-Target (Abhängigkeitsbeziehung mit dem Stereotyp wsdlSchemaTarget) besitzen. Der Dienst <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M29"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M29"/>
   <xsl:template match="@*|node()" priority="-2" mode="M29">
      <xsl:apply-templates select="*" mode="M29"/>
   </xsl:template>
   <!--PATTERN pattern-WsdlSchemaTargetUndWsdlSchemaImportNurZwischenDienstUndSchemaPaketKorrekte WSDL-Modellierung im Kontext WSDL-Service- and -Operations-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Korrekte WSDL-Modellierung im Kontext WSDL-Service- and -Operations</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[kosit-wsdl:wsdlSchemaTarget(.) or kosit-wsdl:wsdlSchemaImport(.)]"
                 priority="1000"
                 mode="M30">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="uml:resolve-client(.)[kosit-wsdl:wsdlServiceAndOperations(.)] and uml:resolve-supplier(.)[xoev:xsdSchema(.)]"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="uml:resolve-client(.)[kosit-wsdl:wsdlServiceAndOperations(.)] and uml:resolve-supplier(.)[xoev:xsdSchema(.)]">
               <xsl:attribute name="id">rule-WsdlSchemaTargetUndWsdlSchemaImportNurZwischenDienstUndSchemaPaket</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Eine Abhängigkeitsbeziehung mit dem Stereotyp wsdlSchemaImport oder wsdlSchemaTarget muss einen Dienst (wsdlServiceAndOperations) mit einem Schema-Paket (xsdSchema) verbinden. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M30"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M30"/>
   <xsl:template match="@*|node()" priority="-2" mode="M30">
      <xsl:apply-templates select="*" mode="M30"/>
   </xsl:template>
</xsl:stylesheet>
