<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:log="http://www.xoev.de/de/xgenerator/framework/1/log" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" xmlns:xgen="http://www.xoev.de/de/xgenerator/framework/1/library" xmlns:xoev="http://www.xoev.de/de/xoev-profil/3_0_2" xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:kosit="http://www.xoev.de/de/kosit-zubehoer/3_1_0" xmlns:kosit-wsdl="http://www.xoev.de/de/kosit-zubehoer/wsdl/3_1_0" xmlns="http://schemas.xmlsoap.org/wsdl/" xmlns:ns="http://schemas.xmlsoap.org/soap/encoding/" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:osci="http://www.osci.de/2006/07/wsdl/" xmlns:tpl="http://www.dvdv.de/dvdv/template/" xmlns:ds="http://www.w3.org/2000/09/xmldsig#" version="2.0" exclude-result-prefixes="xsl xmi xgen xoev kosit-wsdl uml xd log kosit">
    <xsl:template match="/" mode="kosit:default">
        <xsl:apply-templates select="
                $xoev:my-xmodel/descendant-or-self::packagedElement[
                kosit-wsdl:wsdlService(.) and xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceMessage(.)]]" mode="kosit-wsdl:wsdl-document-one-way-active"/>
        <xsl:apply-templates select="
                $xoev:my-xmodel/descendant-or-self::packagedElement[
                kosit-wsdl:wsdlService(.) and xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceInputMessage(.)]]" mode="kosit-wsdl:wsdl-document-request-response"/>
        <xsl:apply-templates select="$xoev:my-xmodel/descendant-or-self::packagedElement[kosit-wsdl:wsdlServiceAndOperations(.)]" mode="kosit-wsdl:wsdl-document-request-response-operations"/>
    </xsl:template>
    <xsl:function name="kosit-wsdl:service-name" as="xs:string">
        <xsl:param name="service-klasse" as="element()"/>
        <xsl:value-of select="
                ($service-klasse/kosit-wsdl:wsdlService(.)/@Dateiname,
                concat($service-klasse/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix,
                replace($service-klasse/ancestor::packagedElement/xoev:xoevVersionStandard(.)/@version, '\.', ''),
                $service-klasse/@name))[1]"/>
    </xsl:function>
    <xsl:function name="kosit-wsdl:namensraum-basis" as="xs:string">
        <xsl:param name="service-klasse" as="element()"/>
        <xsl:value-of select="($service-klasse/kosit-wsdl:wsdlService(.)/@NamensraumOhneDateiname, $service-klasse/ancestor::packagedElement/xoev:xsdXModel(.)/@namespace)[1]"/>
    </xsl:function>
    <xsl:function name="kosit-wsdl:namensraum-basis-mit-slash" as="xs:string">
        <xsl:param name="service-klasse" as="element()"/>
        <xsl:value-of select="
                concat(kosit-wsdl:namensraum-basis($service-klasse),
                if (ends-with(kosit-wsdl:namensraum-basis($service-klasse), '/')) then
                    ''
                else
                    '/')"/>
    </xsl:function>
    <xsl:function name="kosit-wsdl:namensraum" as="xs:string">
        <xsl:param name="service-klasse" as="element()"/>
        <xsl:choose>
            <xsl:when test="$service-klasse/ancestor::packagedElement/kosit-wsdl:wsdlKonfiguration(.)/@StandardaufbauNamensraum = 'URN'">
                <xsl:value-of select="concat($service-klasse/ancestor-or-self::packagedElement[xoev:xoevStandard(.)]/xoev:xoevStandard(.)/@kennung, ':service:wsdl:', kosit-wsdl:service-name($service-klasse))"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="concat(kosit-wsdl:namensraum-basis-mit-slash($service-klasse), kosit-wsdl:service-name($service-klasse), '.wsdl')"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:function>
    <xsl:function name="kosit-wsdl:optionaler-container" as="xs:string">
        <xsl:param name="service-klasse" as="element()"/>
        <xsl:value-of select="
                ($service-klasse/kosit-wsdl:wsdlService(.)/@OptionalerContainer[. != ''],
                $service-klasse/xoev:allParents(.)/kosit-wsdl:osciTransportScenario(.)/@OptionalerContainer)[1]"/>
    </xsl:function>
    <xsl:function name="kosit-wsdl:html-ul-fuer-nachrichtenmenge" as="element()">
        <xsl:param name="nachrichtenmenge" as="element()*"/>
        <ul>
            <xsl:for-each select="$nachrichtenmenge">
                <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                <li>
                    <xsl:value-of select="@name"/>
                </li>
            </xsl:for-each>
        </ul>
    </xsl:function>
    <xsl:template match="packagedElement" mode="kosit-wsdl:schema-fuer-nachrichtenmenge">
        <xsl:param name="messages" as="element()*"/>
        <xsl:param name="art" as="xs:string"/>
        <xsl:variable name="service-klasse" select="."/>
        <xsl:choose>
            <xsl:when test="count(distinct-values($messages/xoev:getNamespace(.))) gt 1">
                <xsl:element name="xs:schema">
                    <xsl:for-each select="distinct-values($messages/ancestor-or-self::packagedElement[xoev:xsdSchema(.)]/@xmi:id)">
                        <xsl:sort select="
                                (xoev:ids-to-elements(., root($service-klasse))/xoev:xsdSchema(.)/@schemaLocation,
                                concat(xoev:ids-to-elements(., root($service-klasse))/ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase,
                                xoev:ids-to-elements(., root($service-klasse))/xoev:xsdSchema(.)/@schemaFile))[1]"/>
                        <xsl:variable name="schema" select="xoev:ids-to-elements(., root($service-klasse))"/>
                        <xsl:namespace name="{$schema/xoev:xsdSchema(.)/@prefix}" select="$schema/xoev:getNamespace(.)"/>
                    </xsl:for-each>
                    <xsl:attribute name="targetNamespace" select="kosit-wsdl:namensraum($service-klasse)"/>
                    <xsl:for-each select="distinct-values($messages/ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id)">
                        <xsl:sort select="
                                (xoev:ids-to-elements(., root($service-klasse))/xoev:xsdSchema(.)/@schemaLocation,
                                concat(xoev:ids-to-elements(., root($service-klasse))/ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase,
                                xoev:ids-to-elements(., root($service-klasse))/xoev:xsdSchema(.)/@schemaFile))[1]"/>
                        <xsl:variable name="schema-paket" select="xoev:ids-to-elements(., root($service-klasse))"/>
                        <xsl:element name="xs:import">
                            <xsl:attribute name="namespace" select="xoev:getNamespace($schema-paket)"/>
                            <xsl:attribute name="schemaLocation" select="
                                    ($schema-paket/xoev:xsdSchema(.)/@schemaLocation,
                                    concat($schema-paket/ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase, $schema-paket/xoev:xsdSchema(.)/@schemaFile))[1]"/>
                        </xsl:element>
                    </xsl:for-each>
                    <xsl:element name="xs:complexType">
                        <xsl:attribute name="name" select="
                                concat(lower-case($service-klasse/@name), $art, 'Schemata')"/>
                        <xsl:element name="xs:choice">
                            <xsl:for-each select="distinct-values($messages/@xmi:id)">
                                <xsl:sort select="xoev:ids-to-elements(., root($service-klasse))/@name"/>
                                <xsl:element name="xs:element">
                                    <xsl:attribute name="name" select="xoev:ids-to-elements(., root($service-klasse))/@name"/>
                                </xsl:element>
                            </xsl:for-each>
                        </xsl:element>
                    </xsl:element>
                </xsl:element>
            </xsl:when>
            <xsl:otherwise>
                <xsl:element name="xs:schema">
                    <xsl:namespace name="" select="kosit-wsdl:namensraum-basis($service-klasse)"/>
                    <xsl:attribute name="targetNamespace" select="kosit-wsdl:namensraum($service-klasse)"/>
                    <xsl:for-each select="distinct-values($messages/ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id)">
                        <xsl:sort select="
                                (xoev:ids-to-elements(., root($service-klasse))/xoev:xsdSchema(.)/@schemaLocation,
                                concat(xoev:ids-to-elements(., root($service-klasse))/ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase,
                                xoev:ids-to-elements(., root($service-klasse))/xoev:xsdSchema(.)/@schemaFile))[1]"/>
                        <xsl:variable name="schema-paket" select="xoev:ids-to-elements(., root($service-klasse))"/>
                        <xsl:element name="xs:import">
                            <xsl:attribute name="namespace" select="xoev:getNamespace($schema-paket)"/>
                            <xsl:attribute name="schemaLocation" select="
                                    ($schema-paket/xoev:xsdSchema(.)/@schemaLocation,
                                    concat($schema-paket/ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase, $schema-paket/xoev:xsdSchema(.)/@schemaFile))[1]"/>
                        </xsl:element>
                    </xsl:for-each>
                    <xsl:element name="xs:complexType">
                        <xsl:attribute name="name" select="
                                concat(lower-case($service-klasse/@name), $art, 'Schemata')"/>
                        <xsl:element name="xs:choice">
                            <xsl:for-each select="distinct-values($messages/@xmi:id)">
                                <xsl:sort select="xoev:ids-to-elements(., root($service-klasse))/@name"/>
                                <xsl:element name="xs:element">
                                    <xsl:attribute name="name" select="xoev:ids-to-elements(., root($service-klasse))/@name"/>
                                </xsl:element>
                            </xsl:for-each>
                        </xsl:element>
                    </xsl:element>
                </xsl:element>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="packagedElement" mode="kosit-wsdl:message">
        <xsl:param name="messages" as="element()*"/>
        <xsl:param name="art" as="xs:string"/>
        <xsl:variable name="service-klasse" select="."/>
        <xsl:variable name="request-response-fault" select="
                if ($art = 'Input') then
                    'Request'
                else
                    if ($art = 'Output') then
                        'Response'
                    else
                        if ($art = 'Fault') then
                            'Fault'
                        else
                            ''"/>
        <message name="{concat(lower-case($service-klasse/@name),
            $request-response-fault,'Nachricht')}">
            <xsl:if test="$messages">
                <xsl:element name="part">
                    <xsl:attribute name="name" select="
                            if ($request-response-fault) then
                                lower-case($request-response-fault)
                            else
                                concat(lower-case($service-klasse/@name), 'Nachricht')"/>
                    <xsl:choose>
                        <xsl:when test="count($messages) = 1">
                            <xsl:attribute name="element" select="
                                    concat(($messages/ancestor::packagedElement/xoev:xsdSchema(.)/@prefix,
                                    $messages/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1], ':', $messages/@name)"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:attribute name="type" select="concat('tns:', lower-case($service-klasse/@name), $art, 'Schemata')"/>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:element>
            </xsl:if>
            <xsl:if test="kosit-wsdl:optionaler-container($service-klasse) = 'true'">
                <part name="optionaleNachricht" type="xs:anyType"/>
            </xsl:if>
        </message>
    </xsl:template>
    <xsl:function name="kosit-wsdl:service-klasse-upper-camel-case" as="xs:string">
        <xsl:param name="service-klasse" as="element()"/>
        <xsl:value-of select="concat(upper-case(substring($service-klasse/@name, 1, 1)), substring($service-klasse/@name, 2, string-length($service-klasse/@name) - 1))"/>
    </xsl:function>
    <xsl:template match="packagedElement" mode="kosit-wsdl:port">
        <xsl:param name="ist-one-way-active" as="xs:boolean" required="no" select="false()"/>
        <xsl:param name="hat-fault-nachrichten" as="xs:boolean" required="no" select="false()"/>
        <xsl:variable name="service-klasse" select="."/>
        <portType name="{concat('osci',kosit-wsdl:service-klasse-upper-camel-case($service-klasse),'Interface')}">
            <xsl:choose>
                <xsl:when test="$ist-one-way-active">
                    <operation name="{concat('sende',kosit-wsdl:service-klasse-upper-camel-case($service-klasse))}">
                        <input message="{concat('tns:',lower-case($service-klasse/@name),'Nachricht')}"/>
                    </operation>
                </xsl:when>
                <xsl:otherwise>
                    <operation name="{concat('sende',kosit-wsdl:service-klasse-upper-camel-case($service-klasse))}">
                        <input message="{concat('tns:',lower-case($service-klasse/@name),'RequestNachricht')}"/>
                        <output message="{concat('tns:',lower-case($service-klasse/@name),'ResponseNachricht')}"/>
                        <xsl:if test="$hat-fault-nachrichten">
                            <fault name="faultMessage" message="{concat('tns:',lower-case($service-klasse/@name),'FaultNachricht')}"/>
                        </xsl:if>
                    </operation>
                </xsl:otherwise>
            </xsl:choose>
        </portType>
    </xsl:template>
    <xsl:template match="packagedElement" mode="kosit-wsdl:binding">
        <xsl:param name="ist-request-response" as="xs:boolean" select="false()" required="no"/>
        <xsl:param name="hat-fault-nachrichten" as="xs:boolean" select="false()" required="no"/>
        <xsl:variable name="service-klasse" select="."/>
        <xsl:variable name="signatur-nutzdaten" select="
                ($service-klasse/kosit-wsdl:wsdlService(.)/@SignaturNutzdaten[. != ''],
                $service-klasse/xoev:allParents(.)/kosit-wsdl:osciTransportScenario(.)/@SignaturNutzdaten)[1]"/>
        <xsl:variable name="signatur-inhaltsdaten" select="
                ($service-klasse/kosit-wsdl:wsdlService(.)/@SignaturInhaltsdaten[. != ''],
                $service-klasse/xoev:allParents(.)/kosit-wsdl:osciTransportScenario(.)/@SignaturInhaltsdaten)[1]"/>
        <xsl:variable name="verschluesselung-nutzdaten" select="
                ($service-klasse/kosit-wsdl:wsdlService(.)/@VerschluesselungNutzdaten[. != ''],
                $service-klasse/xoev:allParents(.)/kosit-wsdl:osciTransportScenario(.)/@VerschluesselungNutzdaten)[1]"/>
        <xsl:variable name="verschluesselung-inhaltsdaten" select="
                ($service-klasse/kosit-wsdl:wsdlService(.)/@VerschluesselungInhaltsdaten[. != ''],
                $service-klasse/xoev:allParents(.)/kosit-wsdl:osciTransportScenario(.)/@VerschluesselungInhaltsdaten)[1]"/>
        <xsl:variable name="kommunikationsszenario" select="
                ($service-klasse/kosit-wsdl:wsdlService(.)/@Kommunikationsszenario[. != ''],
                $service-klasse/xoev:allParents(.)/kosit-wsdl:osciTransportScenario(.)/@Kommunikationsszenario)[1]"/>
        <binding name="osciBinding" type="{concat('tns:','osci',kosit-wsdl:service-klasse-upper-camel-case($service-klasse),'Interface')}">
            <osci:binding signatureLevel="{$signatur-nutzdaten}" encrypted="{$verschluesselung-nutzdaten}">
                <osci:reader name="Inhaltsdaten-Verschlüsselungszertifikat">
                    <tpl:certificate/>
                </osci:reader>
                <xsl:if test="$ist-request-response">
                    <osci:author name="Inhaltsdaten-Signaturzertifikat">
                        <tpl:certificate/>
                    </osci:author>
                </xsl:if>
            </osci:binding>
            <xsl:comment> Vorbelegung der Richtlinien zur Signatur und Verschlüsselung der Nutzdaten für alle Operationen </xsl:comment>
            <operation name="{concat('sende',kosit-wsdl:service-klasse-upper-camel-case($service-klasse))}">
                <xsl:variable name="subject-name" select="
                        if (starts-with(ancestor::packagedElement/kosit-wsdl:wsdlKonfiguration(.)/@StandardaufbauSubjectOperation, 'ModelName')) then
                            concat(upper-case(substring(ancestor::packagedElement[xoev:xsdXModel(.)]/@name, 1, 2)),
                            substring(ancestor::packagedElement[xoev:xsdXModel(.)]/@name, 3, string-length(ancestor::packagedElement[xoev:xsdXModel(.)]/@name)))
                        else
                            concat(upper-case(substring(ancestor::packagedElement/xoev:xsdXModel(.)/@prefix, 1, 2)),
                            substring(ancestor::packagedElement/xoev:xsdXModel(.)/@prefix, 3, string-length(ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)))"/>
                <xsl:variable name="module-version" select="
                        (xoev:dependencies-by-client($service-klasse)[kosit-wsdl:wsdlServiceMessage(.) or kosit-wsdl:wsdlServiceInputMessage(.)]/uml:resolve-supplier(.)/ancestor::packagedElement/xoev:xsdSchema(.)/@version,
                        ancestor::packagedElement/xoev:xoevVersionStandard(.)/@version)[1]"/>
                <osci:operation communicationType="{$kommunikationsszenario}" subject="{
                    ($service-klasse/kosit-wsdl:wsdlService(.)/@SubjectOperation,
                    concat($subject-name, 
                    ' ',
                    if(ends-with(ancestor::packagedElement/kosit-wsdl:wsdlKonfiguration(.)/@StandardaufbauSubjectOperation, 'ModulVersion')) then
                    concat($service-klasse/@name, ' ', $module-version) else
                    concat(ancestor::packagedElement/xoev:xoevVersionStandard(.)/@version, ' ', $service-klasse/@name)))[1]}"/>
                <input>
                    <osci:container signatureLevel="{$signatur-inhaltsdaten}" encrypted="{$verschluesselung-inhaltsdaten}" name="{
                        ($service-klasse/kosit-wsdl:wsdlService(.)/@NameMandatorischerContainer[. != ''],
                        $service-klasse/xoev:allParents(.)/kosit-wsdl:osciTransportScenario(.)/@NameMandatorischerContainer,
                        concat(upper-case($service-klasse/ancestor::packagedElement[xoev:xsdXModel(.)]/@name),'_DATA'))[1]}" required="true">
                        <osci:readerRef ref="Inhaltsdaten-Verschlüsselungszertifikat"/>
                        <osci:part>
                            <osci:content part="{if($ist-request-response) then 'tns:request' else concat('tns:',lower-case($service-klasse/@name),'Nachricht')}"/>
                        </osci:part>
                    </osci:container>
                    <xsl:if test="kosit-wsdl:optionaler-container($service-klasse) = 'true'">
                        <osci:container signatureLevel="none" encrypted="false" required="false">
                            <osci:part>
                                <osci:content part="tns:optionaleNachricht"/>
                            </osci:part>
                        </osci:container>
                    </xsl:if>
                </input>
                <xsl:if test="$ist-request-response">
                    <output>
                        <osci:container signatureLevel="{$signatur-inhaltsdaten}" encrypted="{$verschluesselung-inhaltsdaten}" name="{concat(upper-case(ancestor::packagedElement[xoev:xsdXModel(.)]/@name),'_DATA')}" required="true">
                            <osci:readerRef ref="Inhaltsdaten-Verschlüsselungszertifikat"/>
                            <osci:part>
                                <osci:content part="tns:response"/>
                            </osci:part>
                        </osci:container>
                        <xsl:if test="kosit-wsdl:optionaler-container($service-klasse) = 'true'">
                            <osci:container signatureLevel="none" encrypted="false" required="false">
                                <osci:part>
                                    <osci:content part="tns:optionaleNachricht"/>
                                </osci:part>
                            </osci:container>
                        </xsl:if>
                    </output>
                    <xsl:if test="$hat-fault-nachrichten">
                        <fault name="faultMessage">
                            <osci:container signatureLevel="{$signatur-inhaltsdaten}" encrypted="{$verschluesselung-inhaltsdaten}" name="{concat(upper-case(ancestor::packagedElement[xoev:xsdXModel(.)]/@name),'_DATA')}" required="true">
                                <osci:readerRef ref="Inhaltsdaten-Verschlüsselungszertifikat"/>
                                <osci:part>
                                    <osci:content part="tns:fault"/>
                                </osci:part>
                            </osci:container>
                            <xsl:if test="kosit-wsdl:optionaler-container($service-klasse) = 'true'">
                                <osci:container signatureLevel="none" encrypted="false" required="false">
                                    <osci:part>
                                        <osci:content part="tns:optionaleNachricht"/>
                                    </osci:part>
                                </osci:container>
                            </xsl:if>
                        </fault>
                    </xsl:if>
                </xsl:if>
            </operation>
        </binding>
    </xsl:template>
    <xsl:template match="packagedElement" mode="kosit-wsdl:service">
        <xsl:variable name="service-klasse" select="."/>
        <service name="{concat('osci',$service-klasse/@name,'Service')}">
            <xsl:comment> OSCI Infrastrukturserver </xsl:comment>
            <osci:devices>
                <osci:intermediary uri="" name="InternetIntermediär">
                    <osci:signatureCertificate>
                        <tpl:certificate/>
                    </osci:signatureCertificate>
                    <osci:cipherCertificate>
                        <tpl:certificate/>
                    </osci:cipherCertificate>
                </osci:intermediary>
                <osci:intermediary uri="" name="TESTAIntermediär">
                    <osci:signatureCertificate>
                        <tpl:certificate/>
                    </osci:signatureCertificate>
                    <osci:cipherCertificate>
                        <tpl:certificate/>
                    </osci:cipherCertificate>
                </osci:intermediary>
                <osci:addressee name="InternetEmpfänger">
                    <osci:cipherCertificate>
                        <tpl:certificate/>
                    </osci:cipherCertificate>
                </osci:addressee>
                <osci:addressee name="TESTAEmpfänger">
                    <osci:cipherCertificate>
                        <tpl:certificate/>
                    </osci:cipherCertificate>
                </osci:addressee>
            </osci:devices>
            <xsl:comment> Endpunkt im Internet </xsl:comment>
            <port name="{concat('osci',$service-klasse/@name,'InternetPort')}" binding="tns:osciBinding">
                <documentation>
                    <xsl:choose>
                        <xsl:when test="$service-klasse/kosit-wsdl:wsdlService(.)/@InternetPort = 'required'">
                            <tpl:use>required</tpl:use>
                            <xsl:text> Dieser Port ist nicht optional </xsl:text>
                        </xsl:when>
                        <xsl:otherwise>
                            <tpl:use>optional</tpl:use>
                            <xsl:text> Dieser Port ist optional </xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </documentation>
                <osci:address>
                    <osci:intermediaryRef ref="InternetIntermediär"/>
                    <osci:addresseeRef ref="InternetEmpfänger"/>
                </osci:address>
            </port>
            <xsl:comment> Endpunkt im TESTA </xsl:comment>
            <port name="{concat('osci',$service-klasse/@name,'TestaPort')}" binding="tns:osciBinding">
                <documentation>
                    <xsl:choose>
                        <xsl:when test="$service-klasse/kosit-wsdl:wsdlService(.)/@TestaPort = 'required'">
                            <tpl:use>required</tpl:use>
                            <xsl:text> Dieser Port ist nicht optional </xsl:text>
                        </xsl:when>
                        <xsl:otherwise>
                            <tpl:use>optional</tpl:use>
                            <xsl:text> Dieser Port ist optional </xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </documentation>
                <osci:address>
                    <osci:intermediaryRef ref="TESTAIntermediär"/>
                    <osci:addresseeRef ref="TESTAEmpfänger"/>
                </osci:address>
            </port>
        </service>
    </xsl:template>
    <xsl:template match="packagedElement" mode="kosit-wsdl:wsdl-document-request-response">
        <xsl:variable name="service-klasse" select="."/>
        <xsl:variable name="service-input-message-dependency" select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceInputMessage(.)]"/>
        <xsl:variable name="service-input-messages" select="$service-input-message-dependency/uml:resolve-supplier(.)"/>
        <xsl:variable name="service-output-message-dependency" select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceOutputMessage(.)]"/>
        <xsl:variable name="service-output-messages" select="$service-output-message-dependency/uml:resolve-supplier(.)"/>
        <xsl:variable name="service-fault-message-dependency" select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceFaultMessage(.)]"/>
        <xsl:variable name="service-fault-messages" select="$service-fault-message-dependency/uml:resolve-supplier(.)"/>
        <xsl:call-template name="xgen:result-document">
            <xsl:with-param name="local-path" select="
                    if (ancestor::packagedElement/kosit-wsdl:wsdlKonfiguration(.)/@Dateipraefix = 'ModelName') then
                        xs:anyURI(concat(ancestor::packagedElement[xoev:xsdXModel(.)]/@name, '.', kosit-wsdl:service-name($service-klasse), '.wsdl'))
                    else
                        xs:anyURI(concat(kosit-wsdl:service-name($service-klasse), '.wsdl'))"/>
            <xsl:with-param name="content">
                <xsl:comment> Service </xsl:comment>
                <definitions name="{kosit-wsdl:service-name($service-klasse)}" targetNamespace="{kosit-wsdl:namensraum($service-klasse)}" xsi:schemaLocation="http://schemas.xmlsoap.org/wsdl/ http://schemas.xmlsoap.org/wsdl/">
                    <xsl:namespace name="tns" select="kosit-wsdl:namensraum($service-klasse)"/>
                    <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:standard-namespace"/>
                    <xsl:variable name="begin-cdata"><![CDATA[<![CDATA[]]></xsl:variable>
                    <xsl:variable name="end-cdata"><![CDATA[]]]]><![CDATA[>]]></xsl:variable>
                    <documentation>
                        <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:categories"/>
                        <xsl:value-of select="xgen:unescaped-xml($begin-cdata)"/>
                        <html>
                            <xsl:variable name="serviceInputlist" select="concat('&amp;', 'serviceInputlist;')"/>
                            <xsl:variable name="serviceOutputlist" select="concat('&amp;', 'serviceOutputlist;')"/>
                            <xsl:variable name="serviceFaultlist" select="concat('&amp;', 'serviceFaultlist;')"/>
                            <xsl:value-of select="xgen:unescaped-xml(substring-before(ownedComment/body[. != ''], $serviceInputlist))"/>
                            <xsl:sequence select="kosit-wsdl:html-ul-fuer-nachrichtenmenge($service-input-messages)"/>
                            <xsl:value-of select="xgen:unescaped-xml(substring-after(substring-before(ownedComment/body[. != ''], $serviceOutputlist), $serviceInputlist))"/>
                            <xsl:sequence select="kosit-wsdl:html-ul-fuer-nachrichtenmenge($service-output-messages)"/>
                            <xsl:value-of select="xgen:unescaped-xml(substring-after(substring-before(ownedComment/body[. != ''], $serviceFaultlist), $serviceOutputlist))"/>
                            <xsl:sequence select="kosit-wsdl:html-ul-fuer-nachrichtenmenge($service-fault-messages)"/>
                            <xsl:value-of select="xgen:unescaped-xml(substring-after(ownedComment/body[. != ''], $serviceFaultlist))"/>
                        </html>
                        <xsl:value-of select="xgen:unescaped-xml($end-cdata)"/>
                    </documentation>
                    <import namespace="http://www.osci.de/2006/07/wsdl/" location="http://www.osci.de/wsdl-osci-binding/WSDL-OSCI-Binding_1.2.xsd"/>
                    <xsl:if test="count($service-input-message-dependency) gt 1 or count($service-output-message-dependency) gt 1 or count($service-fault-message-dependency) gt 1">
                        <wsdl:types>
                            <xsl:apply-templates select="$service-klasse[count($service-input-message-dependency) gt 1]" mode="kosit-wsdl:schema-fuer-nachrichtenmenge">
                                <xsl:with-param name="messages" select="$service-input-messages"/>
                                <xsl:with-param name="art">Input</xsl:with-param>
                            </xsl:apply-templates>
                            <xsl:apply-templates select="$service-klasse[count($service-output-message-dependency) gt 1]" mode="kosit-wsdl:schema-fuer-nachrichtenmenge">
                                <xsl:with-param name="messages" select="$service-output-messages"/>
                                <xsl:with-param name="art">Output</xsl:with-param>
                            </xsl:apply-templates>
                            <xsl:apply-templates select="$service-klasse[count($service-fault-message-dependency) gt 1]" mode="kosit-wsdl:schema-fuer-nachrichtenmenge">
                                <xsl:with-param name="messages" select="$service-fault-messages"/>
                                <xsl:with-param name="art">Fault</xsl:with-param>
                            </xsl:apply-templates>
                        </wsdl:types>
                    </xsl:if>
                    <xsl:variable name="input-schema" select="$service-input-messages/ancestor::packagedElement[xoev:xsdSchema(.)]"/>
                    <xsl:variable name="output-schema" select="$service-input-messages/ancestor::packagedElement[xoev:xsdSchema(.)]"/>
                    <xsl:variable name="fault-schema" select="$service-fault-messages/ancestor::packagedElement[xoev:xsdSchema(.)]"/>
                    <xsl:for-each select="
                            distinct-values(($input-schema[count($service-input-message-dependency) = 1]/@xmi:id,
                            $output-schema[count($service-output-message-dependency) = 1]/@xmi:id,
                            $fault-schema[count($service-fault-message-dependency) = 1]/@xmi:id))">
                        <xsl:sort select="
                                (xoev:ids-to-elements(., root($service-klasse))/xoev:xsdSchema(.)/@schemaLocation,
                                concat(xoev:ids-to-elements(., root($service-klasse))/ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase,
                                xoev:ids-to-elements(., root($service-klasse))/xoev:xsdSchema(.)/@schemaFile))[1]"/>
                        <xsl:variable name="schema" select="xoev:ids-to-elements(., root($service-klasse))"/>
                        <import namespace="{($schema/xoev:xsdSchema(.)/@namespace, $schema/ancestor::packagedElement/xoev:xsdXModel(.)/@namespace)[1]}" location="{($schema/xoev:xsdSchema(.)/@schemaLocation, 
                            concat($schema/ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase, $schema/xoev:xsdSchema(.)/@schemaFile))[1]}"/>
                    </xsl:for-each>
                    <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:message">
                        <xsl:with-param name="messages" select="$service-input-messages"/>
                        <xsl:with-param name="art">Input</xsl:with-param>
                    </xsl:apply-templates>
                    <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:message">
                        <xsl:with-param name="messages" select="$service-output-messages"/>
                        <xsl:with-param name="art">Output</xsl:with-param>
                    </xsl:apply-templates>
                    <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:message">
                        <xsl:with-param name="messages" select="$service-fault-messages"/>
                        <xsl:with-param name="art">Fault</xsl:with-param>
                    </xsl:apply-templates>
                    <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:port">
                        <xsl:with-param name="hat-fault-nachrichten" select="not(empty($service-fault-messages))"/>
                    </xsl:apply-templates>
                    <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:binding">
                        <xsl:with-param name="ist-request-response" select="true()"/>
                        <xsl:with-param name="hat-fault-nachrichten" select="not(empty($service-fault-messages))"/>
                    </xsl:apply-templates>
                    <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:service"/>
                </definitions>
            </xsl:with-param>
        </xsl:call-template>
    </xsl:template>
    <xsl:template match="packagedElement" mode="kosit-wsdl:standard-namespace">
        <xsl:variable name="service-klasse" select="."/>
        <xsl:choose>
            <xsl:when test="
                    ancestor::packagedElement/xoev:xoevStandard(.)/@kennung = ('urn:xoev-de:kosit:standard:xinneres.basismodul', 'urn:xoev-de:kosit:standard:xfamilie', 'urn:xoev-de:bva:standard:xbasisdaten') and
                    count(xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceMessage(.)]) = 1">
                <xsl:variable name="schema" select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceMessage(.)]/uml:resolve-supplier(.)/ancestor::packagedElement[xoev:xsdSchema(.)]"/>
                <xsl:namespace name="{$schema/xoev:xsdSchema(.)/@prefix}" select="$schema/xoev:getNamespace(.)"/>
            </xsl:when>
            <xsl:when test="
                    ancestor::packagedElement/xoev:xoevStandard(.)/@kennung = 'urn:xoev-de:bva:standard:xbasisdaten'">
                <xsl:variable name="input-schema" select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceInputMessage(.)]/uml:resolve-supplier(.)/ancestor::packagedElement[xoev:xsdSchema(.)]"/>
                <xsl:variable name="output-schema" select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceOutputMessage(.)]/uml:resolve-supplier(.)/ancestor::packagedElement[xoev:xsdSchema(.)]"/>
                <xsl:variable name="fault-schema" select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceFaultMessage(.)]/uml:resolve-supplier(.)/ancestor::packagedElement[xoev:xsdSchema(.)]"/>
                <xsl:for-each select="distinct-values(($input-schema/@xmi:id, $output-schema/@xmi:id, $fault-schema/@xmi:id))">
                    <xsl:sort select="
                            (xoev:ids-to-elements(., root($service-klasse))/xoev:xsdSchema(.)/@schemaLocation,
                            concat(xoev:ids-to-elements(., root($service-klasse))/ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase,
                            xoev:ids-to-elements(., root($service-klasse))/xoev:xsdSchema(.)/@schemaFile))[1]"/>
                    <xsl:variable name="schema" select="xoev:ids-to-elements(., root($service-klasse))"/>
                    <xsl:namespace name="{$schema/xoev:xsdSchema(.)/@prefix}" select="$schema/xoev:getNamespace(.)"/>
                </xsl:for-each>
            </xsl:when>
            <xsl:otherwise>
                <xsl:namespace name="{ancestor::packagedElement/xoev:xsdXModel(.)/@prefix}" select="ancestor::packagedElement/xoev:xsdXModel(.)/@namespace"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="packagedElement" mode="kosit-wsdl:wsdl-document-one-way-active">
        <xsl:variable name="service-klasse" select="."/>
        <xsl:variable name="service-message-dependency" select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceMessage(.)]"/>
        <xsl:variable name="service-messages" select="$service-message-dependency/uml:resolve-supplier(.)"/>
        <xsl:call-template name="xgen:result-document">
            <xsl:with-param name="local-path" select="
                    if (ancestor::packagedElement/kosit-wsdl:wsdlKonfiguration(.)/@Dateipraefix = 'ModelName') then
                        xs:anyURI(concat(ancestor::packagedElement[xoev:xsdXModel(.)]/@name, '.', kosit-wsdl:service-name($service-klasse), '.wsdl'))
                    else
                        xs:anyURI(concat(kosit-wsdl:service-name($service-klasse), '.wsdl'))"/>
            <xsl:with-param name="content">
                <xsl:comment> Service </xsl:comment>
                <definitions name="{kosit-wsdl:service-name($service-klasse)}" targetNamespace="{kosit-wsdl:namensraum($service-klasse)}" xsi:schemaLocation="http://schemas.xmlsoap.org/wsdl/ http://schemas.xmlsoap.org/wsdl/">
                    <xsl:namespace name="tns" select="kosit-wsdl:namensraum($service-klasse)"/>
                    <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:standard-namespace"/>
                    <xsl:variable name="begin-cdata"><![CDATA[<![CDATA[]]></xsl:variable>
                    <xsl:variable name="end-cdata"><![CDATA[]]]]><![CDATA[>]]></xsl:variable>
                    <documentation>
                        <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:categories"/>
                        <xsl:value-of select="xgen:unescaped-xml($begin-cdata)"/>
                        <html>
                            <xsl:variable name="servicelist" select="concat('&amp;', 'servicelist;')"/>
                            <xsl:value-of select="xgen:unescaped-xml(substring-before(ownedComment/body[. != ''], $servicelist))"/>
                            <xsl:sequence select="kosit-wsdl:html-ul-fuer-nachrichtenmenge($service-messages)"/>
                            <xsl:value-of select="xgen:unescaped-xml(substring-after(ownedComment/body[. != ''], $servicelist))"/>
                        </html>
                        <xsl:value-of select="xgen:unescaped-xml($end-cdata)"/>
                    </documentation>
                    <import namespace="http://www.osci.de/2006/07/wsdl/" location="http://www.osci.de/wsdl-osci-binding/WSDL-OSCI-Binding_1.2.xsd"/>
                    <xsl:choose>
                        <xsl:when test="count($service-message-dependency) = 1">
                            <xsl:variable name="schema" select="$service-messages/ancestor::packagedElement[xoev:xsdSchema(.)]"/>
                            <import namespace="{xoev:getNamespace($schema)}" location="{($schema/xoev:xsdSchema(.)/@schemaLocation, 
                                concat($schema/ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase, $schema/xoev:xsdSchema(.)/@schemaFile))[1]}"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <wsdl:types>
                                <xsl:apply-templates select="$service-klasse[count($service-message-dependency) gt 1]" mode="kosit-wsdl:schema-fuer-nachrichtenmenge">
                                    <xsl:with-param name="messages" select="$service-messages"/>
                                    <xsl:with-param name="art"/>
                                </xsl:apply-templates>
                            </wsdl:types>
                        </xsl:otherwise>
                    </xsl:choose>
                    <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:message">
                        <xsl:with-param name="messages" select="$service-messages"/>
                        <xsl:with-param name="art"/>
                    </xsl:apply-templates>
                    <xsl:variable name="service-klasse-upper-camel-case" select="
                            concat(upper-case(substring($service-klasse/@name, 1, 1)), substring($service-klasse/@name, 2, string-length($service-klasse/@name)))"/>
                    <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:port">
                        <xsl:with-param name="ist-one-way-active" select="true()"/>
                    </xsl:apply-templates>
                    <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:binding"/>
                    <xsl:apply-templates select="$service-klasse" mode="kosit-wsdl:service"/>
                </definitions>
            </xsl:with-param>
        </xsl:call-template>
    </xsl:template>
    <xsl:template match="packagedElement" mode="kosit-wsdl:wsdl-document-request-response-operations">
        <xsl:variable name="service-klasse" select="."/>
        <xsl:variable name="version-standard" select="replace($xoev:my-xmodel/xoev:xoevVersionStandard(.)/@version, '\.', '_')"/>
        <xsl:call-template name="xgen:result-document">
            <xsl:with-param name="local-path" select="
                    xs:anyURI(concat(lower-case($xoev:my-xmodel/@name), '-', $service-klasse/@name, '_', $version-standard, '.wsdl'))"/>
            <xsl:with-param name="content">
                <wsdl:definitions name="xpsrService" xsl:exclude-result-prefixes="tpl osci ds ns xsi xs">
                    <xsl:variable name="schemaTarget" select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlSchemaTarget(.)]/uml:resolve-supplier(.)"/>
                    <xsl:variable name="schemaImports" select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlSchemaImport(.)]/uml:resolve-supplier(.)"/>
                    <xsl:namespace name="xslt">http://xml.apache.org/xslt</xsl:namespace>
                    <xsl:namespace name="xs">http://www.w3.org/2001/XMLSchema</xsl:namespace>
                    <xsl:for-each select="$schemaImports">
                        <xsl:sort select="@name"/>
                        <xsl:variable name="prefix" select="(kosit:dependencies-by-supplier(.)[xoev:xsdImport(.) and uml:resolve-client(.)/ancestor::packagedElement[xoev:xoevStandard(.)] = $xoev:my-xmodel]/xoev:xsdImport(.)/@prefix, xoev:xsdSchema(.)/@prefix)[1]"/>
                        <xsl:namespace name="{($prefix, ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1]}" select="(xoev:xsdSchema(.)/@namespace, ancestor::packagedElement/xoev:xsdXModel(.)/@namespace)[1]"/>
                    </xsl:for-each>
                    <xsl:for-each select="$schemaTarget">
                        <xsl:namespace name="{(xoev:xsdSchema(.)/@prefix, ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1]}" select="(xoev:xsdSchema(.)/@namespace, ancestor::packagedElement/xoev:xsdXModel(.)/@namespace)[1]"/>
                        <xsl:namespace name="tns" select="(xoev:xsdSchema(.)/@namespace, ancestor::packagedElement/xoev:xsdXModel(.)/@namespace)[1]"/>
                        <xsl:attribute name="targetNamespace" select="(xoev:xsdSchema(.)/@namespace, ancestor::packagedElement/xoev:xsdXModel(.)/@namespace)[1]"/>
                    </xsl:for-each>
                    <xsl:namespace name="soap">http://schemas.xmlsoap.org/wsdl/soap/</xsl:namespace>
                    <wsdl:types>
                        <xs:schema elementFormDefault="qualified" targetNamespace="{$schemaTarget/(xoev:xsdSchema(.)/@namespace, ancestor::packagedElement/xoev:xsdXModel(.)/@namespace)[1]}">
                            <xs:include schemaLocation="{if(ancestor::packagedElement/xoev:xsdXModel(.)/@deployment = 'true') then 
                                ($schemaTarget/xoev:xsdSchema(.)/@schemaLocation, concat(ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase,$schemaTarget/xoev:xsdSchema(.)/@schemaFile))[1] else $schemaTarget/xoev:xsdSchema(.)/@schemaFile}"/>
                            <xsl:for-each select="$schemaImports">
                                <xs:import schemaLocation="{if(ancestor::packagedElement/xoev:xsdXModel(.)/@deployment = 'true') then 
                                    (xoev:xsdSchema(.)/@schemaLocation, concat(ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase,xoev:xsdSchema(.)/@schemaFile))[1] else xoev:xsdSchema(.)/@schemaFile}" namespace="{(xoev:xsdSchema(.)/@namespace, ancestor::packagedElement/xoev:xsdXModel(.)/@namespace)[1]}"/>
                            </xsl:for-each>
                        </xs:schema>
                    </wsdl:types>
                    <xsl:for-each select="$service-klasse/ownedOperation">
                        <xsl:sort select="@name"/>
                        <xsl:variable name="in-type" select="ownedParameter[@direction = 'in']/uml:resolve-type(.)"/>
                        <xsl:variable name="return-type" select="ownedParameter[@direction = 'return']/uml:resolve-type(.)"/>
                        <wsdl:message name="{$in-type/@name}Request">
                            <wsdl:part element="xpsrn:{$in-type/@name}" name="parameters"/>
                        </wsdl:message>
                        <wsdl:message name="{$in-type/@name}Response">
                            <wsdl:part element="xpsrn:{$return-type/@name}" name="return"/>
                        </wsdl:message>
                    </xsl:for-each>
                    <xsl:for-each select="distinct-values($service-klasse/ownedOperation/tokenize(@raisedException, ' '))">
                        <xsl:sort select="xoev:ids-to-elements(., $xoev:my-xmodel)/@name"/>
                        <xsl:variable name="exception-name" select="xoev:ids-to-elements(., $xoev:my-xmodel)/@name"/>
                        <wsdl:message name="{substring($exception-name,1, string-length($exception-name)-4)}">
                            <wsdl:part element="xpsrn:{$exception-name}" name="faultInfo"/>
                        </wsdl:message>
                    </xsl:for-each>
                    <wsdl:portType name="xpsrRegisterInterface">
                        <xsl:for-each select="$service-klasse/ownedOperation">
                            <xsl:sort select="@name"/>
                            <xsl:variable name="in-type" select="ownedParameter[@direction = 'in']/uml:resolve-type(.)"/>
                            <xsl:variable name="return-type" select="ownedParameter[@direction = 'return']/uml:resolve-type(.)"/>
                            <wsdl:operation name="{$in-type/@name}">
                                <wsdl:input message="tns:{$in-type/@name}Request"/>
                                <wsdl:output message="tns:{$in-type/@name}Response"/>
                                <xsl:for-each select="distinct-values(tokenize(@raisedException, ' '))">
                                    <xsl:sort select="xoev:ids-to-elements(., $xoev:my-xmodel)/@name"/>
                                    <xsl:variable name="exception-name" select="xoev:ids-to-elements(., $xoev:my-xmodel)/@name"/>
                                    <xsl:variable name="exception-name-substring" select="substring($exception-name, 1, string-length($exception-name) - 4)"/>
                                    <wsdl:fault message="tns:{$exception-name-substring}" name="{$exception-name-substring}"/>
                                </xsl:for-each>
                            </wsdl:operation>
                        </xsl:for-each>
                    </wsdl:portType>
                    <wsdl:binding type="tns:xpsrRegisterInterface" name="xpsrSOAPBinding">
                        <soap:binding transport="http://schemas.xmlsoap.org/soap/http" style="document"/>
                        <xsl:for-each select="ownedOperation">
                            <xsl:sort select="@name"/>
                            <xsl:variable name="in-type" select="ownedParameter[@direction = 'in']/uml:resolve-type(.)"/>
                            <xsl:variable name="return-type" select="ownedParameter[@direction = 'return']/uml:resolve-type(.)"/>
                            <xsl:comment select="concat($in-type/@name, ' ...........................')"/>
                            <wsdl:operation name="{$in-type/@name}">
                                <soap:operation soapAction="http://epr.mni.fh-giessen.de/epr/{$in-type/@name}"/>
                                <wsdl:input>
                                    <soap:body use="literal"/>
                                </wsdl:input>
                                <wsdl:output>
                                    <soap:body use="literal"/>
                                </wsdl:output>
                                <xsl:for-each select="distinct-values(tokenize(@raisedException, ' '))">
                                    <xsl:sort select="xoev:ids-to-elements(., $xoev:my-xmodel)/@name"/>
                                    <xsl:variable name="exception-name" select="xoev:ids-to-elements(., $xoev:my-xmodel)/@name"/>
                                    <xsl:variable name="exception-name-substring" select="substring($exception-name, 1, string-length($exception-name) - 4)"/>
                                    <wsdl:fault name="{$exception-name-substring}">
                                        <soap:fault use="literal" name="{$exception-name-substring}"/>
                                    </wsdl:fault>
                                </xsl:for-each>
                            </wsdl:operation>
                        </xsl:for-each>
                    </wsdl:binding>
                    <wsdl:service name="xpsrRegisterService">
                        <wsdl:port name="xpsrRegisterPort" binding="tns:xpsrSOAPBinding">
                            <soap:address location="http://localhost:8080/"/>
                        </wsdl:port>
                    </wsdl:service>
                </wsdl:definitions>
            </xsl:with-param>
        </xsl:call-template>
    </xsl:template>
    <xsl:template match="packagedElement" mode="kosit-wsdl:categories">
        <xsl:variable name="kategorien" select="kosit-wsdl:wsdlService(.)/KategorieDesDienstanbieters"/>
        <xsl:if test="not(empty($kategorien))">
            <tpl:categories>
                <xsl:for-each select="$kategorien">
                    <xsl:sort select="."/>
                    <tpl:category>
                        <xsl:value-of select="."/>
                    </tpl:category>
                </xsl:for-each>
            </tpl:categories>
        </xsl:if>
    </xsl:template>
</xsl:stylesheet>
