<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:app="http://www.xoev.de/de/xgenerator/framework/1/application"
                xmlns:kosit-wsdl="http://www.xoev.de/de/kosit-zubehoer/wsdl/3_1_0"
                xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML"
                xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl"
                xmlns:xgen="http://www.xoev.de/de/xgenerator/framework/1/library"
                xmlns:xmi="http://www.omg.org/spec/XMI/20131001"
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="2.0">
   <xsl:variable name="kosit-wsdl:profile-application"
                 select="$xgen:profile-applications/xgen:profile-application[@name = 'OSCI-Transport-Profil']"
                 as="element(xgen:profile-application)?"/>
   <xsl:variable name="kosit-wsdl:version">3.1.0</xsl:variable>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlService"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlService']"
            use="(@base_Class)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlService.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlService" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlService', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlServiceMessage"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlServiceMessage']"
            use="(@base_Dependency)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlServiceMessage.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlServiceMessage" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlServiceMessage', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:osciTransportScenario"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='osciTransportScenario']"
            use="(@base_Class)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp osciTransportScenario.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:osciTransportScenario" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:osciTransportScenario', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlServiceInputMessage"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlServiceInputMessage']"
            use="(@base_Dependency)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlServiceInputMessage.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlServiceInputMessage" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlServiceInputMessage', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlServiceOutputMessage"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlServiceOutputMessage']"
            use="(@base_Dependency)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlServiceOutputMessage.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlServiceOutputMessage" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlServiceOutputMessage', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlServiceFaultMessage"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlServiceFaultMessage']"
            use="(@base_Dependency)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlServiceFaultMessage.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlServiceFaultMessage" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlServiceFaultMessage', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlServiceAndOperations"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlServiceAndOperations']"
            use="(@base_Class)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlServiceAndOperations.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlServiceAndOperations" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlServiceAndOperations', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlBinding"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlBinding']"
            use="(@base_Element)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlBinding.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlBinding" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlBinding', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlBindingType"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlBindingType']"
            use="(@base_Dependency)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlBindingType.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlBindingType" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlBindingType', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlMessage"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlMessage']"
            use="(@base_Element)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlMessage.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlMessage" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlMessage', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlOperation"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlOperation']"
            use="(@base_Feature)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlOperation.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlOperation" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlOperation', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlOperationInputHeaderPart"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlOperationInputHeaderPart']"
            use="(@base_Dependency)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlOperationInputHeaderPart.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlOperationInputHeaderPart" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlOperationInputHeaderPart', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlOperationOutputHeaderPart"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlOperationOutputHeaderPart']"
            use="(@base_Dependency)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlOperationOutputHeaderPart.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlOperationOutputHeaderPart" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlOperationOutputHeaderPart', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlPortType"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlPortType']"
            use="(@base_Class)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlPortType.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlPortType" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlPortType', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlSchemaTarget"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlSchemaTarget']"
            use="(@base_Dependency)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlSchemaTarget.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlSchemaTarget" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlSchemaTarget', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlSchemaImport"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlSchemaImport']"
            use="(@base_Dependency)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlSchemaImport.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlSchemaImport" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlSchemaImport', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:wsdlKonfiguration"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='wsdlKonfiguration']"
            use="(@base_Model)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp wsdlKonfiguration.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:wsdlKonfiguration" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:wsdlKonfiguration', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
   <xd:doc>
      <xd:desc>Internal access key. Do not use directly.</xd:desc>
   </xd:doc>
   <xsl:key name="kosit-wsdl:Info"
            match="/xmi:XMI/*[namespace-uri() = $kosit-wsdl:profile-application/@nsURI and local-name()='Info']"
            use="(@base_Package)[1]"/>
   <xd:doc>
      <xd:desc>Access function for applications of stereotyp Info.</xd:desc>
      <xd:param name="model-element">Model element, e. g., packagedElement, ownedAttribut, uml:Model</xd:param>
      <xd:return>Stereotype application (e. g. xsdSchema) or empty sequence.</xd:return>
   </xd:doc>
   <xsl:function name="kosit-wsdl:Info" as="element()?">
      <xsl:param name="model-element" as="element()"/>
      <xsl:sequence select="key('kosit-wsdl:Info', $model-element/@xmi:id, root($model-element))"/>
   </xsl:function>
</xsl:stylesheet>
