<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:log="http://www.xoev.de/de/xgenerator/framework/1/log" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" xmlns:xgen="http://www.xoev.de/de/xgenerator/framework/1/library" xmlns:xoev="http://www.xoev.de/de/xoev-profil/3_0_2" xmlns:xoev-sch="http://www.xoev.de/de/xoev-profil/schematron/3_0_2" xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML" xmlns:kosit="http://www.xoev.de/de/kosit-zubehoer/3_1_0" xmlns:dsmeld="http://www.xoev.de/de/kosit-zubehoer/dsmeld/3_1_0" xmlns:kosit-codelisten="http://www.xoev.de/de/kosit-zubehoer/codelisten/3_1_0" xmlns:kosit-wsdl="http://www.xoev.de/de/kosit-zubehoer/wsdl/3_1_0" xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl" xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:svg="http://www.w3.org/2000/svg" xmlns:xinclude="http://www.w3.org/2001/XInclude" version="2.0" exclude-result-prefixes="xsl xmi xgen xoev uml xd log xs kosit svg xinclude kosit-wsdl kosit-codelisten xoev-sch dsmeld">
   <xsl:template match="/" mode="kosit:default">
      <xsl:apply-templates select="$xoev:my-xmodel/descendant-or-self::packagedElement[kosit:docGeneration(.)]" mode="kosit:package"/>
      <xsl:apply-templates select="
            $xoev:my-xmodel/descendant::packagedElement[$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereAnhangNachrichtentabellen = 'true' and
            @name = 'Nachrichten']/descendant::packagedElement[
            uml:is-Package(.) and
            ancestor-or-self::packagedElement[xoev:xsdSchema(.)] and
            descendant::packagedElement[xoev:xsdMessage(.)]]" mode="kosit:informaltable-for-messages-in-package"/>
      <xsl:apply-templates select="$xoev:my-xmodel/descendant-or-self::packagedElement[xoev:xsdSchema(.)]" mode="kosit:informaltable-for-schema-package-overview"/>
      <xsl:apply-templates select="
            $xoev:my-xmodel/descendant-or-self::packagedElement[$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereWSDLMethoden and
            kosit-wsdl:wsdlServiceAndOperations(.)]/ownedOperation" mode="kosit:section-for-wsdl-method"/>
      <xsl:apply-templates select="
            $xoev:my-xmodel/descendant-or-self::packagedElement[
            $xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereNutzungKomplexerTypen = 'true' and not(xoev:xsdDraft(.)) and (xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.))]" mode="kosit:section-for-type-usage"/>
      <xsl:call-template name="kosit:informaltable-for-messages-in-standard"/>
      <xsl:call-template name="kosit:section-for-codelists"/>
      <xsl:call-template name="kosit:section-for-code-uebersichtstabelle"/>
      <xsl:call-template name="kosit:section-for-externeModelle"/>
      <xsl:call-template name="kosit:section-for-codes-overview"/>
      <xsl:call-template name="kosit:types-and-structures"/>
      <xsl:call-template name="kosit:messages-and-structures"/>
      <xsl:call-template name="kosit:entitys-for-datatypes"/>
      <xsl:call-template name="kosit:entitys-for-rechtsgrundlagen"/>
      <xsl:call-template name="kosit:entitys-for-elements"/>
      <xsl:call-template name="kosit:entitys-for-messages"/>
      <xsl:call-template name="kosit:entitys-for-xgen-ent"/>
      <xsl:call-template name="kosit:appendix-for-not-used-types"/>
      <xsl:apply-templates select="$xoev:my-xmodel/descendant-or-self::packagedElement[xoev:xsdSchema(.)]" mode="kosit:section-for-aggregated-datatypes"/>
      <xsl:if test="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@verwendungBasismodul = 'true'">
         <xsl:call-template name="kosit:section-for-usage-basismodul"/>
      </xsl:if>
      <xsl:if test="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereNachrichtenDiensteUebersicht = 'true'">
         <xsl:call-template name="kosit:xsd-for-message-service-overview"/>
         <xsl:call-template name="kosit:xml-for-message-service-overview"/>
      </xsl:if>
      <xsl:if test="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereWSDLTabelle = 'true'">
         <xsl:choose>
            <xsl:when test="$xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung = 'urn:xoev-de:kosit:standard:xinneres.basismodul'">
               <xsl:call-template name="kosit:table-for-basismodul-wsdl"/>
            </xsl:when>
            <xsl:otherwise>
               <xsl:call-template name="kosit:table-for-wsdl"/>
            </xsl:otherwise>
         </xsl:choose>
      </xsl:if>
      <xsl:for-each select="root()/(descendant::packagedElement | descendant::nestedClassifier)[kosit-wsdl:wsdlService(.)]">
         <xsl:variable name="service" select="."/>
         <xsl:for-each select="ownedAttribute[uml:is-Port(.)]">
            <xsl:variable name="port" select="."/>
            <xsl:variable name="port-type" select="$port/uml:resolve-type(.)/xoev:dependencies-by-client(.)[kosit-wsdl:wsdlBindingType(.)]/uml:resolve-supplier(.)"/>
            <xsl:apply-templates select="$port-type/ownedOperation[kosit-wsdl:wsdlOperation(.)/@istOptional = 'true']" mode="kosit:section-for-wsdl-method-standalone-xta">
               <xsl:with-param name="service" select="$service"/>
               <xsl:with-param name="port" select="$port"/>
            </xsl:apply-templates>
         </xsl:for-each>
      </xsl:for-each>
      <xsl:apply-templates select="$xoev:my-xmodel/(descendant::packagedElement | descendant::nestedClassifier)[kosit-wsdl:wsdlService(.)]/ownedAttribute[uml:is-Port(.)]" mode="kosit:section-for-wsdl-interface-xta"/>
      <xsl:call-template name="kosit:appendix-for-rule-overview-global-elements"/>
      <xsl:call-template name="kosit:appendix-for-rule-overview-types"/>
      <xsl:call-template name="kosit:code-typ-1-structure"/>
   </xsl:template>
   <xsl:template name="kosit:code-typ-1-structure">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('dokumente/anhang/structures/codes.xml')"/>
         <xsl:with-param name="content">
            <kosit:codelists>
               <xsl:for-each select="$uml:root-model/(descendant::packagedElement, descendant::nestedClassifier)/xoev:usages-by-client(.)[xoev:xoevCodeTyp1(.)]/uml:resolve-supplier(.)">
                  <xsl:sort select="xoev:dependencies-by-client(.)/uml:resolve-supplier(.)/xoev:xoevCodeliste(.)/@kennung"/>
                  <xsl:variable name="vcl" select="."/>
                  <xsl:variable name="cl" select="$vcl/xoev:dependencies-by-client(.)/uml:resolve-supplier(.)"/>
                  <xsl:variable name="usage" select="$vcl/xoev:usages-by-supplier(.)"/>
                  <xsl:variable name="code-spalte" select="
                        ($usage/xoev:xoevCodeTyp1(.)/@genutzteCodeSpalte,
                        $vcl/ownedAttribute[xoev:xoevCodelistenspalte(.)/@empfohleneCodeSpalte = 'true'],
                        $vcl/ownedAttribute[xoev:xoevCodelistenspalte(.)/@codeSpalte = 'true'])[1]"/>
                  <xsl:variable name="beschreibungsspalte" select="
                        ($usage/xoev:xoevCodeTyp1(.)/@genutzteBeschreibungsspalte,
                        $vcl/ownedAttribute[not(@xmi:id = $code-spalte/@xmi:id)])[1]"/>
                  <kosit:codelist urn="{$cl/xoev:xoevCodeliste(.)/@kennung}" id="tabelle.{replace(replace($cl/concat(xoev:xoevCodeliste(.)/@kennung, '.', @name), ':', '.'), '/', '_')}">
                     <xsl:for-each select="
                           $uml:root-model/packagedElement[@name = 'Codelisten']/descendant::packagedElement[
                           uml:is-InstanceSpecification(.) and @classifier = $vcl/@xmi:id and not(xoev:xoevCodelisteneintragDeprecated(.))]">
                        <xsl:sort select="
                              slot[uml:resolve-definingFeature(.)/@xmi:id = $code-spalte/@xmi:id]/value/@value/(if ($vcl/kosit:docNumerischeSortierung(.)) then
                                 number(normalize-space(.))
                              else
                                 normalize-space(.))"/>
                        <kosit:entry code="{slot[uml:resolve-definingFeature(.)/@xmi:id = $code-spalte/@xmi:id]/value/@value/normalize-space(.)}">
                           <xsl:value-of select="slot[uml:resolve-definingFeature(.)/@xmi:id = $beschreibungsspalte/@xmi:id]/value/@value/normalize-space(.)"/>
                        </kosit:entry>
                     </xsl:for-each>
                  </kosit:codelist>
               </xsl:for-each>
            </kosit:codelists>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:types-and-structures">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('dokumente/anhang/structures/types.xml')"/>
         <xsl:with-param name="content">
            <kosit:types>
               <xsl:for-each select="$uml:root-model/(descendant::packagedElement, descendant::nestedClassifier)[(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and not(ancestor::packagedElement[xoev:xoevKernkomponentenkatalog(.) or xoev:xoevAdapter(.)])]">
                  <xsl:sort select="xoev:type-name(.)"/>
                  <xsl:variable name="type" select="."/>
                  <kosit:type name="{xoev:type-name(.)}">
                     <xsl:if test="
                           $xoev:my-xmodel/(descendant::packagedElement, descendant::nestedClassifier)[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]
                           [@xmi:id = $type/@xmi:id]">
                        <xsl:attribute name="id" select="
                              concat(kosit:docbook-id(.), if (xoev:xsdGlobalElementAndNamedType(.)) then
                                 '-type'
                              else
                                 '')"/>
                     </xsl:if>
                     <xsl:attribute name="prefix" select="xoev:getPrefix(.)"/>
                     <xsl:apply-templates select="(xoev:allElements(.), xoev:allAttributes(.))" mode="kosit:type-structure">
                        <xsl:with-param name="path" select="''"/>
                        <xsl:with-param name="collected-type-ids" select="@xmi:id"/>
                        <xsl:sort select="
                              if (xoev:xsdAttribute(.)) then
                                 concat('@', @name)
                              else
                                 @name"/>
                     </xsl:apply-templates>
                  </kosit:type>
               </xsl:for-each>
            </kosit:types>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template match="ownedAttribute" mode="kosit:type-structure">
      <xsl:param name="path" as="xs:string"/>
      <xsl:param name="collected-type-ids"/>
      <xsl:variable name="property-name" select="
            if (xoev:is-ref(.)) then
               uml:resolve-type(.)/xoev:global-element-name(.)
            else
               @name"/>
      <xsl:variable name="property-path" select="
            concat($path, if (xoev:xsdAttribute(.)) then
               concat('@', $property-name)
            else
               $property-name)"/>
      <kosit:property name="{$property-path}"/>
      <xsl:if test="not(uml:resolve-type(.)/@xmi:id = $collected-type-ids)">
         <xsl:apply-templates select="uml:resolve-type(.)/(., xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]/uml:resolve-supplier(.))/(xoev:allElements(.), xoev:allAttributes(.))" mode="kosit:type-structure">
            <xsl:with-param name="path" select="concat($property-path, '/')"/>
            <xsl:with-param name="collected-type-ids" select="$collected-type-ids, uml:resolve-type(.)/@xmi:id"/>
         </xsl:apply-templates>
      </xsl:if>
   </xsl:template>
   <xsl:template name="kosit:messages-and-structures">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('dokumente/anhang/structures/messages.xml')"/>
         <xsl:with-param name="content">
            <kosit:messages>
               <xsl:for-each select="
                     $uml:root-model/(descendant::packagedElement, descendant::nestedClassifier)[xoev:xsdMessage(.) and not(ancestor::packagedElement[xoev:xoevKernkomponentenkatalog(.) or xoev:xoevAdapter(.)])]">
                  <xsl:sort select="@name"/>
                  <xsl:variable name="msg" select="."/>
                  <kosit:message name="{@name}" number="{tokenize(@name,'\.')[last()]}">
                     <xsl:if test="$xoev:my-xmodel/(descendant::packagedElement, descendant::nestedClassifier)[xoev:xsdMessage(.)][@xmi:id = $msg/@xmi:id]">
                        <xsl:attribute name="id" select="kosit:docbook-id(.)"/>
                     </xsl:if>
                     <xsl:attribute name="prefix" select="xoev:getPrefix(.)"/>
                     <kosit:title>
                        <xsl:value-of select="xoev:xsdTitled(.)/@title/xgen:unescaped-xml(.)"/>
                     </kosit:title>
                     <xsl:apply-templates select="(., xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]/uml:resolve-supplier(.))/(xoev:allElements(.), xoev:allAttributes(.))" mode="kosit:type-structure">
                        <xsl:with-param name="path" select="''"/>
                        <xsl:with-param name="collected-type-ids" select="@xmi:id"/>
                        <xsl:sort select="
                              if (xoev:xsdAttribute(.)) then
                                 concat('@', @name)
                              else
                                 @name"/>
                     </xsl:apply-templates>
                  </kosit:message>
               </xsl:for-each>
            </kosit:messages>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:appendix-for-not-used-types">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('dokumente/anhang/verwendung/complextypes.xml')"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE appendix [<!ENTITY % complete SYSTEM "../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <xsl:element name="appendix">
               <xsl:attribute name="version">5</xsl:attribute>
               <xsl:attribute name="xml:lang">de</xsl:attribute>
               <xsl:attribute name="xml:id">anhang.verwendung.complextype</xsl:attribute>
               <xsl:attribute name="status" select="concat(xgen:unescaped-xml('&amp;'),'specstatus;')"/>
               <xsl:attribute name="revision" select="concat(xgen:unescaped-xml('&amp;'),'xrecent;')"/>
               <title>Verwendung von Datenypen in Nachrichten</title>
               <para>Der Abschnitt <emphasis>Verwendung des Typs in Nachrichten</emphasis> am Ende einer Beschreibung eines Datentypen listet die Nummern der Nachrichten auf, in denen der vorher beschriebene Typ verwendet wird.</para>
               <para>Ein Typ gilt als verwendet, wenn er </para>
               <itemizedlist>
                  <listitem>
                     <para>direkt oder indirekt von einer Nachricht eingebunden wird. Im XML-Schema besitzt die Nachricht also mindestens ein Kindelement, von diesem Typen oder einer Spezialisierung dieses Typen.</para>
                  </listitem>
                  <listitem>
                     <para>ein Obertyp der Nachricht verwendet diesen Typen auf die vorherige Art.</para>
                  </listitem>
               </itemizedlist>
               <section>
                  <title>Nicht in Nachrichten verwendete Datentypen</title>
                  <itemizedlist>
                     <xsl:for-each select="$xoev:my-xmodel/descendant::packagedElement[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]">
                        <xsl:sort select="lower-case(xoev:type-name(.))"/>
                        <xsl:variable name="type" select="."/>
                        <xsl:if test="empty(key('messages-with-types-key', @xmi:id, $messages-with-types-var))">
                           <listitem>
                              <para>
                                 <xsl:value-of select="xoev:type-name(.)"/>
                              </para>
                           </listitem>
                        </xsl:if>
                     </xsl:for-each>
                  </itemizedlist>
               </section>
            </xsl:element>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:variable name="messages-with-types-var" as="document-node(element(messages-with-types))">
      <xsl:document>
         <messages-with-types xmlns="">
            <xsl:for-each select="$xoev:my-xmodel/descendant-or-self::packagedElement[not(xoev:xsdDraft(.)) and xoev:xsdMessage(.)]">
               <message xmlns="" id="{@xmi:id}" name="{@name}">
                  <xsl:sequence select="kosit:typesUsedInClass(., @xmi:id)"/>
               </message>
            </xsl:for-each>
         </messages-with-types>
      </xsl:document>
   </xsl:variable>
   <xsl:function name="kosit:typesUsedInClass" as="element()*">
      <xsl:param name="class" as="element()"/>
      <xsl:param name="collected-type-ids"/>
      <xsl:for-each select="
            ($class/xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]/uml:resolve-supplier(.),
            $class[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.) or xoev:xsdMessage(.) or xoev:xsdGlobalElement(.))]/generalization/uml:resolve-general(.)[$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@beruecksichtigungVererbungInComplexTypeVerwendung = 'true'],
            xoev:allElements($class)/uml:resolve-type(.))[not(@xmi:id = $collected-type-ids)]">
         <type xmlns="" id="{@xmi:id}" name="{xoev:type-name(.)}"/>
         <xsl:sequence select="kosit:typesUsedInClass(., ($collected-type-ids, @xmi:id))"/>
      </xsl:for-each>
   </xsl:function>
   <xsl:key name="messages-with-types-key" match="message" use="type/@id"/>
   <xsl:template match="packagedElement" mode="kosit:section-for-type-usage">
      <xsl:variable name="optional-prefix" select="
            if ($xoev:my-xmodel/descendant-or-self::packagedElement[not(xoev:xsdDraft(.)) and (xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and xoev:type-name(.) = current()/xoev:type-name(.) and not(@xmi:id = current()/@xmi:id)]) then
               (ancestor::packagedElement/xoev:xsdSchema(.)/@prefix, $xoev:my-xmodel/xoev:xsdXModel(.)/@prefix)[1]
            else
               ''"/>
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="
               xs:anyURI(concat('dokumente/anhang/verwendung/complexTypes/', concat($optional-prefix, lower-case(replace(@name, '-', '_'))), if (xoev:xsdGlobalElementAndNamedType(.)) then
                  '-type'
               else
                  '', '_list.xml'))"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE section [<!ENTITY % complete SYSTEM "../../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <xsl:element name="section">
               <xsl:attribute name="version">5</xsl:attribute>
               <xsl:attribute name="xml:lang">de</xsl:attribute>
               <title>Nutzung des Datentyps</title>
               <xsl:variable name="messages" select="key('messages-with-types-key', @xmi:id, $messages-with-types-var)"/>
               <xsl:variable name="types" select="
                     $xoev:my-xmodel/descendant::packagedElement[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.) or xoev:xsdGlobalElementAndNamedType(.) or xoev:xsdMessage(.)) and
                     (some $g in generalization
                        satisfies $g/uml:resolve-general(.)/@xmi:id = current()/@xmi:id)]"/>
               <xsl:if test="$messages">
                  <xsl:variable name="test" select="."/>
                  <para role="left-aligned">
                     <xsl:text>Dieser Typ kann in den folgenden Nachrichten übermittelt werden: </xsl:text>
                     <xsl:for-each select="$messages">
                        <xsl:sort select="tokenize(xoev:ids-to-elements(@id, root($test))/@name, '\.')[last()]"/>
                        <xsl:variable name="message" select="xoev:ids-to-elements(@id, root($test))"/>
                        <link linkend="{kosit:docbook-id($message)}">
                           <xsl:value-of select="tokenize($message/@name, '\.')[last()]"/>
                        </link>
                        <xsl:if test="position() != last()">, </xsl:if>
                     </xsl:for-each>
                  </para>
               </xsl:if>
               <xsl:if test="$types">
                  <para role="left-aligned">Von diesem Typ leiten ab: <xsl:for-each select="$types">
                        <xsl:sort select="
                              if (xoev:xsdNamedType(.)) then
                                 xoev:type-name(.)
                              else
                                 if (xoev:xsdGlobalElement(.)) then
                                    xoev:global-element-name(.)
                                 else
                                    @name"/>
                        <xsl:choose>
                           <xsl:when test="xoev:xsdGlobalElementAndNamedType(.)">
                              <link linkend="{kosit:docbook-id(.)}-type">
                                 <xsl:value-of select="xoev:type-name(.)"/>
                              </link>
                              <link linkend="{kosit:docbook-id(.)}">
                                 <xsl:value-of select="xoev:global-element-name(.)"/>
                              </link>
                           </xsl:when>
                           <xsl:otherwise>
                              <link linkend="{kosit:docbook-id(.)}">
                                 <xsl:value-of select="
                                       if (xoev:xsdNamedType(.)) then
                                          xoev:type-name(.)
                                       else
                                          xoev:global-element-name(.)"/>
                              </link>
                           </xsl:otherwise>
                        </xsl:choose>
                        <xsl:if test="position() != last()">, </xsl:if>
                     </xsl:for-each>
                  </para>
               </xsl:if>
               <xsl:if test="not($messages) and not($types)">
                  <para/>
               </xsl:if>
            </xsl:element>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:section-for-usage-basismodul">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('dokumente/anhang/verwendungBasismodul/verwendungBasismodul.xml')"/>
         <xsl:with-param name="content">
            <xsl:variable name="section-type" select="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@rootElementVerwendungBasismodul"/>
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE]]>
               <xsl:value-of select="$section-type"/>
               <![CDATA[[
<!ENTITY % complete SYSTEM "]]>../../../../../ent/complete.ent<![CDATA[">
%complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml(string-join($doctype, ''))"/>
            <xsl:element name="{$section-type}">
               <xsl:attribute name="version">5</xsl:attribute>
               <xsl:attribute name="xml:lang">de</xsl:attribute>
               <xsl:attribute name="xml:id">verwendungBasismodul</xsl:attribute>
               <xsl:attribute name="status" select="concat(xgen:unescaped-xml('&amp;'),'specstatus;')"/>
               <xsl:attribute name="revision" select="concat(xgen:unescaped-xml('&amp;'),'xrecent;')"/>
               <title><xsl:text>Verwendung des Basismoduls durch </xsl:text><xsl:value-of select="xgen:unescaped-xml('&amp;')"/>fachmodul;</title>
               <para>Mit dem XInneres-Basismodul werden Datentypen, Nachrichten, Prozesse und Codelisten zur Wiederverwendung in den XInneres Fachmodulen bereitgestellt.</para>
               <para>Das Fachmodul <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>fachmodul; bindet derzeit das XInneres-Basismodul Version <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>basismodul.version; ein. Sowohl die Dokumentation als auch die XML-Schemadateien werden unter http://www.osci.de/xinneres/ zum Download bereitgestellt.</para>
               <section>
                  <title>Verwendung von Datentypen</title>
                  <para>In der folgenden Tabelle sind sämtliche durch das Fachmodul <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>fachmodul; verwendete Datentypen aus dem XInneres-Basismodul und ihre jeweilige Version aufgeführt. Die Version des Datentyps entspricht der Version der Schemadatei. Anforderungen und Hinweise zur technischen Umsetzung finden sich in den Kapiteln des XInneres-Basismoduls, in denen die Datentypen beschrieben werden.</para>
                  <table xml:id="tabelle.verwendungBasismodul.datentypen">
                     <title>Verwendete Datentypen des XInneres-Basismoduls Version <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>basismodul.version;</title>
                     <tgroup cols="3">
                        <colspec colname="dt" colnum="1" colwidth="84mm"/>
                        <colspec colname="sd" colnum="2" colwidth="60mm"/>
                        <colspec colname="v" colnum="3" colwidth="14mm"/>
                        <thead>
                           <row>
                              <entry morerows="1">Datentyp</entry>
                              <entry namest="sd" nameend="v" align="center">Basismodul Version <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>basismodul.version;</entry>
                           </row>
                           <row>
                              <entry>Schemadatei</entry>
                              <entry>Version</entry>
                           </row>
                        </thead>
                        <tbody>
                           <xsl:for-each select="
                                 $uml:root-model/descendant::packagedElement[xoev:xsdXModel(.) and xoev:xoevStandard(.)/@kennung = 'urn:xoev-de:kosit:standard:xinneres.basismodul']/descendant::packagedElement[
                                 (xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and ((some $e in $xoev:my-xmodel/descendant::ownedAttribute[xoev:is-element(.) or xoev:xsdAttribute(.)]
                                    satisfies
                                    uml:resolve-type($e)/@xmi:id = @xmi:id) or (some $t in $xoev:my-xmodel/descendant::packagedElement
                                    satisfies
                                    $t/generalization/uml:resolve-general(.)/@xmi:id = @xmi:id))]">
                              <xsl:sort select="xoev:type-name(.)"/>
                              <row>
                                 <entry>
                                    <xsl:value-of select="xoev:type-name(.)"/>
                                 </entry>
                                 <entry>
                                    <xsl:value-of select="ancestor::packagedElement/xoev:xsdSchema(.)/@schemaFile"/>
                                 </entry>
                                 <entry>
                                    <xsl:value-of select="ancestor::packagedElement/xoev:xsdSchema(.)/@version"/>
                                 </entry>
                              </row>
                           </xsl:for-each>
                        </tbody>
                     </tgroup>
                  </table>
                  <para>Die Verwendung der Datentypen im Fachmodul erfolgt durch ein Import des entsprechenden XML-Schemas aus dem Basismodul. Die Verwendung umfasst die <orderedlist>
                        <listitem>
                           <para>unveränderte Nutzung,</para>
                        </listitem>
                        <listitem>
                           <para>Erweiterung oder</para>
                        </listitem>
                        <listitem>
                           <para>Einschränkung</para>
                        </listitem>
                     </orderedlist> der im Fachmodul benötigten Datentypen. Erweiterungen und Einschränkungen werden im Fachmodul <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>fachmodul; dokumentiert.</para>
               </section>
               <section>
                  <title>Verwendung von Prozessen</title>
                  <para>Das Fachmodul <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>fachmodul; verwendet folgende durch das XInneres-Basismodul bereitgestellten Prozesse und die darin verwendeten Nachrichten.</para>
                  <para>In der Tabelle sind die verwendeten Prozesse, die davon genutzten Schemadateien und deren Version aufgeführt. In den Schemadateien sind die verwendeten Nachrichten beschrieben. Darüber hinaus ist in der Tabelle ein Verweis auf das Kapitel im Fachmodul vorhanden, in dem die Verwendung der Prozesse und Nachrichten aus dem XInneres-Basismodul konkretisiert werden.</para>
                  <table xml:id="tabelle.verwendungBasismodul.prozesse">
                     <title>Verwendete Prozesse des XInneres-Basismoduls Version <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>basismodul.version;</title>
                     <tgroup cols="4">
                        <colspec colname="p" colnum="1" colwidth="74mm"/>
                        <colspec colname="s" colnum="2" colwidth="58mm"/>
                        <colspec colname="v" colnum="3" colwidth="14mm"/>
                        <colspec colname="k" colnum="4" colwidth="12mm"/>
                        <thead>
                           <row>
                              <entry morerows="1">Prozess</entry>
                              <entry namest="s" nameend="v" align="center">Basismodul Version <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>basismodul.version;</entry>
                              <entry morerows="1">Seite</entry>
                           </row>
                           <row>
                              <entry>Schemadatei</entry>
                              <entry>Version</entry>
                           </row>
                        </thead>
                        <tbody>
                           <xsl:for-each select="$xoev:my-xmodel/xoev:dependencies-by-client(.)[kosit:docBasismodulProzess(.)]">
                              <xsl:sort select="uml:resolve-supplier(.)/xoev:xsdTitled(.)/@title"/>
                              <row>
                                 <entry>
                                    <xsl:value-of select="uml:resolve-supplier(.)/xoev:xsdTitled(.)/@title"/>
                                 </entry>
                                 <entry>
                                    <xsl:value-of select="uml:resolve-supplier(.)/xoev:xsdSchema(.)/@schemaFile"/>
                                 </entry>
                                 <entry>
                                    <xsl:value-of select="uml:resolve-supplier(.)/xoev:xsdSchema(.)/@version"/>
                                 </entry>
                                 <entry>
                                    <xsl:for-each select="kosit:docBasismodulProzess(.)/nutzendeFachmodulkapitel">
                                       <xsl:sort select="."/>
                                       <para>
                                          <xref linkend="{.}" role="Seitenzahl"/>
                                       </para>
                                    </xsl:for-each>
                                 </entry>
                              </row>
                           </xsl:for-each>
                        </tbody>
                     </tgroup>
                  </table>
               </section>
               <section>
                  <title>Zu verzeichnende Dienste</title>
                  <para>Die Nutzung eines Prozesses aus dem XInneres-Basismodul im Fachmodul <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>fachmodul; (s. o.) führt zur Verzeichnung eines entsprechenden Dienstes im DVDV. Die jeweils zur Verzeichnung verpflichteten Leistungserbringer sind nach dem jeweiligen Dienst kategorisiert in der folgenden Tabelle benannt.</para>
                  <table xml:id="tabelle.verwendungBasismodul.dienste">
                     <title>Zu verzeichnende Dienste des XInneres-Basismoduls Version <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>basismodul.version;</title>
                     <tgroup cols="3">
                        <colspec colname="w" colnum="1" colwidth="69mm"/>
                        <colspec colname="l" colnum="2" colwidth="69mm"/>
                        <colspec colname="n" colnum="3" colwidth="20mm"/>
                        <thead>
                           <row>
                              <entry>WSDL-Datei</entry>
                              <entry>Leistungserbringer</entry>
                              <entry>Nachrichten</entry>
                           </row>
                        </thead>
                        <tbody>
                           <xsl:for-each select="
                                 $uml:root-model/descendant::packagedElement[kosit-wsdl:wsdlService(.) and
                                 (some $d in $xoev:my-xmodel/xoev:dependencies-by-client(.)[kosit:docBasismodulProzess(.)]
                                    satisfies $d/uml:resolve-supplier(.)/@xmi:id = xoev:dependencies-by-client(.)[1]/uml:resolve-supplier(.)/ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id)]">
                              <xsl:sort select="
                                    (kosit-wsdl:wsdlService(.)/@Dateiname,
                                    concat(ancestor::packagedElement/xoev:xsdXModel(.)/@prefix, ancestor::packagedElement/xoev:xoevVersionStandard(.)/@version, @name))[1]"/>
                              <row>
                                 <entry><xsl:value-of select="
                                          (kosit-wsdl:wsdlService(.)/@Dateiname,
                                          concat(ancestor::packagedElement/xoev:xsdXModel(.)/@prefix,
                                          ancestor::packagedElement/xoev:xoevVersionStandard(.)/@version, @name))[1]"/>.wsdl</entry>
                                 <entry>
                                    <xsl:for-each select="$xoev:my-xmodel/xoev:dependencies-by-client(.)[kosit:docBasismodulProzess(.) and uml:resolve-supplier(.)/@xmi:id = current()/xoev:dependencies-by-client(.)[1]/uml:resolve-supplier(.)/ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id]/kosit:docBasismodulProzess(.)/leistungserbringer">
                                       <xsl:sort select="."/>
                                       <para>
                                          <xsl:value-of select="."/>
                                       </para>
                                    </xsl:for-each>
                                 </entry>
                                 <entry>
                                    <itemizedlist>
                                       <xsl:for-each select="xoev:dependencies-by-client(.)/uml:resolve-supplier(.)">
                                          <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                                          <listitem>
                                             <para>
                                                <xsl:value-of select="tokenize(@name, '\.')[last()]"/>
                                             </para>
                                          </listitem>
                                       </xsl:for-each>
                                    </itemizedlist>
                                 </entry>
                              </row>
                           </xsl:for-each>
                        </tbody>
                     </tgroup>
                  </table>
               </section>
               <section>
                  <title>Einheitliche organisatorische Festlegungen</title>
                  <para>Neben den oben genannten Datentypen, Nachrichten und Prozessen legt das Basismodul organisatorische Rahmenbedingungen fest, die für alle Fachmodule und das Basismodul gelten.</para>
                  <section>
                     <title>Verwendung von Schlüsseltabellen</title>
                     <para>Es gelten die im XInneres-Basismodul Version <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>basismodul.version; festgelegten Regelungen.</para>
                  </section>
                  <section>
                     <title>Fristen für die Gültigkeit von Versionen bei einem Versionswechsel</title>
                     <para>Es gelten die im XInneres-Basismodul Version <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>basismodul.version; festgelegten Regelungen.</para>
                  </section>
               </section>
               <xsl:if test="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@verweisHistorieInVerwendungBasismodul = 'true'">
                  <xsl:element name="include" namespace="http://www.w3.org/2001/XInclude">
                     <xsl:attribute name="href">../../../../../src/verwendungBasismodul/historie.xml</xsl:attribute>
                  </xsl:element>
               </xsl:if>
            </xsl:element>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template match="ownedOperation" mode="kosit:section-for-wsdl-method">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI(concat('dokumente/anhang/methoden/', @name, '.xml'))"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE section [<!ENTITY % complete SYSTEM "../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <xsl:element name="section">
               <xsl:attribute name="version">5</xsl:attribute>
               <xsl:attribute name="xml:lang">de</xsl:attribute>
               <xsl:attribute name="xml:id" select="concat('methoden.', @name)"/>
               <xsl:attribute name="status" select="concat(xgen:unescaped-xml('&amp;'),'specstatus;')"/>
               <xsl:attribute name="revision" select="concat(xgen:unescaped-xml('&amp;'),'xrecent;')"/>
               <info>
                  <title>
                     <xsl:value-of select="@name"/>
                  </title>
               </info>
               <xsl:choose>
                  <xsl:when test="
                        some $c in ownedComment/body
                           satisfies $c = '[nd]'"/>
                  <xsl:when test="ownedComment/body[. != '']">
                     <xsl:for-each select="ownedComment/body[. != '']">
                        <xsl:sort select="."/>
                        <xsl:value-of select="xgen:unescaped-xml(.)"/>
                     </xsl:for-each>
                  </xsl:when>
                  <xsl:otherwise>
                     <annotation role="todo">
                        <info>
                           <title>Dokumentation fehlt!</title>
                        </info>
                        <para>Dieses ToDo wurde automatisch generiert.</para>
                     </annotation>
                  </xsl:otherwise>
               </xsl:choose>
               <xsl:variable name="return-type" select="ownedParameter[@direction = 'return']/uml:resolve-type(.)"/>
               <xsl:variable name="in-type" select="ownedParameter[@direction = 'in']/uml:resolve-type(.)"/>
               <section>
                  <info>
                     <title>Signatur</title>
                  </info>
                  <xsl:variable name="quote">"</xsl:variable>
                  <para>
                     <programlisting><xsl:value-of select="
                              concat(if ($return-type/ownedAttribute[1][upperValue/@value = '*']) then
                                 'List&lt;'
                              else
                                 '', xgen:unescaped-xml('&lt;link role='), $quote, 'schwarz', $quote, ' linkend=', $quote, kosit:docbook-id($return-type), if ($return-type/xoev:xsdGlobalElementAndNamedType(.)) then
                                 '-type'
                              else
                                 '', $quote, xgen:unescaped-xml('&gt;'), $return-type/ownedAttribute[1]/uml:resolve-type(.)/xoev:type-name(.), xgen:unescaped-xml('&lt;/link&gt;'), if ($return-type/ownedAttribute[1][upperValue/@value = '*']) then
                                 '&gt;'
                              else
                                 '', ' ', xgen:unescaped-xml('&lt;link role='), $quote, 'schwarz', $quote, ' ', 'linkend=', $quote, kosit:docbook-id($in-type), if ($in-type/xoev:xsdGlobalElementAndNamedType(.)) then
                                 '-type'
                              else
                                 '', $quote, xgen:unescaped-xml('&gt;'), @name, xgen:unescaped-xml('&lt;/link&gt;'), '(', '&#xA;')"/><xsl:for-each select="$in-type/xoev:elements(.)"><xsl:sort select="xoev:position(.)"/><xsl:text>  </xsl:text><xsl:choose><xsl:when test="uml:resolve-type(.)/xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types'"><xsl:value-of select="uml:resolve-type(.)/xoev:type-name(.)"/></xsl:when><xsl:otherwise><link role="schwarz" linkend="{concat(kosit:docbook-id(uml:resolve-type(.)), if(uml:resolve-type(.)/xoev:xsdGlobalElementAndNamedType(.)) then '-type' else '')}"><xsl:value-of select="uml:resolve-type(.)/xoev:type-name(.)"/></link></xsl:otherwise></xsl:choose><xsl:text> </xsl:text><xsl:choose><xsl:when test="@name != ''"><xsl:value-of select="concat(lower-case(substring(@name, 1, 1)), substring(@name, 2))"/></xsl:when><xsl:otherwise><xsl:value-of select="concat(lower-case(substring(uml:resolve-type(.)/xoev:type-name(.), 1, 1)), substring(uml:resolve-type(.)/xoev:type-name(.), 2))"/></xsl:otherwise></xsl:choose><xsl:choose><xsl:when test="position() != last()"><xsl:text>,</xsl:text></xsl:when><xsl:otherwise><xsl:text> )</xsl:text></xsl:otherwise></xsl:choose><xsl:text>&#xA;</xsl:text></xsl:for-each><xsl:text>throws&#xA;</xsl:text><xsl:for-each select="tokenize(@raisedException, ' ')"><xsl:sort select="xoev:ids-to-elements(., $xoev:my-xmodel)/@name"/><xsl:text>  </xsl:text><link role="schwarz" linkend="{xoev:ids-to-elements(.,$xoev:my-xmodel)/concat(kosit:docbook-id(.), if(xoev:xsdGlobalElementAndNamedType(.)) then '-type' else '')}"><xsl:value-of select="substring-before(xoev:ids-to-elements(., $xoev:my-xmodel)/@name, 'Info')"/></link><xsl:if test="position() != last()"><xsl:text>,&#xA;</xsl:text></xsl:if></xsl:for-each></programlisting>
                  </para>
               </section>
               <xsl:if test="
                     $in-type/ownedAttribute[xoev:is-element(.) and not(some $c in ownedComment/body
                        satisfies $c = '[nd]') and ownedComment/body[. != '']]">
                  <section>
                     <info>
                        <title>Parameter</title>
                     </info>
                     <para>
                        <itemizedlist>
                           <xsl:for-each select="$in-type/xoev:elements(.)">
                              <xsl:sort select="xoev:position(.)"/>
                              <xsl:if test="
                                    not(some $c in ownedComment/body
                                       satisfies $c = '[nd]') and ownedComment/body[. != '']">
                                 <listitem>
                                    <para>
                                       <code>
                                          <xsl:choose>
                                             <xsl:when test="@name != ''">
                                                <xsl:value-of select="concat(lower-case(substring(@name, 1, 1)), substring(@name, 2))"/>
                                             </xsl:when>
                                             <xsl:otherwise>
                                                <xsl:value-of select="concat(lower-case(substring(uml:resolve-type(.)/xoev:type-name(.), 1, 1)), substring(uml:resolve-type(.)/xoev:type-name(.), 2))"/>
                                             </xsl:otherwise>
                                          </xsl:choose>
                                       </code>: </para>
                                    <xsl:for-each select="ownedComment/body[. != '']">
                                       <xsl:sort select="."/>
                                       <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                    </xsl:for-each>
                                 </listitem>
                              </xsl:if>
                           </xsl:for-each>
                        </itemizedlist>
                     </para>
                  </section>
               </xsl:if>
               <xsl:element name="include" namespace="http://www.w3.org/2001/XInclude">
                  <xsl:attribute name="href" select="concat('../../../../../src/methoden/', @name, '_voraussetzungen.xml')"/>
               </xsl:element>
               <xsl:element name="include" namespace="http://www.w3.org/2001/XInclude">
                  <xsl:attribute name="href" select="concat('../../../../../src/methoden/', @name, '_ergebnisse.xml')"/>
               </xsl:element>
            </xsl:element>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:entitys-for-xgen-ent">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('ent/xgen.ent')"/>
         <xsl:with-param name="content">
            <xsl:for-each select="
                  $uml:root-model/descendant::packagedElement[
                  xoev:xsdXModel(.) and xoev:xoevStandard(.)/@kennung = 'urn:xoev-de:kosit:standard:xinneres.basismodul']/xoev:xoevVersionStandard(.)/@version">
               <xsl:variable name="bv"><![CDATA[<!ENTITY]]> basismodul.version "<xsl:value-of select="."/>"></xsl:variable>
               <xsl:value-of select="xgen:unescaped-xml($bv)"/>
            </xsl:for-each>
            <xsl:variable name="sn"><![CDATA[<!ENTITY]]> standard.namespace "<xsl:value-of select="$xoev:my-xmodel/xoev:xsdXModel(.)/@namespace"/>"></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($sn)"/>
            <xsl:variable name="sv"><![CDATA[<!ENTITY]]> standard.version "<xsl:value-of select="$xoev:my-xmodel/xoev:xoevVersionStandard(.)/@version"/>"></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($sv)"/>
            <xsl:for-each select="$xoev:my-xmodel//packagedElement/xoev:xsdSchema(.)[@version[. != '']]">
               <xsl:sort select="@schemaFile"/>
               <xsl:variable name="mv"><![CDATA[<!ENTITY]]>
                  <xsl:value-of select="@schemaFile"/>.version "<xsl:value-of select="@version"/>"></xsl:variable>
               <xsl:value-of select="xgen:unescaped-xml($mv)"/>
            </xsl:for-each>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:entitys-for-messages">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('ent/nachrichten.ent')"/>
         <xsl:with-param name="content">
            <xsl:for-each select="$xoev:my-xmodel/descendant::packagedElement[xoev:xsdMessage(.) and not(xoev:xsdDraft(.))]">
               <xsl:sort select="tokenize(@name, '\.')[last()]"/>
               <xsl:variable name="mes"><![CDATA[<!ENTITY]]> nachricht.<xsl:value-of select="tokenize(@name, '\.')[last()]"/> "<xsl:value-of select="@name"/>"></xsl:variable>
               <xsl:variable name="mes-title"><![CDATA[<!ENTITY]]> nachricht.title.<xsl:value-of select="tokenize(@name, '\.')[last()]"/> "<xsl:value-of select="(xoev:xsdTitled(.)/@title, @name)[1]"/>"></xsl:variable>
               <xsl:variable name="mes-ref"><![CDATA[<!ENTITY]]> nachricht.ref.<xsl:value-of select="tokenize(@name, '\.')[last()]"/> "&lt;link linkend='<xsl:value-of select="kosit:docbook-id(.)"/>'>Nachricht <xsl:value-of select="tokenize(@name, '\.')[last()]"/>&lt;/link>"></xsl:variable>
               <xsl:value-of select="xgen:unescaped-xml($mes)"/>
               <xsl:text>
                    </xsl:text>
               <xsl:value-of select="xgen:unescaped-xml($mes-title)"/>
               <xsl:text>
                    </xsl:text>
               <xsl:value-of select="xgen:unescaped-xml($mes-ref)"/>
               <xsl:text>
                    </xsl:text>
            </xsl:for-each>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:entitys-for-rechtsgrundlagen">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('ent/rechtsgrundlagen.ent')"/>
         <xsl:with-param name="content">
            <xsl:for-each select="$xoev:my-xmodel/descendant::packagedElement[xoev:xsdMessage(.)]">
               <xsl:sort select="@name"/>
               <xsl:variable name="name" select="@name"/>
               <xsl:for-each select="xoev:xsdMessage(.)/rechtsgrundlagen[. != '']">
                  <xsl:text>
</xsl:text>
                  <xsl:variable name="rg"><![CDATA[<!ENTITY]]><xsl:text> </xsl:text>
                     <xsl:value-of select="$name"/><xsl:text>.rechtsgrundlagen</xsl:text><xsl:value-of select="
                           if (last() != 1) then
                              position()
                           else
                              ''"/><xsl:text> "</xsl:text><xsl:value-of select="."/><xsl:text>"></xsl:text></xsl:variable>
                  <xsl:value-of select="xgen:unescaped-xml($rg)"/>
               </xsl:for-each>
            </xsl:for-each>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:entitys-for-elements">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('ent/elemente.ent')"/>
         <xsl:with-param name="content">
            <xsl:for-each select="$xoev:my-xmodel/descendant::packagedElement[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]">
               <xsl:sort select="xoev:type-name(.)"/>
               <xsl:for-each select="ownedAttribute[xoev:is-element(.) or xoev:xsdLocalStructure(.)]">
                  <xsl:sort select="@name"/>
                  <xsl:variable name="ref"><![CDATA[<!ENTITY]]> element.ref.<xsl:value-of select="concat(parent::packagedElement/lower-case(xoev:type-name(.)), '.', lower-case(xoev:type-name(.)))"/> '&lt;emphasis role="<xsl:value-of select="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@rolleEmphasisElementEntitys"/>"><xsl:value-of select="xoev:type-name(.)"/>&lt;/emphasis>'></xsl:variable>
                  <xsl:variable name="ref-datatype"><![CDATA[<!ENTITY]]> element.datentyp.ref.<xsl:value-of select="concat(parent::packagedElement/lower-case(xoev:type-name(.)), '.', lower-case(xoev:type-name(.)))"/> 'Element &lt;emphasis role="<xsl:value-of select="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@rolleEmphasisElementEntitys"/>"><xsl:value-of select="xoev:type-name(.)"/>&lt;/emphasis> in Datentyp &lt;emphasis role="<xsl:value-of select="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@rolleEmphasisElementEntitys"/>"><xsl:value-of select="parent::packagedElement/xoev:type-name(.)"/>&lt;/emphasis>'></xsl:variable>
                  <xsl:value-of select="xgen:unescaped-xml($ref)"/>
                  <xsl:text>
                        </xsl:text>
                  <xsl:value-of select="xgen:unescaped-xml($ref-datatype)"/>
                  <xsl:text>
                        </xsl:text>
               </xsl:for-each>
            </xsl:for-each>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:entitys-for-datatypes">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('ent/datentypen.ent')"/>
         <xsl:with-param name="content">
            <xsl:for-each select="$xoev:my-xmodel/descendant::packagedElement[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]">
               <xsl:sort select="xoev:type-name(.)"/>
               <xsl:variable name="ref"><![CDATA[<!ENTITY]]> datentyp.ref.<xsl:value-of select="lower-case(xoev:type-name(.))"/> '&lt;emphasis role="<xsl:value-of select="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@rolleEmphasisDatentypEntitys"/>"><xsl:value-of select="xoev:type-name(.)"/>&lt;/emphasis>'></xsl:variable>
               <xsl:variable name="link"><![CDATA[<!ENTITY]]> datentyp.ref.link.<xsl:value-of select="lower-case(xoev:type-name(.))"/> '&lt;link linkend="<xsl:value-of select="
                        concat(kosit:docbook-id(.), if (xoev:xsdGlobalElementAndNamedType(.)) then
                           '-type'
                        else
                           '')"/>"><xsl:value-of select="xoev:type-name(.)"/>&lt;/link>'></xsl:variable>
               <xsl:variable name="xref"><![CDATA[<!ENTITY]]> datentyp.ref.xref.<xsl:value-of select="lower-case(xoev:type-name(.))"/> '&lt;xref linkend="<xsl:value-of select="
                        concat(kosit:docbook-id(.), if (xoev:xsdGlobalElementAndNamedType(.)) then
                           '-type'
                        else
                           '')"/>" role="<xsl:value-of select="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@rolleXRefDatentypEntitys"/>"/>'></xsl:variable>
               <xsl:value-of select="xgen:unescaped-xml($ref)"/>
               <xsl:text>
                    </xsl:text>
               <xsl:value-of select="xgen:unescaped-xml($link)"/>
               <xsl:text>
                    </xsl:text>
               <xsl:value-of select="xgen:unescaped-xml($xref)"/>
               <xsl:text>
                    </xsl:text>
            </xsl:for-each>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:table-for-basismodul-wsdl">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('dokumente/anhang/wsdl/wsdl_vorlagedateien_tabelle.xml')"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE appendix [<!ENTITY % complete SYSTEM "../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <xsl:variable name="hinweis-liegt-vor" select="
                  $xoev:my-xmodel/descendant::packagedElement[
                  not(xoev:xsdDraft(.)) and kosit-wsdl:wsdlService(.)/@Hinweis[. != '']]"/>
            <appendix version="5" xml:lang="de" xml:id="anhang.wsdl">
               <info>
                  <title>DVDV-unterstützte Dienste und WSDL-Vorlagedateien</title>
               </info>
               <para>Im Rahmen des <xsl:value-of select="xgen:unescaped-xml('&amp;')"/>xinneres-basismoduls; werden die folgenden WSDL-Vorlagedateien bereitgestellt und die entsprechenden Dienste beim DVDV beantragt.</para>
               <section>
                  <title>
                     <xsl:text>WSDL-Vorlagedateien für das Release </xsl:text>
                     <xsl:value-of select="$xoev:my-xmodel/xoev:xoevVersionStandard(.)/@version"/>
                  </title>
                  <xsl:for-each select="$xoev:my-xmodel/descendant::packagedElement[kosit-wsdl:wsdlService(.) and not(xoev:xsdDraft(.))]">
                     <xsl:sort select="@name"/>
                     <informaltable xml:id="Tabelle.wsdlDateien.{@name}" frame="all" colsep="1" rowsep="1">
                        <tgroup cols="{if($hinweis-liegt-vor) then '4' else '3'}" tgroupstyle="Format A" colsep="1" rowsep="1">
                           <xsl:choose>
                              <xsl:when test="$hinweis-liegt-vor">
                                 <colspec colnum="1" colname="1" colwidth="58mm"/>
                                 <colspec colnum="2" colname="2" colwidth="34mm"/>
                                 <colspec colnum="3" colname="3" colwidth="34mm"/>
                                 <colspec colnum="4" colname="4" colwidth="34mm"/>
                              </xsl:when>
                              <xsl:otherwise>
                                 <colspec colnum="1" colname="1" colwidth="62mm"/>
                                 <colspec colnum="2" colname="2" colwidth="47mm"/>
                                 <colspec colnum="3" colname="3" colwidth="51mm"/>
                              </xsl:otherwise>
                           </xsl:choose>
                           <thead>
                              <row rowsep="1">
                                 <entry namest="1" nameend="{if($hinweis-liegt-vor) then '4' else '3'}" align="left">
                                    <xsl:text>Namespace und URI: </xsl:text>
                                    <emphasis role="codebf">
                                       <xsl:value-of select="
                                             concat(kosit-wsdl:wsdlService(.)/@NamensraumOhneDateiname[. != ''], '/', kosit-wsdl:wsdlService(.)/@Dateiname, '.wsdl')"/>
                                    </emphasis>
                                 </entry>
                              </row>
                              <row rowsep="1">
                                 <entry colname="1">WSDL Vorlagedatei</entry>
                                 <entry colname="2">Leistungserbringer</entry>
                                 <entry colname="3">Nachrichten</entry>
                                 <xsl:if test="$hinweis-liegt-vor">
                                    <entry colname="4">Hinweis</entry>
                                 </xsl:if>
                              </row>
                           </thead>
                           <tbody>
                              <row rowsep="1">
                                 <entry colname="1">
                                    <para>
                                       <emphasis role="codebf">
                                          <xsl:value-of select="kosit-wsdl:wsdlService(.)/@Dateiname"/>
                                          <xsl:text>.wsdl</xsl:text>
                                       </emphasis>
                                    </para>
                                 </entry>
                                 <entry colname="2">
                                    <xsl:value-of select="kosit-wsdl:wsdlService(.)/@Leistungserbringer"/>
                                 </entry>
                                 <entry colname="3" align="left">
                                    <xsl:variable name="nb" select="kosit-wsdl:wsdlService(.)/@Nachrichtenbeschreibung"/>
                                    <xsl:choose>
                                       <xsl:when test="not(starts-with(replace($nb, '\[nl\]', ''), '&lt;para&gt;'))">
                                          <para>
                                             <xsl:value-of select="xgen:unescaped-xml(replace($nb, '\[nl\]', ''))"/>
                                          </para>
                                       </xsl:when>
                                       <xsl:otherwise>
                                          <xsl:value-of select="xgen:unescaped-xml(replace($nb, '\[nl\]', ''))"/>
                                       </xsl:otherwise>
                                    </xsl:choose>
                                    <xsl:if test="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceMessage(.) and (not($nb) or replace($nb, '\[nl\]', '') = $nb)]">
                                       <itemizedlist>
                                          <xsl:for-each select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceMessage(.)]/uml:resolve-supplier(.)">
                                             <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                                             <listitem>
                                                <para>
                                                   <xsl:value-of select="tokenize(@name, '\.')[last()]"/>
                                                </para>
                                             </listitem>
                                          </xsl:for-each>
                                       </itemizedlist>
                                    </xsl:if>
                                    <xsl:if test="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceInputMessage(.) and (not($nb) or replace($nb, '\[nl\]', '') = $nb)]">
                                       <para>Input: <itemizedlist>
                                             <xsl:for-each select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceInputMessage(.)]/uml:resolve-supplier(.)">
                                                <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                                                <listitem>
                                                   <para>
                                                      <xsl:value-of select="tokenize(@name, '\.')[last()]"/>
                                                   </para>
                                                </listitem>
                                             </xsl:for-each>
                                          </itemizedlist>
                                       </para>
                                    </xsl:if>
                                    <xsl:if test="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceOutputMessage(.) and (not($nb) or replace($nb, '\[nl\]', '') = $nb)]">
                                       <para>Output: <itemizedlist>
                                             <xsl:for-each select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceOutputMessage(.)]/uml:resolve-supplier(.)">
                                                <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                                                <listitem>
                                                   <para>
                                                      <xsl:value-of select="tokenize(@name, '\.')[last()]"/>
                                                   </para>
                                                </listitem>
                                             </xsl:for-each>
                                          </itemizedlist>
                                       </para>
                                    </xsl:if>
                                    <xsl:if test="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceFaultMessage(.) and (not($nb) or replace($nb, '\[nl\]', '') = $nb)]">
                                       <para>Fault: <itemizedlist>
                                             <xsl:for-each select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceFaultMessage(.)]/uml:resolve-supplier(.)">
                                                <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                                                <listitem>
                                                   <para>
                                                      <xsl:value-of select="tokenize(@name, '\.')[last()]"/>
                                                   </para>
                                                </listitem>
                                             </xsl:for-each>
                                          </itemizedlist>
                                       </para>
                                    </xsl:if>
                                 </entry>
                                 <xsl:if test="$hinweis-liegt-vor">
                                    <entry colname="4">
                                       <xsl:value-of select="kosit-wsdl:wsdlService(.)/@Hinweis/xgen:unescaped-xml(.)"/>
                                    </entry>
                                 </xsl:if>
                              </row>
                           </tbody>
                        </tgroup>
                     </informaltable>
                  </xsl:for-each>
               </section>
            </appendix>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:table-for-wsdl">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('dokumente/anhang/wsdl/wsdl_vorlagedateien_tabelle.xml')"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE table [<!ENTITY % complete SYSTEM "../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <xsl:variable name="hinweis-liegt-vor" select="
                  $xoev:my-xmodel/descendant::packagedElement[
                  not(xoev:xsdDraft(.)) and kosit-wsdl:wsdlService(.)/@Hinweis[. != '']]"/>
            <table version="5" xml:lang="de" xml:id="Tabelle.wsdlDateien" frame="all" colsep="1" rowsep="1">
               <title>WSDL-Vorlagedateien für das Release <xsl:value-of select="$xoev:my-xmodel/xoev:xoevVersionStandard(.)/@version"/></title>
               <tgroup cols="{if($hinweis-liegt-vor) then '4' else '3'}" tgroupstyle="Format A" colsep="1" rowsep="1">
                  <xsl:choose>
                     <xsl:when test="$hinweis-liegt-vor">
                        <colspec colnum="1" colname="1" colwidth="1.968in"/>
                        <colspec colnum="2" colname="2" colwidth="1.339in"/>
                        <colspec colnum="3" colname="3" colwidth="1.575in"/>
                        <colspec colnum="4" colname="4" colwidth="1.378in"/>
                     </xsl:when>
                     <xsl:otherwise>
                        <colspec colnum="1" colname="1" colwidth="62mm"/>
                        <colspec colnum="2" colname="2" colwidth="47mm"/>
                        <colspec colnum="3" colname="3" colwidth="51mm"/>
                     </xsl:otherwise>
                  </xsl:choose>
                  <thead>
                     <row rowsep="1">
                        <entry namest="1" nameend="{if($hinweis-liegt-vor) then '4' else '3'}">Namespace: <emphasis role="codebf"><xsl:value-of select="$xoev:my-xmodel/xoev:xsdXModel(.)/@namespace"/></emphasis></entry>
                     </row>
                     <row rowsep="1">
                        <entry namest="1" nameend="{if($hinweis-liegt-vor) then '4' else '3'}">URI für die Vorlagedateien: <emphasis role="codebf"><xsl:value-of select="
                                    concat($xoev:my-xmodel/xoev:xsdXModel(.)/@namespace,
                                    '/&lt;dateiname', xgen:unescaped-xml('>'))"/></emphasis></entry>
                     </row>
                     <row rowsep="1">
                        <entry colname="1">WSDL Vorlagedatei</entry>
                        <entry colname="2">Leistungserbringer</entry>
                        <entry colname="3">Nachrichten</entry>
                        <xsl:if test="$hinweis-liegt-vor">
                           <entry colname="4">Hinweis</entry>
                        </xsl:if>
                     </row>
                  </thead>
                  <tbody>
                     <xsl:for-each select="$xoev:my-xmodel/descendant::packagedElement[kosit-wsdl:wsdlService(.) and not(xoev:xsdDraft(.))]">
                        <xsl:sort select="@name"/>
                        <xsl:variable name="sv" select="
                              (kosit-wsdl:wsdlService(.)/@Dateiname,
                              concat($xoev:my-xmodel/xoev:xsdXModel(.)/@prefix,
                              replace($xoev:my-xmodel/xoev:xoevVersionStandard(.)/@version, '\.', ''),
                              @name))[1]"/>
                        <row rowsep="1">
                           <entry colname="1">
                              <para>
                                 <emphasis role="codebf"><xsl:value-of select="replace($sv,'(.)',concat('$1',xgen:unescaped-xml('&amp;'), '#x200B;'))"/>.wsdl</emphasis>
                              </para>
                           </entry>
                           <entry colname="2">
                              <xsl:value-of select="kosit-wsdl:wsdlService(.)/@Leistungserbringer"/>
                           </entry>
                           <entry colname="3">
                              <xsl:variable name="nb" select="kosit-wsdl:wsdlService(.)/@Nachrichtenbeschreibung"/>
                              <xsl:choose>
                                 <xsl:when test="not(starts-with(replace($nb, '\[nl\]', ''), '&lt;para&gt;'))">
                                    <para>
                                       <xsl:value-of select="xgen:unescaped-xml(replace($nb, '\[nl\]', ''))"/>
                                    </para>
                                 </xsl:when>
                                 <xsl:otherwise>
                                    <xsl:value-of select="xgen:unescaped-xml(replace($nb, '\[nl\]', ''))"/>
                                 </xsl:otherwise>
                              </xsl:choose>
                              <xsl:if test="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceMessage(.) and (not($nb) or replace($nb, '\[nl\]', '') = $nb)]">
                                 <itemizedlist>
                                    <xsl:for-each select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceMessage(.)]/uml:resolve-supplier(.)">
                                       <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                                       <listitem>
                                          <para>
                                             <xsl:value-of select="tokenize(@name, '\.')[last()]"/>
                                          </para>
                                       </listitem>
                                    </xsl:for-each>
                                 </itemizedlist>
                              </xsl:if>
                              <xsl:if test="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceInputMessage(.) and (not($nb) or replace($nb, '\[nl\]', '') = $nb)]">
                                 <para>Input: <itemizedlist>
                                       <xsl:for-each select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceInputMessage(.)]/uml:resolve-supplier(.)">
                                          <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                                          <listitem>
                                             <para>
                                                <xsl:value-of select="tokenize(@name, '\.')[last()]"/>
                                             </para>
                                          </listitem>
                                       </xsl:for-each>
                                    </itemizedlist>
                                 </para>
                              </xsl:if>
                              <xsl:if test="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceOutputMessage(.) and (not($nb) or replace($nb, '\[nl\]', '') = $nb)]">
                                 <para>Output: <itemizedlist>
                                       <xsl:for-each select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceOutputMessage(.)]/uml:resolve-supplier(.)">
                                          <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                                          <listitem>
                                             <para>
                                                <xsl:value-of select="tokenize(@name, '\.')[last()]"/>
                                             </para>
                                          </listitem>
                                       </xsl:for-each>
                                    </itemizedlist>
                                 </para>
                              </xsl:if>
                              <xsl:if test="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceFaultMessage(.) and (not($nb) or replace($nb, '\[nl\]', '') = $nb)]">
                                 <para>Fault: <itemizedlist>
                                       <xsl:for-each select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlServiceFaultMessage(.)]/uml:resolve-supplier(.)">
                                          <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                                          <listitem>
                                             <para>
                                                <xsl:value-of select="tokenize(@name, '\.')[last()]"/>
                                             </para>
                                          </listitem>
                                       </xsl:for-each>
                                    </itemizedlist>
                                 </para>
                              </xsl:if>
                           </entry>
                           <xsl:if test="$hinweis-liegt-vor">
                              <entry colname="4">
                                 <xsl:value-of select="kosit-wsdl:wsdlService(.)/@Hinweis/xgen:unescaped-xml(.)"/>
                              </entry>
                           </xsl:if>
                        </row>
                     </xsl:for-each>
                  </tbody>
               </tgroup>
            </table>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:xml-for-message-service-overview">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('dokumente/anhang/wsdl/nachrichtenDiensteUebersicht.xml')"/>
         <xsl:with-param name="content">
            <xoev-nd:uebersicht xmlns:xoev-nd="http://xoev.de/nachrichtenInDiensten/1_0/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://xoev.de/nachrichtenInDiensten/1_0/ nachrichtenDiensteUebersichtSchema.xsd">
               <xsl:for-each select="$xoev:my-xmodel/descendant::packagedElement[xoev:xsdMessage(.)]">
                  <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                  <xoev-nd:nachricht name="{@name}">
                     <xsl:for-each select="
                           $xoev:my-xmodel/descendant::packagedElement[
                           (kosit-wsdl:wsdlServiceMessage(.) or
                           kosit-wsdl:wsdlServiceInputMessage(.) or
                           kosit-wsdl:wsdlServiceOutputMessage(.) or
                           kosit-wsdl:wsdlServiceFaultMessage(.)) and uml:resolve-supplier(.)/@xmi:id = current()/@xmi:id]/uml:resolve-client(.)">
                        <xsl:sort select="@name"/>
                        <xoev-nd:dienst>
                           <xsl:value-of select="
                                 concat($xoev:my-xmodel/xoev:xsdXModel(.)/@namespace, '/',
                                 $xoev:my-xmodel/xoev:xsdXModel(.)/@prefix,
                                 replace($xoev:my-xmodel/xoev:xoevVersionStandard(.)/@version, '\.', ''),
                                 @name, '.wsdl')"/>
                        </xoev-nd:dienst>
                     </xsl:for-each>
                  </xoev-nd:nachricht>
               </xsl:for-each>
            </xoev-nd:uebersicht>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:xsd-for-message-service-overview">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('dokumente/anhang/wsdl/nachrichtenDiensteUebersichtSchema.xsd')"/>
         <xsl:with-param name="content">
            <xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" targetNamespace="http://xoev.de/nachrichtenInDiensten/1_0/" version="1.0" elementFormDefault="qualified" attributeFormDefault="unqualified">
               <xs:annotation>
                  <xs:documentation>Diese Schema-Datei erlaubt die Zuordnung von Diensten bzw. ihrer URIs zu Nachrichten. Instanzen dieses Schemas werden automatisiert auf Grundlage eines XÖV-Fachmodells als Übersicht generiert.</xs:documentation>
               </xs:annotation>
               <xs:element name="uebersicht">
                  <xs:complexType>
                     <xs:sequence>
                        <xs:element name="nachricht" minOccurs="0" maxOccurs="unbounded">
                           <xs:complexType>
                              <xs:sequence>
                                 <xs:element name="dienst" type="xs:string" minOccurs="0" maxOccurs="unbounded"/>
                              </xs:sequence>
                              <xs:attribute name="name" type="xs:string"/>
                           </xs:complexType>
                        </xs:element>
                     </xs:sequence>
                  </xs:complexType>
               </xs:element>
            </xs:schema>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template match="packagedElement" mode="kosit:section-for-aggregated-datatypes">
      <xsl:variable name="schemapaket" select="."/>
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI(concat('dokumente/anhang/datentypen-aggregiert/', xoev:xsdSchema(.)/@schemaFile, '.xml'))"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE section [<!ENTITY % complete SYSTEM "../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <section xml:id="{concat('datentypen.aggregiert.',kosit:docbook-id(.), if(xoev:xsdGlobalElementAndNamedType(.)) then '-type' else '')}">
               <title>Datentypen</title>
               <xsl:for-each select="$schemapaket/(descendant-or-self::packagedElement, descendant-or-self::nestedClassifier)[(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and not(xoev:xsdDraft(.))]">
                  <xsl:sort select="xoev:type-name(.)"/>
                  <xsl:element name="include" namespace="http://www.w3.org/2001/XInclude">
                     <xsl:attribute name="href" select="concat('../../', kosit:paketpfad-clean(., ancestor-or-self::packagedElement[xoev:xoevStandard(.)]), '.xml')"/>
                  </xsl:element>
               </xsl:for-each>
            </section>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template match="packagedElement" mode="kosit:informaltable-for-schema-package-overview">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI(concat('dokumente/anhang/xsd/', xoev:xsdSchema(.)/@schemaFile, '.xml'))"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE informaltable [<!ENTITY % complete SYSTEM "../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <informaltable version="5" xml:lang="de">
               <tgroup cols="2">
                  <colspec colnum="1" colname="c1" colwidth="30mm"/>
                  <colspec colnum="2" colname="c2" colwidth="128mm"/>
                  <thead>
                     <row>
                        <entry align="left" namest="c1" nameend="c2">
                           <emphasis role="bold">XML Schema-Definition: <xsl:value-of select="xoev:xsdSchema(.)/@schemaFile"/></emphasis>
                        </entry>
                     </row>
                  </thead>
                  <tbody>
                     <row>
                        <entry>
                           <emphasis role="bold">Eigenschaft</emphasis>
                        </entry>
                        <entry>
                           <emphasis role="bold">Wert</emphasis>
                        </entry>
                     </row>
                     <row>
                        <entry>Version</entry>
                        <entry>
                           <xsl:value-of select="(xoev:xsdSchema(.)/@version, $xoev:my-xmodel/xoev:xoevVersionStandard(.)/@version)[1]"/>
                        </entry>
                     </row>
                     <row>
                        <entry>Namensraum</entry>
                        <entry>
                           <xsl:value-of select="(xoev:xsdSchema(.)/@namespace, $xoev:my-xmodel/xoev:xsdXModel(.)/@namespace)[1]"/>
                        </entry>
                     </row>
                     <row>
                        <entry>Präfix</entry>
                        <entry>
                           <xsl:value-of select="(xoev:xsdSchema(.)/@prefix, $xoev:my-xmodel/xoev:xsdXModel(.)/@prefix)[1]"/>
                        </entry>
                     </row>
                     <row>
                        <entry>SchemaLocation</entry>
                        <entry>
                           <xsl:value-of select="
                                 (xoev:xsdSchema(.)/@schemaLocation,
                                 concat($xoev:my-xmodel/xoev:xsdXModel(.)/@schemaLocationBase, xoev:xsdSchema(.)/@schemaFile))[1]"/>
                        </entry>
                     </row>
                     <row>
                        <entry>Inkludierte XSDs</entry>
                        <entry>
                           <xsl:if test="xoev:directly-included-packages(.)">
                              <itemizedlist>
                                 <xsl:for-each select="xoev:directly-included-packages(.)">
                                    <xsl:sort select="xoev:xsdSchema(.)/@schemaFile"/>
                                    <listitem>
                                       <para>
                                          <xsl:value-of select="xoev:xsdSchema(.)/@schemaFile"/>
                                       </para>
                                    </listitem>
                                 </xsl:for-each>
                              </itemizedlist>
                           </xsl:if>
                        </entry>
                     </row>
                     <row>
                        <entry>Importierte XSDs</entry>
                        <entry>
                           <xsl:if test="xoev:directly-imported-packages(.)">
                              <xsl:variable name="importing-package" select="."/>
                              <itemizedlist>
                                 <xsl:for-each select="xoev:directly-imported-packages(.)">
                                    <xsl:sort select="xoev:xsdSchema(.)/@schemaFile"/>
                                    <xsl:variable name="imported-package" select="."/>
                                    <xsl:variable name="import-dependency" select="xoev:dependencies-by-supplier($imported-package)[uml:resolve-client(.)/@xmi:id = $importing-package/@xmi:id]"/>
                                    <listitem>
                                       <para>
                                          <xsl:value-of select="
                                                concat($imported-package/xoev:xsdSchema(.)/@schemaFile, ' (',
                                                ($import-dependency/xoev:xsdImport(.)/@prefix, $imported-package/xoev:xsdSchema(.)/@prefix,
                                                $imported-package/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1], ' : ',
                                                ($imported-package/xoev:xsdSchema(.)/@namespace, $imported-package/ancestor::packagedElement/xoev:xsdXModel(.)/@namespace)[1], ')')"/>
                                       </para>
                                    </listitem>
                                 </xsl:for-each>
                              </itemizedlist>
                           </xsl:if>
                        </entry>
                     </row>
                  </tbody>
               </tgroup>
            </informaltable>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template match="packagedElement" mode="kosit:package">
      <xsl:apply-templates select="
            descendant::packagedElement[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.) or xoev:xsdMessage(.) or xoev:xsdGlobalAttribute(.)) and
            not(xoev:xsdDraft(.) or kosit:docInlineSimpleTypeDocumentation(.) or xoev:xoevCodeTyp4(.) or xoev:usages-by-client(.))]" mode="kosit:type-or-global-element">
         <xsl:with-param name="paket" select="."/>
      </xsl:apply-templates>
      <xsl:apply-templates select="descendant::packagedElement[xoev:xsdGlobalElementAndNamedType(.) and not(xoev:xsdDraft(.))]" mode="kosit:type-or-global-element">
         <xsl:with-param name="paket" select="."/>
         <xsl:with-param name="type-or-elem">type</xsl:with-param>
      </xsl:apply-templates>
      <xsl:apply-templates select="descendant::packagedElement[xoev:xsdGlobalElementAndNamedType(.) and not(xoev:xsdDraft(.))]" mode="kosit:type-or-global-element">
         <xsl:with-param name="paket" select="."/>
         <xsl:with-param name="type-or-elem">elem</xsl:with-param>
      </xsl:apply-templates>
      <xsl:apply-templates select="
            (descendant::packagedElement | descendant::nestedClassifier)[uml:is-Class(.) and (xoev:xoevCodeTyp4(.) or xoev:usages-by-client(.)) and not(xoev:xsdDraft(.))]" mode="kosit:section-for-code-type"/>
      <xsl:apply-templates select=".[kosit:docGeneration(.)/@genOverview = 'true']" mode="kosit:section-for-package-overview"/>
   </xsl:template>
   <xsl:template name="kosit:informaltable-for-messages-in-standard">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('dokumente/anhang/nachrichten/tabelle.nachrichten.uebersicht.xml')"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE informaltable [<!ENTITY % complete SYSTEM "../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <xsl:element name="informaltable">
               <xsl:attribute name="version">5</xsl:attribute>
               <xsl:attribute name="xml:lang">de</xsl:attribute>
               <xsl:variable name="wsdl" select="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereWSDLTabelle = 'true'"/>
               <tgroup cols="{if($wsdl) then '5' else '4'}">
                  <xsl:choose>
                     <xsl:when test="$wsdl">
                        <colspec colnum="1" colname="c1" colwidth="27mm"/>
                        <colspec colnum="2" colname="c2" colwidth="13mm"/>
                        <colspec colnum="3" colname="c3" colwidth="63mm"/>
                        <colspec colnum="4" colname="c4" colwidth="32mm"/>
                        <colspec colnum="5" colname="c5" colwidth="25mm"/>
                     </xsl:when>
                     <xsl:otherwise>
                        <colspec colnum="1" colname="c1" colwidth="43mm"/>
                        <colspec colnum="2" colname="c2" colwidth="13mm"/>
                        <colspec colnum="3" colname="c3" colwidth="79mm"/>
                        <colspec colnum="4" colname="c5" colwidth="25mm"/>
                     </xsl:otherwise>
                  </xsl:choose>
                  <thead>
                     <row>
                        <entry align="center">Bezeichnung</entry>
                        <entry align="center">Nr.</entry>
                        <entry align="center">Beschreibung</entry>
                        <xsl:if test="$wsdl">
                           <entry align="center">Dienst</entry>
                        </xsl:if>
                        <entry align="center">Seite</entry>
                     </row>
                  </thead>
                  <tbody>
                     <xsl:for-each select="$xoev:my-xmodel/descendant::packagedElement[xoev:xsdSchema(.)]">
                        <xsl:sort select="xoev:xsdSchema(.)/@schemaFile"/>
                        <row>
                           <entry align="center" namest="c1" nameend="c5">
                              <emphasis role="bold">Schema-Datei: <xsl:value-of select="xoev:xsdSchema(.)/@schemaFile"/></emphasis>
                           </entry>
                        </row>
                        <xsl:for-each select="descendant::packagedElement[xoev:xsdMessage(.)]">
                           <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                           <row>
                              <entry align="left">
                                 <para>
                                    <xsl:value-of select="xgen:unescaped-xml((xoev:xsdTitled(.)/@title, @name)[1])"/>
                                 </para>
                              </entry>
                              <entry>
                                 <para>
                                    <xsl:value-of select="tokenize(@name, '\.')[last()]"/>
                                 </para>
                              </entry>
                              <entry>
                                 <xsl:choose>
                                    <xsl:when test="
                                          some $c in ownedComment/body
                                             satisfies $c = '[nd]'"/>
                                    <xsl:when test="ownedComment/body[. != '']">
                                       <xsl:for-each select="ownedComment/body[. != '']">
                                          <xsl:sort select="."/>
                                          <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                       </xsl:for-each>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <annotation role="todo">
                                          <info>
                                             <title>Dokumentation fehlt!</title>
                                          </info>
                                          <para>Dieses ToDo wurde automatisch generiert.</para>
                                       </annotation>
                                    </xsl:otherwise>
                                 </xsl:choose>
                                 <xsl:if test="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@zeigeRechtsgrundlagenInNachrichtenuebersicht = 'true'">
                                    <xsl:if test="xoev:xsdMessage(.)/rechtsgrundlagen[. != '']">
                                       <para>
                                          <emphasis role="strong">Rechtsgrundlagen:</emphasis>
                                          <itemizedlist>
                                             <xsl:for-each select="xoev:xsdMessage(.)/rechtsgrundlagen[. != '']">
                                                <listitem>
                                                   <para>
                                                      <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                                   </para>
                                                </listitem>
                                             </xsl:for-each>
                                          </itemizedlist>
                                       </para>
                                    </xsl:if>
                                 </xsl:if>
                              </entry>
                              <xsl:if test="$wsdl">
                                 <entry>
                                    <xsl:for-each select="
                                          $xoev:my-xmodel/descendant::packagedElement[
                                          (kosit-wsdl:wsdlServiceMessage(.) or
                                          kosit-wsdl:wsdlServiceInputMessage(.) or
                                          kosit-wsdl:wsdlServiceOutputMessage(.) or
                                          kosit-wsdl:wsdlServiceFaultMessage(.)) and uml:resolve-supplier(.)/@xmi:id = current()/@xmi:id]/uml:resolve-client(.)">
                                       <xsl:sort select="@name"/>
                                       <para>
                                          <xsl:variable name="sv" select="
                                                concat(
                                                $xoev:my-xmodel/xoev:xsdXModel(.)/@prefix,
                                                replace($xoev:my-xmodel/xoev:xoevVersionStandard(.)/@version, '\.', ''),
                                                @name)"/>
                                          <xsl:value-of select="replace($sv,'(.)',concat('$1',xgen:unescaped-xml('&amp;'), '#x200B;'))"/>
                                       </para>
                                    </xsl:for-each>
                                 </entry>
                              </xsl:if>
                              <entry>
                                 <para>
                                    <xref role="Seite" linkend="{kosit:docbook-id(.)}"/>
                                 </para>
                              </entry>
                           </row>
                        </xsl:for-each>
                     </xsl:for-each>
                  </tbody>
               </tgroup>
            </xsl:element>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template match="packagedElement" mode="kosit:informaltable-for-messages-in-package">
      <xsl:variable name="package-id" select="concat('tabelle.', lower-case(replace(kosit:paketpfad-clean(., ancestor::packagedElement[@name = 'Nachrichten']), '/', '.')))"/>
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI(concat('dokumente/anhang/nachrichten/', $package-id, '.xml'))"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE informaltable [<!ENTITY % complete SYSTEM "../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <xsl:element name="informaltable">
               <xsl:attribute name="version">5</xsl:attribute>
               <xsl:attribute name="xml:lang">de</xsl:attribute>
               <xsl:attribute name="xml:id" select="$package-id"/>
               <xsl:variable name="wsdl" select="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereWSDLTabelle = 'true'"/>
               <tgroup cols="{if($wsdl) then '5' else '4'}">
                  <xsl:choose>
                     <xsl:when test="$wsdl">
                        <colspec colnum="1" colname="c1" colwidth="27mm"/>
                        <colspec colnum="2" colname="c2" colwidth="13mm"/>
                        <colspec colnum="3" colname="c3" colwidth="63mm"/>
                        <colspec colnum="4" colname="c4" colwidth="32mm"/>
                        <colspec colnum="5" colname="c5" colwidth="25mm"/>
                     </xsl:when>
                     <xsl:otherwise>
                        <colspec colnum="1" colname="c1" colwidth="43mm"/>
                        <colspec colnum="2" colname="c2" colwidth="13mm"/>
                        <colspec colnum="3" colname="c3" colwidth="79mm"/>
                        <colspec colnum="4" colname="c5" colwidth="25mm"/>
                     </xsl:otherwise>
                  </xsl:choose>
                  <thead>
                     <row>
                        <entry namest="c1" nameend="c5" align="center">Alle Nachrichten zu <quote><xsl:value-of select="(xoev:xsdTitled(.)/@title, @name)[1]"/></quote>
                        </entry>
                     </row>
                     <row>
                        <entry align="center">Bezeichnung</entry>
                        <entry align="center">Nr.</entry>
                        <entry align="center">Beschreibung</entry>
                        <xsl:if test="$wsdl">
                           <entry align="center">Dienst</entry>
                        </xsl:if>
                        <entry align="center">Seite</entry>
                     </row>
                  </thead>
                  <tbody>
                     <xsl:for-each select="descendant::packagedElement[xoev:xsdMessage(.)]">
                        <xsl:sort select="tokenize(@name, '\.')[last()]"/>
                        <row>
                           <entry>
                              <para>
                                 <xsl:value-of select="xgen:unescaped-xml((xoev:xsdTitled(.)/@title, @name)[1])"/>
                              </para>
                           </entry>
                           <entry>
                              <xsl:value-of select="tokenize(@name, '\.')[last()]"/>
                           </entry>
                           <entry>
                              <xsl:choose>
                                 <xsl:when test="
                                       some $c in ownedComment/body
                                          satisfies $c = '[nd]'"/>
                                 <xsl:when test="ownedComment/body[. != '']">
                                    <xsl:for-each select="ownedComment/body[. != '']">
                                       <xsl:sort select="."/>
                                       <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                    </xsl:for-each>
                                 </xsl:when>
                                 <xsl:otherwise>
                                    <annotation role="todo">
                                       <info>
                                          <title>Dokumentation fehlt!</title>
                                       </info>
                                       <para>Dieses ToDo wurde automatisch generiert.</para>
                                    </annotation>
                                 </xsl:otherwise>
                              </xsl:choose>
                           </entry>
                           <xsl:if test="$wsdl">
                              <entry>
                                 <xsl:for-each select="
                                       $xoev:my-xmodel/descendant::packagedElement[
                                       (kosit-wsdl:wsdlServiceMessage(.) or
                                       kosit-wsdl:wsdlServiceInputMessage(.) or
                                       kosit-wsdl:wsdlServiceOutputMessage(.) or
                                       kosit-wsdl:wsdlServiceFaultMessage(.)) and uml:resolve-supplier(.)/@xmi:id = current()/@xmi:id]/uml:resolve-client(.)">
                                    <xsl:sort select="@name"/>
                                    <para>
                                       <xsl:variable name="sv" select="
                                             concat(
                                             $xoev:my-xmodel/xoev:xsdXModel(.)/@prefix,
                                             replace($xoev:my-xmodel/xoev:xoevVersionStandard(.)/@version, '\.', ''),
                                             @name)"/>
                                       <xsl:value-of select="replace($sv,'(.)',concat('$1',xgen:unescaped-xml('&amp;'), '#x200B;'))"/>
                                    </para>
                                 </xsl:for-each>
                              </entry>
                           </xsl:if>
                           <entry>
                              <xref role="Seitenzahl" linkend="{kosit:docbook-id(.)}"/>
                           </entry>
                        </row>
                     </xsl:for-each>
                  </tbody>
               </tgroup>
            </xsl:element>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template match="packagedElement" mode="kosit:section-for-package-overview">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI(concat('dokumente/', kosit:paketpfad-clean(., .), '/overview.xml'))"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE section [
<!ENTITY % complete SYSTEM "]]><xsl:for-each select="tokenize(kosit:paketpfad-clean(., .), '/')">../</xsl:for-each>../../../ent/complete.ent<![CDATA[">
%complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml(string-join($doctype, ''))"/>
            <xsl:element name="section">
               <xsl:attribute name="version">5</xsl:attribute>
               <xsl:attribute name="xml:lang">de</xsl:attribute>
               <xsl:attribute name="xml:id" select="concat(kosit:docbook-id(.), '.overview')"/>
               <xsl:attribute name="status" select="concat(xgen:unescaped-xml('&amp;'),'specstatus;')"/>
               <xsl:attribute name="revision" select="concat(xgen:unescaped-xml('&amp;'),'xrecent;')"/>
               <title>
                  <xsl:value-of select="@name"/>
               </title>
               <xsl:choose>
                  <xsl:when test="
                        some $c in ownedComment/body
                           satisfies $c = '[nd]'"/>
                  <xsl:when test="ownedComment/body[. != '']">
                     <xsl:for-each select="ownedComment/body[. != '']">
                        <xsl:sort select="."/>
                        <xsl:value-of select="xgen:unescaped-xml(.)"/>
                     </xsl:for-each>
                  </xsl:when>
                  <xsl:otherwise>
                     <para>
                        <annotation role="todo">
                           <info>
                              <title>Dokumentation fehlt!</title>
                           </info>
                           <para>Dieses ToDo wurde automatisch generiert.</para>
                        </annotation>
                     </para>
                  </xsl:otherwise>
               </xsl:choose>
               <xsl:for-each select="packagedElement[(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and not(xoev:xsdDraft(.))]">
                  <xsl:sort select="xoev:type-name(.)"/>
                  <xsl:element name="include" namespace="http://www.w3.org/2001/XInclude">
                     <xsl:attribute name="href" select="
                           concat(@name, if (xoev:xsdGlobalElementAndNamedType(.)) then
                              '-type'
                           else
                              '', '.xml')"/>
                  </xsl:element>
               </xsl:for-each>
            </xsl:element>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:section-for-codes-overview">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path">dokumente/anhang/codes/overview.xml</xsl:with-param>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE section [<!ENTITY % complete SYSTEM "../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <xsl:element name="section">
               <xsl:attribute name="version">5</xsl:attribute>
               <xsl:attribute name="xml:lang">de</xsl:attribute>
               <xsl:attribute name="xml:id">code.datentypen.overview</xsl:attribute>
               <xsl:attribute name="status" select="concat(xgen:unescaped-xml('&amp;'),'specstatus;')"/>
               <xsl:attribute name="revision" select="concat(xgen:unescaped-xml('&amp;'),'xrecent;')"/>
               <title>
                  <xsl:value-of select="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@titelDesCodeuebersichtabschnitts"/>
               </title>
               <xsl:for-each select="
                     $xoev:my-xmodel/descendant-or-self::packagedElement[kosit:docGeneration(.)]/
                     (descendant::packagedElement | descendant::nestedClassifier)[(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and not(xoev:xsdDraft(.)) and
                     (xoev:xoevCodeTyp4(.) or xoev:usages-by-client(.)/uml:resolve-supplier(.)[xoev:xoevCodeliste(.) or xoev:xoevVersionCodeliste(.)])]">
                  <xsl:sort select="lower-case(xoev:type-name(.))"/>
                  <xsl:element name="include" namespace="http://www.w3.org/2001/XInclude">
                     <xsl:attribute name="href" select="
                           concat(lower-case(@name), if (xoev:xsdGlobalElementAndNamedType(.)) then
                              '-type'
                           else
                              '', '.xml')"/>
                  </xsl:element>
               </xsl:for-each>
            </xsl:element>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:section-for-externeModelle">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path">dokumente/anhang/externeModelle/externeModelle.xml</xsl:with-param>
         <xsl:with-param name="content">
            <xsl:variable name="section-type" select="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@rootElementExterneModelle"/>
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE]]>
               <xsl:value-of select="$section-type"/>
               <![CDATA[[
<!ENTITY % complete SYSTEM "]]>../../../../../ent/complete.ent<![CDATA[">
%complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml(string-join($doctype, ''))"/>
            <xsl:element name="{$section-type}">
               <xsl:attribute name="version">5</xsl:attribute>
               <xsl:attribute name="xml:lang">de</xsl:attribute>
               <xsl:attribute name="xml:id">externe.modelle</xsl:attribute>
               <xsl:attribute name="status" select="concat(xgen:unescaped-xml('&amp;'),'specstatus;')"/>
               <xsl:attribute name="revision" select="concat(xgen:unescaped-xml('&amp;'),'xrecent;')"/>
               <title>Eingebundene externe Modelle</title>
               <para>Folgende externe Modelle werden in dieser Spezifikation verwendet und sind auf den XÖV-Webseiten (siehe <link xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="http://www.xoev.de/de/produkte">http://www.xoev.de/de/produkte</link>) oder im XRepository (siehe <link xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="http://www.xrepository.de">http://www.xrepository.de</link>) veröffentlicht:</para>
               <xsl:for-each select="
                     $uml:root-model/descendant::packagedElement[xoev:xoevVersionStandard(.) and @xmi:id != $xoev:my-xmodel/@xmi:id and
                     ((some $a in $xoev:my-xmodel/descendant::ownedAttribute[xoev:is-element(.) or xoev:xsdAttribute(.)]
                        satisfies $a/uml:resolve-type(.)/ancestor::packagedElement/@xmi:id = @xmi:id) or
                     (some $t in $xoev:my-xmodel/(descendant::packagedElement, descendant::nestedClassifier)
                        satisfies $t/generalization/uml:resolve-general(.)/ancestor::packagedElement/@xmi:id = @xmi:id))],
                     $uml:root-model/descendant::packagedElement[xoev:xoevBibliothek(.) and
                     ((some $a in $xoev:my-xmodel/descendant::ownedAttribute[xoev:is-element(.) or xoev:xsdAttribute(.)]
                        satisfies $a/uml:resolve-type(.)/ancestor::packagedElement/@xmi:id = @xmi:id) or
                     (some $t in $xoev:my-xmodel/(descendant::packagedElement, descendant::nestedClassifier)
                        satisfies $t/generalization/uml:resolve-general(.)/ancestor::packagedElement/@xmi:id = @xmi:id) or
                     $xoev:my-xmodel/(descendant::packagedElement, descendant::nestedClassifier)/generalization/uml:resolve-general(.)[
                     ancestor::packagedElement/@xmi:id = current()/@xmi:id] or
                     descendant::packagedElement[xoev:xoevDatentyp(.)/@kennung = 'urn:xoev-de:kosit:xoev:datentyp:code' and
                     $xoev:my-xmodel/(descendant::packagedElement, descendant::nestedClassifier)[xoev:xoevCodeTyp4(.) or
                     xoev:usages-by-client(.)/uml:resolve-supplier(.)[xoev:xoevCodeliste(.) or xoev:xoevVersionCodeliste(.)]]])]">
                  <xsl:sort select="$xoev:my-xmodel/packagedElement[uml:resolve-supplier(.)/@xmi:id = current()/@xmi:id]/xoev:xsdXModelImport(.)/@bezeichnung"/>
                  <xsl:variable name="import-bezeichnung" select="
                        $xoev:my-xmodel/packagedElement[
                        uml:resolve-supplier(.)/@xmi:id = current()/@xmi:id]/xoev:xsdXModelImport(.)/@bezeichnung"/>
                  <xsl:variable name="import-bezeichnung-clean" select="
                            replace(replace(replace(replace(replace(replace(replace(
                            $import-bezeichnung,'[\s/&lt;&gt;%?&amp;{}\-\\&quot;\(\)]+','_'),'ä','ae'),'Ä','AE'),'ö','oe'),'Ö','OE'),'ü','ue'),'Ü','UE')"/>
                  <section xml:id="externe.modelle.{$import-bezeichnung-clean}">
                     <title>
                        <xsl:value-of select="$import-bezeichnung"/>
                     </title>
                     <para>
                        <xsl:value-of select="
                              if (xoev:xoevStandard(.)) then
                                 xoev:xoevStandard(.)/@nameKurz
                              else
                                 @name"/>
                        <xsl:if test="xoev:xoevVersionStandard(.)">; Version <xsl:value-of select="xoev:xoevVersionStandard(.)/@version"/></xsl:if>
                        <xsl:if test="xoev:xoevVersionBibliothek(.)">; Fassung <xsl:value-of select="xoev:xoevVersionBibliothek(.)/@version"/></xsl:if>
                     </para>
                     <para>Folgende Datentypen aus dem externen Modell werden in dieser Spezifikation verwendet:</para>
                     <itemizedlist>
                        <xsl:for-each select="
                              distinct-values(($xoev:my-xmodel/descendant::ownedAttribute[xoev:is-element(.) or xoev:xsdAttribute(.)]/uml:resolve-type(.)[ancestor::packagedElement/@xmi:id = current()/@xmi:id]/@xmi:id,
                              $xoev:my-xmodel/(descendant::packagedElement, descendant::nestedClassifier)/generalization/uml:resolve-general(.)[
                              ancestor::packagedElement/@xmi:id = current()/@xmi:id]/@xmi:id,
                              descendant::packagedElement[xoev:xoevDatentyp(.)/@kennung = 'urn:xoev-de:kosit:xoev:datentyp:code' and
                              $xoev:my-xmodel/(descendant::packagedElement, descendant::nestedClassifier)[xoev:xoevCodeTyp4(.) or
                              xoev:usages-by-client(.)/uml:resolve-supplier(.)[xoev:xoevCodeliste(.) or xoev:xoevVersionCodeliste(.)]]]/@xmi:id))">
                           <xsl:sort select="xoev:ids-to-elements(., $uml:root-model)/@name"/>
                           <listitem>
                              <para>
                                 <xsl:value-of select="xoev:ids-to-elements(., $uml:root-model)/@name"/>
                              </para>
                           </listitem>
                        </xsl:for-each>
                     </itemizedlist>
                  </section>
               </xsl:for-each>
            </xsl:element>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:section-for-codelists">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path">dokumente/anhang/schluesseltabellen/schluesseltabellen.xml</xsl:with-param>
         <xsl:with-param name="content">
            <xsl:variable name="section-type" select="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@artDesSchluesseltabellenabschnitts"/>
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE]]>
               <xsl:value-of select="$section-type"/>
               <![CDATA[[
<!ENTITY % complete SYSTEM "]]>../../../../../ent/complete.ent<![CDATA[">
%complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml(string-join($doctype, ''))"/>
            <xsl:element name="{$section-type}">
               <xsl:attribute name="version">5</xsl:attribute>
               <xsl:attribute name="xml:lang">de</xsl:attribute>
               <xsl:attribute name="xml:id">schluesseltabellen</xsl:attribute>
               <xsl:attribute name="status" select="concat(xgen:unescaped-xml('&amp;'),'specstatus;')"/>
               <xsl:attribute name="revision" select="concat(xgen:unescaped-xml('&amp;'),'xrecent;')"/>
               <title>Codelisten</title>
               <para>
                  <xsl:text>In diesem Abschnitt sind die </xsl:text>
                  <xsl:value-of select="if($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                            'urn:xoev-de:kosit:standard:xinneres.basismodul') then 'im Basismodul' else if(not($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung = ('urn:xoev-de:kosit:standard:xinneres.xpersonenstand', 'urn:xoev-de:kosit:standard:xinneres.xmeld','urn:xoev-de:kosit:standard:xinneres.xauslaender', 'urn:xoev-de:kosit:standard:xinneres.xpersonenstandsregister'))) then concat('in ',$xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@nameKurz) else concat('in ', xgen:unescaped-xml('&amp;'),'fachmodul;')"/>
                  <xsl:text> verwendeten Codelisten und ihre Inhalte aufgeführt.</xsl:text>
               </para>
               <xsl:choose>
                  <xsl:when test="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@reduzierungCodeTyp3ListenAufIdentifikationsdaten = 'true'">
                     <xsl:variable name="genutzter-externer-code-datentyp" select="
                           xoev:ids-to-elements($xoev-sch:message-trees//*:type[
                           parent::*:node[empty(*:node)] and
                           @id = $uml:root-model/packagedElement[@name = 'Externe Modelle']//(packagedElement, nestedClassifier)[xoev:xsdNamedType(.)]/@xmi:id]/@id, $uml:root-model)"/>
                     <xsl:variable name="codelisten-code-typ-3" select="
                           ($uml:root-model/packagedElement[@name = 'Codelisten']//packagedElement[
                           (xoev:xoevSonderfallGenutzteCodeliste(.) or
                           xoev:usages-by-supplier(.)/uml:resolve-client(.)[not(xoev:xoevCodeTyp4(.))]/ancestor::packagedElement/@xmi:id = $xoev:my-xmodel/@xmi:id) and
                           xoev:xoevCodeliste(.) and not(xoev:xsdDraft(.))],
                           
                           (if ($xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@ExterneCodeTypenInUebersichtenAnzeigen = 'true') then
                              $genutzter-externer-code-datentyp/xoev:usages-by-client(.)/uml:resolve-supplier(.)[xoev:xoevCodeliste(.) and not(xoev:xsdDraft(.))]
                           else
                              ()
                           )
                           
                           )"/>
                     <xsl:if test="$codelisten-code-typ-3">
                        <section xml:id="schluesseltabellen.uebersicht.codelisten">
                           <title>Übersicht Codelisten (Typ 3)</title>
                           <para>In der nachstehenden Tabelle werden die folgenden Informationen dargestellt:</para>
                           <variablelist>
                              <varlistentry>
                                 <term>Kennung</term>
                                 <listitem>
                                    <para>
                                       <xsl:text>Die Kennungen aller </xsl:text>
                                       <xsl:value-of select="if($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                                                    'urn:xoev-de:kosit:standard:xinneres.basismodul') then 'im Basismodul' else if(not($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung = ('urn:xoev-de:kosit:standard:xinneres.xpersonenstand', 'urn:xoev-de:kosit:standard:xinneres.xmeld','urn:xoev-de:kosit:standard:xinneres.xauslaender', 'urn:xoev-de:kosit:standard:xinneres.xpersonenstandsregister'))) then concat('in ',$xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@nameKurz) else concat('in ', xgen:unescaped-xml('&amp;'),'fachmodul;')"/>
                                       <xsl:text> über einen Code-Typ 3 genutzten Codelisten in alphabetischer Reihenfolge.</xsl:text>
                                       <footnote xml:id="no-entry-3">
                                          <para>
                                             <xsl:text>Sofern in der Spalte „Code-Datentyp(en)“ kein Eintrag vorhanden ist, bedeutet dies, dass </xsl:text>
                                             <xsl:value-of select="
                                                   if ($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                                                   'urn:xoev-de:kosit:standard:xinneres.basismodul') then
                                                      'das Basismodul'
                                                   else
                                                      if (not($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung = ('urn:xoev-de:kosit:standard:xinneres.xpersonenstand', 'urn:xoev-de:kosit:standard:xinneres.xmeld', 'urn:xoev-de:kosit:standard:xinneres.xauslaender', 'urn:xoev-de:kosit:standard:xinneres.xpersonenstandsregister'))) then
                                                         'der Standard'
                                                      else
                                                         'das Fachmodul'"/>
                                             <xsl:text> die jeweilige Codeliste verwendet und dokumentieren möchte. </xsl:text>
                                             <xsl:value-of select="
                                                   if ($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                                                   'urn:xoev-de:kosit:standard:xinneres.basismodul') then
                                                      'Der die Codeliste nutzende Code-Datentyp ist jedoch nicht im Basismodul spezifiziert.'
                                                   else
                                                      if (not($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung = ('urn:xoev-de:kosit:standard:xinneres.xpersonenstand', 'urn:xoev-de:kosit:standard:xinneres.xmeld', 'urn:xoev-de:kosit:standard:xinneres.xauslaender', 'urn:xoev-de:kosit:standard:xinneres.xpersonenstandsregister'))) then
                                                         'Der die Codeliste nutzende Code-Datentyp ist jedoch nicht im Standard spezifiziert.'
                                                      else
                                                         'Der die Codeliste nutzende Code-Datentyp ist jedoch nicht im Fachmodul spezifiziert, sondern z. B. im XInneres-Basismodul.'"/>
                                          </para>
                                       </footnote>
                                    </para>
                                 </listitem>
                              </varlistentry>
                              <varlistentry>
                                 <term>Code-Datentyp(en)</term>
                                 <listitem>
                                    <para>Die die jeweilige Codeliste nutzenden Code-Datentypen.<footnoteref linkend="no-entry-3"/></para>
                                 </listitem>
                              </varlistentry>
                           </variablelist>
                           <para>Die Kennungen stellen Links zur jeweiligen Codeliste im XRepository dar. Die Namen der Code-Datentypen stellen Links zu den jeweiligen Detail-Abschnitten dar.</para>
                           <informaltable version="5" xml:lang="de" xml:id="codelisten-typ3-uebersichtstabelle">
                              <tgroup cols="2">
                                 <colspec colnum="1" colname="kennung" colwidth="90mm"/>
                                 <colspec colnum="2" colname="code" colwidth="70mm"/>
                                 <thead>
                                    <row>
                                       <entry>Kennung</entry>
                                       <entry>Code-Datentyp(en)</entry>
                                    </row>
                                 </thead>
                                 <tbody>
                                    <xsl:for-each select="$codelisten-code-typ-3">
                                       <xsl:sort select="xoev:xoevCodeliste(.)/@kennung"/>
                                       <xsl:variable name="cl" select="."/>
                                       <xsl:variable name="code" select="$cl/xoev:usages-by-supplier(.)/uml:resolve-client(.)"/>
                                       <row>
                                          <entry align="left">
                                             <link role="schwarz" xlink:href="https://www.xrepository.de/details/{xoev:xoevCodeliste(.)/@kennung}">
                                                <xsl:value-of select="xoev:xoevCodeliste(.)/@kennung"/>
                                             </link>
                                          </entry>
                                          <xsl:choose>
                                             <xsl:when test="$code">
                                                <entry align="left">
                                                   <xsl:for-each select="$code[ancestor::packagedElement/@xmi:id = $xoev:my-xmodel/@xmi:id or @xmi:id = $genutzter-externer-code-datentyp/@xmi:id]">
                                                      <xsl:sort select="xoev:type-name(.)"/>
                                                      <xsl:choose>
                                                         <xsl:when test="ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id">
                                                            <link role="schwarz" linkend="{concat(kosit:docbook-id(.), if(xoev:xsdGlobalElementAndNamedType(.)) then '-type' else '')}">
                                                               <xsl:value-of select="xoev:type-name(.)"/>
                                                            </link>
                                                         </xsl:when>
                                                         <xsl:otherwise>
                                                            <xsl:variable name="import-bezeichnung" select="
                                                                  $xoev:my-xmodel/packagedElement[uml:resolve-supplier(.)/@xmi:id = current()/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id]/xoev:xsdXModelImport(.)/@bezeichnung"/>
                                                            <xsl:variable name="linkend" select="
                                                                                replace(replace(replace(replace(replace(replace(replace(
                                                                                $import-bezeichnung,'[\s/&lt;&gt;%?&amp;{}\-\\&quot;\(\)]+','_'),'ä','ae'),'Ä','AE'),'ö','oe'),'Ö','OE'),'ü','ue'),'Ü','UE')"/>
                                                            <link role="schwarz" linkend="externe.modelle.{$linkend}">
                                                               <xsl:value-of select="xoev:type-name(.)"/>
                                                            </link>
                                                         </xsl:otherwise>
                                                      </xsl:choose>
                                                   </xsl:for-each>
                                                </entry>
                                             </xsl:when>
                                             <xsl:otherwise>
                                                <entry/>
                                             </xsl:otherwise>
                                          </xsl:choose>
                                       </row>
                                    </xsl:for-each>
                                 </tbody>
                              </tgroup>
                           </informaltable>
                        </section>
                     </xsl:if>
                     <xsl:variable name="codelisten-code-typ-1-und-2" select="
                           $uml:root-model/packagedElement[@name = 'Codelisten']//packagedElement[
                           (kosit:dependencies-by-supplier(.)/uml:resolve-client(.)[
                           xoev:xoevSonderfallGenutzteVersionCodeliste(.) or
                           xoev:usages-by-supplier(.)/uml:resolve-client(.)/ancestor::packagedElement/@xmi:id = $xoev:my-xmodel/@xmi:id] and
                           xoev:xoevCodeliste(.) and not(xoev:xsdDraft(.))) or
                           (xoev:usages-by-supplier(.)/uml:resolve-client(.)[xoev:xoevCodeTyp4(.)]/ancestor::packagedElement/@xmi:id = $xoev:my-xmodel/@xmi:id and
                           xoev:xoevCodeliste(.) and not(xoev:xsdDraft(.)))]"/>
                     <xsl:if test="$codelisten-code-typ-1-und-2">
                        <section xml:id="schluesseltabellen.uebersicht.codelistenversionen">
                           <title>Übersicht Codelistenversionen (Typ 1 und 2)</title>
                           <para>In der nachstehenden Tabelle werden die folgenden Informationen dargestellt:</para>
                           <variablelist>
                              <varlistentry>
                                 <term>Codeliste</term>
                                 <listitem>
                                    <para>
                                       <xsl:text>Alle </xsl:text>
                                       <xsl:value-of select="if($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                                                    'urn:xoev-de:kosit:standard:xinneres.basismodul') then 'im Basismodul' else if(not($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung = ('urn:xoev-de:kosit:standard:xinneres.xpersonenstand', 'urn:xoev-de:kosit:standard:xinneres.xmeld','urn:xoev-de:kosit:standard:xinneres.xauslaender', 'urn:xoev-de:kosit:standard:xinneres.xpersonenstandsregister'))) then concat('in ',$xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@nameKurz) else concat('in ', xgen:unescaped-xml('&amp;'),'fachmodul;')"/>
                                       <xsl:text> genutzten Codelistenversionen in alphabetischer Reihenfolge, die in mindestens einem Code-Datentyp genutzt werden (Typ der Codelistennutzung 1 bis 2).</xsl:text>
                                       <footnote xml:id="no-entry-12">
                                          <para>
                                             <xsl:text>Sofern in der Spalte „Code-Datentyp(en)“ kein Eintrag vorhanden ist, bedeutet dies, dass </xsl:text>
                                             <xsl:value-of select="
                                                   if ($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                                                   'urn:xoev-de:kosit:standard:xinneres.basismodul') then
                                                      'das Basismodul'
                                                   else
                                                      if (not($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung = ('urn:xoev-de:kosit:standard:xinneres.xpersonenstand', 'urn:xoev-de:kosit:standard:xinneres.xmeld', 'urn:xoev-de:kosit:standard:xinneres.xauslaender', 'urn:xoev-de:kosit:standard:xinneres.xpersonenstandsregister'))) then
                                                         'der Standard'
                                                      else
                                                         'das Fachmodul'"/>
                                             <xsl:text> die jeweilige Codeliste verwendet und dokumentieren möchte. </xsl:text>
                                             <xsl:value-of select="
                                                   if ($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                                                   'urn:xoev-de:kosit:standard:xinneres.basismodul') then
                                                      'Der die Codeliste nutzende Code-Datentyp ist jedoch nicht im Basismodul spezifiziert.'
                                                   else
                                                      if (not($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung = ('urn:xoev-de:kosit:standard:xinneres.xpersonenstand', 'urn:xoev-de:kosit:standard:xinneres.xmeld', 'urn:xoev-de:kosit:standard:xinneres.xauslaender', 'urn:xoev-de:kosit:standard:xinneres.xpersonenstandsregister'))) then
                                                         'Der die Codeliste nutzende Code-Datentyp ist jedoch nicht im Standard spezifiziert.'
                                                      else
                                                         'Der die Codeliste nutzende Code-Datentyp ist jedoch nicht im Fachmodul spezifiziert, sondern z. B. im XInneres-Basismodul.'"/>
                                          </para>
                                       </footnote>
                                    </para>
                                 </listitem>
                              </varlistentry>
                              <varlistentry>
                                 <term>Version</term>
                                 <listitem>
                                    <para>Die Version der Codeliste.</para>
                                 </listitem>
                              </varlistentry>
                              <varlistentry>
                                 <term>Code-Datentyp(en)</term>
                                 <listitem>
                                    <para>Die die jeweilige Codeliste nutzenden Code-Datentypen.<footnoteref linkend="no-entry-12"/></para>
                                 </listitem>
                              </varlistentry>
                           </variablelist>
                           <para>Die Namen der Code-Datentypen und der Codelisten stellen Links zu den jeweiligen Detail-Abschnitten dar.</para>
                           <informaltable version="5" xml:lang="de" xml:id="codelisten-uebersichtstabelle">
                              <tgroup cols="3">
                                 <colspec colnum="1" colname="codeliste" colwidth="73mm"/>
                                 <colspec colnum="2" colname="version" colwidth="14mm"/>
                                 <colspec colnum="3" colname="code" colwidth="73mm"/>
                                 <thead>
                                    <row>
                                       <entry>Codeliste</entry>
                                       <entry>Version</entry>
                                       <entry>Code-Datentyp(en)</entry>
                                    </row>
                                 </thead>
                                 <tbody>
                                    <xsl:for-each select="$codelisten-code-typ-1-und-2">
                                       <xsl:sort select="
                                             if (xoev:xsdTitled(.)/@title[. != '']) then
                                                xoev:xsdTitled(.)/@title
                                             else
                                                xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)"/>
                                       <xsl:variable name="cl" select="."/>
                                       <xsl:variable name="vcl" select="
                                             kosit:dependencies-by-supplier(.)/uml:resolve-client(.)[
                                             xoev:xoevSonderfallGenutzteVersionCodeliste(.) or
                                             xoev:usages-by-supplier(.)/uml:resolve-client(.)/ancestor::packagedElement/@xmi:id = $xoev:my-xmodel/@xmi:id]"/>
                                       <xsl:variable name="code" select="($vcl, $cl)/xoev:usages-by-supplier(.)/uml:resolve-client(.)"/>
                                       <row>
                                          <entry align="left">
                                             <link role="schwarz" linkend="tabelle.{replace(replace(concat(xoev:xoevCodeliste(.)/@kennung, '.', @name), ':', '.'), '/', '_')}">
                                                <xsl:choose>
                                                   <xsl:when test="$cl/xoev:xsdTitled(.)/@title[. != '']">
                                                      <xsl:value-of select="$cl/xoev:xsdTitled(.)/@title"/>
                                                   </xsl:when>
                                                   <xsl:when test="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)[. != '']">
                                                      <xsl:value-of select="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)"/>
                                                   </xsl:when>
                                                   <xsl:otherwise>
                                                      <emphasis role="rot">Codeliste besitzt keinen Namen (kurz)</emphasis>
                                                   </xsl:otherwise>
                                                </xsl:choose>
                                             </link>
                                          </entry>
                                          <entry align="left">
                                             <xsl:choose>
                                                <xsl:when test="$vcl/xoev:xoevVersionCodeliste(.)/@version[. != '']">
                                                   <xsl:value-of select="$vcl/xoev:xoevVersionCodeliste(.)/@version[. != '']"/>
                                                </xsl:when>
                                                <xsl:otherwise>--</xsl:otherwise>
                                             </xsl:choose>
                                          </entry>
                                          <xsl:choose>
                                             <xsl:when test="$code">
                                                <entry align="left">
                                                   <xsl:for-each select="$code">
                                                      <xsl:sort select="xoev:type-name(.)"/>
                                                      <link role="schwarz" linkend="{concat(kosit:docbook-id(.), if(xoev:xsdGlobalElementAndNamedType(.)) then '-type' else '')}">
                                                         <xsl:value-of select="xoev:type-name(.)"/>
                                                      </link>
                                                   </xsl:for-each>
                                                </entry>
                                             </xsl:when>
                                             <xsl:otherwise>
                                                <entry/>
                                             </xsl:otherwise>
                                          </xsl:choose>
                                       </row>
                                    </xsl:for-each>
                                 </tbody>
                              </tgroup>
                           </informaltable>
                        </section>
                     </xsl:if>
                  </xsl:when>
                  <xsl:otherwise>
                     <section xml:id="schluesseltabellen.uebersicht">
                        <title>Übersicht</title>
                        <para>In der nachstehenden Tabelle werden die folgenden Informationen dargestellt:</para>
                        <variablelist>
                           <varlistentry>
                              <term>Codeliste</term>
                              <listitem>
                                 <para>
                                    <xsl:text>Alle </xsl:text>
                                    <xsl:value-of select="if($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                                                    'urn:xoev-de:kosit:standard:xinneres.basismodul') then 'im Basismodul' else if(not($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung = ('urn:xoev-de:kosit:standard:xinneres.xpersonenstand', 'urn:xoev-de:kosit:standard:xinneres.xmeld','urn:xoev-de:kosit:standard:xinneres.xauslaender', 'urn:xoev-de:kosit:standard:xinneres.xpersonenstandsregister'))) then concat('in ',$xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@nameKurz) else concat('in ', xgen:unescaped-xml('&amp;'),'fachmodul;')"/>
                                    <xsl:text> genutzten Codelisten in alphabetischer Reihenfolge, die in mindestens einem Code-Datentyp genutzt werden (Typ der Codelistennutzung 1 bis 3).</xsl:text>
                                    <footnote xml:id="no-entry">
                                       <para>
                                          <xsl:text>Sofern in der Spalte „Code-Datentyp(en)“ kein Eintrag vorhanden ist, bedeutet dies, dass </xsl:text>
                                          <xsl:value-of select="
                                                if ($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                                                'urn:xoev-de:kosit:standard:xinneres.basismodul') then
                                                   'das Basismodul'
                                                else
                                                   if (not($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung = ('urn:xoev-de:kosit:standard:xinneres.xpersonenstand', 'urn:xoev-de:kosit:standard:xinneres.xmeld', 'urn:xoev-de:kosit:standard:xinneres.xauslaender', 'urn:xoev-de:kosit:standard:xinneres.xpersonenstandsregister'))) then
                                                      'der Standard'
                                                   else
                                                      'das Fachmodul'"/>
                                          <xsl:text> die jeweilige Codeliste verwendet und dokumentieren möchte. </xsl:text>
                                          <xsl:value-of select="
                                                if ($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                                                'urn:xoev-de:kosit:standard:xinneres.basismodul') then
                                                   'Der die Codeliste nutzende Code-Datentyp ist jedoch nicht im Basismodul spezifiziert.'
                                                else
                                                   if (not($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung = ('urn:xoev-de:kosit:standard:xinneres.xpersonenstand', 'urn:xoev-de:kosit:standard:xinneres.xmeld', 'urn:xoev-de:kosit:standard:xinneres.xauslaender', 'urn:xoev-de:kosit:standard:xinneres.xpersonenstandsregister'))) then
                                                      'Der die Codeliste nutzende Code-Datentyp ist jedoch nicht im Standard spezifiziert.'
                                                   else
                                                      'Der die Codeliste nutzende Code-Datentyp ist jedoch nicht im Fachmodul spezifiziert, sondern z. B. im XInneres-Basismodul.'"/>
                                       </para>
                                    </footnote>
                                 </para>
                              </listitem>
                           </varlistentry>
                           <varlistentry>
                              <term>Version</term>
                              <listitem>
                                 <para>Die Version der Codeliste.</para>
                              </listitem>
                           </varlistentry>
                           <varlistentry>
                              <term>Code-Datentyp(en)</term>
                              <listitem>
                                 <para>Die die jeweilige Codeliste nutzenden Code-Datentypen.<footnoteref linkend="no-entry"/></para>
                              </listitem>
                           </varlistentry>
                        </variablelist>
                        <para>Die Namen der Code-Datentypen und der Codelisten stellen Links zu den jeweiligen Detail-Abschnitten dar.</para>
                        <informaltable version="5" xml:lang="de" xml:id="codelisten-uebersichtstabelle">
                           <tgroup cols="3">
                              <colspec colnum="1" colname="codeliste" colwidth="73mm"/>
                              <colspec colnum="2" colname="version" colwidth="14mm"/>
                              <colspec colnum="3" colname="code" colwidth="73mm"/>
                              <thead>
                                 <row>
                                    <entry>Codeliste</entry>
                                    <entry>Version</entry>
                                    <entry>Code-Datentyp(en)</entry>
                                 </row>
                              </thead>
                              <tbody>
                                 <xsl:for-each select="
                                       $uml:root-model/packagedElement[@name = 'Codelisten']//packagedElement[
                                       ((., kosit:dependencies-by-supplier(.)/uml:resolve-client(.))[
                                       xoev:xoevSonderfallGenutzteCodeliste(.) or xoev:xoevSonderfallGenutzteVersionCodeliste(.) or
                                       xoev:usages-by-supplier(.)/uml:resolve-client(.)/ancestor::packagedElement/@xmi:id = $xoev:my-xmodel/@xmi:id]) and
                                       xoev:xoevCodeliste(.) and not(xoev:xsdDraft(.))]">
                                    <xsl:sort select="
                                          if (xoev:xsdTitled(.)/@title[. != '']) then
                                             xoev:xsdTitled(.)/@title
                                          else
                                             xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)"/>
                                    <xsl:variable name="cl" select="."/>
                                    <xsl:variable name="vcl" select="
                                          kosit:dependencies-by-supplier(.)/uml:resolve-client(.)[
                                          xoev:xoevSonderfallGenutzteVersionCodeliste(.) or
                                          xoev:usages-by-supplier(.)/uml:resolve-client(.)/ancestor::packagedElement/@xmi:id = $xoev:my-xmodel/@xmi:id]"/>
                                    <xsl:variable name="code" select="($vcl, $cl)/xoev:usages-by-supplier(.)/uml:resolve-client(.)"/>
                                    <row>
                                       <entry align="left">
                                          <link role="schwarz" linkend="tabelle.{replace(replace(concat(xoev:xoevCodeliste(.)/@kennung, '.', @name), ':', '.'), '/', '_')}">
                                             <xsl:choose>
                                                <xsl:when test="$cl/xoev:xsdTitled(.)/@title[. != '']">
                                                   <xsl:value-of select="$cl/xoev:xsdTitled(.)/@title"/>
                                                </xsl:when>
                                                <xsl:when test="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)[. != '']">
                                                   <xsl:value-of select="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)"/>
                                                </xsl:when>
                                                <xsl:otherwise>
                                                   <emphasis role="rot">Codeliste besitzt keinen Namen (kurz)</emphasis>
                                                </xsl:otherwise>
                                             </xsl:choose>
                                          </link>
                                       </entry>
                                       <entry align="left">
                                          <xsl:choose>
                                             <xsl:when test="$vcl/xoev:xoevVersionCodeliste(.)/@version[. != '']">
                                                <xsl:value-of select="$vcl/xoev:xoevVersionCodeliste(.)/@version[. != '']"/>
                                             </xsl:when>
                                             <xsl:otherwise>--</xsl:otherwise>
                                          </xsl:choose>
                                       </entry>
                                       <xsl:choose>
                                          <xsl:when test="$code">
                                             <entry align="left">
                                                <xsl:for-each select="$code">
                                                   <xsl:sort select="xoev:type-name(.)"/>
                                                   <link role="schwarz" linkend="{concat(kosit:docbook-id(.), if(xoev:xsdGlobalElementAndNamedType(.)) then '-type' else '')}">
                                                      <xsl:value-of select="xoev:type-name(.)"/>
                                                   </link>
                                                </xsl:for-each>
                                             </entry>
                                          </xsl:when>
                                          <xsl:otherwise>
                                             <entry/>
                                          </xsl:otherwise>
                                       </xsl:choose>
                                    </row>
                                 </xsl:for-each>
                              </tbody>
                           </tgroup>
                        </informaltable>
                     </section>
                  </xsl:otherwise>
               </xsl:choose>
               <section xml:id="schluesseltabellen.details">
                  <title>Details</title>
                  <xsl:for-each select="
                        $uml:root-model/packagedElement[@name = 'Codelisten']//packagedElement[
                        (if ($xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@reduzierungCodeTyp3ListenAufIdentifikationsdaten = 'true') then
                           kosit:dependencies-by-supplier(.)/uml:resolve-client(.)
                        else
                           (., kosit:dependencies-by-supplier(.)/uml:resolve-client(.)))[
                        xoev:xoevSonderfallGenutzteCodeliste(.) or xoev:xoevSonderfallGenutzteVersionCodeliste(.) or
                        xoev:usages-by-supplier(.)/uml:resolve-client(.)/ancestor::packagedElement/@xmi:id = $xoev:my-xmodel/@xmi:id] and xoev:xoevCodeliste(.) and not(xoev:xsdDraft(.))]">
                     <xsl:sort select="
                           if (xoev:xsdTitled(.)/@title[. != '']) then
                              xoev:xsdTitled(.)/@title
                           else
                              xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)"/>
                     <xsl:variable name="cl" select="."/>
                     <xsl:variable name="cl-id" select="replace(replace(concat(xoev:xoevCodeliste(.)/@kennung, '.', @name), ':', '.'), '/', '_')"/>
                     <xsl:variable name="vcl" select="
                           kosit:dependencies-by-supplier(.)/uml:resolve-client(.)[
                           xoev:xoevSonderfallGenutzteVersionCodeliste(.) or
                           xoev:usages-by-supplier(.)/uml:resolve-client(.)/ancestor::packagedElement/@xmi:id = $xoev:my-xmodel/@xmi:id]"/>
                     <xsl:variable name="hat-beschreibungsspalte6" select="count($vcl/ownedAttribute) &gt;= 7"/>
                     <xsl:variable name="hat-beschreibungsspalte5" select="count($vcl/ownedAttribute) &gt;= 6"/>
                     <xsl:variable name="hat-beschreibungsspalte4" select="count($vcl/ownedAttribute) &gt;= 5"/>
                     <xsl:variable name="hat-beschreibungsspalte3" select="count($vcl/ownedAttribute) &gt;= 4"/>
                     <xsl:variable name="hat-beschreibungsspalte2" select="count($vcl/ownedAttribute) &gt;= 3"/>
                     <section xml:id="tabelle.{$cl-id}">
                        <title>
                           <xsl:choose>
                              <xsl:when test="xoev:xsdTitled(.)/@title[. != '']">
                                 <xsl:value-of select="xoev:xsdTitled(.)/@title"/>
                              </xsl:when>
                              <xsl:when test="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)[. != '']">
                                 <xsl:value-of select="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)"/>
                              </xsl:when>
                              <xsl:otherwise>
                                 <emphasis role="rot">Codeliste besitzt keinen Namen (kurz)</emphasis>
                              </xsl:otherwise>
                           </xsl:choose>
                        </title>
                        <xsl:choose>
                           <xsl:when test="starts-with($cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/beschreibung, .)/xoev:metadatenwert(.)[. != ''], '&lt;para>')">
                              <xsl:for-each select="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/beschreibung, .)/xoev:metadatenwert(.)[. != '']">
                                 <xsl:value-of select="xgen:unescaped-xml(.)"/>
                              </xsl:for-each>
                           </xsl:when>
                           <xsl:otherwise>
                              <para>
                                 <xsl:for-each select="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/beschreibung, .)/xoev:metadatenwert(.)[. != '']">
                                    <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                 </xsl:for-each>
                              </para>
                           </xsl:otherwise>
                        </xsl:choose>
                        <section>
                           <title>Metadaten</title>
                           <informaltable>
                              <tgroup cols="2">
                                 <colspec colnum="1" colname="meta" colwidth="30mm"/>
                                 <colspec colnum="2" colname="wert" colwidth="130mm"/>
                                 <thead>
                                    <row>
                                       <entry>Metadatenelement</entry>
                                       <entry>Wert</entry>
                                    </row>
                                 </thead>
                                 <tbody>
                                    <row>
                                       <entry>Name (lang)</entry>
                                       <entry>
                                          <xsl:for-each select="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameLang, .)/xoev:metadatenwert(.)[. != '']">
                                             <xsl:value-of select="."/>
                                          </xsl:for-each>
                                       </entry>
                                    </row>
                                    <row>
                                       <entry>Name (kurz)</entry>
                                       <entry>
                                          <xsl:for-each select="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)[. != '']">
                                             <xsl:value-of select="."/>
                                          </xsl:for-each>
                                       </entry>
                                    </row>
                                    <row>
                                       <entry>Kennung</entry>
                                       <entry>
                                          <xsl:value-of select="$cl/xoev:xoevCodeliste(.)/@kennung"/>
                                       </entry>
                                    </row>
                                    <xsl:variable name="hrsgKurz" select="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/herausgebernameKurz, .)/xoev:metadatenwert(.)[. != '']"/>
                                    <xsl:variable name="hrsgLang" select="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/herausgebernameLang, .)/xoev:metadatenwert(.)[. != '']"/>
                                    <row>
                                       <entry>Herausgeber</entry>
                                       <entry>
                                          <xsl:if test="$hrsgKurz or $hrsgLang">
                                             <xsl:choose>
                                                <xsl:when test="$hrsgKurz and $hrsgLang">
                                                   <xsl:value-of select="concat($hrsgLang, ' (', $hrsgKurz, ')')"/>
                                                </xsl:when>
                                                <xsl:otherwise>
                                                   <xsl:value-of select="($hrsgLang, $hrsgKurz)[1]"/>
                                                </xsl:otherwise>
                                             </xsl:choose>
                                          </xsl:if>
                                       </entry>
                                    </row>
                                    <row>
                                       <entry>Version</entry>
                                       <entry>
                                          <xsl:value-of select="
                                                if ($vcl/xoev:xoevVersionCodeliste(.)/@version[. != '']) then
                                                   $vcl/xoev:xoevVersionCodeliste(.)/@version
                                                else
                                                   'unbestimmt'"/>
                                       </entry>
                                    </row>
                                    <xsl:for-each select="$vcl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevVersionCodeliste(.)/beschreibung, .)/xoev:metadatenwert(.)[. != '']">
                                       <row>
                                          <entry>Beschreibung (Version)</entry>
                                          <entry>
                                             <xsl:value-of select="."/>
                                          </entry>
                                       </row>
                                    </xsl:for-each>
                                    <xsl:for-each select="$vcl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevVersionCodeliste(.)/aenderungZurVorversion, .)/xoev:metadatenwert(.)[. != '']">
                                       <row>
                                          <entry>Änderungen zur Vorversion</entry>
                                          <entry>
                                             <xsl:value-of select="."/>
                                          </entry>
                                       </row>
                                    </xsl:for-each>
                                    <xsl:for-each select="$vcl/xoev:xoevVersionCodeliste(.)/@datumGueltigkeitAb[. != '']">
                                       <row>
                                          <entry>Gültigkeit ab</entry>
                                          <entry>
                                             <xsl:value-of select="."/>
                                          </entry>
                                       </row>
                                    </xsl:for-each>
                                 </tbody>
                              </tgroup>
                           </informaltable>
                        </section>
                        <xsl:if test="
                              $uml:root-model/packagedElement[@name = 'Codelisten']//packagedElement[uml:is-InstanceSpecification(.) and @classifier = $vcl/@xmi:id and
                              not(xoev:xoevCodelisteneintragDeprecated(.))]">
                           <xsl:variable name="code-spalte" select="
                                 ($vcl/ownedAttribute[xoev:xoevCodelistenspalte(.)/@empfohleneCodeSpalte = 'true'], ownedAttribute[xoev:xoevCodelistenspalte(.)/@codeSpalte = 'true'])[1]"/>
                           <section>
                              <title>Daten</title>
                              <informaltable>
                                 <tgroup cols="{if ($hat-beschreibungsspalte6) then '7' else if($hat-beschreibungsspalte5) then '6' else if($hat-beschreibungsspalte4) then '5'
                                    else if($hat-beschreibungsspalte3) then '4' else if($hat-beschreibungsspalte2) then '3' else '2'}">
                                    <xsl:choose>
                                       <xsl:when test="$hat-beschreibungsspalte6">
                                          <colspec colnum="1" colname="col1" colwidth="22mm"/>
                                          <colspec colnum="2" colname="col2" colwidth="23mm"/>
                                          <colspec colnum="3" colname="col3" colwidth="23mm"/>
                                          <colspec colnum="4" colname="col4" colwidth="23mm"/>
                                          <colspec colnum="5" colname="col5" colwidth="23mm"/>
                                          <colspec colnum="6" colname="col6" colwidth="23mm"/>
                                          <colspec colnum="7" colname="lastcol" colwidth="23mm"/>
                                       </xsl:when>
                                       <xsl:when test="$hat-beschreibungsspalte5">
                                          <colspec colnum="1" colname="col1" colwidth="25mm"/>
                                          <colspec colnum="2" colname="col2" colwidth="27mm"/>
                                          <colspec colnum="3" colname="col3" colwidth="27mm"/>
                                          <colspec colnum="4" colname="col4" colwidth="27mm"/>
                                          <colspec colnum="5" colname="col5" colwidth="27mm"/>
                                          <colspec colnum="6" colname="lastcol" colwidth="27mm"/>
                                       </xsl:when>
                                       <xsl:when test="$hat-beschreibungsspalte4">
                                          <colspec colnum="1" colname="col1" colwidth="24mm"/>
                                          <colspec colnum="2" colname="col2" colwidth="34mm"/>
                                          <colspec colnum="3" colname="col3" colwidth="34mm"/>
                                          <colspec colnum="4" colname="col4" colwidth="34mm"/>
                                          <colspec colnum="5" colname="lastcol" colwidth="34mm"/>
                                       </xsl:when>
                                       <xsl:when test="$hat-beschreibungsspalte3">
                                          <colspec colnum="1" colname="col1" colwidth="25mm"/>
                                          <colspec colnum="2" colname="col2" colwidth="45mm"/>
                                          <colspec colnum="3" colname="col3" colwidth="45mm"/>
                                          <colspec colnum="4" colname="lastcol" colwidth="45mm"/>
                                       </xsl:when>
                                       <xsl:when test="$hat-beschreibungsspalte2">
                                          <colspec colnum="1" colname="key" colwidth="25mm"/>
                                          <colspec colnum="2" colname="val" colwidth="65mm"/>
                                          <colspec colnum="3" colname="desc" colwidth="70mm"/>
                                       </xsl:when>
                                       <xsl:otherwise>
                                          <colspec colnum="1" colname="key" colwidth="25mm"/>
                                          <colspec colnum="2" colname="val" colwidth="135mm"/>
                                       </xsl:otherwise>
                                    </xsl:choose>
                                    <thead>
                                       <row>
                                          <xsl:for-each select="$code-spalte, $vcl/ownedAttribute[not(@xmi:id = $code-spalte/@xmi:id)]">
                                             <entry align="left">
                                                <xsl:value-of select="@name"/>
                                                <xsl:for-each select="xoev:xoevCodelistenspalte(.)/@spaltennameLang[. != '']">
                                                   <xsl:value-of select="concat(' (', ., ')')"/>
                                                </xsl:for-each>
                                             </entry>
                                          </xsl:for-each>
                                       </row>
                                    </thead>
                                    <tbody>
                                       <xsl:for-each select="
                                             $uml:root-model/packagedElement[@name = 'Codelisten']//packagedElement[uml:is-InstanceSpecification(.) and @classifier = $vcl/@xmi:id and
                                             not(xoev:xoevCodelisteneintragDeprecated(.))]">
                                          <xsl:sort select="
                                                slot[uml:resolve-definingFeature(.)/@xmi:id = $code-spalte/@xmi:id]/value/@value/(if ($vcl/kosit:docNumerischeSortierung(.)) then
                                                   number(normalize-space(.))
                                                else
                                                   normalize-space(.))"/>
                                          <xsl:variable name="codelisteneintrag" select="."/>
                                          <row>
                                             <xsl:for-each select="$code-spalte, $vcl/ownedAttribute[not(@xmi:id = $code-spalte/@xmi:id)]">
                                                <xsl:variable name="value" select="$codelisteneintrag/slot[uml:resolve-definingFeature(.)/@xmi:id = current()/@xmi:id]/value/@value/normalize-space(.)"/>
                                                <entry align="left">
                                                   <xsl:value-of select="$value"/>
                                                </entry>
                                             </xsl:for-each>
                                          </row>
                                       </xsl:for-each>
                                    </tbody>
                                 </tgroup>
                              </informaltable>
                           </section>
                        </xsl:if>
                        <xsl:processing-instruction name="KoSIT-FO">hard-pagebreak</xsl:processing-instruction>
                     </section>
                  </xsl:for-each>
               </section>
               <xsl:if test="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@verweisHistorieInSchluesseltabellenabschnitt = 'true'">
                  <xsl:element name="include" namespace="http://www.w3.org/2001/XInclude">
                     <xsl:attribute name="href">../../../../../src/anhang/codelisten/historie.xml</xsl:attribute>
                  </xsl:element>
               </xsl:if>
            </xsl:element>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template match="packagedElement | nestedClassifier" mode="kosit:section-for-code-type">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI(concat('dokumente/anhang/codes/', lower-case(@name), '.xml'))"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE section [
<!ENTITY % complete SYSTEM "]]>../../../../../ent/complete.ent<![CDATA[">
%complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml(string-join($doctype, ''))"/>
            <section version="5" xml:lang="de" xml:id="{concat(kosit:docbook-id(.), if(xoev:xsdGlobalElementAndNamedType(.)) then '-type' else '')}" status="{xgen:unescaped-xml('&amp;')}specstatus;" revision="{xgen:unescaped-xml('&amp;')}xrecent;">
               <title>
                  <xsl:value-of select="xoev:type-name(.)"/>
               </title>
               <xsl:if test="
                     not(some $c in ownedComment/body
                        satisfies $c = '[nd]') and ownedComment/body[. != '']">
                  <xsl:for-each select="ownedComment/body[. != '']">
                     <xsl:sort select="."/>
                     <xsl:value-of select="xgen:unescaped-xml(.)"/>
                  </xsl:for-each>
               </xsl:if>
               <xsl:for-each select="xoev:xsdWithImplementationHint(.)/@implementationHint[. != '']">
                  <para>
                     <emphasis role="strong">Umsetzungshinweise:</emphasis>
                  </para>
                  <xsl:value-of select="
                        if (not(starts-with(replace(., ' ', ''), '&lt;para&gt;'))) then
                           xgen:unescaped-xml(concat('&lt;para&gt;', ., '&lt;/para&gt;'))
                        else
                           xgen:unescaped-xml(.)"/>
               </xsl:for-each>
               <informaltable>
                  <tgroup cols="2">
                     <colspec colnum="1" colname="des" colwidth="22mm"/>
                     <colspec colnum="2" colname="val" colwidth="138mm"/>
                     <thead>
                        <row>
                           <entry>Codelisten</entry>
                           <entry/>
                        </row>
                     </thead>
                     <tbody>
                        <xsl:variable name="vcl" select="xoev:usages-by-client(.)[xoev:xoevCodeTyp1(.) or xoev:xoevCodeTyp2(.)]/uml:resolve-supplier(.)"/>
                        <xsl:variable name="cl" select="
                              if (xoev:usages-by-client(.)/(xoev:xoevCodeTyp1(.), xoev:xoevCodeTyp2(.))) then
                                 $vcl/xoev:dependencies-by-client(.)/uml:resolve-supplier(.)
                              else
                                 xoev:usages-by-client(.)/uml:resolve-supplier(.)"/>
                        <xsl:if test="
                              not($xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@reduzierungCodeTyp3ListenAufIdentifikationsdaten = 'true') or
                              xoev:xoevCodeTyp4(.) or not(xoev:usages-by-client(.)/uml:resolve-supplier(.)/xoev:xoevCodeliste(.))">
                           <row>
                              <entry>-beschreibung</entry>
                              <entry>
                                 <xsl:value-of select="
                                       if ($cl) then
                                          xgen:unescaped-xml($cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/beschreibung, .)/xoev:metadatenwert(.)[. != ''])
                                       else
                                          'unbestimmt'"/>
                              </entry>
                           </row>
                        </xsl:if>
                        <xsl:variable name="cl-id" select="replace(replace(concat($cl/xoev:xoevCodeliste(.)/@kennung, '.', $cl/@name), ':', '.'), '/', '_')"/>
                        <xsl:variable name="listURI" select="$cl/xoev:xoevCodeliste(.)/@kennung"/>
                        <xsl:variable name="listVersionID" select="$vcl/xoev:xoevVersionCodeliste(.)/@version"/>
                        <xsl:variable name="eintraege" select="
                              $xoev:my-xmodel/descendant::packagedElement[uml:is-InstanceSpecification(.) and @classifier = $vcl/@xmi:id and
                              not(xoev:xoevCodelisteneintragDeprecated(.))]"/>
                        <row>
                           <entry>-nutzung</entry>
                           <entry>
                              <xsl:text>Typ: </xsl:text>
                              <xsl:choose>
                                 <xsl:when test="
                                       xoev:usages-by-client(.)/xoev:xoevCodeTyp1(.)">1, Inhalte der Codeliste siehe <xref linkend="tabelle.{$cl-id}" role="Seite"/>
                                 </xsl:when>
                                 <xsl:when test="xoev:usages-by-client(.)/xoev:xoevCodeTyp2(.)">2, <xsl:choose>
                                       <xsl:when test="not(empty($eintraege))">Inhalte der Codeliste siehe <xref linkend="tabelle.{$cl-id}" role="Seite"/></xsl:when>
                                       <xsl:otherwise>siehe Beschreibung</xsl:otherwise></xsl:choose>
                                 </xsl:when>
                                 <xsl:when test="not(xoev:xoevCodeTyp4(.)) and xoev:usages-by-client(.)/uml:resolve-supplier(.)/xoev:xoevCodeliste(.)">
                                    <xsl:text>3</xsl:text>
                                    <xsl:if test="not($xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@reduzierungCodeTyp3ListenAufIdentifikationsdaten = 'true')">
                                       <xsl:text>, siehe Beschreibung</xsl:text>
                                    </xsl:if>
                                 </xsl:when>
                                 <xsl:otherwise>4, siehe Beschreibung des Code-Datentyps</xsl:otherwise>
                              </xsl:choose>
                           </entry>
                        </row>
                        <row>
                           <entry>-kennung</entry>
                           <entry>
                              <xsl:choose>
                                 <xsl:when test="
                                       $xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@reduzierungCodeTyp3ListenAufIdentifikationsdaten = 'true' and
                                       not(xoev:xoevCodeTyp4(.)) and xoev:usages-by-client(.)/uml:resolve-supplier(.)/xoev:xoevCodeliste(.)">
                                    <link role="schwarz" xlink:href="https://www.xrepository.de/details/{$listURI}">
                                       <xsl:value-of select="$listURI"/>
                                    </link>
                                 </xsl:when>
                                 <xsl:when test="$listURI[. != '']">
                                    <xsl:value-of select="$listURI"/>
                                 </xsl:when>
                                 <xsl:otherwise>unbestimmt</xsl:otherwise>
                              </xsl:choose>
                           </entry>
                        </row>
                        <row>
                           <entry>-version</entry>
                           <entry>
                              <xsl:choose>
                                 <xsl:when test="$listVersionID[. != '']">
                                    <xsl:value-of select="$listVersionID"/>
                                 </xsl:when>
                                 <xsl:otherwise>unbestimmt</xsl:otherwise>
                              </xsl:choose>
                           </entry>
                        </row>
                     </tbody>
                  </tgroup>
               </informaltable>
               <xsl:if test="(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and $xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereNutzungKomplexerTypen = 'true'">
                  <xsl:variable name="optional-prefix" select="
                        if ($xoev:my-xmodel/descendant-or-self::packagedElement[not(xoev:xsdDraft(.)) and (xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and @name = current()/@name and not(@xmi:id = current()/@xmi:id)]) then
                           (ancestor::packagedElement/xoev:xsdSchema(.)/@prefix, $xoev:my-xmodel/xoev:xsdXModel(.)/@prefix)[1]
                        else
                           ''"/>
                  <xsl:variable name="href">../verwendung/complexTypes/<xsl:value-of select="concat($optional-prefix,replace(lower-case(@name), '[\s&lt;&gt;#%?&amp;{}\-\\()]+', '_'), if (xoev:xsdGlobalElementAndNamedType(.)) then
                            '-type'
                            else
                            '')"/>_list.xml</xsl:variable>
                  <xsl:element name="include" namespace="http://www.w3.org/2001/XInclude">
                     <xsl:attribute name="href" select="$href"/>
                  </xsl:element>
               </xsl:if>
            </section>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:section-for-code-uebersichtstabelle">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path">dokumente/anhang/codes/code-uebersichtstabelle.xml</xsl:with-param>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE section [
<!ENTITY % complete SYSTEM "]]>../../../../../ent/complete.ent<![CDATA[">
%complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml(string-join($doctype, ''))"/>
            <xsl:choose>
               <xsl:when test="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@reduzierungCodeTyp3ListenAufIdentifikationsdaten = 'true'">
                  <section xml:id="code-uebersicht" xml:lang="de">
                     <title>Übersicht </title>
                     <section xml:id="code-uebersicht-typ3">
                        <title>Code-Typ 3</title>
                        <para>In der nachstehenden Tabelle werden die folgenden Informationen dargestellt:</para>
                        <variablelist>
                           <varlistentry>
                              <term>Code-Datentyp</term>
                              <listitem>
                                 <para>
                                    <xsl:text>Alle </xsl:text>
                                    <xsl:value-of select="if($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                                                'urn:xoev-de:kosit:standard:xinneres.basismodul') then 'im Basismodul' else concat('in ', xgen:unescaped-xml('&amp;'),'fachmodul;')"/>
                                    <xsl:text> definierten Code-Datentypen des Typ 3 in alphabetischer Reihenfolge. </xsl:text>
                                 </para>
                              </listitem>
                           </varlistentry>
                           <varlistentry>
                              <term>Kennung</term>
                              <listitem>
                                 <para>
                                    <xsl:text>Die Kennung</xsl:text>
                                    <footnote>
                                       <para>Weitere Informationen zu den Metadaten einer Codeliste sind im aktuellen XÖV-Handbuch beschrieben.</para>
                                    </footnote>
                                    <xsl:text> der im jeweiligen Code-Datentyp genutzten Codeliste.</xsl:text>
                                 </para>
                              </listitem>
                           </varlistentry>
                        </variablelist>
                        <para>Die Namen der Code-Datentypen stellen Links zu den jeweiligen Detail-Abschnitten dar. Die Kennungen stellen Links zur jeweiligen Codeliste im XRepository dar. </para>
                        <informaltable version="5" xml:lang="de" xml:id="code-uebersichtstabelle-typ3">
                           <tgroup cols="2">
                              <colspec colnum="1" colname="code" colwidth="70mm"/>
                              <colspec colnum="2" colname="codeliste" colwidth="90mm"/>
                              <thead>
                                 <row>
                                    <entry>Code-Datentyp</entry>
                                    <entry>Kennung</entry>
                                 </row>
                              </thead>
                              <tbody>
                                 <xsl:for-each select="
                                       ($xoev:my-xmodel/descendant::packagedElement |
                                       $xoev:my-xmodel/descendant::nestedClassifier |
                                       (if ($xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@ExterneCodeTypenInUebersichtenAnzeigen = 'true') then
                                          xoev:ids-to-elements($xoev-sch:message-trees//*:type[
                                          parent::*:node[empty(*:node)] and
                                          @id = $uml:root-model/packagedElement[@name = 'Externe Modelle']//(packagedElement, nestedClassifier)[xoev:xsdNamedType(.)]/@xmi:id]/@id, $uml:root-model)
                                       else
                                          ()
                                       ))
                                       [uml:is-Class(.) and not(xoev:xoevCodeTyp4(.)) and (xoev:usages-by-client(.)/uml:resolve-supplier(.)/xoev:xoevCodeliste(.)) and not(xoev:xsdDraft(.))]">
                                    <xsl:sort select="@name"/>
                                    <row>
                                       <entry align="left">
                                          <xsl:choose>
                                             <xsl:when test="ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id">
                                                <link role="schwarz" linkend="{concat(kosit:docbook-id(.), if(xoev:xsdGlobalElementAndNamedType(.)) then '-type' else '')}">
                                                   <xsl:value-of select="xoev:type-name(.)"/>
                                                </link>
                                             </xsl:when>
                                             <xsl:otherwise>
                                                <xsl:variable name="import-bezeichnung" select="
                                                      $xoev:my-xmodel/packagedElement[uml:resolve-supplier(.)/@xmi:id = current()/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id]/xoev:xsdXModelImport(.)/@bezeichnung"/>
                                                <xsl:variable name="linkend" select="
                                                                    replace(replace(replace(replace(replace(replace(replace(
                                                                    $import-bezeichnung,'[\s/&lt;&gt;%?&amp;{}\-\\&quot;\(\)]+','_'),'ä','ae'),'Ä','AE'),'ö','oe'),'Ö','OE'),'ü','ue'),'Ü','UE')"/>
                                                <link role="schwarz" linkend="externe.modelle.{$linkend}">
                                                   <xsl:value-of select="xoev:type-name(.)"/>
                                                </link>
                                             </xsl:otherwise>
                                          </xsl:choose>
                                       </entry>
                                       <xsl:variable name="cl" select="xoev:usages-by-client(.)/uml:resolve-supplier(.)"/>
                                       <xsl:variable name="cl-id" select="replace(replace(concat($cl/xoev:xoevCodeliste(.)/@kennung, '.', $cl/@name), ':', '.'), '/', '_')"/>
                                       <entry align="left">
                                          <link role="schwarz" xlink:href="https://www.xrepository.de/details/{$cl/xoev:xoevCodeliste(.)/@kennung}">
                                             <xsl:value-of select="$cl/xoev:xoevCodeliste(.)/@kennung"/>
                                          </link>
                                       </entry>
                                    </row>
                                 </xsl:for-each>
                              </tbody>
                           </tgroup>
                        </informaltable>
                     </section>
                     <section xml:id="code-uebersicht-typ124">
                        <title>Code-Typ 1, 2 und 4</title>
                        <para>In der nachstehenden Tabelle werden die folgenden Informationen dargestellt:</para>
                        <variablelist>
                           <varlistentry>
                              <term>Code-Datentyp</term>
                              <listitem>
                                 <para>
                                    <xsl:text>Alle </xsl:text>
                                    <xsl:value-of select="if($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                                                'urn:xoev-de:kosit:standard:xinneres.basismodul') then 'im Basismodul' else concat('in ', xgen:unescaped-xml('&amp;'),'fachmodul;')"/>
                                    <xsl:text> definierten Code-Datentypen des Typs 1, 2 und 4 in alphabetischer Reihenfolge.</xsl:text>
                                 </para>
                              </listitem>
                           </varlistentry>
                           <varlistentry>
                              <term>Codeliste</term>
                              <listitem>
                                 <para>
                                    <xsl:text> Der Name (kurz)</xsl:text>
                                    <footnote>
                                       <para>Weitere Informationen zu den Metadaten einer Codeliste sind im aktuellen XÖV-Handbuch beschrieben.</para>
                                    </footnote>
                                    <xsl:text> der im jeweiligen Code-Datentyp genutzten Codeliste.</xsl:text>
                                 </para>
                              </listitem>
                           </varlistentry>
                           <varlistentry>
                              <term>Version</term>
                              <listitem>
                                 <para> Die Version der im jeweiligen Code-Datentyp genutzten Codeliste (Attribut listVersionID). </para>
                              </listitem>
                           </varlistentry>
                           <varlistentry>
                              <term>Typ</term>
                              <listitem>
                                 <para> Art der Codelistennutzung, wie im XÖV-Handbuch beschrieben. </para>
                              </listitem>
                           </varlistentry>
                        </variablelist>
                        <para>Die Namen der Code-Datentypen und der Codelisten stellen Links zu den jeweiligen Detail-Abschnitten dar.</para>
                        <informaltable version="5" xml:lang="de" xml:id="code-uebersichtstabelle-typ124">
                           <tgroup cols="4">
                              <colspec colnum="1" colname="code" colwidth="74mm"/>
                              <colspec colnum="2" colname="codeliste" colwidth="65mm"/>
                              <colspec colnum="3" colname="version" colwidth="14mm"/>
                              <colspec colnum="4" colname="nutzung" colwidth="7mm"/>
                              <thead>
                                 <row>
                                    <entry>Code-Datentyp</entry>
                                    <entry>Codeliste</entry>
                                    <entry>Version</entry>
                                    <entry>Typ</entry>
                                 </row>
                              </thead>
                              <tbody>
                                 <xsl:for-each select="
                                       ($xoev:my-xmodel/descendant::packagedElement | $xoev:my-xmodel/descendant::nestedClassifier)[
                                       uml:is-Class(.) and (xoev:xoevCodeTyp4(.) or xoev:usages-by-client(.)[empty(uml:resolve-supplier(.)/xoev:xoevCodeliste(.))]) and not(xoev:xsdDraft(.))]">
                                    <xsl:sort select="xoev:type-name(.)"/>
                                    <row>
                                       <entry align="left">
                                          <link role="schwarz" linkend="{concat(kosit:docbook-id(.), if(xoev:xsdGlobalElementAndNamedType(.)) then '-type' else '')}">
                                             <xsl:value-of select="xoev:type-name(.)"/>
                                          </link>
                                       </entry>
                                       <xsl:variable name="vcl" select="xoev:usages-by-client(.)[xoev:xoevCodeTyp1(.), xoev:xoevCodeTyp2(.)]/uml:resolve-supplier(.)"/>
                                       <xsl:variable name="cl" select="
                                             if (xoev:usages-by-client(.)/(xoev:xoevCodeTyp1(.), xoev:xoevCodeTyp2(.))) then
                                                $vcl/xoev:dependencies-by-client(.)/uml:resolve-supplier(.)
                                             else
                                                xoev:usages-by-client(.)/uml:resolve-supplier(.)"/>
                                       <xsl:variable name="version" select="$vcl/xoev:xoevVersionCodeliste(.)/@version"/>
                                       <xsl:variable name="cl-id" select="replace(replace(concat($cl/xoev:xoevCodeliste(.)/@kennung, '.', $cl/@name), ':', '.'), '/', '_')"/>
                                       <entry align="left">
                                          <xsl:choose>
                                             <xsl:when test="$cl">
                                                <link role="schwarz" linkend="tabelle.{$cl-id}">
                                                   <xsl:choose>
                                                      <xsl:when test="$cl/xoev:xsdTitled(.)/@title[. != '']">
                                                         <xsl:value-of select="$cl/xoev:xsdTitled(.)/@title"/>
                                                      </xsl:when>
                                                      <xsl:when test="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)[. != '']">
                                                         <xsl:value-of select="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)"/>
                                                      </xsl:when>
                                                      <xsl:otherwise>
                                                         <emphasis role="rot">Codeliste besitzt keinen Namen (kurz)</emphasis>
                                                      </xsl:otherwise>
                                                   </xsl:choose>
                                                </link>
                                             </xsl:when>
                                             <xsl:otherwise>--</xsl:otherwise>
                                          </xsl:choose>
                                       </entry>
                                       <entry align="left">
                                          <xsl:choose>
                                             <xsl:when test="$version">
                                                <xsl:value-of select="$version"/>
                                             </xsl:when>
                                             <xsl:otherwise>--</xsl:otherwise>
                                          </xsl:choose>
                                       </entry>
                                       <entry align="left">
                                          <xsl:choose>
                                             <xsl:when test="xoev:usages-by-client(.)/xoev:xoevCodeTyp1(.)">1</xsl:when>
                                             <xsl:when test="xoev:usages-by-client(.)/xoev:xoevCodeTyp2(.)">2</xsl:when>
                                             <xsl:when test="not(xoev:xoevCodeTyp4(.)) and xoev:usages-by-client(.)/uml:resolve-supplier(.)/xoev:xoevCodeliste(.)">3</xsl:when>
                                             <xsl:otherwise>4</xsl:otherwise>
                                          </xsl:choose>
                                       </entry>
                                    </row>
                                 </xsl:for-each>
                              </tbody>
                           </tgroup>
                        </informaltable>
                     </section>
                  </section>
               </xsl:when>
               <xsl:otherwise>
                  <section xml:id="code-uebersicht">
                     <title>Übersicht</title>
                     <para>In der nachstehenden Tabelle werden die folgenden Informationen dargestellt:</para>
                     <variablelist>
                        <varlistentry>
                           <term>Code-Datentyp</term>
                           <listitem>
                              <para>
                                 <xsl:text>Alle </xsl:text>
                                 <xsl:value-of select="if($xoev:my-xmodel/descendant-or-self::packagedElement/xoev:xoevStandard(.)/@kennung =
                                                'urn:xoev-de:kosit:standard:xinneres.basismodul') then 'im Basismodul' else concat('in ', xgen:unescaped-xml('&amp;'),'fachmodul;')"/>
                                 <xsl:text> definierten Code-Datentypen in alphabetischer Reihenfolge. </xsl:text>
                              </para>
                           </listitem>
                        </varlistentry>
                        <varlistentry>
                           <term>Codeliste</term>
                           <listitem>
                              <para>
                                 <xsl:text> Der Name (kurz)</xsl:text>
                                 <footnote>
                                    <para>Weitere Informationen zu den Metadaten einer Codeliste sind im aktuellen XÖV-Handbuch beschrieben.</para>
                                 </footnote>
                                 <xsl:text> der im jeweiligen Code-Datentyp genutzten Codeliste.</xsl:text>
                              </para>
                           </listitem>
                        </varlistentry>
                        <varlistentry>
                           <term>Version</term>
                           <listitem>
                              <para> Die Version der im jeweiligen Code-Datentyp genutzten Codeliste (Attribut listVersionID). </para>
                           </listitem>
                        </varlistentry>
                        <varlistentry>
                           <term>Typ</term>
                           <listitem>
                              <para> Art der Codelistennutzung, wie im XÖV-Handbuch beschrieben. </para>
                           </listitem>
                        </varlistentry>
                     </variablelist>
                     <para>Die Namen der Code-Datentypen und der Codelisten stellen Links zu den jeweiligen Detail-Abschnitten dar.</para>
                     <informaltable version="5" xml:lang="de" xml:id="code-uebersichtstabelle">
                        <tgroup cols="4">
                           <colspec colnum="1" colname="code" colwidth="74mm"/>
                           <colspec colnum="2" colname="codeliste" colwidth="65mm"/>
                           <colspec colnum="3" colname="version" colwidth="14mm"/>
                           <colspec colnum="4" colname="nutzung" colwidth="7mm"/>
                           <thead>
                              <row>
                                 <entry>Code-Datentyp</entry>
                                 <entry>Codeliste</entry>
                                 <entry>Version</entry>
                                 <entry>Typ</entry>
                              </row>
                           </thead>
                           <tbody>
                              <xsl:for-each select="
                                    ($xoev:my-xmodel/descendant::packagedElement | $xoev:my-xmodel/descendant::nestedClassifier)[uml:is-Class(.) and (xoev:xoevCodeTyp4(.) or xoev:usages-by-client(.)) and not(xoev:xsdDraft(.))]">
                                 <xsl:sort select="xoev:type-name(.)"/>
                                 <row>
                                    <entry align="left">
                                       <link role="schwarz" linkend="{concat(kosit:docbook-id(.), if(xoev:xsdGlobalElementAndNamedType(.)) then '-type' else '')}">
                                          <xsl:value-of select="xoev:type-name(.)"/>
                                       </link>
                                    </entry>
                                    <xsl:variable name="vcl" select="xoev:usages-by-client(.)[xoev:xoevCodeTyp1(.), xoev:xoevCodeTyp2(.)]/uml:resolve-supplier(.)"/>
                                    <xsl:variable name="cl" select="
                                          if (xoev:usages-by-client(.)/(xoev:xoevCodeTyp1(.), xoev:xoevCodeTyp2(.))) then
                                             $vcl/xoev:dependencies-by-client(.)/uml:resolve-supplier(.)
                                          else
                                             xoev:usages-by-client(.)/uml:resolve-supplier(.)"/>
                                    <xsl:variable name="version" select="$vcl/xoev:xoevVersionCodeliste(.)/@version"/>
                                    <xsl:variable name="cl-id" select="replace(replace(concat($cl/xoev:xoevCodeliste(.)/@kennung, '.', $cl/@name), ':', '.'), '/', '_')"/>
                                    <entry align="left">
                                       <xsl:choose>
                                          <xsl:when test="$cl">
                                             <link role="schwarz" linkend="tabelle.{$cl-id}">
                                                <xsl:choose>
                                                   <xsl:when test="$cl/xoev:xsdTitled(.)/@title[. != '']">
                                                      <xsl:value-of select="$cl/xoev:xsdTitled(.)/@title"/>
                                                   </xsl:when>
                                                   <xsl:when test="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)[. != '']">
                                                      <xsl:value-of select="$cl/xoev:metadatenelement-in-genutzter-sprache(xoev:xoevCodeliste(.)/nameKurz, .)/xoev:metadatenwert(.)"/>
                                                   </xsl:when>
                                                   <xsl:otherwise>
                                                      <emphasis role="rot">Codeliste besitzt keinen Namen (kurz)</emphasis>
                                                   </xsl:otherwise>
                                                </xsl:choose>
                                             </link>
                                          </xsl:when>
                                          <xsl:otherwise>--</xsl:otherwise>
                                       </xsl:choose>
                                    </entry>
                                    <entry align="left">
                                       <xsl:choose>
                                          <xsl:when test="$version">
                                             <xsl:value-of select="$version"/>
                                          </xsl:when>
                                          <xsl:otherwise>--</xsl:otherwise>
                                       </xsl:choose>
                                    </entry>
                                    <entry align="left">
                                       <xsl:choose>
                                          <xsl:when test="xoev:usages-by-client(.)/xoev:xoevCodeTyp1(.)">1</xsl:when>
                                          <xsl:when test="xoev:usages-by-client(.)/xoev:xoevCodeTyp2(.)">2</xsl:when>
                                          <xsl:when test="not(xoev:xoevCodeTyp4(.)) and xoev:usages-by-client(.)/uml:resolve-supplier(.)/xoev:xoevCodeliste(.)">3</xsl:when>
                                          <xsl:otherwise>4</xsl:otherwise>
                                       </xsl:choose>
                                    </entry>
                                 </row>
                              </xsl:for-each>
                           </tbody>
                        </tgroup>
                     </informaltable>
                  </section>
               </xsl:otherwise>
            </xsl:choose>
            <xsl:processing-instruction name="KoSIT-FO">hard-pagebreak</xsl:processing-instruction>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template match="packagedElement | nestedClassifier" mode="kosit:type-or-global-element">
      <xsl:param name="paket" required="yes" as="element()"/>
      <xsl:param name="type-or-elem" required="no"/>
      <xsl:choose>
         <xsl:when test="xoev:xsdGlobalAttribute(.)">
            <xsl:call-template name="xgen:result-document">
               <xsl:with-param name="local-path" select="xs:anyURI(concat('dokumente/', kosit:paketpfad-clean(., $paket), '.xml'))"/>
               <xsl:with-param name="content">
                  <xsl:apply-templates select="." mode="kosit:type-or-global-element-xml">
                     <xsl:with-param name="paket" select="$paket"/>
                  </xsl:apply-templates>
               </xsl:with-param>
            </xsl:call-template>
         </xsl:when>
         <xsl:otherwise>
            <xsl:variable name="schema-object" as="element()">
               <xsl:choose>
                  <xsl:when test="xoev:xsdNamedType(.) or $type-or-elem = 'type'">
                     <xsl:apply-templates select="." mode="xoev:type"/>
                  </xsl:when>
                  <xsl:when test="xoev:xsdMessage(.) or xoev:xsdGlobalElement(.) or $type-or-elem = 'elem'">
                     <xsl:apply-templates select="." mode="xoev:element"/>
                  </xsl:when>
               </xsl:choose>
            </xsl:variable>
            <xsl:variable name="svg" as="element()">
               <xsl:apply-templates select="$schema-object" mode="kosit:svg"/>
            </xsl:variable>
            <xsl:if test="
                  $xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereSVG = 'true' and
                  not(ownedLiteral or xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types' or xoev:xsdUnion(.))">
               <xsl:call-template name="xgen:result-document">
                  <xsl:with-param name="local-path" select="
                        xs:anyURI(concat('zeichnungen/', kosit:paketpfad-clean(., $paket), if ($type-or-elem[. != '']) then
                           concat('-', $type-or-elem)
                        else
                           '', '.svg'))"/>
                  <xsl:with-param name="content">
                     <xsl:sequence select="$svg"/>
                  </xsl:with-param>
               </xsl:call-template>
            </xsl:if>
            <xsl:call-template name="xgen:result-document">
               <xsl:with-param name="local-path" select="
                     xs:anyURI(concat('dokumente/', kosit:paketpfad-clean(., $paket), if ($type-or-elem[. != '']) then
                        concat('-', $type-or-elem)
                     else
                        '', '.xml'))"/>
               <xsl:with-param name="content">
                  <xsl:apply-templates select="." mode="kosit:type-or-global-element-xml">
                     <xsl:with-param name="paket" select="$paket"/>
                     <xsl:with-param name="svg" select="$svg"/>
                     <xsl:with-param name="type-or-elem" select="$type-or-elem"/>
                  </xsl:apply-templates>
               </xsl:with-param>
            </xsl:call-template>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>
   <xsl:template match="packagedElement | nestedClassifier" mode="kosit:type-or-global-element-xml">
      <xsl:param name="paket" as="element()" required="yes"/>
      <xsl:param name="svg" as="element()?" required="no"/>
      <xsl:param name="type-or-elem" required="no"/>
      <xsl:variable name="current-type-or-element" select="."/>
      <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
      <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE section [
<!ENTITY % complete SYSTEM "]]><xsl:for-each select="tokenize(kosit:paketpfad-clean(., $paket), '/')">../</xsl:for-each>../../ent/complete.ent<![CDATA[">
%complete;]>]]></xsl:variable>
      <xsl:value-of select="xgen:unescaped-xml(string-join($doctype, ''))"/>
      <section version="5" xml:lang="de" xml:id="{concat(kosit:docbook-id(.), if($type-or-elem[.!='']) then concat('-',$type-or-elem) else '')}">
         <xsl:for-each select="xoev:xsdDeprecated(.)">
            <xsl:attribute name="annotations" select="@deprecatedContext"/>
         </xsl:for-each>
         <title>
            <xsl:value-of select="
                  xgen:unescaped-xml((xoev:xsdTitled(.)/@title[. != ''],
                  if ($type-or-elem = 'type' or xoev:xsdNamedType(.)) then
                     xoev:type-name(.)
                  else
                     if ($type-or-elem = 'elem' or xoev:xsdGlobalElement(.)) then
                        xoev:global-element-name(.)
                     else
                        @name)[1])"/>
         </title>
         <xsl:if test="
               not($xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereSubtitleNurWennUnterschiedZumTitel = 'true') or
               xoev:xsdTitled(.)/@title[. != '']">
            <subtitle>
               <xsl:value-of select="
                     if (xoev:xsdMessage(.)) then
                        'Nachricht: '
                     else
                        if (xoev:xsdGlobalElement(.)) then
                           'Globales Element: '
                        else
                           if (xoev:xsdGlobalAttribute(.)) then
                              'Globales Attribut: '
                           else
                              if (xoev:xsdNamedType(.)) then
                                 'Typ: '
                              else
                                 if (xoev:xoevABIE(.)) then
                                    'Kernkomponente: '
                                 else
                                    ()"/>
               <emphasis role="codebf">
                  <xsl:value-of select="
                        if ($type-or-elem = 'type' or xoev:xsdNamedType(.)) then
                           xoev:type-name(.)
                        else
                           if ($type-or-elem = 'elem' or xoev:xsdGlobalElement(.)) then
                              xoev:global-element-name(.)
                           else
                              @name"/>
               </emphasis>
               <xsl:if test="@isAbstract = 'true'"> (abstrakt)</xsl:if>
            </subtitle>
         </xsl:if>
         <xsl:if test="dsmeld:dsmeldBezug(.)/blatt">
            <para>
               <emphasis role="bold">
                  <xsl:text>DSMeld-</xsl:text>
                  <xsl:value-of select="
                        if (count(dsmeld:dsmeldBezug(.)/blatt) = 1) then
                           'Blatt: '
                        else
                           'Blätter: '"/>
               </emphasis>
               <xsl:for-each select="dsmeld:dsmeldBezug(.)/blatt">
                  <xsl:value-of select="."/>
                  <xsl:if test="position() != last()">
                     <xsl:text>, </xsl:text>
                  </xsl:if>
               </xsl:for-each>
            </para>
         </xsl:if>
         <xsl:choose>
            <xsl:when test="
                  some $c in ownedComment/body
                     satisfies $c = '[nd]'"/>
            <xsl:when test="ownedComment/body[. != '']">
               <xsl:for-each select="ownedComment/body[. != '']">
                  <xsl:sort select="."/>
                  <xsl:value-of select="xgen:unescaped-xml(.)"/>
               </xsl:for-each>
            </xsl:when>
            <xsl:otherwise>
               <annotation role="todo">
                  <info>
                     <title>Dokumentation des Typs fehlt!</title>
                  </info>
                  <para>Dieses ToDo wurde automatisch generiert.</para>
               </annotation>
            </xsl:otherwise>
         </xsl:choose>
         <xsl:for-each select="xoev:xsdWithImplementationHint(.)/@implementationHint[. != '']">
            <para>
               <emphasis role="strong">Umsetzungshinweise:</emphasis>
            </para>
            <xsl:value-of select="
                  if (not(starts-with(replace(., ' ', ''), '&lt;para&gt;'))) then
                     xgen:unescaped-xml(concat('&lt;para&gt;', ., '&lt;/para&gt;'))
                  else
                     xgen:unescaped-xml(.)"/>
         </xsl:for-each>
         <xsl:for-each select="xoev:xsdMessage(.)/rechtsgrundlagen[. != '' and $xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@zeigeRechtsgrundlagenInNachrichten = 'true']">
            <para>
               <emphasis role="strong">Rechtsgrundlagen:</emphasis>
               <itemizedlist>
                  <listitem>
                     <para>
                        <xsl:value-of select="xgen:unescaped-xml(.)"/>
                     </para>
                  </listitem>
               </itemizedlist>
            </para>
         </xsl:for-each>
         <xsl:apply-templates select="
               .[$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereSVG = 'true' and not(xoev:xsdGlobalAttribute(.)) and not($type-or-elem = 'elem') and (xoev:elements(.) or xoev:attributes(.) or xoev:xsdAnyContents(.)) and
               not(ownedLiteral or (xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types') or xoev:xsdUnion(.))]" mode="kosit:figure">
            <xsl:with-param name="paket" select="$paket"/>
            <xsl:with-param name="svg" select="$svg"/>
            <xsl:with-param name="type-or-elem" select="$type-or-elem"/>
         </xsl:apply-templates>
         <xsl:apply-templates select=".[generalization]" mode="kosit:verweis-vererbung"/>
         <xsl:if test="xoev:xsdUnion(.) and $xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@AbbildungUnionMemberTypesAlsVariableListe = 'true'">
            <para>Bei dem Datentyp handelt es sich um eine Union mit den im Folgenden aufgeführten Member Types:</para>
            <variablelist>
               <xsl:for-each select="xoev:dependencies-by-client(.)[xoev:xsdUnionMember(.)]/uml:resolve-supplier(.)">
                  <xsl:sort select="
                        if (xoev:xsdNamedType(.)) then
                           xoev:type-name(.)
                        else
                           xoev:global-element-name(.)"/>
                  <varlistentry>
                     <term>
                        <emphasis role="codebf">
                           <xsl:value-of select="
                                 if ($type-or-elem = 'type' or xoev:xsdNamedType(.)) then
                                    xoev:type-name(.)
                                 else
                                    if ($type-or-elem = 'elem' or xoev:xsdGlobalElement(.)) then
                                       xoev:global-element-name(.)
                                    else
                                       @name"/>
                        </emphasis>
                     </term>
                     <listitem>
                        <xsl:if test="
                              not(some $c in ownedComment/body
                                 satisfies $c = '[nd]' or xoev:xsdWithImplementationHint(.)/@implementationHint[. != ''] or generalization)">
                           <para/>
                        </xsl:if>
                        <xsl:if test="
                              some $c in ownedComment/body
                                 satisfies $c = '[nd]'">
                           <xsl:for-each select="ownedComment/body[. != '']">
                              <xsl:sort select="."/>
                              <xsl:value-of select="xgen:unescaped-xml(.)"/>
                           </xsl:for-each>
                        </xsl:if>
                        <xsl:for-each select="xoev:xsdWithImplementationHint(.)/@implementationHint[. != '']">
                           <para>
                              <emphasis role="strong">Umsetzungshinweise:</emphasis>
                           </para>
                           <xsl:value-of select="
                                 if (not(starts-with(replace(., ' ', ''), '&lt;para&gt;'))) then
                                    xgen:unescaped-xml(concat('&lt;para&gt;', ., '&lt;/para&gt;'))
                                 else
                                    xgen:unescaped-xml(.)"/>
                        </xsl:for-each>
                        <xsl:apply-templates select=".[generalization]" mode="kosit:verweis-vererbung"/>
                     </listitem>
                  </varlistentry>
               </xsl:for-each>
            </variablelist>
         </xsl:if>
         <xsl:choose>
            <xsl:when test="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@nutzeTabellenformat = 'true'">
               <xsl:choose>
                  <xsl:when test="
                        $xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereFlacheNachrichtentabellen = 'true' or
                        $xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereFlacheDatentypentabellen = 'true'">
                     <xsl:apply-templates select=".[xoev:allElements(.) or xoev:attributes(.)]" mode="kosit:elements-and-attributes-table-flat">
                        <xsl:with-param name="type-or-elem" select="$type-or-elem"/>
                     </xsl:apply-templates>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:apply-templates select=".[xoev:elements(.) or xoev:attributes(.)]" mode="kosit:elements-and-attributes-table">
                        <xsl:with-param name="type-or-elem" select="$type-or-elem"/>
                     </xsl:apply-templates>
                  </xsl:otherwise>
               </xsl:choose>
            </xsl:when>
            <xsl:otherwise>
               <xsl:apply-templates select=".[xoev:elements(.) or xoev:attributes(.)]" mode="kosit:elements-and-attributes-simple-table">
                  <xsl:with-param name="type-or-elem" select="$type-or-elem"/>
               </xsl:apply-templates>
            </xsl:otherwise>
         </xsl:choose>
         <xsl:if test="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@nutzeTabellenformat != 'true'">
            <xsl:for-each select="(xoev:elements(.), xoev:attributes(.))">
               <xsl:variable name="basiseigenschaft" select="uml:resolve-general(../generalization[xoev:xsdRestriction(.)])/ownedAttribute[@name = current()/@name]"/>
               <xsl:if test="
                     not(some $c in ownedComment/body
                        satisfies $c = '[nd]') and
                     (if (empty(ownedComment/body[. != ''])) then
                        ($basiseigenschaft and not(some $c in $basiseigenschaft/ownedComment/body
                           satisfies $c = '[nd]') and $basiseigenschaft/ownedComment/body[. != '']) or
                        (uml:resolve-type(.)[not(xoev:xsdNamedType(.)) and not(xoev:xsdGlobalElement(.)) and not(xoev:xsdGlobalElementAndNamedType(.))] and
                        (not(some $c in uml:resolve-type(.)/ownedComment/body
                           satisfies $c = '[nd]') and uml:resolve-type(.)/ownedComment/body[. != '']))
                     else
                        true())">
                  <xsl:choose>
                     <xsl:when test="uml:resolve-type(.)[xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.) or xoev:xsdGlobalElementAndNamedType(.) or parent::packagedElement/@name = 'W3C Data Types']">
                        <xsl:apply-templates select="." mode="kosit:section-for-named-types-and-elements">
                           <xsl:with-param name="type-or-elem" select="$type-or-elem"/>
                        </xsl:apply-templates>
                     </xsl:when>
                     <xsl:otherwise>
                        <xsl:apply-templates select="." mode="kosit:section-for-anonymous-types">
                           <xsl:with-param name="pfad" select="
                                 concat(kosit:docbook-id(..), if ($type-or-elem[. != '']) then
                                    concat('-', $type-or-elem)
                                 else
                                    '')"/>
                        </xsl:apply-templates>
                     </xsl:otherwise>
                  </xsl:choose>
               </xsl:if>
            </xsl:for-each>
         </xsl:if>
         <xsl:if test="(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and $xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereNutzungKomplexerTypen = 'true'">
            <xsl:variable name="optional-prefix" select="
                  if ($xoev:my-xmodel/descendant-or-self::packagedElement[not(xoev:xsdDraft(.)) and (xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and @name = current()/@name and not(@xmi:id = current()/@xmi:id)]) then
                     (ancestor::packagedElement/xoev:xsdSchema(.)/@prefix, $xoev:my-xmodel/xoev:xsdXModel(.)/@prefix)[1]
                  else
                     ''"/>
            <xsl:variable name="href"><xsl:for-each select="tokenize(kosit:paketpfad-clean(., $paket), '/')"><xsl:if test="not(position() = last())">../</xsl:if></xsl:for-each>anhang/verwendung/complexTypes/<xsl:value-of select="concat($optional-prefix,replace(lower-case(@name), '[\s&lt;&gt;#%?&amp;{}\-\\()]+', '_'), if (xoev:xsdGlobalElementAndNamedType(.)) then
                    '-type'
                    else
                    '')"/>_list.xml</xsl:variable>
            <xsl:element name="include" namespace="http://www.w3.org/2001/XInclude">
               <xsl:attribute name="href" select="$href"/>
            </xsl:element>
         </xsl:if>
         <xsl:apply-templates select="
               .[$xoev-sch:rules-and-contexts//rule/context/@id = $current-type-or-element/
               (., xoev:attributes(.)/(., uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.))]), xoev:elements(.)/xoev:elements-in-anonymous-structures(.)/(., uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.))]))/@xmi:id]" mode="kosit:section-for-constraints">
            <xsl:with-param name="type-or-elem" select="$type-or-elem"/>
         </xsl:apply-templates>
      </section>
   </xsl:template>
   <xsl:function name="xoev:elements-in-anonymous-structures" as="element()+">
      <xsl:param name="element" as="element()"/>
      <xsl:sequence select="$element"/>
      <xsl:for-each select="$element/uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.))]/xoev:elements(.)">
         <xsl:sequence select="xoev:elements-in-anonymous-structures(.)"/>
      </xsl:for-each>
   </xsl:function>
   <xsl:template match="packagedElement | nestedClassifier" mode="kosit:section-for-constraints">
      <xsl:param name="type-or-elem" required="no"/>
      <xsl:variable name="current-type-or-element" select="."/>
      <xsl:variable name="rule-structure">
         <rule-structure>
            <xsl:for-each select="$xoev-sch:rules-and-contexts//rule[context/@id = $current-type-or-element/@xmi:id and context/@constrainedElementId = $current-type-or-element/@xmi:id]">
               <xsl:sort select="@name"/>
               <rule name="{@name}" id="{@id}"/>
            </xsl:for-each>
            <xsl:for-each select="
                  distinct-values((
                  $xoev-sch:rules-and-contexts//rule/context[@id = $current-type-or-element/@xmi:id]/paths-from-context-to-constrained-element/path/@name-path,
                  
                  $xoev-sch:rules-and-contexts//rule/context[@id = $current-type-or-element/(xoev:attributes(.),
                  xoev:elements(.)/xoev:elements-in-anonymous-structures(.))/@xmi:id]/concat(
                  if ($current-type-or-element[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]) then
                     xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:type-nodes-by-id(@id)[1], xoev-sch:type-nodes-by-id($current-type-or-element/@xmi:id))
                  else
                     xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:message-nodes-by-id(@id)[1], xoev-sch:message-nodes-by-id($current-type-or-element/@xmi:id)),
                  paths-from-context-to-constrained-element/path/@name-path),
                  
                  $xoev-sch:rules-and-contexts//rule/context[@id = $current-type-or-element/xoev:elements(.)/xoev:elements-in-anonymous-structures(.)/uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.))]/@xmi:id]/concat(
                  if ($current-type-or-element[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]) then
                     xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:type-nodes-by-type-id(@id)[1], xoev-sch:type-nodes-by-id($current-type-or-element/@xmi:id))
                  else
                     xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:message-nodes-by-type-id(@id)[1], xoev-sch:message-nodes-by-id($current-type-or-element/@xmi:id)),
                  paths-from-context-to-constrained-element/path/@name-path)))">
               <xsl:sort select="."/>
               <xsl:variable name="path" select="."/>
               <xsl:variable name="path-clean" select="substring($path, 2, string-length($path))"/>
               <path name-path="{$path}">
                  <xsl:for-each select="
                        $xoev-sch:rules-and-contexts//rule[
                        context[@id = $current-type-or-element/@xmi:id]/paths-from-context-to-constrained-element/path/@name-path = $path or
                        context[@id = $current-type-or-element/(xoev:attributes(.),
                        xoev:elements(.)/xoev:elements-in-anonymous-structures(.))/@xmi:id]/concat(
                        if ($current-type-or-element[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]) then
                           xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:type-nodes-by-id(@id)[1], xoev-sch:type-nodes-by-id($current-type-or-element/@xmi:id))
                        else
                           xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:message-nodes-by-id(@id)[1], xoev-sch:message-nodes-by-id($current-type-or-element/@xmi:id)),
                        paths-from-context-to-constrained-element/path/@name-path) = $path or
                        context[@id = $current-type-or-element/xoev:elements(.)/xoev:elements-in-anonymous-structures(.)/uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.))]/@xmi:id]/concat(
                        if ($current-type-or-element[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]) then
                           xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:type-nodes-by-type-id(@id)[1], xoev-sch:type-nodes-by-id($current-type-or-element/@xmi:id))
                        else
                           xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:message-nodes-by-type-id(@id)[1], xoev-sch:message-nodes-by-id($current-type-or-element/@xmi:id)),
                        paths-from-context-to-constrained-element/path/@name-path) = $path
                        ]">
                     <xsl:sort select="@name"/>
                     <rule name="{@name}" id="{@id}"/>
                  </xsl:for-each>
               </path>
            </xsl:for-each>
         </rule-structure>
      </xsl:variable>
      <section>
         <title>Geschäftsregeln</title>
         <informaltable xml:id="table.{concat(kosit:docbook-id(.), if($type-or-elem[.!='']) then concat('-',$type-or-elem) else '')}.rules">
            <tgroup cols="2">
               <colspec colname="id" colnum="1" colwidth="20mm"/>
               <colspec colname="regel" colnum="2" colwidth="140mm"/>
               <thead>
                  <row>
                     <entry>ID</entry>
                     <entry>Regel / XPath</entry>
                  </row>
               </thead>
               <tbody>
                  <xsl:for-each select="$rule-structure/*:rule-structure/*:rule">
                     <xsl:sort select="@name"/>
                     <xsl:variable name="constraint" select="xoev:ids-to-elements(@id, $current-type-or-element/root())"/>
                     <row>
                        <entry morerows="1">
                           <xsl:value-of select="replace($constraint/@name,'(.)',concat('$1',xgen:unescaped-xml('&amp;'), '#x200B;'))"/>
                        </entry>
                        <entry>
                           <xsl:for-each select="$constraint/ownedComment/body/xoev:clean-text(.)[. != '']">
                              <xsl:sort select="."/>
                              <xsl:value-of select="."/>
                           </xsl:for-each>
                        </entry>
                     </row>
                     <row>
                        <entry align="left">
                           <xsl:variable name="line" select="tokenize($constraint/(specification/body, specification/@value)[1], '(\r\n|\r|\n)')"/>
                           <xsl:for-each select="$line">
                              <para>
                                 <emphasis role="codebf">
                                    <xsl:value-of select="."/>
                                 </emphasis>
                              </para>
                           </xsl:for-each>
                        </entry>
                     </row>
                  </xsl:for-each>
                  <xsl:for-each select="$rule-structure//*:path">
                     <xsl:sort select="@name-path"/>
                     <xsl:variable name="path-orig" select="@name-path"/>
                     <xsl:variable name="path-clean" select="substring($path-orig, 2, string-length($path-orig))"/>
                     <row>
                        <entry namest="id" nameend="regel">
                           <emphasis role="codebf">
                              <xsl:value-of select="$path-clean"/>
                           </emphasis>
                        </entry>
                     </row>
                     <xsl:for-each select="*:rule">
                        <xsl:sort select="@name"/>
                        <xsl:variable name="constraint" select="xoev:ids-to-elements(@id, $current-type-or-element/root())"/>
                        <row>
                           <entry morerows="1">
                              <xsl:value-of select="replace($constraint/@name,'(.)',concat('$1',xgen:unescaped-xml('&amp;'), '#x200B;'))"/>
                           </entry>
                           <entry>
                              <xsl:for-each select="$constraint/ownedComment/body/xoev:clean-text(.)[. != '']">
                                 <xsl:sort select="."/>
                                 <xsl:value-of select="."/>
                              </xsl:for-each>
                           </entry>
                        </row>
                        <row>
                           <entry align="left">
                              <xsl:variable name="line" select="tokenize($constraint/(specification/body, specification/@value)[1], '(\r\n|\r|\n)')"/>
                              <xsl:for-each select="$line">
                                 <para>
                                    <emphasis role="codebf">
                                       <xsl:value-of select="."/>
                                    </emphasis>
                                 </para>
                              </xsl:for-each>
                           </entry>
                        </row>
                     </xsl:for-each>
                  </xsl:for-each>
               </tbody>
            </tgroup>
         </informaltable>
      </section>
   </xsl:template>
   <xsl:template name="kosit:appendix-for-rule-overview-types">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('dokumente/anhang/rules/rules-overview-types.xml')"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE informaltable [<!ENTITY % complete SYSTEM "../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <informaltable xml:id="table.rules.overview.types">
               <tgroup cols="2">
                  <colspec colname="id" colnum="1" colwidth="20mm"/>
                  <colspec colname="regel" colnum="2" colwidth="140mm"/>
                  <thead>
                     <row>
                        <entry>ID</entry>
                        <entry>Regel / XPath</entry>
                     </row>
                  </thead>
                  <tbody>
                     <xsl:for-each select="$xoev:my-xmodel/(descendant::packagedElement, descendant::packagedELement)[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]">
                        <xsl:sort select="@name"/>
                        <xsl:variable name="current-type-or-element" select="."/>
                        <xsl:variable name="rule-structure">
                           <rule-structure>
                              <xsl:for-each select="$xoev-sch:rules-and-contexts//rule[context/@id = $current-type-or-element/@xmi:id and context/@constrainedElementId = $current-type-or-element/@xmi:id]">
                                 <xsl:sort select="@name"/>
                                 <rule name="{@name}" id="{@id}"/>
                              </xsl:for-each>
                              <xsl:for-each select="
                                    distinct-values((
                                    $xoev-sch:rules-and-contexts//rule/context[@id = $current-type-or-element/@xmi:id]/paths-from-context-to-constrained-element/path/@name-path,
                                    
                                    $xoev-sch:rules-and-contexts//rule/context[@id = $current-type-or-element/(xoev:attributes(.),
                                    xoev:elements(.)/xoev:elements-in-anonymous-structures(.))/@xmi:id]/concat(
                                    if ($current-type-or-element[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]) then
                                       xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:type-nodes-by-id(@id)[1], xoev-sch:type-nodes-by-id($current-type-or-element/@xmi:id))
                                    else
                                       xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:message-nodes-by-id(@id)[1], xoev-sch:message-nodes-by-id($current-type-or-element/@xmi:id)),
                                    paths-from-context-to-constrained-element/path/@name-path),
                                    
                                    $xoev-sch:rules-and-contexts//rule/context[@id = $current-type-or-element/xoev:elements(.)/xoev:elements-in-anonymous-structures(.)/uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.))]/@xmi:id]/concat(
                                    if ($current-type-or-element[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]) then
                                       xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:type-nodes-by-type-id(@id)[1], xoev-sch:type-nodes-by-id($current-type-or-element/@xmi:id))
                                    else
                                       xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:message-nodes-by-type-id(@id)[1], xoev-sch:message-nodes-by-id($current-type-or-element/@xmi:id)),
                                    paths-from-context-to-constrained-element/path/@name-path)))">
                                 <xsl:sort select="."/>
                                 <xsl:variable name="path" select="."/>
                                 <xsl:variable name="path-clean" select="substring($path, 2, string-length($path))"/>
                                 <path name-path="{$path}">
                                    <xsl:for-each select="
                                          $xoev-sch:rules-and-contexts//rule[
                                          context[@id = $current-type-or-element/@xmi:id]/paths-from-context-to-constrained-element/path/@name-path = $path or
                                          context[@id = $current-type-or-element/(xoev:attributes(.),
                                          xoev:elements(.)/xoev:elements-in-anonymous-structures(.))/@xmi:id]/concat(
                                          if ($current-type-or-element[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]) then
                                             xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:type-nodes-by-id(@id)[1], xoev-sch:type-nodes-by-id($current-type-or-element/@xmi:id))
                                          else
                                             xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:message-nodes-by-id(@id)[1], xoev-sch:message-nodes-by-id($current-type-or-element/@xmi:id)),
                                          paths-from-context-to-constrained-element/path/@name-path) = $path or
                                          context[@id = $current-type-or-element/xoev:elements(.)/xoev:elements-in-anonymous-structures(.)/uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.))]/@xmi:id]/concat(
                                          if ($current-type-or-element[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]) then
                                             xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:type-nodes-by-type-id(@id)[1], xoev-sch:type-nodes-by-id($current-type-or-element/@xmi:id))
                                          else
                                             xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:message-nodes-by-type-id(@id)[1], xoev-sch:message-nodes-by-id($current-type-or-element/@xmi:id)),
                                          paths-from-context-to-constrained-element/path/@name-path) = $path
                                          ]">
                                       <xsl:sort select="@name"/>
                                       <rule name="{@name}" id="{@id}"/>
                                    </xsl:for-each>
                                 </path>
                              </xsl:for-each>
                           </rule-structure>
                        </xsl:variable>
                        <xsl:if test="$rule-structure//*:rule">
                           <row>
                              <entry namest="id" nameend="regel" align="center">
                                 <emphasis role="bold">
                                    <xsl:text>Typ </xsl:text>
                                    <xsl:value-of select="@name"/>
                                 </emphasis>
                                 <xsl:processing-instruction name="dbhtml">bgcolor="#EEEEEE"</xsl:processing-instruction>
                                 <xsl:processing-instruction name="dbfo">bgcolor="#EEEEEE"</xsl:processing-instruction>
                              </entry>
                           </row>
                           <xsl:for-each select="$rule-structure/*:rule-structure/*:rule">
                              <xsl:sort select="@name"/>
                              <xsl:variable name="constraint" select="xoev:ids-to-elements(@id, $current-type-or-element/root())"/>
                              <row>
                                 <entry morerows="1">
                                    <xsl:value-of select="replace($constraint/@name,'(.)',concat('$1',xgen:unescaped-xml('&amp;'), '#x200B;'))"/>
                                 </entry>
                                 <entry>
                                    <xsl:for-each select="$constraint/ownedComment/body/xoev:clean-text(.)[. != '']">
                                       <xsl:sort select="."/>
                                       <xsl:value-of select="."/>
                                    </xsl:for-each>
                                 </entry>
                              </row>
                              <row>
                                 <entry align="left">
                                    <xsl:variable name="line" select="tokenize($constraint/(specification/body, specification/@value)[1], '(\r\n|\r|\n)')"/>
                                    <xsl:for-each select="$line">
                                       <para>
                                          <emphasis role="codebf">
                                             <xsl:value-of select="."/>
                                          </emphasis>
                                       </para>
                                    </xsl:for-each>
                                 </entry>
                              </row>
                           </xsl:for-each>
                           <xsl:for-each select="$rule-structure//*:path">
                              <xsl:sort select="@name-path"/>
                              <xsl:variable name="path-orig" select="@name-path"/>
                              <xsl:variable name="path-clean" select="substring($path-orig, 2, string-length($path-orig))"/>
                              <row>
                                 <entry namest="id" nameend="regel">
                                    <emphasis role="codebf">
                                       <xsl:value-of select="$path-clean"/>
                                    </emphasis>
                                 </entry>
                              </row>
                              <xsl:for-each select="*:rule">
                                 <xsl:sort select="@name"/>
                                 <xsl:variable name="constraint" select="xoev:ids-to-elements(@id, $current-type-or-element/root())"/>
                                 <row>
                                    <entry morerows="1">
                                       <xsl:value-of select="replace($constraint/@name,'(.)',concat('$1',xgen:unescaped-xml('&amp;'), '#x200B;'))"/>
                                    </entry>
                                    <entry>
                                       <xsl:for-each select="$constraint/ownedComment/body/xoev:clean-text(.)[. != '']">
                                          <xsl:sort select="."/>
                                          <xsl:value-of select="."/>
                                       </xsl:for-each>
                                    </entry>
                                 </row>
                                 <row>
                                    <entry align="left">
                                       <xsl:variable name="line" select="tokenize($constraint/(specification/body, specification/@value)[1], '(\r\n|\r|\n)')"/>
                                       <xsl:for-each select="$line">
                                          <para>
                                             <emphasis role="codebf">
                                                <xsl:value-of select="."/>
                                             </emphasis>
                                          </para>
                                       </xsl:for-each>
                                    </entry>
                                 </row>
                              </xsl:for-each>
                           </xsl:for-each>
                        </xsl:if>
                     </xsl:for-each>
                  </tbody>
               </tgroup>
            </informaltable>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template name="kosit:appendix-for-rule-overview-global-elements">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI('dokumente/anhang/rules/rules-overview-global-elements.xml')"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE informaltable [<!ENTITY % complete SYSTEM "../../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <informaltable xml:id="table.rules.overview.global-elements">
               <tgroup cols="2">
                  <colspec colname="id" colnum="1" colwidth="20mm"/>
                  <colspec colname="regel" colnum="2" colwidth="140mm"/>
                  <thead>
                     <row>
                        <entry>ID</entry>
                        <entry>Regel / XPath</entry>
                     </row>
                  </thead>
                  <tbody>
                     <xsl:for-each select="$xoev:my-xmodel/(descendant::packagedElement, descendant::packagedELement)[xoev:xsdMessage(.) or xoev:xsdGlobalElement(.) or xoev:xsdGlobalElementAndNamedType(.)]">
                        <xsl:sort select="@name"/>
                        <xsl:variable name="current-type-or-element" select="."/>
                        <xsl:variable name="rule-structure">
                           <rule-structure>
                              <xsl:for-each select="$xoev-sch:rules-and-contexts//rule[context/@id = $current-type-or-element/@xmi:id and context/@constrainedElementId = $current-type-or-element/@xmi:id]">
                                 <xsl:sort select="@name"/>
                                 <rule name="{@name}" id="{@id}"/>
                              </xsl:for-each>
                              <xsl:for-each select="
                                    distinct-values((
                                    $xoev-sch:rules-and-contexts//rule/context[@id = $current-type-or-element/@xmi:id]/paths-from-context-to-constrained-element/path/@name-path,
                                    
                                    $xoev-sch:rules-and-contexts//rule/context[@id = $current-type-or-element/(xoev:attributes(.),
                                    xoev:elements(.)/xoev:elements-in-anonymous-structures(.))/@xmi:id]/concat(
                                    if ($current-type-or-element[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]) then
                                       xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:type-nodes-by-id(@id)[1], xoev-sch:type-nodes-by-id($current-type-or-element/@xmi:id))
                                    else
                                       xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:message-nodes-by-id(@id)[1], xoev-sch:message-nodes-by-id($current-type-or-element/@xmi:id)),
                                    paths-from-context-to-constrained-element/path/@name-path),
                                    
                                    $xoev-sch:rules-and-contexts//rule/context[@id = $current-type-or-element/xoev:elements(.)/xoev:elements-in-anonymous-structures(.)/uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.))]/@xmi:id]/concat(
                                    if ($current-type-or-element[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]) then
                                       xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:type-nodes-by-type-id(@id)[1], xoev-sch:type-nodes-by-id($current-type-or-element/@xmi:id))
                                    else
                                       xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:message-nodes-by-type-id(@id)[1], xoev-sch:message-nodes-by-id($current-type-or-element/@xmi:id)),
                                    paths-from-context-to-constrained-element/path/@name-path)))">
                                 <xsl:sort select="."/>
                                 <xsl:variable name="path" select="."/>
                                 <xsl:variable name="path-clean" select="substring($path, 2, string-length($path))"/>
                                 <path name-path="{$path}">
                                    <xsl:for-each select="
                                          $xoev-sch:rules-and-contexts//rule[
                                          context[@id = $current-type-or-element/@xmi:id]/paths-from-context-to-constrained-element/path/@name-path = $path or
                                          context[@id = $current-type-or-element/(xoev:attributes(.),
                                          xoev:elements(.)/xoev:elements-in-anonymous-structures(.))/@xmi:id]/concat(
                                          if ($current-type-or-element[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]) then
                                             xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:type-nodes-by-id(@id)[1], xoev-sch:type-nodes-by-id($current-type-or-element/@xmi:id))
                                          else
                                             xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:message-nodes-by-id(@id)[1], xoev-sch:message-nodes-by-id($current-type-or-element/@xmi:id)),
                                          paths-from-context-to-constrained-element/path/@name-path) = $path or
                                          context[@id = $current-type-or-element/xoev:elements(.)/xoev:elements-in-anonymous-structures(.)/uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.))]/@xmi:id]/concat(
                                          if ($current-type-or-element[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)]) then
                                             xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:type-nodes-by-type-id(@id)[1], xoev-sch:type-nodes-by-id($current-type-or-element/@xmi:id))
                                          else
                                             xoev-sch:name-path-from-constrained-element-to-context(xoev-sch:message-nodes-by-type-id(@id)[1], xoev-sch:message-nodes-by-id($current-type-or-element/@xmi:id)),
                                          paths-from-context-to-constrained-element/path/@name-path) = $path
                                          ]">
                                       <xsl:sort select="@name"/>
                                       <rule name="{@name}" id="{@id}"/>
                                    </xsl:for-each>
                                 </path>
                              </xsl:for-each>
                           </rule-structure>
                        </xsl:variable>
                        <xsl:if test="$rule-structure//*:rule">
                           <row>
                              <entry namest="id" nameend="regel" align="center">
                                 <emphasis role="bold">
                                    <xsl:text>Globales Element </xsl:text>
                                    <xsl:value-of select="@name"/>
                                 </emphasis>
                                 <xsl:processing-instruction name="dbhtml">bgcolor="#EEEEEE"</xsl:processing-instruction>
                                 <xsl:processing-instruction name="dbfo">bgcolor="#EEEEEE"</xsl:processing-instruction>
                              </entry>
                           </row>
                           <xsl:for-each select="$rule-structure/*:rule-structure/*:rule">
                              <xsl:sort select="@name"/>
                              <xsl:variable name="constraint" select="xoev:ids-to-elements(@id, $current-type-or-element/root())"/>
                              <row>
                                 <entry morerows="1">
                                    <xsl:value-of select="replace($constraint/@name,'(.)',concat('$1',xgen:unescaped-xml('&amp;'), '#x200B;'))"/>
                                 </entry>
                                 <entry>
                                    <xsl:for-each select="$constraint/ownedComment/body/xoev:clean-text(.)[. != '']">
                                       <xsl:sort select="."/>
                                       <xsl:value-of select="."/>
                                    </xsl:for-each>
                                 </entry>
                              </row>
                              <row>
                                 <entry align="left">
                                    <xsl:variable name="line" select="tokenize($constraint/(specification/body, specification/@value)[1], '(\r\n|\r|\n)')"/>
                                    <xsl:for-each select="$line">
                                       <para>
                                          <emphasis role="codebf">
                                             <xsl:value-of select="."/>
                                          </emphasis>
                                       </para>
                                    </xsl:for-each>
                                 </entry>
                              </row>
                           </xsl:for-each>
                           <xsl:for-each select="$rule-structure//*:path">
                              <xsl:sort select="@name-path"/>
                              <xsl:variable name="path-orig" select="@name-path"/>
                              <xsl:variable name="path-clean" select="substring($path-orig, 2, string-length($path-orig))"/>
                              <row>
                                 <entry namest="id" nameend="regel">
                                    <emphasis role="codebf">
                                       <xsl:value-of select="$path-clean"/>
                                    </emphasis>
                                 </entry>
                              </row>
                              <xsl:for-each select="*:rule">
                                 <xsl:sort select="@name"/>
                                 <xsl:variable name="constraint" select="xoev:ids-to-elements(@id, $current-type-or-element/root())"/>
                                 <row>
                                    <entry morerows="1">
                                       <xsl:value-of select="replace($constraint/@name,'(.)',concat('$1',xgen:unescaped-xml('&amp;'), '#x200B;'))"/>
                                    </entry>
                                    <entry>
                                       <xsl:for-each select="$constraint/ownedComment/body/xoev:clean-text(.)[. != '']">
                                          <xsl:sort select="."/>
                                          <xsl:value-of select="."/>
                                       </xsl:for-each>
                                    </entry>
                                 </row>
                                 <row>
                                    <entry align="left">
                                       <xsl:variable name="line" select="tokenize($constraint/(specification/body, specification/@value)[1], '(\r\n|\r|\n)')"/>
                                       <xsl:for-each select="$line">
                                          <para>
                                             <emphasis role="codebf">
                                                <xsl:value-of select="."/>
                                             </emphasis>
                                          </para>
                                       </xsl:for-each>
                                    </entry>
                                 </row>
                              </xsl:for-each>
                           </xsl:for-each>
                        </xsl:if>
                     </xsl:for-each>
                  </tbody>
               </tgroup>
            </informaltable>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template match="ownedAttribute" mode="kosit:section-for-named-types-and-elements">
      <xsl:param name="pfad" required="no"/>
      <xsl:param name="type-or-elem" required="no"/>
      <section xml:id="{concat(if ($pfad) then $pfad else concat(kosit:docbook-id(..), if($type-or-elem[.!='']) then concat('-',$type-or-elem) else ''), '..', if (xoev:is-ref(.)) then uml:resolve-type(.)/@name else @name)}">
         <title>
            <emphasis role="codebf"><xsl:value-of select="
                     if (xoev:is-ref(.)) then
                        uml:resolve-type(.)/xoev:global-element-name(.)
                     else
                        @name"/></emphasis> (<xsl:choose>
               <xsl:when test="xoev:is-ref(.)">
                  <emphasis role="codebf">Elementreferenz</emphasis>
               </xsl:when>
               <xsl:when test="uml:resolve-type(.)/parent::packagedElement/@name = 'W3C Data Types'">
                  <emphasis role="codebf">
                     <xsl:value-of select="concat('xs:', uml:resolve-type(.)/@name)"/>
                  </emphasis>
               </xsl:when>
               <xsl:when test="xoev:xsdNamedType(uml:resolve-type(.)) or xoev:xsdGlobalElementAndNamedType(uml:resolve-type(.)) or uml:is-Enumeration(uml:resolve-type(.))">
                  <emphasis role="codebf">
                     <xsl:value-of select="uml:resolve-type(.)/xoev:type-name(.)"/>
                  </emphasis>
               </xsl:when>
            </xsl:choose>)</title>
         <xsl:for-each select="defaultValue/(@value, body, uml:resolve-instance(.)/@name)[1][. != '']">
            <para>Default-Wert: <xsl:value-of select="."/></para>
         </xsl:for-each>
         <xsl:choose>
            <xsl:when test="
                  not(some $c in ownedComment/body
                     satisfies $c = '[nd]') and ownedComment/body[. != '']">
               <xsl:for-each select="ownedComment/body[. != '']">
                  <xsl:sort select="."/>
                  <xsl:value-of select="xgen:unescaped-xml(.)"/>
               </xsl:for-each>
            </xsl:when>
            <xsl:otherwise>
               <xsl:variable name="basiseigenschaft" select="uml:resolve-general(../generalization[xoev:xsdRestriction(.)])/ownedAttribute[@name = current()/@name]"/>
               <xsl:if test="
                     not(some $c in $basiseigenschaft/ownedComment/body
                        satisfies $c = '[nd]') and $basiseigenschaft/ownedComment/body[. != '']">
                  <para>Dokumentation aus <xsl:apply-templates select="$basiseigenschaft/parent::packagedElement" mode="kosit:xref">
                        <xsl:with-param name="rolle">Quelle</xsl:with-param>
                        <xsl:with-param name="type-or-elem">type</xsl:with-param>
                     </xsl:apply-templates>:</para>
                  <xsl:for-each select="$basiseigenschaft/ownedComment/body[. != '']">
                     <xsl:sort select="."/>
                     <xsl:value-of select="xgen:unescaped-xml(.)"/>
                  </xsl:for-each>
               </xsl:if>
            </xsl:otherwise>
         </xsl:choose>
      </section>
   </xsl:template>
   <xsl:template match="ownedAttribute" mode="kosit:section-for-anonymous-types">
      <xsl:param name="pfad" required="yes"/>
      <xsl:variable name="property" select="."/>
      <section xml:id="{concat($pfad, '..', @name)}">
         <title>
            <emphasis role="codebf">
               <xsl:value-of select="@name"/>
            </emphasis>
         </title>
         <xsl:if test="
               not(some $c in ownedComment/body
                  satisfies $c = '[nd]')">
            <xsl:choose>
               <xsl:when test="ownedComment/body[. != '']">
                  <xsl:for-each select="ownedComment/body[. != '']">
                     <xsl:sort select="."/>
                     <xsl:value-of select="xgen:unescaped-xml(.)"/>
                  </xsl:for-each>
               </xsl:when>
               <xsl:when test="
                     uml:resolve-type(.) and not(some $c in uml:resolve-type(.)/ownedComment/body
                        satisfies $c = '[nd]') and uml:resolve-type(.)/ownedComment/body[. != '']">
                  <xsl:for-each select="uml:resolve-type(.)/ownedComment/body[. != '']">
                     <xsl:sort select="."/>
                     <xsl:value-of select="xgen:unescaped-xml(.)"/>
                  </xsl:for-each>
               </xsl:when>
               <xsl:otherwise>
                  <annotation role="todo">
                     <info>
                        <title>Dokumentation fehlt!</title>
                     </info>
                     <para>Dieses ToDo wurde automatisch generiert.</para>
                  </annotation>
               </xsl:otherwise>
            </xsl:choose>
         </xsl:if>
         <xsl:apply-templates select="uml:resolve-type(.)[generalization]" mode="kosit:verweis-vererbung"/>
         <xsl:apply-templates select="uml:resolve-type(.)[not(xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types')]" mode="kosit:elements-and-attributes-simple-table">
            <xsl:with-param name="id" select="concat($pfad, '..', @name)"/>
         </xsl:apply-templates>
         <xsl:for-each select="
               (xoev:elements(uml:resolve-type(.)), xoev:attributes(uml:resolve-type(.)))[not(some $c in ownedComment/body
                  satisfies $c = '[nd]') and ownedComment/body[. != '']]">
            <xsl:choose>
               <xsl:when test="uml:resolve-type(.)[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.) or xoev:xsdGlobalElement(.) or parent::packagedElement/@name = 'W3C Data Types']">
                  <xsl:apply-templates select="." mode="kosit:section-for-named-types-and-elements">
                     <xsl:with-param name="pfad" select="concat($pfad, '..', $property/@name)"/>
                  </xsl:apply-templates>
               </xsl:when>
               <xsl:otherwise>
                  <xsl:apply-templates select="." mode="kosit:section-for-anonymous-types">
                     <xsl:with-param name="pfad" select="concat($pfad, '..', $property/@name)"/>
                  </xsl:apply-templates>
               </xsl:otherwise>
            </xsl:choose>
         </xsl:for-each>
      </section>
   </xsl:template>
   <xsl:template match="packagedElement | nestedClassifier" mode="kosit:elements-and-attributes-simple-table">
      <xsl:param name="id" required="no"/>
      <xsl:param name="type-or-elem" required="no"/>
      <informaltable xml:id="table.{if ($id) then $id else concat(kosit:docbook-id(.), if($type-or-elem[.!='']) then concat('-',$type-or-elem) else '')}">
         <xsl:if test="xoev:elements(.)">
            <tgroup cols="5">
               <colspec colname="child" colnum="1" colwidth="40mm"/>
               <colspec colname="type" colnum="2" colwidth="51mm"/>
               <colspec colname="cardinality" colnum="3" colwidth="24mm"/>
               <colspec colname="reference" colnum="4" colwidth="30mm"/>
               <colspec colname="page" colnum="5" colwidth="15mm"/>
               <thead>
                  <row>
                     <entry namest="child" nameend="page" align="center">
                        <xsl:value-of select="
                              if (not(empty(xoev:elements(.)))) then
                                 'Kindelement'
                              else
                                 ''"/>
                        <xsl:value-of select="
                              if (count(xoev:elements(.)) > 1) then
                                 'e'
                              else
                                 ''"/>
                        <xsl:text> von </xsl:text>
                        <emphasis role="codebf">
                           <xsl:value-of select="
                                 if ($id) then
                                    tokenize($id, '\.')[last()]
                                 else
                                    if ($type-or-elem = 'type' or xoev:xsdNamedType(.)) then
                                       xoev:type-name(.)
                                    else
                                       if ($type-or-elem = 'elem' or xoev:xsdGlobalElement(.)) then
                                          xoev:global-element-name(.)
                                       else
                                          @name"/>
                        </emphasis>
                     </entry>
                  </row>
                  <row>
                     <entry>Kindelement</entry>
                     <entry>Typ</entry>
                     <entry>Häufigkeit</entry>
                     <entry>Referenz</entry>
                     <entry>Seite</entry>
                  </row>
               </thead>
               <tbody>
                  <xsl:for-each select="xoev:elements(.)">
                     <row>
                        <entry>
                           <xsl:value-of select="
                                 if (xoev:is-ref(.)) then
                                    uml:resolve-type(.)/xoev:global-element-name(.)
                                 else
                                    @name"/>
                        </entry>
                        <entry>
                           <xsl:choose>
                              <xsl:when test="uml:resolve-type(.)/parent::packagedElement/@name = 'W3C Data Types'">
                                 <emphasis role="codebf">
                                    <xsl:value-of select="concat('xs:', uml:resolve-type(.)/@name)"/>
                                 </emphasis>
                              </xsl:when>
                              <xsl:when test="xoev:xsdNamedType(uml:resolve-type(.)) or xoev:xsdGlobalElementAndNamedType(uml:resolve-type(.)) or uml:is-Enumeration(uml:resolve-type(.))">
                                 <emphasis role="codebf">
                                    <xsl:value-of select="uml:resolve-type(.)/xoev:type-name(.)"/>
                                 </emphasis>
                              </xsl:when>
                           </xsl:choose>
                        </entry>
                        <entry>
                           <xsl:variable name="lower" select="
                                 if (lowerValue/@value = 1 or not(lowerValue)) then
                                    '1'
                                 else
                                    if (lowerValue and not(lowerValue/@value)) then
                                       '0'
                                    else
                                       lowerValue/@value"/>
                           <xsl:variable name="upper" select="
                                 if (upperValue/@value = '*') then
                                    'n'
                                 else
                                    if (upperValue/@value = '1' or not(upperValue)) then
                                       '1'
                                    else
                                       if (upperValue and not(upperValue/@value)) then
                                          '0'
                                       else
                                          upperValue/@value"/>
                           <xsl:value-of select="$lower"/>
                           <xsl:if test="$lower != $upper">..<xsl:value-of select="$upper"/></xsl:if>
                        </entry>
                        <xsl:choose>
                           <xsl:when test="
                                 uml:resolve-type(.)[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.) or xoev:xsdGlobalElement(.)] and
                                 not(uml:resolve-type(.)[kosit:docInlineSimpleTypeDocumentation(.)])">
                              <entry>
                                 <xsl:apply-templates select="uml:resolve-type(.)" mode="kosit:xref">
                                    <xsl:with-param name="rolle" select="
                                          if (uml:resolve-type(.)/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id) then
                                             'Abschnitt'
                                          else
                                             'Quelle'"/>
                                    <xsl:with-param name="type-or-elem" select="
                                          if (uml:resolve-type(.)/xoev:xsdGlobalElementAndNamedType(.)) then
                                             if (xoev:is-ref(.)) then
                                                'elem'
                                             else
                                                'type'
                                          else
                                             ''"/>
                                 </xsl:apply-templates>
                                 <xsl:if test="
                                       not(some $c in ownedComment/body
                                          satisfies $c = '[nd]') and
                                       ownedComment/body[. != ''] and
                                       not(uml:resolve-type(.)/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id)"> *</xsl:if>
                              </entry>
                              <entry>
                                 <xsl:apply-templates select="uml:resolve-type(.)" mode="kosit:xref">
                                    <xsl:with-param name="rolle">Seitenzahl</xsl:with-param>
                                    <xsl:with-param name="type-or-elem" select="
                                          if (uml:resolve-type(.)/xoev:xsdGlobalElementAndNamedType(.)) then
                                             if (xoev:is-ref(.)) then
                                                'elem'
                                             else
                                                'type'
                                          else
                                             ''"/>
                                 </xsl:apply-templates>
                                 <xsl:if test="
                                       not(some $c in ownedComment/body
                                          satisfies $c = '[nd]') and
                                       ownedComment/body[. != ''] and
                                       uml:resolve-type(.)/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id"> *</xsl:if>
                              </entry>
                           </xsl:when>
                           <xsl:when test="
                                 uml:resolve-type(.)/generalization and not(xoev:is-ref(.)) and
                                 not(xoev:topmost-parent(uml:resolve-type(.))/parent::packagedElement/@name = 'W3C Data Types') and
                                 not(uml:resolve-type(.)[kosit:docInlineSimpleTypeDocumentation(.)])">
                              <entry>
                                 <xsl:apply-templates select="uml:resolve-general(uml:resolve-type(.)/generalization)" mode="kosit:xref">
                                    <xsl:with-param name="rolle" select="
                                          if (uml:resolve-general(uml:resolve-type(.)/generalization)/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id) then
                                             'AbschnittNummer'
                                          else
                                             'Quelle'"/>
                                    <xsl:with-param name="type-or-elem" select="
                                          if (uml:resolve-general(uml:resolve-type(.)/generalization)/xoev:xsdGlobalElementAndNamedType(.)) then
                                             if (xoev:is-ref(.)) then
                                                'elem'
                                             else
                                                'type'
                                          else
                                             ''"/>
                                 </xsl:apply-templates>
                              </entry>
                              <entry>
                                 <xsl:apply-templates select="uml:resolve-general(uml:resolve-type(.)/generalization)" mode="kosit:xref">
                                    <xsl:with-param name="rolle">Seitenzahl</xsl:with-param>
                                    <xsl:with-param name="type-or-elem" select="
                                          if (uml:resolve-general(uml:resolve-type(.)/generalization)/xoev:xsdGlobalElementAndNamedType(.)) then
                                             if (xoev:is-ref(.)) then
                                                'elem'
                                             else
                                                'type'
                                          else
                                             ''"/>
                                 </xsl:apply-templates>
                              </entry>
                           </xsl:when>
                           <xsl:otherwise>
                              <entry/>
                              <entry/>
                           </xsl:otherwise>
                        </xsl:choose>
                     </row>
                  </xsl:for-each>
               </tbody>
            </tgroup>
         </xsl:if>
         <xsl:if test="xoev:attributes(.)">
            <tgroup cols="5">
               <colspec colname="child" colnum="1" colwidth="40mm"/>
               <colspec colname="type" colnum="2" colwidth="51mm"/>
               <colspec colname="cardinality" colnum="3" colwidth="24mm"/>
               <colspec colname="reference" colnum="4" colwidth="30mm"/>
               <colspec colname="page" colnum="5" colwidth="15mm"/>
               <thead>
                  <row>
                     <entry namest="child" nameend="page" align="center">
                        <xsl:value-of select="
                              if (count(xoev:attributes(.)) = 1) then
                                 'Attribut'
                              else
                                 'Attribute'"/> von <emphasis role="codebf"><xsl:value-of select="@name"/></emphasis>
                     </entry>
                  </row>
                  <row>
                     <entry>Attribut</entry>
                     <entry>Typ</entry>
                     <entry>Erforderlich</entry>
                     <entry>Referenz</entry>
                     <entry>Seite</entry>
                  </row>
               </thead>
               <tbody>
                  <xsl:for-each select="xoev:attributes(.)">
                     <row>
                        <entry>
                           <xsl:value-of select="@name"/>
                        </entry>
                        <entry>
                           <xsl:choose>
                              <xsl:when test="uml:resolve-type(.)/parent::packagedElement/@name = 'W3C Data Types'">
                                 <emphasis role="codebf">
                                    <xsl:value-of select="concat('xs:', uml:resolve-type(.)/@name)"/>
                                 </emphasis>
                              </xsl:when>
                              <xsl:when test="xoev:xsdNamedType(uml:resolve-type(.)) or xoev:xsdGlobalElementAndNamedType(uml:resolve-type(.)) or uml:is-Enumeration(uml:resolve-type(.))">
                                 <emphasis role="codebf">
                                    <xsl:value-of select="uml:resolve-type(.)/xoev:type-name(.)"/>
                                 </emphasis>
                              </xsl:when>
                           </xsl:choose>
                        </entry>
                        <entry>
                           <xsl:variable name="lower" select="
                                 if (lowerValue/@value = 1 or not(lowerValue)) then
                                    '1'
                                 else
                                    if (lowerValue and not(lowerValue/@value)) then
                                       '0'
                                    else
                                       lowerValue/@value"/>
                           <xsl:if test="$lower != '0'">ja</xsl:if>
                        </entry>
                        <xsl:choose>
                           <xsl:when test="
                                 uml:resolve-type(.)[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)] and
                                 not(uml:resolve-type(.)[kosit:docInlineSimpleTypeDocumentation(.)])">
                              <entry>
                                 <xsl:apply-templates select="uml:resolve-type(.)" mode="kosit:xref">
                                    <xsl:with-param name="rolle" select="
                                          if (uml:resolve-type(.)/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id) then
                                             'Abschnitt'
                                          else
                                             'Quelle'"/>
                                    <xsl:with-param name="type-or-elem" select="
                                          if (uml:resolve-type(.)/xoev:xsdGlobalElementAndNamedType(.)) then
                                             if (xoev:is-ref(.)) then
                                                'elem'
                                             else
                                                'type'
                                          else
                                             ''"/>
                                 </xsl:apply-templates>
                                 <xsl:if test="
                                       not(some $c in ownedComment/body
                                          satisfies $c = '[nd]') and
                                       ownedComment/body[. != ''] and
                                       not(uml:resolve-type(.)/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id)"> *</xsl:if>
                              </entry>
                              <entry>
                                 <xsl:apply-templates select="uml:resolve-type(.)" mode="kosit:xref">
                                    <xsl:with-param name="rolle">Seitenzahl</xsl:with-param>
                                    <xsl:with-param name="type-or-elem" select="
                                          if (uml:resolve-type(.)/xoev:xsdGlobalElementAndNamedType(.)) then
                                             if (xoev:is-ref(.)) then
                                                'elem'
                                             else
                                                'type'
                                          else
                                             ''"/>
                                 </xsl:apply-templates>
                                 <xsl:if test="
                                       not(some $c in ownedComment/body
                                          satisfies $c = '[nd]') and
                                       ownedComment/body[. != ''] and
                                       uml:resolve-type(.)/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id"> *</xsl:if>
                              </entry>
                           </xsl:when>
                           <xsl:when test="
                                 uml:resolve-type(.)/generalization and not(xoev:is-ref(.)) and
                                 not(uml:resolve-type(.)/parent::packagedElement/@name = 'W3C Data Types') and
                                 not(uml:resolve-type(.)[kosit:docInlineSimpleTypeDocumentation(.)])">
                              <entry>
                                 <xsl:apply-templates select="uml:resolve-general(uml:resolve-type(.)/generalization)" mode="kosit:xref">
                                    <xsl:with-param name="rolle" select="
                                          if (uml:resolve-general(uml:resolve-type(.)/generalization)/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id) then
                                             'AbschnittNummer'
                                          else
                                             'Quelle'"/>
                                    <xsl:with-param name="type-or-elem" select="
                                          if (uml:resolve-general(uml:resolve-type(.)/generalization)/xoev:xsdGlobalElementAndNamedType(.)) then
                                             if (xoev:is-ref(.)) then
                                                'elem'
                                             else
                                                'type'
                                          else
                                             ''"/>
                                 </xsl:apply-templates>
                              </entry>
                              <entry>
                                 <xsl:apply-templates select="uml:resolve-general(uml:resolve-type(.)/generalization)" mode="kosit:xref">
                                    <xsl:with-param name="rolle">Seitenzahl</xsl:with-param>
                                    <xsl:with-param name="type-or-elem" select="
                                          if (uml:resolve-general(uml:resolve-type(.)/generalization)/xoev:xsdGlobalElementAndNamedType(.)) then
                                             if (xoev:is-ref(.)) then
                                                'elem'
                                             else
                                                'type'
                                          else
                                             ''"/>
                                 </xsl:apply-templates>
                              </entry>
                           </xsl:when>
                           <xsl:otherwise>
                              <entry/>
                              <entry/>
                           </xsl:otherwise>
                        </xsl:choose>
                     </row>
                  </xsl:for-each>
               </tbody>
            </tgroup>
         </xsl:if>
      </informaltable>
   </xsl:template>
   <xsl:template match="packagedElement | nestedClassifier" mode="kosit:elements-and-attributes-table">
      <xsl:param name="type-or-elem" required="no"/>
      <informaltable xml:id="table.{concat(kosit:docbook-id(.), if($type-or-elem[.!='']) then concat('-',$type-or-elem) else '')}">
         <xsl:variable name="tief" select="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@hoheVerschachtelungstiefeInKindelementtabellen = 'true'"/>
         <tgroup cols="{if ($tief) then '20' else '11'}">
            <xsl:choose>
               <xsl:when test="$tief">
                  <colspec colname="indent0" colnum="1" colwidth="2mm"/>
                  <colspec colname="indent1" colnum="2" colwidth="2mm"/>
                  <colspec colname="indent2" colnum="3" colwidth="2mm"/>
                  <colspec colname="indent3" colnum="4" colwidth="2mm"/>
                  <colspec colname="indent4" colnum="5" colwidth="2mm"/>
                  <colspec colname="indent5" colnum="6" colwidth="2mm"/>
                  <colspec colname="indent6" colnum="7" colwidth="2mm"/>
                  <colspec colname="indent7" colnum="8" colwidth="2mm"/>
                  <colspec colname="indent8" colnum="9" colwidth="2mm"/>
                  <colspec colname="indent9" colnum="10" colwidth="2mm"/>
                  <colspec colname="indent10" colnum="11" colwidth="2mm"/>
                  <colspec colname="indent11" colnum="12" colwidth="2mm"/>
                  <colspec colname="indent12" colnum="13" colwidth="2mm"/>
                  <colspec colname="indent13" colnum="14" colwidth="2mm"/>
                  <colspec colname="indent14" colnum="15" colwidth="2mm"/>
                  <colspec colname="child" colnum="16" colwidth="27mm"/>
                  <colspec colname="type" colnum="17" colwidth="65mm"/>
                  <colspec colname="cardinality" colnum="18" colwidth="12mm"/>
                  <colspec colname="reference" colnum="19" colwidth="14mm"/>
                  <colspec colname="page" colnum="20" colwidth="12mm"/>
               </xsl:when>
               <xsl:otherwise>
                  <colspec colname="indent0" colnum="1" colwidth="5mm"/>
                  <colspec colname="indent1" colnum="2" colwidth="5mm"/>
                  <colspec colname="indent2" colnum="3" colwidth="5mm"/>
                  <colspec colname="indent3" colnum="4" colwidth="5mm"/>
                  <colspec colname="indent4" colnum="5" colwidth="5mm"/>
                  <colspec colname="indent5" colnum="6" colwidth="5mm"/>
                  <colspec colname="child" colnum="7" colwidth="27mm"/>
                  <colspec colname="type" colnum="8" colwidth="65mm"/>
                  <colspec colname="cardinality" colnum="9" colwidth="12mm"/>
                  <colspec colname="reference" colnum="10" colwidth="14mm"/>
                  <colspec colname="page" colnum="11" colwidth="12mm"/>
               </xsl:otherwise>
            </xsl:choose>
            <thead>
               <row>
                  <entry namest="indent0" nameend="page" align="center">
                     <xsl:value-of select="
                           if (not(empty(xoev:elements(.)))) then
                              'Kindelement'
                           else
                              ''"/>
                     <xsl:value-of select="
                           if (count(xoev:elements(.)) > 1) then
                              'e'
                           else
                              ''"/>
                     <xsl:if test="not(empty(xoev:elements(.))) and not(empty(xoev:attributes(.)))">
                        <xsl:text> / </xsl:text>
                     </xsl:if>
                     <xsl:value-of select="
                           if (not(empty(xoev:attributes(.)))) then
                              'Attribut'
                           else
                              ''"/>
                     <xsl:value-of select="
                           if (count(xoev:attributes(.)) > 1) then
                              'e'
                           else
                              ''"/>
                     <xsl:text> von </xsl:text>
                     <emphasis role="codebf">
                        <xsl:value-of select="
                              if (xoev:xsdNamedType(.) or $type-or-elem = 'type') then
                                 xoev:type-name(.)
                              else
                                 if (xoev:xsdGlobalElement(.) or $type-or-elem = 'elem') then
                                    xoev:global-element-name(.)
                                 else
                                    @name"/>
                     </emphasis>
                  </entry>
               </row>
               <row>
                  <entry namest="indent0" nameend="child">
                     <xsl:value-of select="
                           if (not(empty(xoev:elements(.)))) then
                              'Kindelement'
                           else
                              ''"/>
                     <xsl:if test="not(empty(xoev:elements(.))) and not(empty(xoev:attributes(.)))">
                        <xsl:text> / </xsl:text>
                     </xsl:if>
                     <xsl:value-of select="
                           if (not(empty(xoev:attributes(.)))) then
                              'Attribut'
                           else
                              ''"/>
                  </entry>
                  <entry>Typ</entry>
                  <entry>Anz.</entry>
                  <entry>Ref.</entry>
                  <entry>Seite</entry>
               </row>
            </thead>
            <tbody>
               <xsl:for-each select="(xoev:attributes(.), xoev:elements(.))">
                  <xsl:apply-templates select="." mode="kosit:tabelle-zeile">
                     <xsl:with-param name="indent" select="0"/>
                     <xsl:with-param name="lastElement" select="position() = last()"/>
                  </xsl:apply-templates>
               </xsl:for-each>
            </tbody>
         </tgroup>
      </informaltable>
      <para/>
   </xsl:template>
   <xsl:template match="packagedElement | nestedClassifier" mode="kosit:elements-and-attributes-table-flat">
      <xsl:param name="type-or-elem" required="no"/>
      <xsl:variable name="class" select="."/>
      <informaltable xml:id="table.{concat(kosit:docbook-id(.), if($type-or-elem[.!='']) then concat('-',$type-or-elem) else '')}">
         <tgroup cols="13">
            <colspec colname="indent0" colnum="1" colwidth="5mm"/>
            <colspec colname="indent1" colnum="2" colwidth="5mm"/>
            <colspec colname="indent2" colnum="3" colwidth="5mm"/>
            <colspec colname="indent3" colnum="4" colwidth="5mm"/>
            <colspec colname="indent4" colnum="5" colwidth="5mm"/>
            <colspec colname="indent5" colnum="6" colwidth="5mm"/>
            <colspec colname="indent6" colnum="7" colwidth="5mm"/>
            <colspec colname="indent7" colnum="8" colwidth="5mm"/>
            <colspec colname="indent8" colnum="9" colwidth="5mm"/>
            <colspec colname="child" colnum="10" colwidth="27mm"/>
            <colspec colname="type" colnum="11" colwidth="65mm"/>
            <colspec colname="cardinality" colnum="12" colwidth="12mm"/>
            <colspec colname="page" colnum="13" colwidth="12mm"/>
            <thead>
               <row>
                  <entry namest="indent0" nameend="page" align="center">
                     <xsl:value-of select="
                           if (not(empty(xoev:allElements(.)))) then
                              'Kindelement'
                           else
                              ''"/>
                     <xsl:value-of select="
                           if (count(xoev:allElements(.)) > 1) then
                              'e'
                           else
                              ''"/>
                     <xsl:if test="not(empty(xoev:allElements(.))) and not(empty(xoev:attributes(.)))">
                        <xsl:text> / </xsl:text>
                     </xsl:if>
                     <xsl:value-of select="
                           if (not(empty(xoev:attributes(.)))) then
                              'Attribut'
                           else
                              ''"/>
                     <xsl:value-of select="
                           if (count(xoev:attributes(.)) > 1) then
                              'e'
                           else
                              ''"/>
                     <xsl:text> von </xsl:text>
                     <emphasis role="codebf">
                        <xsl:value-of select="@name"/>
                     </emphasis>
                  </entry>
               </row>
               <row>
                  <entry namest="indent0" nameend="child">
                     <xsl:value-of select="
                           if (not(empty(xoev:allElements(.)))) then
                              'Kindelement'
                           else
                              ''"/>
                     <xsl:if test="not(empty(xoev:allElements(.))) and not(empty(xoev:attributes(.)))">
                        <xsl:text> / </xsl:text>
                     </xsl:if>
                     <xsl:value-of select="
                           if (not(empty(xoev:attributes(.)))) then
                              'Attribut'
                           else
                              ''"/>
                  </entry>
                  <entry>Typ</entry>
                  <entry>Anz.</entry>
                  <entry>Seite</entry>
               </row>
            </thead>
            <tbody>
               <!-- ANFORDERUNG: Bei Erweiterungen werden alle direkt und indirekt geerbten Elemente, nicht aber die Attribute, angezeigt: attributes(.) vs. allElements(.) -->
               <xsl:for-each select="xoev:attributes(.)">
                  <xsl:apply-templates select="." mode="kosit:tabelle-zeile-flat">
                     <xsl:with-param name="indent" select="0"/>
                     <xsl:with-param name="lastElement" select="position() = last() and empty($class/xoev:allElements(.))"/>
                  </xsl:apply-templates>
               </xsl:for-each>
               <xsl:for-each select="xoev:allElements(.)">
                  <xsl:variable name="element" select="."/>
                  <xsl:apply-templates select="." mode="kosit:tabelle-zeile-flat">
                     <xsl:with-param name="indent" select="0"/>
                     <xsl:with-param name="lastElement" select="position() = last()"/>
                     <xsl:with-param name="inherited" select="empty(xoev:elements($class)[@xmi:id = $element/@xmi:id])"/>
                     <xsl:with-param name="template-prop" select="
                           not(empty($class/generalization[not(xoev:xsdRestriction(.))]/uml:resolve-general(.)[
                           kosit:docTemplate(.) and ownedAttribute[@name = current()/@name]]))"/>
                  </xsl:apply-templates>
               </xsl:for-each>
            </tbody>
         </tgroup>
      </informaltable>
      <para/>
   </xsl:template>
   <xsl:template match="packagedElement | nestedClassifier" mode="kosit:figure">
      <xsl:param name="svg" required="yes"/>
      <xsl:param name="paket" required="yes"/>
      <xsl:param name="type-or-elem" required="no"/>
      <figure xml:id="figure.{concat(kosit:docbook-id(.), if($type-or-elem[.!='']) then concat('-',$type-or-elem) else '')}">
         <title>
            <xsl:value-of select="
                  if (xoev:xsdNamedType(.) or $type-or-elem = 'type') then
                     xoev:type-name(.)
                  else
                     if (xoev:xsdGlobalElement(.) or $type-or-elem = 'elem') then
                        xoev:global-element-name(.)
                     else
                        @name"/>
         </title>
         <!-- Die SVG-Generierung erzeugt ein SVG-Element, welches in width und height Angaben in px (1pt = 1.25px). 
                 Das bedeutet, zur Einbindung muss der Anwender noch ermitteln, wie das SVG ggf. skaliert werden muss. -->
         <mediaobject>
            <imageobject>
               <imagedata format="svg" align="center" scale="{floor(min((1.1, 750.0 div $svg/@width, 1000.0 div $svg/@height)) * 100)}">
                  <xsl:attribute name="fileref">
                     <xsl:for-each select="
                           tokenize(kosit:paketpfad-clean(., $paket),
                           '/')">../</xsl:for-each>zeichnungen/<xsl:value-of select="kosit:paketpfad-clean(., $paket)"/><xsl:value-of select="
                           if ($type-or-elem[. != '']) then
                              concat('-', $type-or-elem)
                           else
                              ''"/>.svg</xsl:attribute>
               </imagedata>
            </imageobject>
         </mediaobject>
      </figure>
   </xsl:template>
   <xsl:template match="packagedElement | nestedClassifier" mode="kosit:verweis-vererbung">
      <xsl:variable name="bezeichnung" select="
            if (xoev:xsdMessage(.)) then
               'Diese Nachricht '
            else
               if (kosit:docInlineSimpleTypeDocumentation(.)) then
                  'Der Typ dieses Elements '
               else
                  'Dieser Typ '"/>
      <xsl:variable name="rg" select="xoev:xsdRestriction(generalization)"/>
      <xsl:choose>
         <xsl:when test="xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types'">
            <xsl:choose>
               <xsl:when test="$rg">
                  <para>
                     <xsl:value-of select="$bezeichnung"/>
                     <xsl:text>ist eine Einschränkung des Basistyps </xsl:text>
                     <xsl:choose>
                        <xsl:when test="uml:resolve-general(generalization)/parent::packagedElement/@name = 'W3C Data Types'">
                           <emphasis role="codebf">
                              <xsl:value-of select="xoev:qualified-type-name(uml:resolve-general(generalization), ., false())"/>
                           </emphasis>
                        </xsl:when>
                        <xsl:otherwise>
                           <emphasis role="codebf">
                              <xsl:value-of select="uml:resolve-general(generalization)/xoev:type-name(.)"/>
                           </emphasis>
                           <xsl:text> (siehe </xsl:text>
                           <xsl:apply-templates select="uml:resolve-general(generalization)" mode="kosit:xref">
                              <xsl:with-param name="rolle">AS</xsl:with-param>
                              <xsl:with-param name="type-or-elem" select="
                                    if (uml:resolve-general(generalization)/xoev:xsdGlobalElementAndNamedType(.)) then
                                       'type'
                                    else
                                       ''"/>
                           </xsl:apply-templates>
                           <xsl:text>)</xsl:text>
                        </xsl:otherwise>
                     </xsl:choose>
                     <xsl:text>.</xsl:text>
                  </para>
                  <xsl:if test="
                        $rg/@pattern and $rg/@pattern != '' and
                        ($xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@zeigeRestrictionFacetten = 'true' or
                        uml:resolve-general(generalization)/parent::packagedElement/@name = 'W3C Data Types')">
                     <xsl:variable name="muster" as="xs:string*"><![CDATA[<![CDATA[]]><xsl:value-of select="$rg/@pattern"/>]]&gt;</xsl:variable>
                     <para>Die Werte müssen dem Muster '<xsl:value-of select="xgen:unescaped-xml(string-join($muster, ''))"/>' entsprechen.</para>
                  </xsl:if>
                  <xsl:variable name="facetten" select="
                        ($rg/@enumeration, $rg/@fractionDigits, $rg/@length, $rg/@maxExclusive, $rg/@maxInclusive, $rg/@maxLength,
                        $rg/@minExclusive, $rg/@minInclusive, $rg/@minLength, $rg/@totalDigits, $rg/@whitespace)"/>
                  <xsl:if test="$xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@zeigeRestrictionFacetten = 'true' and $facetten">
                     <para>Beschränkungen (XML-Schema-Facetten): <xsl:for-each select="$facetten"><xsl:value-of select="concat(name(), ':', .)"/><xsl:if test="position() != last()">; </xsl:if></xsl:for-each></para>
                  </xsl:if>
                  <!--<xsl:for-each select="xoev:type-by-name($rg/@enumeration, root(.))">
                            <para>Die Werte müssen den Codes der Werteliste <emphasis role="codebf"><xsl:value-of select="substring-after(., '.')"/></emphasis> entsprechen (siehe <xref linkend="tabelle."/>).</para>
                        </xsl:for-each>-->
               </xsl:when>
               <xsl:otherwise>
                  <xsl:choose>
                     <xsl:when test="uml:resolve-general(generalization)/parent::packagedElement/@name = 'W3C Data Types'">
                        <para><xsl:value-of select="$bezeichnung"/> ist eine Erweiterung des Basistyps <emphasis role="codebf"><xsl:value-of select="xoev:qualified-type-name(uml:resolve-general(generalization), ., false())"/></emphasis>.</para>
                     </xsl:when>
                     <xsl:otherwise>
                        <para><xsl:value-of select="$bezeichnung"/> ist eine Erweiterung des Basistyps <emphasis role="codebf"><xsl:value-of select="uml:resolve-general(generalization)/xoev:type-name(.)"/></emphasis> (siehe <xsl:apply-templates select="uml:resolve-general(generalization)" mode="kosit:xref">
                              <xsl:with-param name="rolle">AS</xsl:with-param>
                              <xsl:with-param name="type-or-elem" select="
                                    if (uml:resolve-general(generalization)/xoev:xsdGlobalElementAndNamedType(.)) then
                                       'type'
                                    else
                                       ''"/>
                           </xsl:apply-templates>).</para>
                     </xsl:otherwise>
                  </xsl:choose>
               </xsl:otherwise>
            </xsl:choose>
         </xsl:when>
         <xsl:otherwise>
            <para>
               <xsl:value-of select="$bezeichnung"/>
               <xsl:text> ist eine </xsl:text>
               <xsl:value-of select="
                     if ($rg) then
                        'Einschränkung'
                     else
                        'Erweiterung'"/>
               <xsl:text> des Basistyps </xsl:text>
               <emphasis role="codebf">
                  <xsl:value-of select="uml:resolve-general(generalization)/xoev:type-name(.)"/>
               </emphasis>
               <xsl:text> (siehe </xsl:text>
               <xsl:apply-templates select="uml:resolve-general(generalization)" mode="kosit:xref">
                  <xsl:with-param name="rolle">AS</xsl:with-param>
                  <xsl:with-param name="type-or-elem" select="
                        if (uml:resolve-general(generalization)/xoev:xsdGlobalElementAndNamedType(.)) then
                           'type'
                        else
                           ''"/>
               </xsl:apply-templates>
               <xsl:text>).</xsl:text>
               <xsl:if test="not($rg) and xoev:xsdMessage(.) and $xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@hinweisDokumentationElementeBasistyp = 'true'">
                  <xsl:text> Die semantische Dokumentation der ererbten Kindelemente entspricht derjenigen an den Elementen des genannten Basistyps und ist dort nachzulesen.</xsl:text>
               </xsl:if>
            </para>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>
   <xsl:template match="packagedElement | nestedClassifier" mode="kosit:xref">
      <xsl:param name="rolle" required="yes"/>
      <xsl:param name="type-or-elem" required="no"/>
      <xsl:choose>
         <xsl:when test="ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id">
            <xref linkend="{concat(kosit:docbook-id(.), if($type-or-elem[.!='']) then concat('-',$type-or-elem) else '')}" role="{$rolle}"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:variable name="import-bezeichnung" select="
                  $xoev:my-xmodel/packagedElement[uml:resolve-supplier(.)/@xmi:id = current()/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id]/xoev:xsdXModelImport(.)/@bezeichnung"/>
            <xsl:variable name="linkend" select="
                    replace(replace(replace(replace(replace(replace(replace(
                    $import-bezeichnung,'[\s/&lt;&gt;%?&amp;{}\-\\&quot;\(\)]+','_'),'ä','ae'),'Ä','AE'),'ö','oe'),'Ö','OE'),'ü','ue'),'Ü','UE')"/>
            <xref linkend="externe.modelle.{$linkend}" role="{$rolle}"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>
   <xsl:template match="ownedAttribute" mode="kosit:tabelle-zeile">
      <xsl:param name="indent" as="xs:integer" required="yes"/>
      <xsl:param name="lastElement" as="xs:boolean*" required="yes"/>
      <xsl:variable name="property" select="."/>
      <xsl:variable name="doc" as="xs:string*">
         <xsl:choose>
            <xsl:when test="ownedComment/body[. = '[nd]']"/>
            <xsl:when test="ownedComment/body[. != '']">
               <xsl:for-each select="ownedComment/body[. != '']">
                  <xsl:sort select="."/>
                  <xsl:value-of select="xgen:unescaped-xml(.)"/>
               </xsl:for-each>
            </xsl:when>
            <xsl:when test="
                  ownedComment/body[. = '[dt]'] or
                  (uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and
                  not(ownedLiteral or (xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types' and not(generalization) or
                  generalization/xoev:xsdRestriction(.)) or xoev:xsdUnion(.))])">
               <xsl:for-each select="uml:resolve-type(.)/ownedComment/body[. != '']">
                  <xsl:sort select="."/>
                  <xsl:value-of select="xgen:unescaped-xml(.)"/>
               </xsl:for-each>
            </xsl:when>
            <xsl:when test="uml:resolve-general(../generalization[xoev:xsdRestriction(.)])/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id != $xoev:my-xmodel/@xmi:id">
               <xsl:variable name="basiseigenschaft" select="uml:resolve-general(../generalization[xoev:xsdRestriction(.)])/ownedAttribute[@name = $property/@name]"/>
               <xsl:for-each select="$basiseigenschaft/ownedComment/body[. != '']">
                  <xsl:sort select="."/>
                  <xsl:value-of select="xgen:unescaped-xml(.)"/>
               </xsl:for-each>
            </xsl:when>
            <xsl:when test="uml:resolve-general(../generalization[xoev:xsdRestriction(.)])"/>
            <xsl:otherwise>generiereTodo</xsl:otherwise>
         </xsl:choose>
      </xsl:variable>
      <row>
         <xsl:for-each select="xoev:xsdDeprecated(.)/@deprecatedContext">
            <xsl:attribute name="annotations" select="."/>
         </xsl:for-each>
         <xsl:for-each select="1 to $indent">
            <!-- rowsep='1' wenn,
                    - auf der aktuellen Ebene und in den tieferen Verschachtelungsebenen keine weiteren Elemente oder Attribute folgen und
                    - das aktuelle Element bzw. Attribut nicht dokumentiert wird und
                -->
            <entry rowsep="{if (
                    empty(index-of(subsequence($lastElement, position() + 1), false())) and
                    (uml:resolve-type($property)[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)] or uml:resolve-type($property)/xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types') and
                    empty($doc))
                    then
                    '1'
                    else
                    '0'}" colsep="{if (position() = last()) then '1' else '0'}"/>
         </xsl:for-each>
         <entry namest="indent{$indent}" nameend="child">
            <xsl:choose>
               <xsl:when test="xoev:xsdLocalStructure(.) and uml:resolve-type(.)[xoev:xsdAnyContents(.)]"/>
               <xsl:when test="xoev:xsdAttribute(.)">
                  <emphasis>
                     <emphasis role="bold">
                        <xsl:value-of select="
                              if (xoev:is-ref(.)) then
                                 uml:resolve-type(.)/@name
                              else
                                 @name"/>
                     </emphasis>
                  </emphasis>
               </xsl:when>
               <xsl:otherwise>
                  <xsl:variable name="prefix" select="
                        if ($xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@zeigeNamensraumpraefix = 'true') then
                           concat((uml:resolve-type(.)/ancestor::packagedElement/xoev:xsdSchema(.)/@prefix,
                           uml:resolve-type(.)/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1], ':')
                        else
                           ''"/>
                  <emphasis role="bold">
                     <xsl:value-of select="
                           if (xoev:is-ref(.)) then
                              concat($prefix, uml:resolve-type(.)/xoev:global-element-name(.))
                           else
                              @name"/>
                  </emphasis>
               </xsl:otherwise>
            </xsl:choose>
            <xsl:value-of select="
                  if (xoev:is-ref(.)) then
                     ' (ref)'
                  else
                     ''"/>
         </entry>
         <entry>
            <xsl:choose>
               <xsl:when test="uml:resolve-type(.)/parent::packagedElement/@name = 'W3C Data Types'">
                  <emphasis role="codebf">
                     <xsl:value-of select="concat('xs:', uml:resolve-type(.)/@name)"/>
                  </emphasis>
               </xsl:when>
               <xsl:when test="(xoev:xsdNamedType(uml:resolve-type(.)) or xoev:xsdGlobalElementAndNamedType(uml:resolve-type(.)) or uml:is-Enumeration(uml:resolve-type(.))) and not(xoev:is-ref(.))">
                  <xsl:variable name="prefix" select="
                        if ($xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@zeigeNamensraumpraefix = 'true') then
                           concat((uml:resolve-type(.)/ancestor::packagedElement/xoev:xsdSchema(.)/@prefix,
                           uml:resolve-type(.)/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1], ':')
                        else
                           ''"/>
                  <emphasis role="codebf">
                     <xsl:value-of select="concat($prefix, uml:resolve-type(.)/xoev:type-name(.))"/>
                  </emphasis>
               </xsl:when>
               <xsl:when test="uml:resolve-type(.)/generalization and not(xoev:is-ref(.))">
                  <xsl:variable name="prefix" select="
                        if ($xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@zeigeNamensraumpraefix = 'true') then
                           concat((uml:resolve-general(uml:resolve-type(.)/generalization)/ancestor::packagedElement/xoev:xsdSchema(.)/@prefix,
                           uml:resolve-general(uml:resolve-type(.)/generalization)/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1], ':')
                        else
                           ''"/>
                  <emphasis role="codebf">
                     <xsl:value-of select="concat($prefix, uml:resolve-general(uml:resolve-type(.)/generalization)/@name)"/>
                  </emphasis>
                  <xsl:text> (Basistyp)</xsl:text>
               </xsl:when>
            </xsl:choose>
         </entry>
         <entry>
            <xsl:if test="not(xoev:xsdLocalStructure(.) and uml:resolve-type(.)[xoev:xsdAnyContents(.)])">
               <emphasis role="bold">
                  <xsl:variable name="lower" select="
                        if (lowerValue/@value = 1 or not(lowerValue)) then
                           '1'
                        else
                           if (lowerValue and not(lowerValue/@value)) then
                              '0'
                           else
                              lowerValue/@value"/>
                  <xsl:variable name="upper" select="
                        if (upperValue/@value = '*') then
                           'n'
                        else
                           if (upperValue/@value = '1' or not(upperValue)) then
                              '1'
                           else
                              if (upperValue and not(upperValue/@value)) then
                                 '0'
                              else
                                 upperValue/@value"/>
                  <xsl:value-of select="$lower"/>
                  <xsl:if test="$lower != $upper">..<xsl:value-of select="$upper"/></xsl:if>
               </emphasis>
            </xsl:if>
         </entry>
         <xsl:choose>
            <xsl:when test="xoev:is-ref(.) or uml:resolve-type(.)[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)] and not(uml:resolve-type(.)[kosit:docInlineSimpleTypeDocumentation(.)])">
               <entry>
                  <xsl:apply-templates select="uml:resolve-type(.)" mode="kosit:xref">
                     <xsl:with-param name="rolle" select="
                           if (uml:resolve-type(.)/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id) then
                              'AbschnittNummer'
                           else
                              'Quelle'"/>
                     <xsl:with-param name="type-or-elem" select="
                           if (uml:resolve-type(.)/xoev:xsdGlobalElementAndNamedType(.)) then
                              if (xoev:is-ref(.)) then
                                 'elem'
                              else
                                 'type'
                           else
                              ''"/>
                  </xsl:apply-templates>
               </entry>
               <entry>
                  <xsl:apply-templates select="uml:resolve-type(.)" mode="kosit:xref">
                     <xsl:with-param name="rolle">Seitenzahl</xsl:with-param>
                     <xsl:with-param name="type-or-elem" select="
                           if (uml:resolve-type(.)/xoev:xsdGlobalElementAndNamedType(.)) then
                              if (xoev:is-ref(.)) then
                                 'elem'
                              else
                                 'type'
                           else
                              ''"/>
                  </xsl:apply-templates>
               </entry>
            </xsl:when>
            <xsl:when test="
                  uml:resolve-type(.)/generalization and
                  not(uml:resolve-type(.)/parent::packagedElement/@name = 'W3C Data Types') and
                  not(uml:resolve-type(.)[kosit:docInlineSimpleTypeDocumentation(.)])">
               <entry>
                  <xsl:apply-templates select="uml:resolve-general(uml:resolve-type(.)/generalization)" mode="kosit:xref">
                     <xsl:with-param name="rolle" select="
                           if (uml:resolve-general(uml:resolve-type(.)/generalization)/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id = $xoev:my-xmodel/@xmi:id) then
                              'AbschnittNummer'
                           else
                              'Quelle'"/>
                     <xsl:with-param name="type-or-elem" select="
                           if (uml:resolve-general(uml:resolve-type(.)/generalization)/xoev:xsdGlobalElementAndNamedType(.)) then
                              if (xoev:is-ref(.)) then
                                 'elem'
                              else
                                 'type'
                           else
                              ''"/>
                  </xsl:apply-templates>
               </entry>
               <entry>
                  <xsl:apply-templates select="uml:resolve-general(uml:resolve-type(.)/generalization)" mode="kosit:xref">
                     <xsl:with-param name="rolle">Seitenzahl</xsl:with-param>
                     <xsl:with-param name="type-or-elem" select="
                           if (uml:resolve-general(uml:resolve-type(.)/generalization)/xoev:xsdGlobalElementAndNamedType(.)) then
                              if (xoev:is-ref(.)) then
                                 'elem'
                              else
                                 'type'
                           else
                              ''"/>
                  </xsl:apply-templates>
               </entry>
            </xsl:when>
            <xsl:otherwise>
               <entry/>
               <entry/>
            </xsl:otherwise>
         </xsl:choose>
      </row>
      <xsl:variable name="default-value" select="defaultValue/(@value, body, uml:resolve-instance(.)/@name)[1]"/>
      <xsl:if test="not(empty($doc)) or uml:resolve-type($property)[xoev:allParents(.) and kosit:docInlineSimpleTypeDocumentation(.)] or xoev:xsdWithImplementationHint(.)/@implementationHint[. != ''] or $default-value">
         <row>
            <xsl:for-each select="1 to $indent">
               <entry rowsep="{if (
                        empty(index-of(subsequence($lastElement, position() + 1), false())) and
                        (uml:resolve-type($property)[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)] or uml:resolve-type($property)/xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types'))
                        then
                        '1'
                        else
                        '0'}" colsep="{if (position() = last()) then '1' else '0'}"/>
            </xsl:for-each>
            <entry namest="indent{$indent}" nameend="page">
               <!-- TODO (MK mit FB): Klären, warum das folgende if erforderlich: Wenn man den Text in die $doc-Variable packt, verschwinden die Tags. -->
               <!-- FB: Zwei Variante: a) die hier zu erzeugenden Tags oben bereits als maskierten String schreiben
                        oder b) - meine Präferenz - Variable als element()* deklarieren, Tags normal schreiben und dann
                        hier xsl:sequence anstelle von xsl:value-of nutzen-->
               <xsl:if test="
                     not(ownedComment/body[. != '']) and not(uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.))] and not(some $c in uml:resolve-type(.)/ownedComment/body
                        satisfies $c = '[nd]') and uml:resolve-type(.)/ownedComment/body[. != '']) and uml:resolve-general(../generalization[xoev:xsdRestriction(.)])/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id != $xoev:my-xmodel/@xmi:id">
                  <xsl:variable name="basiseigenschaft" select="uml:resolve-general(../generalization[xoev:xsdRestriction(.)])/ownedAttribute[@name = $property/@name]"/>
                  <xsl:if test="
                        not(some $c in $basiseigenschaft/ownedComment/body
                           satisfies $c = '[nd]') and $basiseigenschaft/ownedComment/body[. != '']">
                     <para>Dokumentation aus <xsl:apply-templates select="$basiseigenschaft/parent::packagedElement" mode="kosit:xref">
                           <xsl:with-param name="rolle">Quelle</xsl:with-param>
                           <xsl:with-param name="type-or-elem" select="
                                 if ($basiseigenschaft/parent::packagedElement/xoev:xsdGlobalElementAndNamedType(.)) then
                                    if (xoev:is-ref(.)) then
                                       'elem'
                                    else
                                       'type'
                                 else
                                    ''"/>
                        </xsl:apply-templates>:</para>
                  </xsl:if>
               </xsl:if>
               <xsl:choose>
                  <xsl:when test="$doc[. = 'generiereTodo']">
                     <annotation role="todo">
                        <info>
                           <title>Dokumentation fehlt!</title>
                        </info>
                        <para>Dieses ToDo wurde automatisch generiert.</para>
                     </annotation>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:value-of select="$doc"/>
                     <xsl:variable name="rg" select="
                           (
                           uml:resolve-type($property)/generalization/xoev:xsdRestriction(.),
                           uml:resolve-type($property)/generalization/uml:resolve-general(.)/generalization/xoev:xsdRestriction(.))[1]"/>
                     <xsl:variable name="facetten" select="
                           ($rg/@enumeration, $rg/@fractionDigits, $rg/@length, $rg/@maxExclusive, $rg/@maxInclusive, $rg/@maxLength,
                           $rg/@minExclusive, $rg/@minInclusive, $rg/@minLength, $rg/@totalDigits, $rg/@whitespace)"/>
                     <xsl:if test="
                           not(uml:resolve-type($property)/kosit:docInlineSimpleTypeDocumentation(.)) and
                           uml:resolve-type($property)/xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types' and
                           not(uml:resolve-type($property)[ancestor::packagedElement/xoev:xoevBibliothek(.) and @name = 'datatypeC']) and
                           ($rg/@pattern[. != ''] or not(empty($facetten))) and
                           $xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@AbbildungXSDFacetten = 'true'">
                        <xsl:variable name="muster" as="xs:string*"><![CDATA[<![CDATA[]]><xsl:value-of select="$rg/@pattern"/>]]&gt;</xsl:variable>
                        <xsl:if test="$rg/@pattern[. != '']">
                           <para>
                              <xsl:text>Die Werte müssen dem Muster '</xsl:text>
                              <xsl:value-of select="xgen:unescaped-xml(string-join($muster, ''))"/>
                              <xsl:text>' entsprechen.</xsl:text>
                           </para>
                        </xsl:if>
                        <xsl:if test="$facetten">
                           <para>
                              <xsl:text>Beschränkungen (XML-Schema-Facetten): </xsl:text>
                              <xsl:for-each select="$facetten">
                                 <xsl:value-of select="concat(name(), ':', .)"/>
                                 <xsl:if test="position() != last()">; </xsl:if>
                              </xsl:for-each>
                           </para>
                        </xsl:if>
                     </xsl:if>
                  </xsl:otherwise>
               </xsl:choose>
               <xsl:apply-templates select="uml:resolve-type($property)[xoev:allParents(.) and kosit:docInlineSimpleTypeDocumentation(.)]" mode="kosit:verweis-vererbung"/>
               <xsl:choose>
                  <xsl:when test="$default-value and @isReadOnly = 'true'">
                     <para>In diesem Element/Attribut ist nur Wert <quote><xsl:value-of select="$default-value"/></quote> zulässig (fixed-Wert).</para>
                  </xsl:when>
                  <xsl:when test="$default-value">
                     <para>Dieses Element/Attribut hat den Wert <quote><xsl:value-of select="$default-value"/></quote>, sofern kein anderer Wert übermittelt wird (default-Wert).</para>
                  </xsl:when>
               </xsl:choose>
               <xsl:for-each select="xoev:xsdWithImplementationHint(.)/@implementationHint[. != '']">
                  <para>
                     <emphasis role="strong">Umsetzungshinweise:</emphasis>
                  </para>
                  <xsl:value-of select="
                        if (not(starts-with(replace(., ' ', ''), '&lt;para&gt;'))) then
                           xgen:unescaped-xml(concat('&lt;para&gt;', ., '&lt;/para&gt;'))
                        else
                           xgen:unescaped-xml(.)"/>
               </xsl:for-each>
            </entry>
         </row>
      </xsl:if>
      <xsl:for-each select="uml:resolve-type(.)[not(xoev:xsdGlobalElement(.)) and not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and not(uml:resolve-type(.)/xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types')]">
         <xsl:for-each select="(xoev:attributes(.), xoev:elements(.))">
            <xsl:apply-templates select="." mode="kosit:tabelle-zeile">
               <xsl:with-param name="indent" select="$indent + 1"/>
               <xsl:with-param name="lastElement" select="($lastElement, position() = last())"/>
            </xsl:apply-templates>
         </xsl:for-each>
      </xsl:for-each>
   </xsl:template>
   <xsl:template match="ownedAttribute" mode="kosit:tabelle-zeile-flat">
      <xsl:param name="indent" as="xs:integer" required="yes"/>
      <xsl:param name="lastElement" as="xs:boolean*" required="yes"/>
      <xsl:param name="inherited" as="xs:boolean" required="no" select="false()"/>
      <xsl:param name="template-prop" as="xs:boolean" required="no" select="false()"/>
      <xsl:variable name="property" select="."/>
      <xsl:variable name="doc" as="xs:string*">
         <xsl:choose>
            <xsl:when test="ownedComment/body[. = '[nd]']"/>
            <xsl:when test="ownedComment/body[. != '']">
               <xsl:for-each select="ownedComment/body[. != '']">
                  <xsl:sort select="."/>
                  <xsl:value-of select="xgen:unescaped-xml(.)"/>
               </xsl:for-each>
            </xsl:when>
            <xsl:when test="
                  ownedComment/body[. = '[dt]'] or
                  (uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) and
                  not(ownedLiteral or (xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types' and not(generalization) or
                  generalization/xoev:xsdRestriction(.)) or xoev:xsdUnion(.))])">
               <xsl:for-each select="uml:resolve-type(.)/ownedComment/body[. != '']">
                  <xsl:sort select="."/>
                  <xsl:value-of select="xgen:unescaped-xml(.)"/>
               </xsl:for-each>
            </xsl:when>
            <xsl:when test="../generalization[xoev:xsdRestriction(.)]">
               <xsl:variable name="basiseigenschaft" select="uml:resolve-general(../generalization[xoev:xsdRestriction(.)])/ownedAttribute[@name = $property/@name]"/>
               <xsl:for-each select="$basiseigenschaft/ownedComment/body[. != '']">
                  <xsl:sort select="."/>
                  <xsl:value-of select="xgen:unescaped-xml(.)"/>
               </xsl:for-each>
            </xsl:when>
            <xsl:otherwise>generiereTodo</xsl:otherwise>
         </xsl:choose>
      </xsl:variable>
      <row>
         <xsl:for-each select="xoev:xsdDeprecated(.)/@deprecatedContext">
            <xsl:attribute name="annotations" select="."/>
         </xsl:for-each>
         <xsl:for-each select="1 to $indent">
            <!-- rowsep='1' wenn,
                    - auf der aktuellen Ebene und in den tieferen Verschachtelungsebenen keine weiteren Elemente oder Attribute folgen und
                    - das aktuelle Element bzw. Attribut nicht dokumentiert wird und
                -->
            <xsl:variable name="nested-elements-or-attributes" select="
                  uml:resolve-type($property)[
                  (
                  not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) or
                  (
                  $property/kosit:documentInFlatList(.) or
                  (
                  not($property/kosit:ignoreInFlatList(.)) and
                  not(kosit:ignoreInFlatList(.)) and
                  (xoev:allElements(.) or not($inherited) or $template-prop))
                  )
                  ) and
                  not(uml:resolve-type($property)/xoev:topmost-parent(.)/parent::*/@name = 'W3C Data Types')]"/>
            <entry rowsep="{if (
                    (empty(index-of(subsequence($lastElement, position() + 1), false())) and (not(position()=last()) or empty($nested-elements-or-attributes) or 
                    uml:resolve-type($property)[xoev:xoevCodeTyp4(.) or xoev:usages-by-client(.)/uml:resolve-supplier(.)[xoev:xoevCodeliste(.) or xoev:xoevVersionCodeliste(.)]]
                    )) and
                    (uml:resolve-type($property)[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)] or uml:resolve-type($property)/xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types') and
                    (empty($doc) or ($inherited and not($template-prop))))
                    then
                    '1'
                    else
                    '0'}" colsep="{if (position() = last()) then '1' else '0'}"/>
         </xsl:for-each>
         <entry namest="indent{$indent}" nameend="{if(ancestor::packagedElement/kosit:docGlobaleVariablen(.)/@MergeSpalteKindelementUndTypBeiAnonymenTypen = 'true' and not((uml:resolve-type(.)/parent::packagedElement/@name = 'W3C Data Types') or (xoev:xsdNamedType(uml:resolve-type(.)) or uml:is-Enumeration(uml:resolve-type(.))) or (uml:resolve-type(.)/generalization and not(xoev:xsdElement(.)/@isRef)))) then 'type' else 'child'}">
            <xsl:choose>
               <xsl:when test="xoev:xsdLocalStructure(.) and uml:resolve-type(.)[xoev:xsdAnyContents(.)]"/>
               <xsl:when test="xoev:xsdAttribute(.)">
                  <emphasis>
                     <emphasis role="bold">
                        <xsl:value-of select="@name"/>
                     </emphasis>
                  </emphasis>
               </xsl:when>
               <xsl:otherwise>
                  <xsl:if test="parent::*[xoev:xsdChoice(.)]">
                     <xsl:value-of select="
                           concat('[C',
                           count(parent::*/xoev:elements(.)[xoev:position(.) &lt;= current()/xoev:position(.)]),
                           '/',
                           count(parent::*/xoev:elements(.)), '] ')"/>
                  </xsl:if>
                  <emphasis role="bold">
                     <xsl:value-of select="
                           if (xoev:is-ref(.)) then
                              uml:resolve-type(.)/xoev:global-element-name(.)
                           else
                              @name"/>
                  </emphasis>
               </xsl:otherwise>
            </xsl:choose>
            <xsl:value-of select="
                  if (xoev:is-ref(.)) then
                     ' (ref)'
                  else
                     ''"/>
         </entry>
         <xsl:choose>
            <xsl:when test="uml:resolve-type(.)/parent::packagedElement/@name = 'W3C Data Types'">
               <entry>
                  <emphasis role="codebf">
                     <xsl:value-of select="concat('xs:', uml:resolve-type(.)/@name)"/>
                  </emphasis>
               </entry>
            </xsl:when>
            <xsl:when test="(xoev:xsdNamedType(uml:resolve-type(.)) or xoev:xsdGlobalElementAndNamedType(uml:resolve-type(.)) or uml:is-Enumeration(uml:resolve-type(.))) and not(xoev:is-ref(.))">
               <entry>
                  <emphasis role="codebf">
                     <xsl:value-of select="uml:resolve-type(.)/xoev:type-name(.)"/>
                  </emphasis>
               </entry>
            </xsl:when>
            <xsl:when test="uml:resolve-type(.)/generalization and not(xoev:is-ref(.))">
               <entry>
                  <emphasis role="codebf">
                     <xsl:value-of select="uml:resolve-general(uml:resolve-type(.)/generalization)/xoev:type-name(.)"/>
                  </emphasis>
                  <xsl:text> (Basistyp)</xsl:text>
               </entry>
            </xsl:when>
            <xsl:when test="ancestor::packagedElement/kosit:docGlobaleVariablen(.)/@MergeSpalteKindelementUndTypBeiAnonymenTypen != 'true'">
               <entry/>
            </xsl:when>
         </xsl:choose>
         <entry>
            <xsl:if test="not(xoev:xsdLocalStructure(.) and uml:resolve-type(.)[xoev:xsdAnyContents(.)])">
               <emphasis role="bold">
                  <xsl:variable name="lower" select="
                        if (lowerValue/@value = 1 or not(lowerValue)) then
                           '1'
                        else
                           if (lowerValue and not(lowerValue/@value)) then
                              '0'
                           else
                              lowerValue/@value"/>
                  <xsl:variable name="upper" select="
                        if (upperValue/@value = '*') then
                           'n'
                        else
                           if (upperValue/@value = '1' or not(upperValue)) then
                              '1'
                           else
                              if (upperValue and not(upperValue/@value)) then
                                 '0'
                              else
                                 upperValue/@value"/>
                  <xsl:value-of select="$lower"/>
                  <xsl:if test="$lower != $upper">..<xsl:value-of select="$upper"/></xsl:if>
               </emphasis>
            </xsl:if>
         </entry>
         <xsl:choose>
            <xsl:when test="uml:resolve-type(.)[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)] and not(uml:resolve-type(.)[kosit:docInlineSimpleTypeDocumentation(.)])">
               <entry>
                  <xsl:apply-templates select="uml:resolve-type(.)" mode="kosit:xref">
                     <xsl:with-param name="rolle">Seitenzahl</xsl:with-param>
                  </xsl:apply-templates>
                  <xsl:if test="
                        not($xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereSternhinweisInFlacheListenDarstellung = 'false') and
                        not(some $c in ownedComment/body
                           satisfies $c = '[nd]') and
                        ownedComment/body[. != '']"> *</xsl:if>
               </entry>
            </xsl:when>
            <xsl:when test="
                  uml:resolve-type(.)/generalization and not(xoev:is-ref(.)) and
                  not(uml:resolve-type(.)/parent::packagedElement/@name = 'W3C Data Types') and
                  not(uml:resolve-type(.)[kosit:docInlineSimpleTypeDocumentation(.)])">
               <entry>
                  <xsl:apply-templates select="uml:resolve-general(uml:resolve-type(.)/generalization)" mode="kosit:xref">
                     <xsl:with-param name="rolle">Seitenzahl</xsl:with-param>
                     <xsl:with-param name="type-or-elem" select="
                           if (uml:resolve-general(uml:resolve-type(.)/generalization)/xoev:xsdGlobalElementAndNamedType(.)) then
                              if (xoev:is-ref(.)) then
                                 'elem'
                              else
                                 'type'
                           else
                              ''"/>
                  </xsl:apply-templates>
                  <xsl:if test="
                        not($xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@generiereSternhinweisInFlacheListenDarstellung = 'false') and
                        not(some $c in ownedComment/body
                           satisfies $c = '[nd]') and
                        ownedComment/body[. != '']"> *</xsl:if>
               </entry>
            </xsl:when>
            <xsl:otherwise>
               <entry/>
            </xsl:otherwise>
         </xsl:choose>
      </row>
      <xsl:variable name="default-value" select="defaultValue/(@value, body, uml:resolve-instance(.)/@name)[1]"/>
      <!-- ANFORDERUNG: Dokumentation geerbter Elemente und Attribute ($inherited = true) wird nicht angezeigt. -->
      <!-- ANFORDERUNG: Dokumentation eigener Elemente und Attribute wird immer angezeigt, auch für (angezeigte) Unterstrukturen. -->
      <xsl:if test="(not($inherited) or $template-prop) and (not(empty($doc)) or uml:resolve-type($property)[xoev:allParents(.) and kosit:docInlineSimpleTypeDocumentation(.)] or xoev:xsdWithImplementationHint(.)/@implementationHint[. != ''] or $default-value)">
         <row>
            <xsl:for-each select="1 to $indent">
               <xsl:variable name="nested-elements-or-attributes" select="
                     uml:resolve-type($property)[
                     (not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) or
                     ($property/kosit:documentInFlatList(.) or (not($property/kosit:ignoreInFlatList(.)) and not(kosit:ignoreInFlatList(.)) and (not($inherited) or $template-prop))))
                     and not(uml:resolve-type($property)/xoev:topmost-parent(.)/parent::*/@name = 'W3C Data Types')]"/>
               <entry rowsep="{if (
                        (empty(index-of(subsequence($lastElement, position() + 1), false())) and (not(position()=last()) or empty($nested-elements-or-attributes) or
                        uml:resolve-type($property)[xoev:xoevCodeTyp4(.) or xoev:usages-by-client(.)/uml:resolve-supplier(.)[xoev:xoevCodeliste(.) or xoev:xoevVersionCodeliste(.)]])) and
                        (uml:resolve-type($property)[xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)] or uml:resolve-type($property)/xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types'))
                        then
                        '1'
                        else
                        '0'}" colsep="{if (position() = last()) then '1' else '0'}"/>
            </xsl:for-each>
            <entry namest="indent{$indent}" nameend="page">
               <!-- TODO (MK mit FB): Klären, warum das folgende if erforderlich: Wenn man den Text in die $doc-Variable packt, verschwinden die Tags. -->
               <!-- FB: Zwei Variante: a) die hier zu erzeugenden Tags oben bereits als maskierten String schreiben
                        oder b) - meine Präferenz - Variable als element()* deklarieren, Tags normal schreiben und dann
                        hier xsl:sequence anstelle von xsl:value-of nutzen-->
               <xsl:if test="
                     not(ownedComment/body[. != '']) and
                     not(
                     uml:resolve-type(.)[not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.))] and
                     not(some $c in uml:resolve-type(.)/ownedComment/body
                        satisfies $c = '[nd]') and
                     uml:resolve-type(.)/ownedComment/body[. != '']
                     ) and
                     uml:resolve-general(../generalization[xoev:xsdRestriction(.)])/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id != $xoev:my-xmodel/@xmi:id">
                  <xsl:variable name="basiseigenschaft" select="uml:resolve-general(../generalization[xoev:xsdRestriction(.)])/ownedAttribute[@name = $property/@name]"/>
                  <xsl:if test="
                        not(some $c in $basiseigenschaft/ownedComment/body
                           satisfies $c = '[nd]') and $basiseigenschaft/ownedComment/body[. != '']">
                     <para>Dokumentation aus <xsl:apply-templates select="$basiseigenschaft/parent::packagedElement" mode="kosit:xref">
                           <xsl:with-param name="rolle">Quelle</xsl:with-param>
                           <xsl:with-param name="type-or-elem" select="
                                 if ($basiseigenschaft/parent::packagedElement/xoev:xsdGlobalElementAndNamedType(.)) then
                                    if (xoev:is-ref(.)) then
                                       'elem'
                                    else
                                       'type'
                                 else
                                    ''"/>
                        </xsl:apply-templates>:</para>
                  </xsl:if>
               </xsl:if>
               <xsl:choose>
                  <xsl:when test="$doc[. = 'generiereTodo']">
                     <annotation role="todo">
                        <info>
                           <title>Dokumentation fehlt!</title>
                        </info>
                        <para>Dieses ToDo wurde automatisch generiert.</para>
                     </annotation>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:value-of select="$doc"/>
                     <xsl:variable name="rg" select="
                           (
                           uml:resolve-type($property)/generalization/xoev:xsdRestriction(.),
                           uml:resolve-type($property)/generalization/uml:resolve-general(.)/generalization/xoev:xsdRestriction(.))[1]"/>
                     <xsl:variable name="facetten" select="
                           ($rg/@enumeration, $rg/@fractionDigits, $rg/@length, $rg/@maxExclusive, $rg/@maxInclusive, $rg/@maxLength,
                           $rg/@minExclusive, $rg/@minInclusive, $rg/@minLength, $rg/@totalDigits, $rg/@whitespace)"/>
                     <xsl:if test="
                           not(uml:resolve-type($property)/kosit:docInlineSimpleTypeDocumentation(.)) and
                           uml:resolve-type($property)/xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types' and
                           not(uml:resolve-type($property)[ancestor::packagedElement/xoev:xoevBibliothek(.) and @name = 'datatypeC']) and
                           ($rg/@pattern[. != ''] or not(empty($facetten))) and
                           $xoev:my-xmodel/kosit:docGlobaleVariablen(.)/@AbbildungXSDFacetten = 'true'">
                        <xsl:variable name="muster" as="xs:string*"><![CDATA[<![CDATA[]]><xsl:value-of select="$rg/@pattern"/>]]&gt;</xsl:variable>
                        <xsl:if test="$rg/@pattern[. != '']">
                           <para>
                              <xsl:text>Die Werte müssen dem Muster '</xsl:text>
                              <xsl:value-of select="xgen:unescaped-xml(string-join($muster, ''))"/>
                              <xsl:text>' entsprechen.</xsl:text>
                           </para>
                        </xsl:if>
                        <xsl:if test="$facetten">
                           <para>
                              <xsl:text>Beschränkungen (XML-Schema-Facetten): </xsl:text>
                              <xsl:for-each select="$facetten">
                                 <xsl:value-of select="concat(name(), ':', .)"/>
                                 <xsl:if test="position() != last()">; </xsl:if>
                              </xsl:for-each>
                           </para>
                        </xsl:if>
                     </xsl:if>
                  </xsl:otherwise>
               </xsl:choose>
               <xsl:apply-templates select="uml:resolve-type($property)[xoev:allParents(.) and kosit:docInlineSimpleTypeDocumentation(.)]" mode="kosit:verweis-vererbung"/>
               <xsl:choose>
                  <xsl:when test="$default-value and @isReadOnly = 'true'">
                     <para>In diesem Element/Attribut ist nur Wert <quote><xsl:value-of select="$default-value"/></quote> zulässig (fixed-Wert).</para>
                  </xsl:when>
                  <xsl:when test="$default-value">
                     <para>Dieses Element/Attribut hat den Wert <quote><xsl:value-of select="$default-value"/></quote>, sofern kein anderer Wert übermittelt wird (default-Wert).</para>
                  </xsl:when>
               </xsl:choose>
               <xsl:for-each select="xoev:xsdWithImplementationHint(.)/@implementationHint[. != '']">
                  <para>
                     <emphasis role="strong">Umsetzungshinweise:</emphasis>
                  </para>
                  <xsl:value-of select="
                        if (not(starts-with(replace(., ' ', ''), '&lt;para&gt;'))) then
                           xgen:unescaped-xml(concat('&lt;para&gt;', ., '&lt;/para&gt;'))
                        else
                           xgen:unescaped-xml(.)"/>
               </xsl:for-each>
            </entry>
         </row>
      </xsl:if>
      <!-- ANFORDERUNG: Wenn ein Typ mit ignoreInFlatList annotiert ist, werden dessen Unterstrukturen nicht angezeigt. -->
      <!-- ANFORDERUNG: Wenn eine Eigenschaft mit ignoreInFlatList annotiert ist, werden dessen Unterstrukturen nicht angezeigt. (Überschreibt jeweils die Regelung zum Typ.) -->
      <!-- ANFORDERUNG: Wenn eine Eigenschaft mit documentInFlatList annotiert ist, werden die Unterstrukturen angezeigt. (Überschreibt jeweils die Regelung zum Typ.) -->
      <xsl:for-each select="
            uml:resolve-type(.)[
            (
            not(xoev:xsdNamedType(.) or xoev:xsdGlobalElementAndNamedType(.)) or
            (
            $property/kosit:documentInFlatList(.) or
            (
            not($property/kosit:ignoreInFlatList(.)) and
            not(kosit:ignoreInFlatList(.))
            )
            )
            ) and not(uml:resolve-type(.)/xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types')]">
         <xsl:variable name="type" select="."/>
         <!-- ANFORDERUNG: Bei Erweiterungen werden alle direkt und indirekt geerbten Elemente, nicht aber die Attribute, angezeigt: attributes(.) vs. allElements(.) -->
         <xsl:for-each select="xoev:attributes(.)[not($inherited) or $template-prop]">
            <xsl:apply-templates select="." mode="kosit:tabelle-zeile-flat">
               <xsl:with-param name="indent" select="$indent + 1"/>
               <xsl:with-param name="lastElement" select="($lastElement, (position() = last()) and empty($type/xoev:allElements(.)))"/>
            </xsl:apply-templates>
         </xsl:for-each>
         <xsl:for-each select="xoev:allElements(.)">
            <xsl:apply-templates select="." mode="kosit:tabelle-zeile-flat">
               <xsl:with-param name="indent" select="$indent + 1"/>
               <xsl:with-param name="lastElement" select="($lastElement, position() = last())"/>
               <xsl:with-param name="inherited" select="$inherited"/>
               <xsl:with-param name="template-prop" select="$template-prop and not($type/(xoev:xsdNamedType(.), xoev:xsdGlobalElementAndNamedType(.)))"/>
            </xsl:apply-templates>
         </xsl:for-each>
      </xsl:for-each>
   </xsl:template>
   <xsl:template match="ownedAttribute" mode="kosit:section-for-wsdl-interface-xta">
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI(concat('dokumente/schnittstellen/', parent::*/@name, '_', @name, '.xml'))"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE section [<!ENTITY % complete SYSTEM "../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <xsl:element name="section">
               <xsl:variable name="service" select="parent::*"/>
               <xsl:variable name="port" select="."/>
               <xsl:variable name="portType" select="$port/uml:resolve-type(.)/xoev:dependencies-by-client(.)[kosit-wsdl:wsdlBindingType(.)]/uml:resolve-supplier(.)"/>
               <xsl:attribute name="version">5</xsl:attribute>
               <xsl:attribute name="xml:lang">de</xsl:attribute>
               <xsl:attribute name="xml:id" select="concat('spezifikation.xta-webservice.methoden.schnittstellen', '.', $service/@name, '.', $port/@name)"/>
               <xsl:attribute name="status" select="concat(xgen:unescaped-xml('&amp;'),'specstatus;')"/>
               <xsl:attribute name="revision" select="concat(xgen:unescaped-xml('&amp;'),'xrecent;')"/>
               <xsl:namespace name="xlink">http://www.w3.org/1999/xlink</xsl:namespace>
               <info>
                  <title>
                     <xsl:text>Schnittstellentyp </xsl:text>
                     <xsl:value-of select="$portType/@name"/>
                  </title>
               </info>
               <xsl:for-each select="
                     $portType/ownedComment[every $c in body
                        satisfies $c != '[nd]']/body[. != '']">
                  <xsl:sort select="."/>
                  <xsl:value-of select="xgen:unescaped-xml(.)"/>
               </xsl:for-each>
               <informaltable>
                  <tgroup cols="2">
                     <colspec colnum="1" colname="c1" colwidth="100mm"/>
                     <colspec colnum="2" colname="c2" colwidth="58mm"/>
                     <thead>
                        <row>
                           <entry align="center">Methode</entry>
                           <entry align="center">Referenz</entry>
                        </row>
                     </thead>
                     <tbody>
                        <xsl:for-each select="$portType/ownedOperation">
                           <xsl:sort select="@name"/>
                           <row>
                              <entry>
                                 <xsl:value-of select="@name"/>
                              </entry>
                              <entry>
                                 <xref role="AS">
                                    <xsl:attribute name="linkend" select="
                                          concat('spezifikation.xta-webservice.methoden.schnittstellen.',
                                          $service/@name, '.', $port/@name, '.', @name)"/>
                                 </xref>
                              </entry>
                           </row>
                        </xsl:for-each>
                     </tbody>
                  </tgroup>
               </informaltable>
               <xsl:apply-templates select="$portType/ownedOperation[not(kosit-wsdl:wsdlOperation(.)/@istOptional = 'true')]" mode="kosit:section-for-wsdl-method-xta">
                  <xsl:with-param name="service" select="$service"/>
                  <xsl:with-param name="port" select="$port"/>
                  <xsl:sort select="@name"/>
               </xsl:apply-templates>
               <xsl:element name="include" namespace="http://www.w3.org/2001/XInclude">
                  <xsl:attribute name="href" select="concat('../../../../src/xta-webservice/xta-webservice-wichtige-objekte-', $portType/@name, '.xml')"/>
               </xsl:element>
               <xsl:if test="$portType/kosit-wsdl:wsdlPortType(.)/@hatOptionalenTeil = 'true'">
                  <xsl:element name="include" namespace="http://www.w3.org/2001/XInclude">
                     <xsl:attribute name="href" select="concat('../../../../src/xta-webservice/xta-webservice-optionaler-teil-', $portType/@name, '.xml')"/>
                  </xsl:element>
               </xsl:if>
            </xsl:element>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
   <xsl:template match="ownedOperation" mode="kosit:section-for-wsdl-method-xta">
      <xsl:param name="service" as="element()" required="yes"/>
      <xsl:param name="port" as="element()" required="yes"/>
      <xsl:param name="standalone" as="xs:boolean" required="no" select="false()"/>
      <xsl:variable name="methode" select="."/>
      <xsl:variable name="portInputHeader" select="$port/uml:resolve-type(.)/xoev:dependencies-by-client(.)[kosit-wsdl:wsdlOperationInputHeaderPart(.)]/uml:resolve-supplier(.)"/>
      <xsl:variable name="methodeInputHeader" select="$methode/xoev:dependencies-by-client(.)[kosit-wsdl:wsdlOperationInputHeaderPart(.)]/uml:resolve-supplier(.)"/>
      <xsl:variable name="portOutputHeader" select="$port/uml:resolve-type(.)/xoev:dependencies-by-client(.)[kosit-wsdl:wsdlOperationOutputHeaderPart(.)]/uml:resolve-supplier(.)"/>
      <xsl:variable name="methodeOutputHeader" select="$methode/xoev:dependencies-by-client(.)[kosit-wsdl:wsdlOperationOutputHeaderPart(.)]/uml:resolve-supplier(.)"/>
      <xsl:variable name="input" select="$methode/ownedParameter[@direction != 'return']"/>
      <xsl:variable name="input-type" select="$input/uml:resolve-type(.)"/>
      <xsl:variable name="return" select="$methode/ownedParameter[@direction = 'return']"/>
      <xsl:variable name="return-type" select="$return/uml:resolve-type(.)"/>
      <xsl:element name="section">
         <xsl:if test="$standalone">
            <xsl:attribute name="version">5</xsl:attribute>
            <xsl:attribute name="xml:lang">de</xsl:attribute>
            <xsl:attribute name="xml:id" select="concat('spezifikation.xta-webservice.methoden.schnittstellen', '.', $service/@name, '.', $port/@name, '.', @name)"/>
            <xsl:attribute name="status" select="concat(xgen:unescaped-xml('&amp;'),'specstatus;')"/>
            <xsl:attribute name="revision" select="concat(xgen:unescaped-xml('&amp;'),'xrecent;')"/>
            <xsl:namespace name="xlink">http://www.w3.org/1999/xlink</xsl:namespace>
         </xsl:if>
         <xsl:attribute name="xml:id" select="concat('spezifikation.xta-webservice.methoden.schnittstellen', '.', $service/@name, '.', $port/@name, '.', $methode/@name)"/>
         <info>
            <title>
               <xsl:text>Methode </xsl:text>
               <xsl:value-of select="$methode/@name"/>
            </title>
         </info>
         <xsl:for-each select="
               $methode/ownedComment[every $c in body
                  satisfies $c != '[nd]']/body[. != '']">
            <xsl:sort select="."/>
            <xsl:value-of select="xgen:unescaped-xml(.)"/>
         </xsl:for-each>
         <section>
            <info>
               <title>Ergebnisse</title>
            </info>
            <xsl:for-each select="$methode/ownedParameter[@direction = 'return']/ownedComment/body[. != '']">
               <xsl:sort select="."/>
               <xsl:value-of select="xgen:unescaped-xml(.)"/>
            </xsl:for-each>
            <para>Im Fehlerfall wird anstelle der Nachricht eine der folgenden Fehlermeldungen zurückgeliefert:</para>
            <itemizedlist>
               <xsl:for-each select="xoev:ids-to-elements(tokenize($methode/@raisedException, ' '), $xoev:my-xmodel)">
                  <xsl:sort select="@name"/>
                  <listitem>
                     <xsl:value-of select="xgen:unescaped-xml(ownedComment/body[. != ''])"/>
                  </listitem>
               </xsl:for-each>
            </itemizedlist>
         </section>
         <section>
            <info>
               <title>Input</title>
            </info>
            <xsl:choose>
               <xsl:when test="$portInputHeader or $methodeInputHeader">
                  <xsl:call-template name="kosit:table-for-wsdl-header">
                     <xsl:with-param name="portHeader" select="$portInputHeader"/>
                     <xsl:with-param name="methodeHeader" select="$methodeInputHeader"/>
                  </xsl:call-template>
               </xsl:when>
               <xsl:otherwise>
                  <para>Keine Header-Informationen.</para>
               </xsl:otherwise>
            </xsl:choose>
            <table>
               <title>Body</title>
               <tgroup cols="3">
                  <colspec colnum="1" colname="c1" colwidth="50mm"/>
                  <colspec colnum="2" colname="c2" colwidth="50mm"/>
                  <colspec colnum="3" colname="c3" colwidth="58mm"/>
                  <thead>
                     <row>
                        <entry align="center">WSDL Message</entry>
                        <entry align="center">Message Part</entry>
                        <entry align="center">Part Element</entry>
                     </row>
                  </thead>
                  <tbody>
                     <xsl:choose>
                        <xsl:when test="$input-type[xoev:xsdMessage(.) or xoev:xsdGlobalElement(.), xoev:xsdGlobalElementAndNamedType(.)]">
                           <row>
                              <entry>
                                 <xsl:value-of select="$input-type/@name"/>
                              </entry>
                              <entry>
                                 <xsl:value-of select="$input-type/@name"/>
                              </entry>
                              <xsl:call-template name="kosit:table-for-wsdl-xref">
                                 <xsl:with-param name="parameter" select="$input"/>
                              </xsl:call-template>
                           </row>
                           <xsl:for-each select="$input/ownedComment/body[. != '']">
                              <xsl:sort select="."/>
                              <row>
                                 <entry namest="c1" nameend="c3">
                                    <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                 </entry>
                              </row>
                           </xsl:for-each>
                        </xsl:when>
                        <xsl:when test="empty($input-type/ownedAttribute)">
                           <row>
                              <entry>
                                 <xsl:value-of select="$input-type/@name"/>
                              </entry>
                              <entry/>
                              <entry/>
                           </row>
                           <xsl:for-each select="$input/ownedComment/body[. != '']">
                              <xsl:sort select="."/>
                              <row>
                                 <entry namest="c1" nameend="c3">
                                    <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                 </entry>
                              </row>
                           </xsl:for-each>
                        </xsl:when>
                        <xsl:otherwise>
                           <xsl:for-each select="$input-type/ownedAttribute">
                              <xsl:sort select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                              <xsl:variable name="part" select="."/>
                              <xsl:variable name="part-type" select="$part/uml:resolve-type(.)"/>
                              <row>
                                 <entry>
                                    <xsl:value-of select="$input-type/@name"/>
                                 </entry>
                                 <entry>
                                    <xsl:value-of select="($part/@name[. != ''], $part-type/@name)[1]"/>
                                 </entry>
                                 <xsl:call-template name="kosit:table-for-wsdl-xref">
                                    <xsl:with-param name="parameter" select="$part"/>
                                 </xsl:call-template>
                              </row>
                              <xsl:for-each select="$input/ownedComment/body[. != '']">
                                 <xsl:sort select="."/>
                                 <row>
                                    <entry namest="c1" nameend="c3">
                                       <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                    </entry>
                                 </row>
                              </xsl:for-each>
                           </xsl:for-each>
                        </xsl:otherwise>
                     </xsl:choose>
                  </tbody>
               </tgroup>
            </table>
         </section>
         <section>
            <info>
               <title>Output</title>
            </info>
            <xsl:choose>
               <xsl:when test="$portOutputHeader or $methodeOutputHeader">
                  <xsl:call-template name="kosit:table-for-wsdl-header">
                     <xsl:with-param name="portHeader" select="$portOutputHeader"/>
                     <xsl:with-param name="methodeHeader" select="$methodeOutputHeader"/>
                  </xsl:call-template>
               </xsl:when>
               <xsl:otherwise>
                  <para>Keine Header-Informationen.</para>
               </xsl:otherwise>
            </xsl:choose>
            <table>
               <title>Body</title>
               <tgroup cols="3">
                  <colspec colnum="1" colname="c1" colwidth="50mm"/>
                  <colspec colnum="2" colname="c2" colwidth="50mm"/>
                  <colspec colnum="3" colname="c3" colwidth="58mm"/>
                  <thead>
                     <row>
                        <entry align="center">WSDL Message</entry>
                        <entry align="center">Message Part</entry>
                        <entry align="center">Part Element</entry>
                     </row>
                  </thead>
                  <tbody>
                     <xsl:choose>
                        <xsl:when test="$return-type[xoev:xsdMessage(.) or xoev:xsdGlobalElement(.), xoev:xsdGlobalElementAndNamedType(.)]">
                           <row>
                              <entry>
                                 <xsl:value-of select="$return-type/@name"/>
                              </entry>
                              <entry>
                                 <xsl:value-of select="$return-type/@name"/>
                              </entry>
                              <xsl:call-template name="kosit:table-for-wsdl-xref">
                                 <xsl:with-param name="parameter" select="$return"/>
                              </xsl:call-template>
                           </row>
                           <xsl:for-each select="$return/ownedComment/body[. != '']">
                              <xsl:sort select="."/>
                              <row>
                                 <entry namest="c1" nameend="c3">
                                    <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                 </entry>
                              </row>
                           </xsl:for-each>
                        </xsl:when>
                        <xsl:when test="empty($return-type/ownedAttribute)">
                           <row>
                              <entry>
                                 <xsl:value-of select="$return-type/@name"/>
                              </entry>
                              <entry/>
                              <entry/>
                           </row>
                           <xsl:for-each select="$return/ownedComment/body[. != '']">
                              <xsl:sort select="."/>
                              <row>
                                 <entry namest="c1" nameend="c3">
                                    <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                 </entry>
                              </row>
                           </xsl:for-each>
                        </xsl:when>
                        <xsl:otherwise>
                           <xsl:for-each select="$return-type/ownedAttribute">
                              <xsl:sort select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                              <xsl:variable name="part" select="."/>
                              <xsl:variable name="part-type" select="$part/uml:resolve-type(.)"/>
                              <row>
                                 <entry>
                                    <xsl:value-of select="$return-type/@name"/>
                                 </entry>
                                 <entry>
                                    <xsl:value-of select="($part/@name[. != ''], $part-type/@name)[1]"/>
                                 </entry>
                                 <xsl:call-template name="kosit:table-for-wsdl-xref">
                                    <xsl:with-param name="parameter" select="$part"/>
                                 </xsl:call-template>
                              </row>
                              <xsl:for-each select="$return/ownedComment/body[. != '']">
                                 <xsl:sort select="."/>
                                 <row>
                                    <entry namest="c1" nameend="c3">
                                       <xsl:value-of select="xgen:unescaped-xml(.)"/>
                                    </entry>
                                 </row>
                              </xsl:for-each>
                           </xsl:for-each>
                        </xsl:otherwise>
                     </xsl:choose>
                  </tbody>
               </tgroup>
            </table>
         </section>
         <section>
            <info>
               <title>Beispielcode (Aufruf der Methode)</title>
            </info>
            <para>
               <emphasis role="codebf">
                  <xsl:value-of select="$methode/@name"/>
                  <xsl:text>(</xsl:text>
                  <xsl:for-each select="$portInputHeader">
                     <xsl:sort select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                     <xsl:variable name="header" select="."/>
                     <xsl:variable name="header-type" select="$header/uml:resolve-type(.)"/>
                     <xsl:value-of select="xoev:qualified-type-name($header-type, $header-type, false())"/>
                     <xsl:if test="position() != last() or $methodeInputHeader or $input-type[xoev:xsdMessage(.) or xoev:xsdGlobalElement(.), xoev:xsdGlobalElementAndNamedType(.)] or $input-type/ownedAttribute">
                        <xsl:text>, </xsl:text>
                     </xsl:if>
                  </xsl:for-each>
                  <xsl:for-each select="$methodeInputHeader">
                     <xsl:sort select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                     <xsl:variable name="header" select="."/>
                     <xsl:variable name="header-type" select="$header/uml:resolve-type(.)"/>
                     <xsl:value-of select="xoev:qualified-type-name($header-type, $header-type, false())"/>
                     <xsl:if test="position() != last() or $input-type[xoev:xsdMessage(.) or xoev:xsdGlobalElement(.), xoev:xsdGlobalElementAndNamedType(.)] or $input-type/ownedAttribute">
                        <xsl:text>, </xsl:text>
                     </xsl:if>
                  </xsl:for-each>
                  <xsl:choose>
                     <xsl:when test="$input-type[xoev:xsdMessage(.) or xoev:xsdGlobalElement(.), xoev:xsdGlobalElementAndNamedType(.)]">
                        <xsl:value-of select="xoev:qualified-type-name($input-type, $input-type, false())"/>
                     </xsl:when>
                     <xsl:when test="$input-type/ownedAttribute">
                        <xsl:for-each select="$input-type/ownedAttribute">
                           <xsl:sort select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                           <xsl:value-of select="xoev:qualified-type-name(uml:resolve-type(.), uml:resolve-type(.), false())"/>
                           <xsl:if test="position() != last()">
                              <xsl:text>, </xsl:text>
                           </xsl:if>
                        </xsl:for-each>
                     </xsl:when>
                  </xsl:choose>
                  <xsl:text>)</xsl:text>
               </emphasis>
            </para>
         </section>
      </xsl:element>
   </xsl:template>
   <xsl:template match="ownedAttribute" mode="kosit:section-for-wsdl-method-header">
      <xsl:variable name="header" select="."/>
      <xsl:variable name="header-type" select="$header/uml:resolve-type(.)"/>
      <xsl:variable name="header-type-qualified-name" select="xoev:qualified-type-name($header-type, $header-type, false())"/>
      <xsl:variable name="header-type-prefix" select="tokenize($header-type-qualified-name, ':')[1]"/>
      <row>
         <entry>
            <xsl:value-of select="$header/parent::*/@name"/>
         </entry>
         <entry>
            <xsl:value-of select="($header/@name[. != ''], $header-type/@name)[1]"/>
         </entry>
         <xsl:variable name="import-id" select="
               concat('externe.modelle.',
               $xoev:my-xmodel/xoev:dependencies-by-client(.)
               [xoev:xsdXModelImport(.) and uml:resolve-supplier(.)/@xmi:id = $header-type/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id]
               /xoev:xsdXModelImport(.))"/>
         <entry>
            <xsl:value-of select="$header-type-qualified-name"/>
            <xsl:text> (vgl. </xsl:text>
            <xref role="Seite">
               <xsl:attribute name="linkend" select="
                     if ($header-type-prefix = ('xta', 'osci', 'oscimeta')) then
                        concat(kosit:docbook-id($header-type), if ($header-type/xoev:xsdGlobalElementAndNamedType(.)) then
                           '-type'
                        else
                           '')
                     else
                        $import-id"/>
            </xref>
            <xsl:text>)</xsl:text>
         </entry>
      </row>
      <xsl:for-each select="$header/ownedComment/body[. != '']">
         <xsl:sort select="."/>
         <row>
            <entry namest="c1" nameend="c3">
               <xsl:value-of select="xgen:unescaped-xml(.)"/>
            </entry>
         </row>
      </xsl:for-each>
   </xsl:template>
   <xsl:template name="kosit:table-for-wsdl-header">
      <xsl:param name="portHeader"/>
      <xsl:param name="methodeHeader"/>
      <table>
         <title>Header</title>
         <tgroup cols="3">
            <colspec colnum="1" colname="c1" colwidth="50mm"/>
            <colspec colnum="2" colname="c2" colwidth="50mm"/>
            <colspec colnum="3" colname="c3" colwidth="58mm"/>
            <thead>
               <row>
                  <entry align="center">WSDL Message</entry>
                  <entry align="center">Message Part</entry>
                  <entry align="center">Part Element</entry>
               </row>
            </thead>
            <tbody>
               <xsl:apply-templates select="$portHeader" mode="kosit:section-for-wsdl-method-header">
                  <xsl:sort select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
               </xsl:apply-templates>
               <xsl:apply-templates select="$methodeHeader" mode="kosit:section-for-wsdl-method-header">
                  <xsl:sort select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
               </xsl:apply-templates>
            </tbody>
         </tgroup>
      </table>
   </xsl:template>
   <xsl:template name="kosit:table-for-wsdl-xref">
      <xsl:param name="parameter"/>
      <xsl:variable name="parameter-type" select="$parameter/uml:resolve-type(.)"/>
      <xsl:variable name="import-id" select="
                concat('externe.modelle.',
                $xoev:my-xmodel/xoev:dependencies-by-client(.)
                [xoev:xsdXModelImport(.) and uml:resolve-supplier(.)/@xmi:id = $parameter-type/ancestor::packagedElement[xoev:xsdXModel(.)]/@xmi:id]
                /xoev:xsdXModelImport(.)/replace(@bezeichnung,'[\s&lt;&gt;#%?&amp;{}\-\\()]+', '_'))"/>
      <xsl:variable name="type-qualified-name" select="xoev:qualified-type-name($parameter-type, $parameter-type, false())"/>
      <xsl:variable name="type-prefix" select="tokenize($type-qualified-name, ':')[1]"/>
      <entry>
         <xsl:value-of select="$type-qualified-name"/>
         <xsl:text> (vgl. </xsl:text>
         <xref role="Seite">
            <xsl:attribute name="linkend" select="
                  if ($type-prefix = ('xta', 'osci', 'oscimeta')) then
                     concat(kosit:docbook-id($parameter-type), if ($parameter-type/xoev:xsdGlobalElementAndNamedType(.)) then
                        '-type'
                     else
                        '')
                  else
                     $import-id"/>
         </xref>
         <xsl:text>)</xsl:text>
      </entry>
   </xsl:template>
   <xsl:template match="ownedOperation" mode="kosit:section-for-wsdl-method-standalone-xta">
      <xsl:param name="service"/>
      <xsl:param name="port"/>
      <xsl:call-template name="xgen:result-document">
         <xsl:with-param name="local-path" select="xs:anyURI(concat('dokumente/schnittstellen/', $service/@name, '_', $port/@name, '_', @name, '.xml'))"/>
         <xsl:with-param name="content">
            <xsl:processing-instruction name="xml-model">href="http://www.oasis-open.org/docbook/xml/5.0/rng/docbookxi.rng" schematypens="http://relaxng.org/ns/structure/1.0"</xsl:processing-instruction>
            <xsl:variable name="doctype" as="xs:string*"><![CDATA[<!DOCTYPE section [<!ENTITY % complete SYSTEM "../../../../ent/complete.ent"> %complete;]>]]></xsl:variable>
            <xsl:value-of select="xgen:unescaped-xml($doctype)"/>
            <xsl:apply-templates select="." mode="kosit:section-for-wsdl-method-xta">
               <xsl:with-param name="service" select="$service"/>
               <xsl:with-param name="port" select="$port"/>
               <xsl:with-param name="standalone" select="true()"/>
            </xsl:apply-templates>
         </xsl:with-param>
      </xsl:call-template>
   </xsl:template>
</xsl:stylesheet>
